SystemOrganization addCategory: #'Maui-Core-Domain'!
SystemOrganization addCategory: #'Maui-Core-Exceptions'!
SystemOrganization addCategory: #'Maui-Core-Info'!
SystemOrganization addCategory: #'Maui-Core-Kernel'!
SystemOrganization addCategory: #'Maui-Core-Messages'!
SystemOrganization addCategory: #'Maui-Core-Morphs'!
SystemOrganization addCategory: #'Maui-Core-SUnit tests'!
SystemOrganization addCategory: #'Maui-Core-Tools'!
SystemOrganization addCategory: #'Maui-Core-Widgets'!

MaNotification subclass: #MauiNotification
	instanceVariableNames: 'result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Exceptions'!

!MauiNotification class methodsFor: 'as yet unclassified' stamp: 'cmm 6/17/2003 00:47'!
signalResult: anObject
	"Signals the current result of a command executed on a MauiObject."

	^(self result: anObject) signal! !

!MauiNotification methodsFor: 'as yet unclassified' stamp: 'cmm 6/17/2003 00:47'!
result

	^result! !

!MauiNotification methodsFor: 'as yet unclassified' stamp: 'cmm 6/17/2003 00:48'!
result: anObject

	result := anObject! !

!HandMorph methodsFor: '*maui-core-balloon help' stamp: 'cmm 3/3/2008 12:46'!
spawnMauiBalloon: aBalloonMorph 
	aBalloonMorph popUpForHand: self! !

!Color class methodsFor: '*maui-core' stamp: 'cmm 2/4/2014 14:31'!
maNamedColors
	| namedColorsCategory allNamedColors |
	namedColorsCategory := (self class >> #black) methodReference category.
	allNamedColors := self class methodReferencesInCategory: namedColorsCategory.
	^ allNamedColors collect: [ : each | each selector ]! !

!Color class methodsFor: '*maui-core' stamp: 'cmm 7/10/2007 15:47'!
mauiCodedViews
	^ #(namedColors specifiedColor) asSortedCollection! !

!Color class methodsFor: '*maui-core' stamp: 'cmm 7/10/2007 16:35'!
mauiName
	^ 'Color Picker'! !

!Color methodsFor: '*maui-core' stamp: 'cmm 12/11/2008 15:17'!
asFillStyle
	^ SolidFillStyle color: self! !

!Color methodsFor: '*maui-core' stamp: 'cmm 7/25/2007 13:13'!
mauiCodedViews
	^ super mauiCodedViews, #(horizontalIcon verticalIcon small transform)! !

!Color methodsFor: '*maui-core' stamp: 'cmm 7/28/2007 17:48'!
mauiName
	^ self name ifNil: [ self printString ]! !

!SystemWindow methodsFor: '*maui-core' stamp: 'cmm 1/19/2004 23:15'!
canDropIntoMauiMorph

	^false! !

Object subclass: #MauiNotificationHandler
	instanceVariableNames: ''
	classVariableNames: 'DefaultInstance'
	poolDictionaries: ''
	category: 'Maui-Core-Exceptions'!

!MauiNotificationHandler commentStamp: 'cmm 5/7/2007 12:40' prior: 0!
I am the default notification-handler installed for all MauiMorphs.

MaNotification's that are signaled by domain code should be handled somwhere.  I don't handle them other than by displaying a message to the Transcript indicating the message was ignored.!

!MauiNotificationHandler class methodsFor: 'as yet unclassified' stamp: 'cmm 1/2/2005 16:15'!
default

	^DefaultInstance! !

!MauiNotificationHandler class methodsFor: 'as yet unclassified' stamp: 'cmm 1/1/2005 18:33'!
initialize

	DefaultInstance := self new! !

!MauiNotificationHandler methodsFor: 'as yet unclassified' stamp: 'cmm 11/19/2010 10:33'!
send: aMessageOrBlock to: anObject 
	^ [ aMessageOrBlock sentTo: anObject ] 
		on: MaNotification
		do: 
			[ : noti | 
			Transcript
				cr ;
				show: noti messageText.
			noti resume ]! !

!Object methodsFor: '*maui-core' stamp: 'cmm 6/3/2009 15:07'!
addMessagesToMauiSettingsPanel: aMauiDomainMorph 
	(aMauiDomainMorph addMessageNamed: #view) asGetterSetter.
	#(#previewView #producedView #level #notificationHandler #wantsModality ) do: [ : each | (aMauiDomainMorph addMessageNamed: each) asGetterSetter ]! !

!Object methodsFor: '*maui-core' stamp: 'cmm 11/17/2010 17:19'!
asMauiMorph
	^ MauiWorld current family 
		newViewNamed: self mauiDefaultView
		for: self! !

!Object methodsFor: '*maui-core' stamp: 'cmm 3/29/2009 19:40'!
asMauiMorphFor: preferenceHolder 
	"Private"
	^ (self mauiMorphClass isSpecialized 
		ifTrue: [ MauiMorph newFor: self ]
		ifFalse: 
			[ (preferenceHolder preferred: self prototypePreferenceSelector) copy
				object: self ;
				family: MauiWorld current family ;
				yourself ]) in: 
		[ : answer | 
		preferenceHolder isMauiMorph 
			ifTrue: 
				[ answer
					notificationHandler: preferenceHolder notificationHandler ;
					yourself ]
			ifFalse: [ answer ] ]! !

!Object methodsFor: '*maui-core' stamp: 'cmm 7/26/2004 12:56'!
asMauiPrototype

	^ MauiPrototype current! !

!Object methodsFor: '*maui-core' stamp: 'cmm 8/2/2007 12:37'!
isMauiDomainMorph
	^ false! !

!Object methodsFor: '*maui-core' stamp: 'cmm 5/1/2009 14:07'!
isMauiInstructionMorph
	^ false! !

!Object methodsFor: '*maui-core' stamp: 'cmm 1/18/2004 15:00'!
isMauiMessageMorph

	^false! !

!Object methodsFor: '*maui-core' stamp: 'cmm 1/18/2004 14:40'!
isMauiMorph

	^false! !

!Object methodsFor: '*maui-core' stamp: 'cmm 7/26/2004 13:42'!
isMauiPrototype
	^ false! !

!Object methodsFor: '*maui-core' stamp: 'cmm 7/11/2008 14:19'!
maChooseNotificationHandlerUsing: anObject 
	"Subclasses may override to allow the domain to take part in selection of the notiicationHandler."
	^ self! !

!Object methodsFor: '*maui-core' stamp: 'cmm 7/18/2013 14:27'!
maValidateTypeIs: aClass
	"Might want to use this to put type-validation into a Maui UI."
	(self isKindOf: aClass) ifFalse: 
		[ MauiUserError signalPage: (MauiPage streamContents: 
				[ : stream | 
				stream
					nextPut: self ;
					maPrint: ' is not a kind of ' ;
					nextPut: aClass ;
					maPrint: $. ]) ]! !

!Object methodsFor: '*maui-core' stamp: 'cmm 5/22/2013 21:39'!
maui
	^ self maui: #openInHand! !

!Object methodsFor: '*maui-core' stamp: 'cmm 5/22/2013 21:39'!
maui: openSelector
	^ self asMauiMorph in:
		[ : morph | morph canBeNotificationHandler ifTrue: [ morph beNotificationHandler ].
		morph perform: openSelector ]! !

!Object methodsFor: '*maui-core' stamp: 'cmm 6/8/2009 17:21'!
mauiCodedViews
	"Subclasses list the selectors that create the views described by code, not visually-built prototypes."
	^ #(defaultListEntry)! !

!Object methodsFor: '*maui-core' stamp: 'cmm 12/27/2009 19:51'!
mauiColor
	^ Color gray! !

!Object methodsFor: '*maui-core' stamp: 'cmm 8/21/2007 12:00'!
mauiDefaultColumns
	"Answer the default selector Symbols that will make up my defaultListEntry view"
	^ #(mauiName)! !

!Object methodsFor: '*maui-core' stamp: 'cmm 7/12/2007 17:43'!
mauiDefaultView
	^ #panel! !

!Object methodsFor: '*maui-core' stamp: 'cmm 9/3/2012 16:22'!
mauiDeveloperViews
	"Subclasses list the selectors that create the views that are typically only used for development and debugging."
	^ #(#loaded #physical #clear)! !

!Object methodsFor: '*maui-core' stamp: 'cmm 12/14/2003 21:47'!
mauiIconColor
	"If using the standard mauiIcon for the iconic view, answer the color of this icon."

	^Color orange! !

!Object methodsFor: '*maui-core' stamp: 'cmm 5/22/2013 21:40'!
mauiIntoWorld
	^ self maui: #openInWorld! !

!Object methodsFor: '*maui-core' stamp: 'cmm 4/10/2005 18:00'!
mauiMorphClass
	^MauiRegistry global mauiMorphClassFor: self maOriginalClass! !

!Object methodsFor: '*maui-core' stamp: 'cmm 5/27/2012 17:47'!
mauiMorphForDesktopFrom: aTransferMorph 
	^ self asMauiMorph! !

!Object methodsFor: '*maui-core' stamp: 'cmm 10/30/2007 12:07'!
mauiName
	"Answers the name to be displayed when the halos of my MauiMorph are selected."
	^ MauiWorld current nameFor: self printString! !

!Object methodsFor: '*maui-core' stamp: 'cmm 7/13/2009 18:24'!
mauiServices
	"A way to extend with additional Maui-specific services."
	^ self maOriginalClass services! !

!Object methodsFor: '*maui-core' stamp: 'cmm 6/20/2012 15:40'!
mauiSortableColumns
	"Answer an Array of the same length of #mauiDefaultColumns.  Each index of the array will be nil if that column should not have sort buttons.  If it should have sort buttons, that element of the Array will have the selector used for comparison."
	"Default is that no columns are sortable."
	^ Array empty! !

!Object methodsFor: '*maui-core' stamp: 'cmm 5/27/2012 18:10'!
possibleTransfers
	^ Array with: self! !

!Object methodsFor: '*maui-core' stamp: 'cmm 12/10/2008 20:14'!
prototypePreferenceSelector
	^ #domainMorph! !

!Association methodsFor: '*maui-core' stamp: 'cmm 9/26/2011 19:14'!
mauiDefaultColumns 
	^ #(key value)! !

!BalloonMorph class methodsFor: '*maui-core-instance creation' stamp: 'cmm 1/3/2005 17:11'!
contentsMorph: contentsMorph for: targetMorph

	| vertices |
	vertices := 
		self
			mauiVerticesFor: contentsMorph
			target: targetMorph.
	contentsMorph setToAdhereToEdge: #adjustedCenter.
	^ self new color: targetMorph balloonColor;
		 setVertices: vertices;
		 addMorph: contentsMorph;
		 setTarget: targetMorph! !

!BalloonMorph class methodsFor: '*maui-core-private' stamp: 'cmm 1/3/2005 17:10'!
mauiVerticesFor: contentsMorph target: targetMorph

	| vertices |
	vertices := self getVertices: (contentsMorph bounds expandBy: 3@3).
	vertices := self
				getBestLocation: vertices
				for: targetMorph
				corner: #bottomLeft.
	^ vertices! !

!BalloonMorph class methodsFor: '*maui-core-private' stamp: 'cmm 1/3/2005 17:03'!
mauiVerticesFor: contentsMorph target: targetMorph corner: cornerName

	| vertices |
	vertices := self getVertices: (contentsMorph bounds expandBy: 3@3).
	vertices := self
				getBestLocation: vertices
				for: targetMorph
				corner: cornerName.
	^ vertices! !

!BalloonMorph methodsFor: '*maui-core-morphic workarounds' stamp: 'cmm 1/3/2005 17:15'!
mauiAdjustVertices

	self
		setVertices:
			(self class
				mauiVerticesFor: submorphs anyOne  "ugh!!"
				target: target) ;
		setTarget: target! !

!BalloonMorph methodsFor: '*maui-core-morphic workarounds' stamp: 'cmm 1/3/2005 18:00'!
mauiTarget
	^ target! !

BalloonMorph subclass: #MauiBalloonMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Widgets'!

!MauiBalloonMorph commentStamp: 'cmm 1/6/2005 12:28' prior: 0!
This class exists solely so I can override #delete.  It is the only reliable way, as far as I've discovered, to know when a Morph is being removed from the screen because Morphic provides no hooks for this outside of eToy stuff.  I could not get #outOfWorld: to work properly for me.!

!MauiBalloonMorph methodsFor: 'as yet unclassified' stamp: 'cmm 3/3/2008 14:27'!
privateDelete
	"Unfortunately, I see no easier way to hook when I am deleted reliably (replaceSubmorph:by: doesn't call #delete)."
	super privateDelete.
	"Delete the submorphs because I otherwise observed the sketch's owners still referenced in the MauiFamily.."
	self submorphs do: [ : each | each delete ]! !

!MaContextResultsContext methodsFor: '*maui-core' stamp: 'cmm 8/4/2013 20:08'!
mauiName

	| msg |
	msg := MaUserMessage new.
	msg append: (self maOriginalClass name first isVowel ifTrue: ['an '] ifFalse: ['a ']).
		self size = 0 ifTrue: [ msg append: 'empty ' ].
		msg append: self maOriginalClass name.
		self size = 0 ifFalse:
			[ | classCounts |
			msg append: ' of '.
			classCounts := (self collect: [ : each | each isBehavior ifTrue: [ Class ] ifFalse: [ each class ] ]) asBag sortedCounts.
			classCounts size > 1 ifTrue: [ msg append: 'mostly ' ].
			msg 
				appendProperlyPluralized: classCounts first value name
				for: classCounts first key ].
	^ msg messageText! !

!String methodsFor: '*maui-core' stamp: 'cmm 4/9/2008 22:38'!
mauiCodedViews
	^ #(#panel #word #wrapped )! !

!String methodsFor: '*maui-core' stamp: 'cmm 7/12/2007 17:44'!
mauiDefaultView
	^ #word! !

!String methodsFor: '*maui-core' stamp: 'cmm 11/19/2007 10:56'!
mauiName
self maMarked: 'dev'.  "The copy was needed back in 2004, make sure the copy is still necessary.."
	^ self copy "copy because #invoke won't display mauiName message result if result==receiver"! !

!FillStyle methodsFor: '*maui-core' stamp: 'cmm 12/11/2008 15:18'!
asFillStyle
	^ self! !

!FillStyle methodsFor: '*maui-core' stamp: 'cmm 11/30/2008 20:51'!
customizeForMauiMorph: aMauiMorph
	"Do nothing by default."! !

!FillStyle methodsFor: '*maui-core' stamp: 'cmm 11/30/2008 20:16'!
mauiCodedViews
	^ super mauiCodedViews , #(#small #horizontalIcon #verticalIcon )! !

!RunArray methodsFor: '*maui-core' stamp: 'cmm 10/30/2007 12:42'!
veryDeepInner: aDeepCopier
	super veryDeepInner: aDeepCopier.
	runs := runs veryDeepCopyWith: aDeepCopier.
	values := values veryDeepCopyWith: aDeepCopier! !

!MenuMorph methodsFor: '*maui-core' stamp: 'cmm 1/19/2004 23:17'!
canDropIntoMauiMorph

	^false! !

!MenuIcons class methodsFor: '*maui-core' stamp: 'cmm 11/19/2010 10:45'!
seeMyIcons
	"Open palette of all my icons."
	| iconSelectors palette|
	palette := RectangleMorph new
		color: Color white ;
		layoutPolicy: TableLayout new ;
		listDirection: #leftToRight ;
		hResizing: #shrinkWrap ;
		vResizing: #shrinkWrap ;
		wrapDirection: #topToBottom ;
		extent: World extent // 2 ;
		cellInset: 10 ;
		yourself.
	iconSelectors := (self class selectors select: [ : e | e endsWith: 'Icon' ]) asSortedCollection.
	iconSelectors do: 
		[ : each | | labelledIcon |
		labelledIcon := RectangleMorph new
			layoutPolicy: TableLayout new ;
			listDirection: #topToBottom ;
			layoutInset: 4 ;
			hResizing: #shrinkWrap ;
			vResizing: #shrinkWrap ;
			color: Color transparent ;
			borderWidth: 0 ;
			yourself.
		labelledIcon 
			addMorph: (StringMorph contents: each) ;
			addMorph: (SketchMorph withForm: (self perform: each)).
		palette addMorphBack: labelledIcon ].
	palette openInWorld! !

!Magnitude methodsFor: '*maui-core' stamp: 'cmm 7/28/2007 09:49'!
mauiDefaultView
	^ #word! !

!Interval methodsFor: '*maui-core' stamp: 'cmm 7/20/2011 14:55'!
mauiName
	^ String streamContents: [ : stream | self printOn: stream ]! !

!FlapTab methodsFor: '*maui-core' stamp: 'cmm 8/6/2008 20:10'!
installInWorld: aPasteUpMorph 
	"This is the code executed by Flaps class>>#addLocalFlap."
	aPasteUpMorph addMorphFront: self.
	self
		adaptToWorld: aPasteUpMorph ;
		computeEdgeFraction! !

!SequenceableCollection methodsFor: '*maui-core' stamp: 'cmm 11/11/2010 16:49'!
addMessagesToMauiSettingsPanel: aMauiDomainMorph 
	super addMessagesToMauiSettingsPanel: aMauiDomainMorph.
	self class isPointers ifTrue: [ (aMauiDomainMorph addMessageNamed: #headingMorph) asGetterSetter ]! !

!SequenceableCollection methodsFor: '*maui-core' stamp: 'cmm 5/3/2009 21:45'!
mauiCodedViews
	^ super mauiCodedViews , #(#horizontalListView #verticalList )! !

!SequenceableCollection methodsFor: '*maui-core' stamp: 'cmm 6/20/2012 17:56'!
sortBy: selectorSymbol ascending: aBoolean 
	| sel | sel := selectorSymbol realObjectIfMutatingProxy.
	self
		 sort:
			[ : a : b | | aVal bVal |
			(a respondsTo: sel) ifTrue: [ aVal := a perform: sel ].
			(b respondsTo: sel) ifTrue: [ bVal := b perform: sel ].
			(aVal notNil and: [ bVal notNil ]) and:
				[ aBoolean
					ifTrue: [ aVal < bVal ]
					ifFalse: [ aVal > bVal ] ] ] ;
		 changed! !

!UndefinedObject methodsFor: '*maui-core' stamp: 'cmm 12/27/2009 19:52'!
mauiColor
	^ Color gray muchDarker alpha: 0.1! !

!UndefinedObject methodsFor: '*maui-core' stamp: 'cmm 4/2/2008 13:00'!
mauiDefaultView
	^ #word! !

!Metaclass methodsFor: '*maui-core' stamp: 'cmm 3/18/2009 13:51'!
mauiServices
	^ #()! !

!TextMorph methodsFor: '*maui-core' stamp: 'cmm 12/20/2010 09:29'!
maContextKeywordsDo: aBlock
	self contents asString maContextKeywordsDo: aBlock! !

!TextMorph methodsFor: '*maui-core' stamp: 'cmm 10/31/2007 15:45'!
maxOneLineWidth
	"The width before the first-line of text should wrap to the next line."
	^ World width // 4! !

!TextMorph methodsFor: '*maui-core' stamp: 'cmm 10/31/2007 16:13'!
shortContentsExtent
	"Quickly answer the width of my text contents (if they are short) by my maxHeight.  If they're longer than #oneLineWidth, don't try to calculate, just answer nil."
	| totalWidth maxHeight oneLineWidth |
	totalWidth := maxHeight := 0.
	oneLineWidth := self maxOneLineWidth.
	self text withIndexDo: 
		[ : eachChar : x | 
		| font |
		font := self text 
			fontAt: x
			withStyle: self textStyle.
		totalWidth := totalWidth + (font widthOf: eachChar).
		maxHeight := maxHeight max: font ascent + font descent.
		totalWidth > oneLineWidth ifTrue: [ ^ false -> (totalWidth @ maxHeight) ] ].
	^ true -> (totalWidth truncated @ maxHeight)! !

!DateAndTime methodsFor: '*maui-core' stamp: 'cmm 8/14/2007 13:36'!
mauiName
	^ String streamContents: 
		[ : aStream | 
		self 
			printYMDOn: aStream
			withLeadingSpace: false.
		aStream nextPut: $@.
		self printHMSOn: aStream.
		self nanoSecond ~= 0 ifTrue: 
			[ | z ps |
			ps := self nanoSecond printString 
				padded: #left
				to: 9
				with: $0.
			z := ps findLast: [ : c | c asciiValue > $0 asciiValue ].
			z > 0 ifTrue: [ aStream nextPut: $. ].
			ps 
				from: 1
				to: z
				do: [ : c | aStream nextPut: c ] ] ]! !

!Browser methodsFor: '*maui-core' stamp: 'cmm 1/21/2004 22:28'!
mauiSelectedClass

	self selectedClass maui! !

MenuItemMorph subclass: #MauiMenuItemMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Widgets'!

!MauiMenuItemMorph commentStamp: 'cmm 8/15/2004 15:56' prior: 0!
I was created to allow use of BalloonMorph showing a preview of the Maui view instead of a TextMorph.!

!MauiMenuItemMorph methodsFor: 'accessing' stamp: 'cmm 8/15/2004 15:00'!
balloonContentsMorph

	^ self valueOfProperty: #balloonContentsMorph! !

!MauiMenuItemMorph methodsFor: 'accessing' stamp: 'cmm 8/15/2004 15:04'!
balloonContentsMorph: aMorph

	self 
		setProperty: #balloonContentsMorph
		toValue: aMorph! !

!MauiMenuItemMorph methodsFor: 'initialization' stamp: 'cmm 11/28/2007 22:04'!
initialize
	super initialize.
	self arguments: EmptyArray! !

!MauiMenuItemMorph methodsFor: 'overriding' stamp: 'cmm 3/1/2012 21:30'!
mauiBalloonText
	^ self balloonContentsMorph 
		ifNil: [ super mauiBalloonText ]
		ifNotNil: [ String empty "need a non-nil to satisfy Morph>>wantsBalloon" ]! !

!MauiMenuItemMorph methodsFor: 'overriding' stamp: 'cmm 1/6/2005 12:29'!
showBalloon: msgString hand: aHand
	"Pop up a balloon containing the given string,
	first removing any existing BalloonMorphs in the world."

	| w balloon h |
	self balloonContentsMorph ifNil: [ ^ super showBalloon: msgString hand: aHand ].
	(w := self world) ifNil: [^ self].
	h := aHand.
	h ifNil:[ h := w activeHand].
	balloon :=
		MauiBalloonMorph
			contentsMorph: self balloonContentsMorph 
			for: self balloonHelpAligner.
	balloon popUpFor: self hand: h.! !

!MenuItemMorph methodsFor: '*maui-core' stamp: 'cmm 11/19/2003 22:37'!
isItemForMauiObject

	^target isMauiMessageMorph and: [ selector = #invokeFromUserMenu ]! !

!MenuItemMorph methodsFor: '*maui-core' stamp: 'cmm 11/19/2003 00:24'!
maCanInvoke

	target ifNil: [ ^false ].
	selector ifNil: [ ^false ].
	^target respondsTo: selector! !

!MenuItemMorph methodsFor: '*maui-core' stamp: 'cmm 11/19/2003 00:19'!
maIsMenuItemMorph

	^true! !

!MenuItemMorph methodsFor: '*maui-core' stamp: 'cmm 5/1/2009 15:58'!
mauiBalloonText
	^self isItemForMauiObject 
		ifTrue: 
			[target instruction receiver maOriginalClass 
				maFirstCommentOrNilAt: target object selector]
		ifFalse: 
			[self maCanInvoke 
				ifTrue: [target maOriginalClass maFirstCommentOrNilAt: selector]]! !

!MauiPage methodsFor: '*maui-core-menu' stamp: 'cmm 3/16/2010 11:37'!
appendYellowButtonItemsTo: aMenuMorph 
	"Ok, it turns out PluggableTextMorph, which calls this method, appends itself as a mixin of the target.  This is lucky because I prefer to delegate these to the UI.  Also, if any of the menu item names are part of MenuIcons class>>'TranslatedIcons' (a class variable), they will be added by the system (see #decorateMenu: for details).
	Another note:  I use MauiMenuItemMorph's even when it seems I don't have to because they are smarter with initialization; they initialize #arguments: to EmptyArray so you don't have to.'"
	aMenuMorph
		addMenuItem: (MauiMenuItemMorph new
	"No need to set target because the editor will answer all the messages."
	"			target: self ;"	"-----------"
				contents: 'set font... (k)' ;
				selector: #offerFontMenu) ;
		addMenuItem: (MauiMenuItemMorph new
				contents: 'set style... (K)' ;
				selector: #changeStyle) ;
		addMenuItem: (MauiMenuItemMorph new
				contents: 'set alignment... (u)' ;
				selector: #chooseAlignment) ;
		addLine ;
		addMenuItem: (MauiMenuItemMorph new
				contents: 'find... (f)' ;
				selector: #find) ;
		addMenuItem: (MauiMenuItemMorph new
				contents: 'find again (g)' ;
				selector: #findAgain) ;
		addMenuItem: (MauiMenuItemMorph new
				contents: 'set search string (h)' ;
				target: self ;
				selector: #setSearchString) ;
		addLine ;
		addMenuItem: (MauiMenuItemMorph new
				contents: 'do again (j)' ;
				target: self ;
				selector: #setSearchString) ;
		addMenuItem: (MauiMenuItemMorph new
				contents: 'undo (z)' ;
				target: self ;
				selector: #undo) ;
		addLine ;
		addMenuItem: (MauiMenuItemMorph new
				contents: 'copy (c)' ;
				target: self ;
				selector: #copySelection) ;
		addMenuItem: (MauiMenuItemMorph new
				contents: 'cut (x)' ;
				target: self ;
				selector: #cut) ;
		addMenuItem: (MauiMenuItemMorph new
				contents: 'paste (v)' ;
				target: self ;
				selector: #paste) ;
		addMenuItem: (MauiMenuItemMorph new
				contents: 'paste...' ;
				target: self ;
				selector: #pasteRecent) ;
		addLine ;
		addMenuItem: (MauiMenuItemMorph new
				contents: 'do it (d)' ;
				target: self ;
				selector: #doIt) ;
		addMenuItem: (MauiMenuItemMorph new
				contents: 'print it (p)' ;
				target: self ;
				selector: #printIt) ;
		addMenuItem: (MauiMenuItemMorph new
				contents: 'inspect it (i)' ;
				target: self ;
				selector: #inspectIt) ;
		addMenuItem: (MauiMenuItemMorph new
				contents: 'explore it (I)' ;
				target: self ;
				selector: #exploreIt) ;
		addMenuItem: (MauiMenuItemMorph new
				contents: 'debug it' ;
				selector: #debugIt) ;
		addMenuItem: (MauiMenuItemMorph new
				contents: 'maui it (o)' ;
				selector: #mauiIt) ;
		addLine ;
		addMenuItem: (MauiMenuItemMorph new
				contents: 'accept (s)' ;
				selector: #accept) ;
		addMenuItem: (MauiMenuItemMorph new
				contents: 'cancel (l)' ;
				selector: #cancel)
! !

!MauiPage methodsFor: '*maui-core-model' stamp: 'cmm 8/29/2012 13:44'!
backupText: aText 
	MagmaSessionRequest signalCommit: [ self text: aText veryDeepCopy ].
	self dependents
		do:
			[ : each | each ifNotNil:
				[ each hasUnacceptedEdits
					ifTrue: [ each hasEditingConflicts: true ]
					ifFalse:
						[ (each respondsTo: #cancel) ifTrue: [ each cancel ] ] ] ]
		without: self.
	^ true! !

!MauiPage methodsFor: '*maui-core-menu' stamp: 'cmm 11/28/2007 21:35'!
buildMenu: aMenu shifted: shifted 
	self appendYellowButtonItemsTo: aMenu.
	^ aMenu! !

!MauiPage methodsFor: '*maui-core-ui' stamp: 'cmm 12/24/2008 14:03'!
mauiName
	^ text 
		ifNil: [ super mauiName ]
		ifNotNil: 
			[ text isEmpty 
				ifTrue: [ super mauiName ]
				ifFalse: 
					[ self string linesDo: 
						[ : eachLine | 
						(eachLine anySatisfy: [ : each | each isLetter ]) ifTrue: [ ^ eachLine ] ] ] ]! !

!MauiPage methodsFor: '*maui-core-ui' stamp: 'cmm 2/11/2012 14:47'!
openInWorld
	self maui! !

!MauiPage methodsFor: '*maui-core-model' stamp: 'cmm 10/30/2007 16:55'!
restoreText
	^ text veryDeepCopy! !

!SARInstaller class methodsFor: '*maui-core' stamp: 'cmm 6/8/2009 13:46'!
fileInMauiFamilyFromStream: aReadStream 
	MauiFamily fileInFromStream: aReadStream! !

!SARInstaller class methodsFor: '*maui-core' stamp: 'cmm 11/21/2010 21:10'!
installMauiWorldFromStream: aReadStream 
	| newWorld |
	newWorld := MaObjectSerializer objectFromStream: aReadStream.
	newWorld
		beForCurrentWorld ;
		installMenu ;
		installFlaps ;
		installPlayers! !

!SARInstaller methodsFor: '*maui-core' stamp: 'cmm 6/8/2009 15:07'!
fileInMauiFamilyNamed: filename 
	"This is to be used from preamble/postscript code to file in zip members as ChangeSets."
	| member |
	member := self memberNamed: filename.
	member ifNil: [ ^ self errorNoSuchMember: filename ].
	self class fileInMauiFamilyFromStream: member contentStream reset.
	self installed: member! !

!SARInstaller methodsFor: '*maui-core' stamp: 'cmm 6/8/2009 15:08'!
fileInMauiWorldNamed: filename 
	"This is to be used from preamble/postscript code to file in zip members as ChangeSets."
	| member |
	member := self memberNamed: filename.
	member ifNil: [ ^ self errorNoSuchMember: filename ].
	self class installMauiWorldFromStream: member contentStream reset.
	self installed: member! !

PackageInfo subclass: #MauiPackageInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Info'!

!MauiPackageInfo class methodsFor: 'overriding' stamp: 'cmm 4/21/2011 16:47'!
initialize
	^ self new register! !

!PackageInfo methodsFor: '*maui-core' stamp: 'cmm 12/2/2008 23:55'!
mauiName
	^ self packageName ! !

!Boolean methodsFor: '*maui-core' stamp: 'cmm 9/10/2007 17:10'!
addMauiFolderIconTo: aMauiMorph
	"Only True adds the icon, False doesn't, it remains empty."! !

!Boolean methodsFor: '*maui-core' stamp: 'cmm 4/2/2008 13:01'!
mauiDefaultView
	^ #word! !

!Year methodsFor: '*maui-core' stamp: 'cmm 5/3/2009 16:54'!
mauiName
	^ self start year asString! !

Notification subclass: #MauiSetNotificationHandlerNotification
	instanceVariableNames: 'handler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Exceptions'!

!MauiSetNotificationHandlerNotification commentStamp: 'cmm 1/3/2004 15:48' prior: 0!
I allow you signal commits to your persistence layer from your domain.  By registering a MaNotificationHandler, all MaNotifications signaled in your software can be handled by the send:to: method you write in your own handler.

To set your handler, you signal me.  I don't inherit from from MaNotification because I will then be handled by the default, do-nothing MaNotificationHandler.!

!MauiSetNotificationHandlerNotification class methodsFor: 'as yet unclassified' stamp: 'cmm 1/2/2004 14:17'!
handler: aMaNotificationHandler  "<-- implement this interface to provide your own handler."

	^self new handler: aMaNotificationHandler! !

!MauiSetNotificationHandlerNotification class methodsFor: 'as yet unclassified' stamp: 'cmm 11/19/2007 16:43'!
signalHandler: anObject
	"Set anObject as the (controller) object that will handle signals from the domain (such as MagmaSessionRequests).  Specify nil to remove all objects with the current handler from the screen."
	(self handler: anObject) signal! !

!MauiSetNotificationHandlerNotification methodsFor: 'access' stamp: 'cmm 1/2/2004 14:17'!
handler

	^handler! !

!MauiSetNotificationHandlerNotification methodsFor: 'access' stamp: 'cmm 1/2/2004 14:16'!
handler: aMaNotificationHandler

	handler := aMaNotificationHandler! !

!Timespan methodsFor: '*maui-core' stamp: 'cmm 11/15/2007 08:01'!
backward: aDuration
	"Position the calendar behind its current position."
	self maStart: self start - aDuration! !

!Timespan methodsFor: '*maui-core' stamp: 'cmm 11/15/2007 08:09'!
backwardDays: numberOfDays
	"Position the calendar behind its current position by a numberOfDays."
	self backward: numberOfDays days! !

!Timespan methodsFor: '*maui-core' stamp: 'cmm 11/15/2007 08:00'!
forward: aDuration
	"Position the calendar ahead of its current position."
	self maStart: self start + aDuration! !

!Timespan methodsFor: '*maui-core' stamp: 'cmm 11/15/2007 08:09'!
forwardDays: numberOfDays
	"Position the calendar ahead of its current position by a numberOfDays."
	self forward: numberOfDays days! !

!Timespan methodsFor: '*maui-core' stamp: 'cmm 11/19/2007 14:15'!
maEnd: aDateAndTime 
	"Adjust the duration of this timespan by specifying a new end DateAndTime."
	aDateAndTime < self start ifTrue: [ MauiUserError signal: 'End must be after my start.' ].
	self
		duration: aDateAndTime - self start ;
		changed! !

!Timespan methodsFor: '*maui-core' stamp: 'cmm 11/14/2007 16:39'!
maStart: aDateTime 
	"Shift the start of this timespan without changing its duration."
	self
		start: aDateTime ;
		changed! !

!Timespan methodsFor: '*maui-core' stamp: 'cmm 12/9/2007 13:16'!
mauiCodedViews
	^ super mauiCodedViews , #(
			#dayOfMonth
			#oneMonth
			#threeMonth
			#datePicker
			#timespanPicker
		)! !

!Timespan methodsFor: '*maui-core' stamp: 'cmm 11/14/2007 10:39'!
withSurroundingMonthsDo: aBlock 
	self dates in: 
		[ : dates | 
		"We have two next's on the to: side because Chronology's #to: seems to take us up to, but excluding, the next month.."
		(dates first asMonth previous to: dates last asMonth next next) monthsDo: aBlock ]! !

!MaProgressor methodsFor: '*maui-core' stamp: 'cmm 3/3/2008 16:42'!
mauiCodedViews
	^ super mauiCodedViews, #(details)! !

MaWarning subclass: #MauiWarning
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Exceptions'!

!ReadStream methodsFor: '*maui-core' stamp: 'cmm 7/16/2009 21:29'!
mauiName
	^ [ self contents printString ] 
		on: Error
		do: [ : err | 'could not print Stream contents' ]! !

!Collection methodsFor: '*maui-core' stamp: 'cmm 12/2/2007 23:41'!
lastKnownSize
	^ self size! !

!Collection methodsFor: '*maui-core' stamp: 'cmm 5/27/2008 09:01'!
mauiCodedViews
	^ super mauiCodedViews , #(#listEditor )! !

!Collection methodsFor: '*maui-core' stamp: 'cmm 1/31/2013 15:21'!
mauiName
	^ self maPrintDescription! !

!BookMorph methodsFor: '*maui-core' stamp: 'cmm 12/20/2010 14:07'!
maContextKeywordsDo: aBlock 
	pages do:
		[ : each | each maContextKeywordsDo: aBlock ]! !

RectangleMorph subclass: #MauiMorph
	instanceVariableNames: 'object notificationHandler priorOwner redButtonMessage preferences runningEffects family lastRefreshTime'
	classVariableNames: 'BlackCloseBoxImage WhiteCloseBoxImage'
	poolDictionaries: ''
	category: 'Maui-Core-Morphs'!

MauiMorph subclass: #MauiDomainMorph
	instanceVariableNames: 'labelBar label view previewView producedView spacer wantsModality pickee panels needsRefreshed level contextMenuMessages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Morphs'!

MauiDomainMorph subclass: #MauiBehaviorFinderMorph
	instanceVariableNames: 'initiallyRefreshed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Morphs'!

!MauiBehaviorFinderMorph methodsFor: 'view' stamp: 'cmm 12/4/2008 17:59'!
actionPane
	"Action pane"
	self clear.
	#(#addAll #addElement: #clear ) do: [ : each | (self addMessageNamed: each) invocationStrategy selectNoResultTarget ].
	self view: #actionPane! !

!MauiBehaviorFinderMorph methodsFor: 'view' stamp: 'cmm 12/4/2008 21:38'!
addCaseSensitivitySetting
	| message |
	message := (self addMessageNamed: #caseSensitive) asGetterSetter.
	message firstParameterHolder
		optionalParametersMorph: {  true. false  } asMauiMorph ;
		optionalParametersStrategy: MauiCycleParametersStrategy new! !

!MauiBehaviorFinderMorph methodsFor: 'view' stamp: 'cmm 12/10/2008 21:04'!
addCopyMessage
	| message |
	message := self addMessageNamed: #copy.
	message invocationStrategy
		resultView: #panel ;
		selectWorldResultTarget ;
		producedView: nil! !

!MauiBehaviorFinderMorph methodsFor: 'view' stamp: 'cmm 12/6/2008 15:08'!
categoriesPane
	"Classes pane"
	| listInvocationStrategy |
	listInvocationStrategy := (self addMessageNamed: #categories) selectStrategy: MauiAutoInvocationStrategy.
	listInvocationStrategy resultView: #panel.
	#(#selectMethodsInCategory: #rejectMethodsInCategory: ) do: 
		[ : each | 
		(self addMessageNamed: each) firstParameterHolder evaluator: MauiStringEvaluator ]! !

!MauiBehaviorFinderMorph methodsFor: 'view' stamp: 'cmm 12/15/2008 20:40'!
classesPane
	"Classes pane"
	| listInvocationStrategy parameterHolder filterPanel message |
	listInvocationStrategy := (self addMessageNamed: #classes) selectStrategy: MauiAutoInvocationStrategy.
	listInvocationStrategy resultView: #panel.
	filterPanel := self addPanel: self newPanel.
	filterPanel addMessageNamed: #removeClass:.
	#(
		#selectClassesNamed:
		#rejectClassesNamed:
		#selectCommonBehavior
		#selectSuperclassHierarchy:
		#rejectSuperclassHierarchy:
		#selectSubclassHierarchy:
		#rejectSubclassHierarchy:
		#selectClassHierarchy:
		#rejectClassHierarchy:
	) do: 
		[ : each | 
		message := filterPanel addMessageNamed: each.
		(each endsWith: 'Named:') ifTrue: 
			[ parameterHolder := message firstParameterHolder.
			parameterHolder evaluator: MauiStringEvaluator ] ].
	#(
		#addCommonBehaviorForClass:
		#addSuperclassHierarchy:
		#addSubclassHierarchy:
		#addClassHierarchy:
		#addClassesNamed:
	) do: 
		[ : each | 
		message := filterPanel addMessageNamed: each.
		(each endsWith: 'Named:') ifTrue: 
			[ parameterHolder := message firstParameterHolder.
			parameterHolder evaluator: MauiStringEvaluator ] ]! !

!MauiBehaviorFinderMorph methodsFor: 'view' stamp: 'cmm 2/13/2009 14:25'!
initializeSubmorphs
	| mainPanel menuPane menuBar listInvocationStrategy miscPanel methodsMsg |
	super initializeSubmorphs.
	mainPanel := self addPanel: (self newPanel
			listDirection: #leftToRight ;
			yourself).
	menuPane := mainPanel addPanel: self newPanel.
	menuBar := menuPane addPanel: (self newPanel listDirection: #leftToRight).
	"Add tabs to menuBar"
	menuBar
		addTab: 'Action'
			view: #actionPane ;
		addTab: 'Packages'
			view: #packagesPane ;
		addTab: 'Classes'
			view: #classesPane ;
		addTab: 'Categories'
			view: #categoriesPane.
	methodsMsg := menuBar 
		addTab: 'Methods --->'
		view: #methodsPane.
	(methodsMsg selectStrategy: MauiAutoInvocationStrategy) postInvokeAction: #selectClickedStrategy.
	mainPanel addPanel: menuPane.
	listInvocationStrategy := (mainPanel addMessageNamed: #sortedMethods)
		hideLabels ;
		selectStrategy: MauiAutoInvocationStrategy.
	listInvocationStrategy resultView: #panel.
	miscPanel := self newPanel
		listDirection: #leftToRight ;
		cellPositioning: #leftCenter ;
		addCaseSensitivitySetting ;
		addCopyMessage.
	self
		addPanel: mainPanel ;
		addPanel: miscPanel ;
		view: #panel! !

!MauiBehaviorFinderMorph methodsFor: 'view' stamp: 'cmm 3/12/2010 17:08'!
methodsPane
	"Methods pane"
	| parameterHolder addPane removePane |
	removePane := self addPanel: self newPanel.
	addPane := self addPanel: self newPanel.
	#(
		#selectMethodsWithNamesContaining:
		#rejectMethodsWithNamesContaining:
		#selectMethodsNamed:
		#rejectMethodsNamed:
		#selectMethodsSending:
		#rejectMethodsSending:
		#selectMethodsWithStringLiteral:
		#rejectMethodsWithStringLiteral:
		#selectMethodsReferencing:
		#selectPublicMethods
		#selectPrivateMethods
		#selectMethodsAuthoredBy:
		#rejectMethodsAuthoredBy:
		#selectMethodsContainingString:
		#rejectMethodsContainingString:
		#selectMethodsWithUnimplementedSends
		#selectUnsentMethods
		#selectMethodsReferencingSuper
	) do: 
		[ : each | 
		parameterHolder := (removePane addMessageNamed: each) firstParameterHolder.
		parameterHolder ifNotNil: [ parameterHolder evaluator: MauiSmalltalkEvaluator ] ].
	#(
		#addMethodsWithNamesContaining:
		#addMethodsNamed:
		#addMethodsReferencing:
		#addMethodsSending:
		#addMethodsWithStringLiteral:
	) do: 
		[ : each | 
		parameterHolder := (addPane addMessageNamed: each) firstParameterHolder.
		parameterHolder ifNotNil: [ parameterHolder evaluator: MauiSmalltalkEvaluator ] ]! !

!MauiBehaviorFinderMorph methodsFor: 'view' stamp: 'cmm 12/4/2008 22:19'!
packagesPane
	"Packages pane."
	self clear.
	(self addMessageNamed: #packages) invocationStrategy resultView: #panel.
	self addMessageNamed: #removePackage:.
	#(#addPackagesWithNamesBeginning: #addPackagesWithNamesContaining: ) do: 
		[ : each | 
		| parameterHolder |
		parameterHolder := (self addMessageNamed: each) firstParameterHolder.
		parameterHolder evaluator: MauiStringEvaluator ].
	self view: #packagesPane! !

!MauiBehaviorFinderMorph methodsFor: 'view' stamp: 'cmm 2/18/2009 14:06'!
refreshData
	initiallyRefreshed == true ifFalse: 
		[ | msg |
		super refreshData.
		self mauiEnsureOnScreen.
		msg := self messageNamed: #selectMethodsWithNamesContaining:.
		msg ifNotNil: [ ActiveHand newKeyboardFocus: msg firstParameterHolder ].
		initiallyRefreshed := true ]! !

!MauiBehaviorFinderMorph methodsFor: 'copying' stamp: 'cmm 2/18/2009 14:06'!
veryDeepInner: aDeepCopier 
	super veryDeepInner: aDeepCopier.
	initiallyRefreshed := false! !

MauiDomainMorph subclass: #MauiBooleanMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Morphs'!

!MauiBooleanMorph methodsFor: 'as yet unclassified' stamp: 'cmm 9/10/2007 17:10'!
folderIcon
	self
		clear ;
		beTransparent ;
		extent: 16@16.
	self object addMauiFolderIconTo: self! !

MauiDomainMorph subclass: #MauiClientProcessMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Morphs'!

!MauiClientProcessMorph methodsFor: 'private' stamp: 'cmm 4/6/2013 15:32'!
addCompactProgress
	self addProgressorView: #panel! !

!MauiClientProcessMorph methodsFor: 'private' stamp: 'cmm 4/4/2013 18:31'!
addControlButtons
	| panel |
	panel := (self addPanel: self newPanel)
		 listDirection: #leftToRight ;
		 yourself.
	#(#pause #resume #stop )
		with: #(#pauseIcon #playIcon #stopIcon )
		do:
			[ : eachSelector : eachIcon | ((panel addMessageNamed: eachSelector)
				labelAt: 1
				put: (MauiIconSet new perform: eachIcon) ;
				 yourself) invocationStrategy selectNoResultTarget ]! !

!MauiClientProcessMorph methodsFor: 'private' stamp: 'cmm 4/6/2013 15:33'!
addDetailedProgress
	"This is same as compact except we use the #details view of the progressor."
	self addProgressorView: #detailedProgress! !

!MauiClientProcessMorph methodsFor: 'private' stamp: 'cmm 4/6/2013 16:04'!
addDetailsOption
	| msg |
	msg := self addMessageNamed: #yourself.
	msg
		labelAt: 1
		put: '...'.
	(msg selectStrategy: MauiClickedInvocationStrategy) resultView: #details.
	msg resultHolderMorph: self! !

!MauiClientProcessMorph methodsFor: 'private' stamp: 'cmm 4/4/2013 22:17'!
addDetailsPanel
	| msg |
	msg := self addMessageNamed: #yourself.
	msg hideLabels.
	(msg selectStrategy: MauiAutoInvocationStrategy) resultView: #details! !

!MauiClientProcessMorph methodsFor: 'private' stamp: 'cmm 11/20/2007 17:01'!
addPrioritySelector
	| setter |
	setter := (self addMessageNamed: #prioritySelection) asGetterSetter.
	setter firstParameterHolder
		optionalParametersStrategy: MauiClickAndPickParameterStrategy new ;
		optionalParametersMorph: self clientProcess mauiClientProcessPriorities asMauiMorph! !

!MauiClientProcessMorph methodsFor: 'private' stamp: 'cmm 4/6/2013 16:00'!
addProgressDetails
	"This is same as compact except we use the #details view of the progressor."
	self addProgressorView: #details! !

!MauiClientProcessMorph methodsFor: 'private' stamp: 'cmm 4/6/2013 15:32'!
addProgressorView: view
	"This is same as compact except we use the #details view of the progressor."
	(((self addMessageNamed: #progressor)
		 hideLabels ;
		 yourself) selectStrategy: MauiAutoInvocationStrategy) resultView: view! !

!MauiClientProcessMorph methodsFor: 'accessing' stamp: 'cmm 11/20/2007 15:08'!
clientProcess
	^ self object! !

!MauiClientProcessMorph methodsFor: 'view' stamp: 'cmm 4/6/2013 15:44'!
console
	"A view which shows all available progress information, along with control buttons."
	self
		 clear ;
		 addDetailedProgress ;
		 addControlButtons ;
		 view: #console! !

!MauiClientProcessMorph methodsFor: 'view' stamp: 'cmm 4/6/2013 16:03'!
details
	"Shows just the progress message, rate message, and time remaining.  Intended to be the result of the details-option of the compactProgress view."
	self
		clear ;
		addProgressDetails ;
		addControlButtons ;
		view: #details! !

!MauiClientProcessMorph methodsFor: 'view' stamp: 'cmm 4/4/2013 22:07'!
expanded
	"A view which shows all available progress information, along with control buttons."
	! !

!MauiClientProcessMorph methodsFor: 'view' stamp: 'cmm 4/6/2013 16:09'!
initializeSubmorphs
	| innerPanel |
	innerPanel := self addPanel: self newPanel.
	(innerPanel overridden: #embeddedDomainMorph) borderWidth: 0.
	super initializeSubmorphs.
	innerPanel
		listDirection: #leftToRight ;
		addCompactProgress ;
		addDetailsOption.
	(innerPanel messageNamed: #yourself) resultHolderMorph: self.
	self labelString: self clientProcess name! !

MauiDomainMorph subclass: #MauiCollectionMorph
	instanceVariableNames: 'pane scrollBar elementsView startIndex elementHeight paneAndScrollerHolder priorExtent morphsByObject redrawQueued headingMorphs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Morphs'!

!MauiCollectionMorph commentStamp: 'cmm 8/14/2007 16:19' prior: 0!
I render Collections by displaying a portion of them at a time next to a ScrollBar.  The user may operate my scrollBar to indicate which part of the collection he wishes to see.  The height of each element must be equal for the scrollBar dimensions to be calculated correctly.!

!MauiCollectionMorph methodsFor: 'heading' stamp: 'cmm 6/20/2012 11:04'!
addHeadingSplittersTo: aMauiDomainMorph 
	"Add splitters."
	| count |
	count := aMauiDomainMorph submorphs size.
	aMauiDomainMorph submorphs withIndexDo:
		[ : each : index | index < count ifTrue:
			[ aMauiDomainMorph
				addPaneVSplitterBetween: each
				and:
					(aMauiDomainMorph submorphs
						copyFrom: index + 1
						to: count) ] ].
	aMauiDomainMorph linkSubmorphsToSplitters! !

!MauiCollectionMorph methodsFor: 'private' stamp: 'cmm 5/3/2009 21:44'!
addToListFrom: startElementIndex to: stopElementIndex 
	startElementIndex 
		to: stopElementIndex
		do: 
			[ : n | 
			| objectN morphN |
			objectN := self collection 
				at: n
				ifAbsent: [ ^ self ].
			morphN := self newListEntryMorphFor: objectN.
			morphN hResizing: #shrinkWrap.
			self 
				enter: morphN
				pane: self
				at: n ]! !

!MauiCollectionMorph methodsFor: 'pane morph' stamp: 'cmm 12/2/2007 23:41'!
allElementsHeight
	^ self elementHeight 
		ifNil: [ 0 ]
		ifNotNil: [ self elementHeight * self collection lastKnownSize ]! !

!MauiCollectionMorph methodsFor: 'pane morph' stamp: 'cmm 4/29/2009 17:41'!
allRows
	"Include the headingMorph in my rows if I have one."
	^ self headingRows , self paneRows! !

!MauiCollectionMorph methodsFor: 'menu' stamp: 'cmm 5/24/2007 12:51'!
buildContextMenu
	| menu |
	menu := super buildContextMenu.
	self mauiWorld userStrategy 
		appendCollectionMenuItemsTo: menu
		for: self.
	^ menu! !

!MauiCollectionMorph methodsFor: 'pane morph' stamp: 'cmm 4/29/2009 14:18'!
canOptimizeListSpec
	"We can only properly optimize the list width if all auto-invoking messages with local results have been invoked and have a result.  If there are auto-invoking messages that want local results, but don't have any, answer false."
	self allRows do: 
		[ : each | 
		each isMauiDomainMorph ifTrue: 
			[ each messageMorphsDo: 
				[ : eachMm | 
				eachMm invocationStrategy isSuitableForGetter ifTrue: [ eachMm hasResult ifFalse: [ ^ false ] ] ] ] ].
	^ true! !

!MauiCollectionMorph methodsFor: 'private' stamp: 'cmm 5/6/2010 21:00'!
checkElementHeight
	"Not sure why, elementHeight is sometimes computed incorrectly during building."
	self pane submorphs ifNotEmpty: 
		[ ((self pane submorphs detectMax: [ : each | each height ]) height+1) = elementHeight ifFalse: 
			[ elementHeight := nil.
			self elementHeight ] ]! !

!MauiCollectionMorph methodsFor: 'view' stamp: 'cmm 6/15/2009 19:59'!
clear
	super clear.
	self isFullListView: false! !

!MauiCollectionMorph methodsFor: 'accessing' stamp: 'cmm 5/29/2007 13:33'!
collection
	^ self object! !

!MauiCollectionMorph methodsFor: 'heading' stamp: 'cmm 8/22/2012 22:41'!
createSortableColumn: columnIndex using: paneRowMorph 
	"Answer a newPanel L2R with label and another newPanel T2B containing the ascending/descending sort by"
	| col buttons ascendingMsg descendingMsg attr lbl |
	col := self newPanel
		 listDirection: #leftToRight ;
		 hResizing: #spaceFill ;
		 vResizing: #spaceFill ;
		 cellPositioning: #bottomLeft.
	(col overridden: #domainMorph)
		 layoutInset: -1 @ 0 ;
		 cellInset: 0 ; borderWidth: 0.
	(col overridden: #embeddedDomainMorph)
		 layoutInset: -1 @ 0 ;
		 cellInset: 0 ;
		 borderWidth: 0.
	(col overridden: #blockMorph)
		 borderColor: Color transparent ;
		 color: Color transparent ;
		 layoutInset: 0.
	buttons := self newPanel
		 listDirection: #topToBottom ;
		 beInvisible ;
		 yourself.
	(buttons overridden: #domainMorph)
		 cellInset: 0 ; borderWidth: 0.
	(buttons overridden: #embeddedDomainMorph)
		 cellInset: 0 ; borderWidth: 0.
"	(buttons overridden: #messageMorph)
		 borderColor: Color transparent ;
		 color: Color transparent ;
		 layoutInset: (0@ -1).
"	attr := paneRowMorph object mauiSortableColumns at: columnIndex.
	ascendingMsg := (MauiBlock
		receiver: self collection
		block:
			[ : aCollection | aCollection
				sortBy: attr
				ascending: true ]) asMauiMorphFor: self.
	ascendingMsg
		labelAt: 1
		put: (self preferred: #iconSet) ascendingSort.
	(ascendingMsg overridden: #blockMorph) layoutInset: 0.
	ascendingMsg invocationStrategy selectNoResultTarget.
	descendingMsg := (MauiBlock
		receiver: self collection
		block:
			[ : aCollection | aCollection
				sortBy: attr
				ascending: false ]) asMauiMorphFor: self.
	descendingMsg
		labelAt: 1
		put: (self preferred: #iconSet) descendingSort.
	(descendingMsg overridden: #blockMorph) layoutInset: 0.
	descendingMsg invocationStrategy selectNoResultTarget.
	buttons
		 addMessage: ascendingMsg ;
		 addMessage: descendingMsg.
	col
		 addPanel: buttons ;
		 addMorphBack: (self createLabel: (lbl:=(paneRowMorph submorphs at: columnIndex) mauiLabelString)) ;
		 setBalloonText: lbl.
	^ col! !

!MauiCollectionMorph methodsFor: 'events and overrides' stamp: 'cmm 10/4/2007 22:12'!
customize: aMauiMessageMorph 
	| receiverMorph |
	super customize: aMauiMessageMorph.
	"Only do automatic adjustment for the default view, if the user has her own view, she would have laid out aMauiMessageMorph the way she wants."
	(receiverMorph := aMauiMessageMorph receiverMorph)
		ifNotNil: 
			[ ((receiverMorph isCustomLayout not and: [ self view = #panel ]) and: [ aMauiMessageMorph resultMorph owner == aMauiMessageMorph ]) ifTrue: [  aMauiMessageMorph listDirection: #topToBottom ] ]! !

!MauiCollectionMorph methodsFor: 'view' stamp: 'cmm 4/18/2014 14:01'!
defaultListEntry
	"List up to my first 100 objects horizontally in a proportionally-spaced row."
self maMarked: 'delete'.
	self
		clear ;
		asListEntry ;
		view: #defaultListEntry.
	"Use #word for the default elementsView."
	elementsView = #defaultListEntry ifTrue: [ elementsView := #word ].
	pane := nil.
	self 
		addToListFrom: 1
		to: 100
"Removed call to set isFullListView: because it causes #refreshData to do too much."! !

!MauiCollectionMorph methodsFor: 'pane morph' stamp: 'cmm 12/15/2008 20:59'!
elementCapacity
	^ self elementHeight ifNotNil: 
		[ ((self pane height min: self height - (self maVerticalLayoutInset * 2) - (self borderWidth * 2)) / self elementHeight truncateTo: 1) ]! !

!MauiCollectionMorph methodsFor: 'pane morph' stamp: 'cmm 7/26/2010 14:18'!
elementHeight
	(elementHeight isNil and: [ self collection lastKnownSize > 0 ]) ifTrue: 
		[ self pane submorphs in: 
			[ : paneSubmorphs | 
			paneSubmorphs ifNotEmpty: 
				[ [ paneSubmorphs first hasUnfinishedInvocations ] whileTrue: 
					[ paneSubmorphs first messageMorphsDo: 
						[ : each | 
						each invocationStrategy isSuitableForGetter ifTrue: [ each invokeIfPossible ] ] ].
				"This next line fixes the bug where height is not calculated correctly, leading to the crazy stepping-bigger-and-bigger bug."
				paneSubmorphs first doLayoutIn: paneSubmorphs first layoutBounds.
				elementHeight := (paneSubmorphs detectMax: [ : e | e height ]) height + 1.
"				self optimizePaneSize" ] ] ].
	^ elementHeight! !

!MauiCollectionMorph methodsFor: 'accessing' stamp: 'cmm 3/17/2008 22:01'!
elementsView
	^ elementsView! !

!MauiCollectionMorph methodsFor: 'view' stamp: 'cmm 5/3/2009 21:46'!
elementsView: aString 
	elementsView := aString.
	self hasPane 
		ifTrue: 
			[ elementHeight := nil.
			self pane removeAllMorphs.
			self
				initializeMorphsByObject ;
				scheduleRedraw ]
		ifFalse: 
			[ self isFullListView ifTrue: 
				[ self
					removeAllMorphs ;
					perform: view ] ]! !

!MauiCollectionMorph methodsFor: 'heading' stamp: 'cmm 7/1/2012 14:58'!
embedHeadingMorph: aMauiDomainMorph 
	(self nearestHeadingHolderFor: aMauiDomainMorph)
		ifNil:
			[ MauiUserError signalPage:
				(MauiPage streamContents:
					[ : stream | stream
						 nextPut: aMauiDomainMorph ;
						 nextPutAll: ' could not be embedded as a header in the expected places.' ]) ]
		ifNotNilDo:
			[ : holder | aMauiDomainMorph hResizing: #rigid.
			holder
				addPanel: aMauiDomainMorph
				at: 1.
			headingMorphs := headingMorphs
				ifNil: [ Array with: aMauiDomainMorph ]
				ifNotNil: [ headingMorphs copyWith: aMauiDomainMorph ] ]! !

!MauiCollectionMorph methodsFor: 'accessing' stamp: 'cmm 11/7/2007 16:59'!
endIndex
	^ self elementCapacity in: 
		[ : cap | 
		cap 
			ifNil: [ 0 ]
			ifNotNil: [ startIndex + self elementCapacity - 1 ] ]! !

!MauiCollectionMorph methodsFor: 'pane morph' stamp: 'cmm 6/26/2007 16:55'!
ensurePane
	(submorphs includes: self pane) ifFalse: 
		[ self initializePaneAndScrollerHolder.
		paneAndScrollerHolder addMorphBack: self pane.
		self vResizing: #rigid ]! !

!MauiCollectionMorph methodsFor: 'pane morph' stamp: 'cmm 4/18/2014 14:03'!
enter: aMauiMorph pane: paneMorph at: indexPosition 
	aMauiMorph isMauiDomainMorph ifTrue: 
		[ aMauiMorph
			pickee: pickee ;
			notificationHandler: self notificationHandler ;
			borderWidth: 1.
		aMauiMorph producedView ifNil: [ aMauiMorph producedView: aMauiMorph object mauiDefaultView ] ].
	paneMorph 
		addMorph: aMauiMorph
		asElementNumber: indexPosition! !

!MauiCollectionMorph methodsFor: 'Morphic' stamp: 'cmm 11/27/2007 16:51'!
externalName
	^ self statusString ! !

!MauiCollectionMorph methodsFor: 'heading' stamp: 'cmm 7/1/2012 15:33'!
generateHeading
	| answer mostColumns |
	answer := (object asMauiMorphFor: self) clear.
	answer cellPositioning: #bottomLeft.
	mostColumns := self paneRows notEmpty ifTrue: 
		[ self paneRows detectMax:
			[ : eachRow | eachRow submorphs size ] ].
	mostColumns ifNotNil:
		[ 1
			to: mostColumns submorphs size
			do:
				[ : n | answer
					addColumn: n
					using: mostColumns ] ].
	^ answer! !

!MauiCollectionMorph methodsFor: 'pane morph' stamp: 'cmm 6/27/2007 11:12'!
hasPane
	^ pane notNil and: [ pane world notNil ]! !

!MauiCollectionMorph methodsFor: 'scrollbar' stamp: 'cmm 5/25/2007 15:13'!
hasScrollBar
	^ scrollBar notNil and: [ scrollBar isInWorld ]! !

!MauiCollectionMorph methodsFor: 'heading' stamp: 'cmm 6/8/2009 22:23'!
headingMorph
	^ headingMorphs isEmptyOrNil ifFalse: [ headingMorphs anyOne ]! !

!MauiCollectionMorph methodsFor: 'heading' stamp: 'cmm 6/21/2012 14:29'!
headingMorph: aMauiDomainMorph 
	"99% of the time, a single headingMorph is sufficient.  Therefore, this api is for setting/deleting a single headingMorph."
	| newHeadingMorph |
	(headingMorphs notNil and: [ headingMorphs includes: aMauiDomainMorph ]) ifTrue: [ ^ self ].
	"Allow easy replacement if it is still local, otherwise embed it before my 'pane'."
	newHeadingMorph := (aMauiDomainMorph isNil or: [ aMauiDomainMorph isLikeListEntry ]) 
		ifTrue: [ aMauiDomainMorph ]
		ifFalse: [ aMauiDomainMorph asListEntry ].
	headingMorphs isEmptyOrNil 
		ifTrue: 
			[ newHeadingMorph ifNotNil: [ self embedHeadingMorph: newHeadingMorph ] ]
		ifFalse: 
			[ | existingHeadingMorph |
			existingHeadingMorph := headingMorphs anyOne.
			newHeadingMorph 
				ifNil: [ headingMorphs do: [ : each | each delete ]. headingMorphs:=nil ]
				ifNotNil: 
					[ (self isLocal: existingHeadingMorph) 
						ifTrue: 
							[ existingHeadingMorph owner 
								replaceSubmorph: existingHeadingMorph
								by: newHeadingMorph.
							headingMorphs at: (headingMorphs indexOf: existingHeadingMorph) put: newHeadingMorph ]
						ifFalse: [ self embedHeadingMorph: newHeadingMorph ] ] ].
	newHeadingMorph 
		ifNil: [ headingMorphs := nil ]
		ifNotNil: 
			[ newHeadingMorph hResizing: 
				((newHeadingMorph allOwners includes: self) 
					ifTrue: 
						[ "my child"
						#spaceFill ]
					ifFalse: [ #rigid ]) ]! !

!MauiCollectionMorph methodsFor: 'pane morph' stamp: 'cmm 6/8/2009 22:22'!
headingRows
	^ headingMorphs 
		ifNil: [ Array new ]
		ifNotNil: [ headingMorphs ]! !

!MauiCollectionMorph methodsFor: 'heading' stamp: 'cmm 6/8/2009 22:14'!
heightOfLocalHeading
	^ headingMorphs 
		ifNil: [ 0 ]
		ifNotNil: 
			[ headingMorphs 
				inject: 0
				into: [ : sum : each | sum + each height + (self cellInset * 2) ] ]! !

!MauiCollectionMorph methodsFor: 'scrollbar' stamp: 'cmm 12/2/2007 23:41'!
hideOrShowScrollBars
	"My scrollBar requires a model.  I am that model.  As the model, I must respond to this message."
	"don't blow up"
	self elementHeight ifNil: [ ^ self ].
	(self collection isMauiPrototype not and: [ self elementHeight * self collection lastKnownSize > self pane height ]) 
		ifTrue: [ self showScrollBar ]
		ifFalse: [ self hideScrollBar ]! !

!MauiCollectionMorph methodsFor: 'scrollbar' stamp: 'cmm 6/26/2007 12:54'!
hideScrollBar
	scrollBar ifNotNil: [ scrollBar delete ].
	startIndex := 1! !

!MauiCollectionMorph methodsFor: 'view' stamp: 'cmm 6/15/2009 19:45'!
horizontalListView
	"List up to my first 100 objects horizontally."
	self
		clear ;
		layoutPolicy: TableLayout new ;
		listDirection: #leftToRight ;
		cellPositioning: #center ;
		hResizing: #shrinkWrap ;
		vResizing: #shrinkWrap ;
		view: #horizontalListView.
	pane := nil.
	self 
		addToListFrom: 1
		to: 100.
	self isFullListView: true! !

!MauiCollectionMorph methodsFor: 'initializing' stamp: 'cmm 3/6/2008 12:58'!
initialize
	redrawQueued := false.
	super initialize.
	self extent: 56 @ 32.
	elementsView := #defaultListEntry.
	startIndex := 1.
	priorExtent := 0 @ 0.
	self initializeMorphsByObject! !

!MauiCollectionMorph methodsFor: 'initializing' stamp: 'cmm 12/29/2009 15:44'!
initializeColor
	self view = #panel 
		ifTrue: [ self fillStyle: self colorScheme contentFill copy ]
		ifFalse: [ super initializeColor ]! !

!MauiCollectionMorph methodsFor: 'initializing' stamp: 'cmm 4/25/2010 21:15'!
initializeMorphsByObject
	morphsByObject := MaObjectSerializerPreferences newWeakIdentityKeyDictionary! !

!MauiCollectionMorph methodsFor: 'initializing' stamp: 'cmm 5/29/2007 17:22'!
initializePaneAndScrollerHolder
	self addMorphBack: 
		(paneAndScrollerHolder := RectangleMorph new
			color: Color transparent ;
			name: 'paneAndScrollerHolder' ;
			borderWidth: 0 ;
			layoutPolicy: TableLayout new ;
			listDirection: #leftToRight ;
			hResizing: #spaceFill ;
			vResizing: #spaceFill)! !

!MauiCollectionMorph methodsFor: 'view' stamp: 'cmm 1/26/2008 00:14'!
initializeSubmorphs
	super initializeSubmorphs.
	self
		height: 32 ;
		ensurePane ;
		ensureNoBar! !

!MauiCollectionMorph methodsFor: 'private' stamp: 'cmm 5/3/2009 21:39'!
intersectingViews
	| uniques elementsContainer |
	uniques := Set new.
	elementsContainer := self isFullListView 
		ifTrue: [ self ]
		ifFalse: [ self pane ].
	elementsContainer submorphs do: 
		[ : each | 
		| eachViews |
		eachViews := Set new.
		each family 
			customViewsFor: each object
			do: [ : eachView | eachViews add: eachView ].
		eachViews addAll: each object mauiCodedViews.
		uniques isEmpty 
			ifTrue: [ uniques := eachViews ]
			ifFalse: [ uniques := uniques intersection: eachViews ] ].
	^ uniques asSortedCollection! !

!MauiCollectionMorph methodsFor: 'Morphic' stamp: 'cmm 6/18/2009 21:07'!
intoWorld: aWorld 
	super intoWorld: aWorld.
	"This was originally put here to improve refresh anomalies."
	aWorld ifNotNil: [ self scheduleRedraw ]! !

!MauiCollectionMorph methodsFor: 'testing' stamp: 'cmm 12/11/2008 14:41'!
isContent
	^ super isContent or: [ self view = #panel ]! !

!MauiCollectionMorph methodsFor: 'testing' stamp: 'cmm 6/15/2009 19:42'!
isFullListView
	"Answer whether my view shows the entire list (as opposed a scrolling list with a scroll-bar)."
	^ self 
		valueOfProperty: #isFullListView
		ifAbsent: [ false ]! !

!MauiCollectionMorph methodsFor: 'initializing' stamp: 'cmm 6/15/2009 19:45'!
isFullListView: aBoolean 
	self 
		setProperty: #isFullListView
		toValue: aBoolean! !

!MauiCollectionMorph methodsFor: 'private' stamp: 'cmm 3/4/2008 11:15'!
isOptimizedFor: anObject 
	^ anObject isCollection or: [ super isOptimizedFor: anObject ]! !

!MauiCollectionMorph methodsFor: 'testing' stamp: 'cmm 8/8/2012 14:12'!
isShowingMauiName
	^ self hasLabelBar! !

!MauiCollectionMorph methodsFor: 'Morphic' stamp: 'cmm 4/24/2009 15:11'!
layoutChanged
	super layoutChanged.
	"this method is called *during* a redraw.  We're only interested in our resizing behavior when it is called as a result of resizing."
	redrawQueued ifTrue: [ ^ self ].
	pane ifNotNil: 
		[ "We don't have any materialization hooks, priorExtent comes back nil on materialization; prevent a NullPointer.."
		priorExtent ifNil: [ priorExtent := -1 @ -1 ].
		"If I shrunk in vertical size, delete my last morph in my list pane to allow me to shrink."
		(self isInWorld and: [ priorExtent isNil or: [ priorExtent ~= pane extent ] ]) ifTrue: 
			[ pane extent y < priorExtent y ifTrue: [ self removeExcessListEntries ].
			self scheduleRedraw.
			priorExtent := self pane extent ] ]! !

!MauiCollectionMorph methodsFor: 'view' stamp: 'cmm 5/27/2008 17:10'!
listEditor
	"A view that allows adds and removals of objects."
	| addMessage removeMessage |
	self
		clear ;
		ensureBar ;
		view: #listEditor.
	addMessage := self addMessageNamed: #add:.
	addMessage invocationStrategy postInvokeAction: #receiverChanged.
	self addPanel: self newPanel panel.
	removeMessage := self addMessageNamed: #remove:.
	removeMessage invocationStrategy postInvokeAction: #receiverChanged! !

!MauiCollectionMorph methodsFor: 'private' stamp: 'cmm 6/16/2009 09:41'!
listHolder
	^ pane ifNil: [ self isFullListView ifTrue: [ self ] ]! !

!MauiCollectionMorph methodsFor: 'private' stamp: 'cmm 5/25/2007 15:17'!
listMorphAt: anInteger 
	^ self pane submorphs 
		at: anInteger
		ifAbsent: [ nil ]! !

!MauiCollectionMorph methodsFor: 'private' stamp: 'cmm 5/24/2007 12:40'!
listObjectAt: anInteger
	^ (self listMorphAt: anInteger) object! !

!MauiCollectionMorph methodsFor: 'view' stamp: 'cmm 4/29/2009 12:23'!
listSpec
	"An object describing the auto-generated MauiListSpec describing the columns produced by the #defaultListEntry view."
	| answer |
	answer := MauiListSpec new.
	self numberOfColumns timesRepeat: [ answer addColumn ].
	^ answer! !

!MauiCollectionMorph methodsFor: 'ma object serialization' stamp: 'cmm 4/12/2009 21:12'!
maTransientVariables
	^super maTransientVariables, #('morphsByObject')! !

!MauiCollectionMorph methodsFor: 'Morphic' stamp: 'cmm 11/12/2010 16:54'!
mauiNoteOutOfWorld
	super mauiNoteOutOfWorld.
	morphsByObject ifNotNil: [ WeakArray removeWeakDependent: morphsByObject ]! !

!MauiCollectionMorph methodsFor: 'heading' stamp: 'cmm 4/29/2009 17:13'!
nearestHeadingHolderFor: aMauiDomainMorph 
	"Answer the most-local Morph which can hold aMauiDomainMorph as a header.  It's got to be either my paneAndScrollerHolder or my owner's owner.."
	self withAllOwnersDo: 
		[ : each | 
		(each isMauiDomainMorph and: [ each object == aMauiDomainMorph object ]) ifTrue: [ ^ each ] ].
	^ nil! !

!MauiCollectionMorph methodsFor: 'pane morph' stamp: 'cmm 4/12/2009 21:05'!
newListEntryMorphFor: anObject 
	"Instantiate a new MauiMorph for anObject with a clean view if it is a coded view, because it will be rebuilt to my elementsView later."
	^ self family 
		newViewNamed: elementsView
		for: anObject! !

!MauiCollectionMorph methodsFor: 'events and overrides' stamp: 'cmm 10/14/2010 14:26'!
notificationHandler: aMaNotificationHandler 
	super notificationHandler: aMaNotificationHandler.
	pane ifNotNil:
		[ pane submorphs do:
			[ : each | each notificationHandler: self notificationHandler ] ]! !

!MauiCollectionMorph methodsFor: 'private' stamp: 'cmm 4/29/2009 13:51'!
numberOfColumns
	"In case there are different numbers of columns among my rows, treat them as a width of 0 in the rows that don't have that column."
	^ self allRows
		inject: 0
		into: [ : max : each | each submorphs size max: max ]! !

!MauiCollectionMorph methodsFor: 'accessing' stamp: 'cmm 7/4/2009 17:54'!
object: aCollection 
	headingMorphs ifNotNil: 
		[ headingMorphs do: [ : each | each object == object ifTrue: [ each object: aCollection ] ] ].
	super object: aCollection.
	(self layoutPolicy isTableLayout and: 
		[ self listDirection = #leftToRight and: [ self submorphs allSatisfy: [ : each | each isMauiDomainMorph ] ] ]) ifTrue: 
		[ "Assume we are in some kind of #horizontalListView, but it may be custom."
		aCollection isMauiPrototype 
			ifTrue: [ self submorphs do: [ : each | each object: aCollection ] ]
			ifFalse: 
				[ "We are populating this horizontalList with elements  from aCollection, which may be a different size than the one it was saved under."
				"Set the object of each submorph to the corresponding element in aCollection."
				| smCopy |
				1 
					to: (self submorphs size min: aCollection size)
					do: 
						[ : n | 
						(self submorphs at: n)
							object: (aCollection at: n) ;
							notificationHandler: self notificationHandler ].
				"Add in any additional morphs if we are short submorphs."
				self 
					addToListFrom: self submorphs size + 1
					to: aCollection size.
				"Delete any further submorphs."
				smCopy := self submorphs copy.
				aCollection size + 1 
					to: smCopy size
					do: [ : n | (smCopy at: n) delete ] ] ]! !

!MauiCollectionMorph methodsFor: 'pane morph' stamp: 'cmm 1/17/2008 06:17'!
optimizeColumnWidths
	self 
		startStepping: #optimizeListSpecIfPossible
		at: Time millisecondClockValue
		arguments: #()
		stepTime: 2100! !

!MauiCollectionMorph methodsFor: 'pane morph' stamp: 'cmm 6/20/2012 14:25'!
optimizeListSpec
	"Optimize the column-widths of each row and my userRows.  Each column width is apportioned according to the total-width the all data-values in each column relative to the total width of all data presented."
	self numberOfColumns = 0 ifTrue: [ ^ self ].
	self optimizedListSpec in:
		[ : listSpec | self allRows do:
			[ : each | listSpec adjustColumnsWidthsIn: each ].
		self optimizeWidthUsing: listSpec.
		headingMorphs ifNotNil:
			[ headingMorphs do:
				[ : each | each width: self width.
				each mergedColumns ifNotNilDo:
					[ : eachArray | | numberOfRemovedColumns mergedListSpec |
					numberOfRemovedColumns := 0.
					mergedListSpec := eachArray
						inject: listSpec
						into:
							[ : nextMerged : eachRange | | merged |
							merged := nextMerged copyMerged: (eachRange first - numberOfRemovedColumns to: eachRange last - numberOfRemovedColumns).
							numberOfRemovedColumns := numberOfRemovedColumns + eachRange size - 1.
							merged ].
					mergedListSpec adjustColumnsWidthsIn: each ] ] ].
"		headingMorphs isEmptyOrNil ifFalse: [ self addHeadingSplittersTo: headingMorphs first ]" ]! !

!MauiCollectionMorph methodsFor: 'pane morph' stamp: 'cmm 1/17/2008 08:16'!
optimizeListSpecIfPossible
	self canOptimizeListSpec ifTrue: 
		[ self
			optimizeListSpec ;
			stopSteppingSelector: #optimizeListSpecIfPossible ]! !

!MauiCollectionMorph methodsFor: 'pane morph' stamp: 'cmm 12/24/2009 16:38'!
optimizePaneSize
	| world targetPaneHeight |
	world := self world.
	world ifNil: [ ^ self ].
	targetPaneHeight := world height // 3 min: self allElementsHeight.
	self
		height: targetPaneHeight + ((self maVerticalLayoutInset + self borderWidth) * 2) + (self heightOf: (self submorphs copyWithout: paneAndScrollerHolder)) + self heightOfLocalHeading + 2 "for bottom-margin balance" ;
		mauiEnsureOnScreen! !

!MauiCollectionMorph methodsFor: 'pane morph' stamp: 'cmm 11/8/2009 21:48'!
optimizeWidthUsing: listSpec 
	"Impose a luxurious real-estate tax over the minimum needed, because the ratio of white to black space must not 'feel' cramped, even if all the information is visible."
	self minWidth: listSpec widths sum * 1.2! !

!MauiCollectionMorph methodsFor: 'pane morph' stamp: 'cmm 12/16/2009 21:31'!
optimizedListSpec
	"Calculate an optimized listSpec; the column-widths of my paneRows (excluding my headingRows).  Each column width is apportioned according to the total-width the all data-values in each column relative to the total width of all data presented."
	| totalWidths n numberOfRows numberOfColumns |
	numberOfColumns := self numberOfColumns.
	numberOfRows := self paneRows size.
	numberOfColumns = 0 ifTrue: 
		[ "no optimization needed"
		^ self ].
	totalWidths := Array 
		new: numberOfColumns
		withAll: 1.
	self paneRows do: 
		[ : eachRow | 
		n := 1.
		eachRow submorphs do: 
			[ : eachField | 
			totalWidths 
				at: n
				put: (totalWidths at: n) + eachField width + 10 "minimum 5-pixel margin on each side".
			n := n + 1 ] ].
	^ self listSpec in: 
		[ : ls | 
		totalWidths withIndexDo: 
			[ : each : x | 
			ls 
				widthAt: x
				put: each / (numberOfRows max: 1) asFloat ].
		ls ]! !

!MauiCollectionMorph methodsFor: 'optional parameters' stamp: 'cmm 7/12/2007 14:01'!
optionalParameters
	^ self collection ! !

!MauiCollectionMorph methodsFor: 'pane morph' stamp: 'cmm 9/10/2009 14:23'!
pane
	^ pane ifNil: 
		[ pane := RectangleMorph new
			name: 'pane' ;
			color: Color transparent;
			borderWidth: 1 ;
			borderColor: Color transparent ;
			layoutPolicy: TableLayout new ;
			listDirection: #topToBottom ;
			hResizing: #spaceFill ;
			vResizing: #spaceFill ;
			cellPositioning: #leftCenter ;
			clipSubmorphs: true ]
! !

!MauiCollectionMorph methodsFor: 'pane morph' stamp: 'cmm 4/29/2009 17:41'!
paneRows
	^ pane 
		ifNil: 
			[ {   } ]
		ifNotNil: [ pane submorphs ]! !

!MauiCollectionMorph methodsFor: 'view' stamp: 'cmm 6/15/2009 20:00'!
panel
	super panel.
	self isFullListView: false! !

!MauiCollectionMorph methodsFor: 'optional parameters' stamp: 'cmm 6/16/2009 09:42'!
pickee: aMauiParameterHolderMorph 
	super pickee: aMauiParameterHolderMorph.
	self listHolder ifNotNilDo: 
		[ : listHolder | 
		listHolder submorphsDo: [ : each | each isMauiDomainMorph ifTrue: [ each pickee: pickee ] ] ]! !

!MauiCollectionMorph methodsFor: 'pane morph' stamp: 'cmm 4/20/2010 21:08'!
populatePane
	"Update my pane with up to one page worth of Morphs.  The Morphs displayed are the ones of my collection starting at my startIndex."
	| listX collectionX elementCapacity |
	self isInWorld ifFalse: [ ^ self ].
	self pane removeAllMorphs.
	listX := 1.
	collectionX := startIndex.
	"elementCapacity will be nil the first time for a new collection-morph."
	elementCapacity := self elementCapacity.
	morphsByObject ifNil: [ self initializeMorphsByObject ].
	
	[ collectionX <= self collection lastKnownSize and: [ elementCapacity isNil or: [ listX <= elementCapacity ] ] ] whileTrue: 
		[ | listMorph currentObject cachedMorph |
		currentObject := self collection 
			at: collectionX
			ifAbsent: [ ^ self ].
		cachedMorph := morphsByObject 
			at: currentObject
			ifAbsent: [ nil ].
		(cachedMorph notNil and: [ (pane submorphs includes: cachedMorph) not ]) 
			ifTrue: 
				[ cachedMorph notificationHandler: self notificationHandler.
				self pane 
					addMorph: cachedMorph
					asElementNumber: listX ]
			ifFalse: 
				[ self 
					enter: (listMorph := self newListEntryMorphFor: currentObject)
					pane: self pane
					at: listX.
				cachedMorph ifNil: 
					[ "Now we can compute elementCapacity since we have an element and can know the elementHeight."
					elementCapacity := self elementCapacity.
					morphsByObject 
						at: currentObject
						put: listMorph ] ].
		self isInWorld ifFalse: [ ^ self ].
		listX := listX + 1.
		collectionX := collectionX + 1 ].
	"This is needed to cause the pane to layout correctly, Arrrgh!!"
	World doOneCycle.
"	self isInWorld ifTrue: [ self checkElementHeight ]."
	Sensor redButtonPressed ifFalse: [ scrollBar ifNotNil: [ scrollBar finishedScrolling ] ]! !

!MauiCollectionMorph methodsFor: 'scrollbar' stamp: 'cmm 12/8/2009 10:38'!
positionScroller
	self allElementsHeight in: 
		[ : totalHeight | 
		totalHeight = 0 ifFalse: 
			[ | elementPercentage pagePercentage |
			elementPercentage := self elementHeight / totalHeight asFloat.
			pagePercentage := self elementCapacity / self collection lastKnownSize asFloat.
			self scrollBar
				scrollDelta: elementPercentage
					pageDelta: pagePercentage ;
				interval: pagePercentage ;
				value: startIndex / self collection lastKnownSize asFloat ] ]! !

!MauiCollectionMorph methodsFor: 'initializing' stamp: 'cmm 8/2/2008 13:09'!
postInitialize
	super postInitialize.
	self refresh! !

!MauiCollectionMorph methodsFor: 'private' stamp: 'cmm 7/23/2008 22:59'!
refresh
	self
		initializeMorphsByObject ;
		scheduleRedraw! !

!MauiCollectionMorph methodsFor: 'events and overrides' stamp: 'cmm 6/18/2009 21:08'!
refreshData
	super refreshData.
	view = #panel 
		ifTrue: [ self scheduleRedraw ]
		ifFalse: 
			[ self isFullListView ifTrue: 
				[ submorphs copy do: [ : each | each delete ].
				self 
					addToListFrom: 1
					to: 100 ] ]! !

!MauiCollectionMorph methodsFor: 'heading' stamp: 'cmm 10/9/2012 22:01'!
regenerateHeading
	"Generate a new heading and add it above the list, first removing any existing headingMorphs."
	self
		 headingMorph: nil ;
		 headingMorph: self generateHeading.
	priorExtent := nil.
	self layoutChanged! !

!MauiCollectionMorph methodsFor: 'Morphic' stamp: 'cmm 4/29/2009 19:17'!
removeExcessListEntries
	pane ifNil: [ ^ self ].
	[ pane submorphs notEmpty and: [ pane submorphs last bottom > self bottom ] ] whileTrue: 
		[ pane submorphs last delete.
		self doLayoutIn: self bounds ]! !

!MauiCollectionMorph methodsFor: 'scrollbar' stamp: 'cmm 7/26/2010 14:19'!
resetScrollBar
	self collection isMauiPrototype ifFalse: 
		[ self
			hideOrShowScrollBars ;
			positionScroller ].
	"Without this, slider does not draw correctly upon entering world."
	self hasScrollBar ifTrue: [ WorldState addDeferredUIMessage: [ self scrollBar expandSlider ] ]! !

!MauiCollectionMorph methodsFor: 'pane morph' stamp: 'cmm 7/26/2010 14:57'!
scheduleRedraw
	(view = #panel and: 
		[ "redrawQueued not" true and: [ self isInWorld and: [ self collection isMauiPrototype not ] ] ]) ifTrue: 
		[ redrawQueued := true.
		WorldState addDeferredUIMessage: 
			[ 
			[ self
				populatePane ;
				optimizeColumnWidths ;
				optimizePaneSize.
			self resetScrollBar ] ensure: [ redrawQueued := false ] ] ]! !

!MauiCollectionMorph methodsFor: 'scrollbar' stamp: 'cmm 11/7/2007 15:57'!
scrollBar
	^ scrollBar ifNil: 
		[ scrollBar := (MauiScrollBar new 
			model: self
			slotName: 'verticalScrollBar')
			vResizing: #spaceFill ;
			yourself ]! !

!MauiCollectionMorph methodsFor: 'scrollbar' stamp: 'cmm 5/29/2007 17:30'!
showScrollBar
	(paneAndScrollerHolder submorphs includes: self scrollBar) ifFalse: [ paneAndScrollerHolder addMorphBack: self scrollBar ]! !

!MauiCollectionMorph methodsFor: 'accessing' stamp: 'cmm 12/2/2007 23:42'!
statusString
	^ String streamContents: 
		[ : stream | 
		| size |
		size := self collection lastKnownSize.
		stream
			maPrint: startIndex ;
			maPrint: ' to ' ;
			maPrint: (self endIndex min: size) ;
			maPrint: ' of ' ;
			maPrint: size ]! !

!MauiCollectionMorph methodsFor: 'Morphic' stamp: 'cmm 5/6/2010 20:47'!
step
	super step.
	self hasPane ifTrue: 
		[ self
			checkElementHeight ;
			removeExcessListEntries ;
			resetScrollBar ]! !

!MauiCollectionMorph methodsFor: 'events and overrides' stamp: 'cmm 7/26/2010 14:52'!
update: dummy 
	super update: dummy.
	self mauiWorld rehashPlayers.
	self refreshData! !

!MauiCollectionMorph methodsFor: 'view' stamp: 'cmm 6/7/2009 21:10'!
verticalList
	"List up to my first 100 objects vertically."
	self
		horizontalListView ;
		listDirection: #topToBottom ;
		view: #verticalList ;
		hResizing: #shrinkWrap! !

!MauiCollectionMorph methodsFor: 'scrollbar' stamp: 'cmm 1/24/2008 11:28'!
verticalScrollBarValue: aFloat 
	| priorStartIndex |
	self maMarked: 'magic'.
	"This method is called by my scrollBar with aFloat between 0.0 and 1.0.  Set my startIndex appropriately after the set up in #initializeScrollBar."
	priorStartIndex := startIndex.
	startIndex := (scrollBar sliderTop * self collection lastKnownSize roundTo: 1) max: 1.
	priorStartIndex = startIndex ifFalse: [ self scheduleRedraw ]! !

!MauiCollectionMorph methodsFor: 'copying' stamp: 'cmm 10/28/2011 15:41'!
veryDeepFixupWith: aDeepCopier 
	super veryDeepFixupWith: aDeepCopier.
	"The headingMorph might have been residing in one of my parent-morphs.  *If* that parent morph was also copied as part of this copy, we can point my headingMorph at the new one, otherwise, we can't copy the headingMorph because it was for a different object."
	headingMorphs ifNotNil: 
		[ headingMorphs do: 
			[ : each | 
			aDeepCopier references 
				at: each
				ifPresent: 
					[ : copiedHeadingMorph | 
					headingMorphs 
						at: (headingMorphs indexOf: each)
						put: copiedHeadingMorph ]
				ifAbsent: [ ^ self headingMorph: nil ] ] ]! !

!MauiCollectionMorph methodsFor: 'copying' stamp: 'cmm 7/15/2013 10:39'!
veryDeepInner: aDeepCopier 
	super veryDeepInner: aDeepCopier.
	pane := pane veryDeepCopyWith: aDeepCopier.
	pane ifNotNil: [ pane removeAllMorphs ].
	self isFullListView ifTrue: [ self removeAllMorphs ].
	self initializeMorphsByObject.
	scrollBar := scrollBar veryDeepCopyWith: aDeepCopier.
	paneAndScrollerHolder := paneAndScrollerHolder veryDeepCopyWith: aDeepCopier.
	redrawQueued := false.
	"Just a shallow copy for now for headingMorphs.  See #veryDeepFixupWith:."
	headingMorphs := headingMorphs copy.
	"Tired of the scroll-bar position starting half-way down just because that's where it was when the view was saved."
	startIndex := 1! !

MauiDomainMorph subclass: #MauiColorMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Morphs'!

!MauiColorMorph commentStamp: 'cmm 7/3/2007 11:16' prior: 0!
I present a simple Maui interface for a Color object.!

!MauiColorMorph methodsFor: 'view' stamp: 'cmm 12/27/2008 15:51'!
adjustTab
	#(
		#adjustSaturation:brightness:
		#alpha:
		#alphaMixed:with:
		#atLeastAsLuminentAs:
		#atMostAsLuminentAs:
		#negated
	) do: 
		[ : each | 
		| msg invocationStrategy |
		msg := self newMessageNamed: each.
		invocationStrategy := msg selectStrategy: MauiAutoInvocationStrategy.
		invocationStrategy resultView: #small.
		msg selector isUnary 
			ifTrue: [ invocationStrategy selectLocalResultTarget ]
			ifFalse: [ invocationStrategy selectHandResultTarget ].
		self addMessage: msg ].
	self view: #adjustTab! !

!MauiColorMorph methodsFor: 'view' stamp: 'cmm 12/27/2008 15:22'!
darkerTab
	#(
		#slightlyDarker
		#darker
		#twiceDarker
		#duller
		#muchDarker
		#blacker
	) do: 
		[ : each | 
		| msg |
		msg := self newMessageNamed: each.
		(msg selectStrategy: MauiAutoInvocationStrategy)
			resultView: #small ;
			selectLocalResultTarget ;
			producedView: #darkerTab.
		self addMessage: msg ].
	self view: #darkerTab! !

!MauiColorMorph methodsFor: 'view' stamp: 'cmm 1/27/2008 12:50'!
horizontalIcon
	"A rectangle of my color, with a label to the right of it.  This form consumes less vertical screen space than verticalIcon."
	self
		iconListed: #leftToRight ;
		cellInset: 2 ;
		view: #horizontalIcon! !

!MauiColorMorph methodsFor: 'view' stamp: 'cmm 12/11/2008 00:00'!
iconListed: listDirection 
	| fillBlob lbl |
	self
		clear ;
		beInvisible.
	fillBlob := self newPanel
		small ;
		producedView: #horizontalIcon ;
		borderWidth: 0 ;
		lock ;
		yourself.
	lbl := self newPanel
		word ;
		borderWidth: 0 ;
		lock.
	self
		cellPositioning: #center ;
		cellInset: 2 ;
		beInvisible ;
		listDirection: listDirection.
	self
		addPanel: fillBlob ;
		addPanel: lbl! !

!MauiColorMorph methodsFor: 'initialize' stamp: 'cmm 12/15/2008 14:06'!
initializeColor
	"For Colors, my #small view actually represents the actual color, so don't spoil that by resetting my color to the default colors."
	view = #small 
		ifTrue: [ self object isMauiPrototype ifFalse: [ self color: self object ] ]
		ifFalse: [ super initializeColor ]! !

!MauiColorMorph methodsFor: 'view' stamp: 'cmm 12/27/2008 15:22'!
lighterTab
	#(
		#slightlyLighter
		#lighter
		#twiceLighter
		#muchLighter
		#whiter
	) do: 
		[ : each | 
		| msg |
		msg := self newMessageNamed: each.
		(msg selectStrategy: MauiAutoInvocationStrategy)
			resultView: #small ;
			producedView: #lighterTab ;
			selectLocalResultTarget.
		self addMessage: msg ].
	self view: #lighterTab! !

!MauiColorMorph methodsFor: 'initialize' stamp: 'cmm 7/30/2007 11:56'!
object: aColor 
	"I'm getting a new color, but any of my morphs which reflect the current color should be updated to the new Color (aColor)."
	| oldColor |
	oldColor := self object.
	super object: aColor.
	aColor isColor ifTrue: 
		[ self color = oldColor ifTrue: [ self color: aColor ] ]! !

!MauiColorMorph methodsFor: 'view' stamp: 'cmm 12/3/2007 11:16'!
small
	self
		clear ;
		color: self object ;
		view: #small! !

!MauiColorMorph methodsFor: 'view' stamp: 'cmm 11/19/2007 10:51'!
transform
	| tabsPane |
	self view: #transform.
	tabsPane := self newPanel listDirection: #leftToRight.
	self addPanel: tabsPane.
	#(#lighterTab #darkerTab #adjustTab ) do: 
		[ : each | 
		tabsPane 
			addTab: 
				(each 
					copyFrom: 1
					to: each size - 3)
			selector: #yourself
			view: each ]! !

!MauiColorMorph methodsFor: 'view' stamp: 'cmm 7/13/2007 10:40'!
verticalIcon
	"A rectangle of my color, with a label below it."
	self
		iconListed: #topToBottom ;
		view: #verticalIcon! !

MauiDomainMorph subclass: #MauiColorPickerMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Morphs'!

!MauiColorPickerMorph methodsFor: 'view' stamp: 'cmm 1/8/2008 12:17'!
namedColors
	self
		panel ;
		listDirection: #leftToRight ;
		wrapDirection: #rightToLeft ;
		cellPositioning: #center ;
		width: World width // 4 ;
		view: #namedColors.
	self object maNamedColors do: 
		[ : each | 
		| msg |
		msg := (self newMessageNamed: each)
			borderWidth: 0 ;
			hideLabels ;
			cellPositioning: #center.
		(msg selectStrategy: MauiAutoInvocationStrategy)
			resultView: #small ;
			producedView: #verticalIcon.
		self addMessage: msg ]! !

!MauiColorPickerMorph methodsFor: 'view' stamp: 'cmm 7/13/2007 10:43'!
specifiedColor
	self
		panel ;
		listDirection: #topToBottom ;
		view: #specifiedColor.
	#(#gray: #h:s:v:alpha: #r:g:b:alpha: #random ) do: 
		[ : each | 
		| msg |
		msg := self newMessageNamed: each.
		msg invocationStrategy
			resultView: #verticalIcon ;
			producedView: #verticalIcon.
		self addMessage: msg ]! !

MauiDomainMorph subclass: #MauiColorSchemeMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Morphs'!

!MauiColorSchemeMorph methodsFor: 'initialize' stamp: 'cmm 12/3/2008 10:38'!
addColorSelectorFor: aMethodReference picker: colorPickerMorph 
	| getter setter |
	getter := self newMessageNamed: aMethodReference selector.
	getter invocationStrategy
		resultView: #horizontalIcon ;
		producedView: #horizontalIcon.
	setter := getter asGetterSetter.
	setter firstParameterHolder optionalParametersMorph: colorPickerMorph.
	self addMessage: setter! !

!MauiColorSchemeMorph methodsFor: 'initialize' stamp: 'cmm 12/10/2008 21:08'!
initializeSubmorphs
	| colorPicker |
	super initializeSubmorphs.
	colorPicker := Color asMauiMorph namedColors.
	self object accessingMethods do: 
		[ : each | 
		self 
			addColorSelectorFor: each
			picker: colorPicker ]! !

MauiDomainMorph subclass: #MauiContextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Morphs'!

MauiContextMorph subclass: #MauiCompositeContextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Morphs'!

!MauiCompositeContextMorph methodsFor: 'initializing' stamp: 'cmm 6/30/2013 16:18'!
addOutputMessages
	|  message parameterHolder |
	message := self addMessage: ((self newMessageNamed: #subcontextNamed:)
			listDirection: #topToBottom ;
			hideLabels ;
			yourself).
	message invocationStrategy selectLocalResultTarget resultView: #outputOnly.
	parameterHolder := message firstParameterHolder.
	parameterHolder
		optionalParametersMorph: (self context subcontexts collect: [ : each | each name ]) asMauiMorph horizontalListView ;
		optionalParametersStrategy: MauiListSelectionStrategy new ;
		yourself! !

!MauiCompositeContextMorph methodsFor: 'initializing' stamp: 'cmm 6/30/2013 16:19'!
initializeSubmorphs
	self
		addInputPanel ;
		addOutputMessages ;
		addCopyMessage ;
		addRefreshSourceMessage! !

!MauiContextMorph methodsFor: 'initializing' stamp: 'cmm 6/17/2008 22:54'!
addCopyMessage
	| copyMessage |
	copyMessage := self newMessageNamed: #copyForIndependentSearch.
	copyMessage invocationStrategy
		resultView: #panel ;
		producedView: nil.
	self addViewLevelUserMessage: copyMessage! !

!MauiContextMorph methodsFor: 'initializing' stamp: 'cmm 3/24/2008 12:15'!
addInputPanel
	| panel refreshMessage keywordsMessage |
	(panel := self addPanel: self newPanel)
		cellPositioning: #leftCenter ;
		listDirection: #leftToRight ;
		addMessage: ((keywordsMessage := self newMessageNamed: #keywordsString:) asGetterSetter
				labelAt: 1
					put: 'Keywords:' ;
				yourself).
	keywordsMessage firstParameterHolder evaluator: MauiStringEvaluator.
	refreshMessage := panel addMessageNamed: #refresh.
	refreshMessage invocationStrategy selectNoResultTarget! !

!MauiContextMorph methodsFor: 'initializing' stamp: 'cmm 3/7/2008 15:58'!
addNameMessage
	| message |
	message := self addMessageNamed: #name.
	message hideLabels.
	(message selectStrategy: MauiAutoInvocationStrategy)
		resultView: #word ;
		producedView: nil! !

!MauiContextMorph methodsFor: 'initializing' stamp: 'cmm 6/30/2013 16:18'!
addOutputMessages
	| resultsMessage progressMessage resultsObject resultsMorph removeMessage |
	resultsMessage := self newMessageNamed: #results.
	(resultsMessage selectStrategy: MauiAutoInvocationStrategy)
		resultView: #panel ;
		producedView: #panel.
	"Pre-load the resultMorph of resultsMessage to be a MauiCollectionMorph so it will be represented as a list."
	resultsObject := Array empty maNewSearchContext results.
	resultsMorph := Array empty asMauiMorph object: resultsObject.
	resultsMessage resultMorph: resultsMorph.
	removeMessage := self newMessageNamed: #remove:.
	removeMessage invocationStrategy selectNoResultTarget.
	progressMessage := (self newMessageNamed: #scanProcess) hideLabels.
	(progressMessage selectStrategy: MauiAutoInvocationStrategy)
		selectLocalResultTarget ;
		resultView: #panel ;
		producedView: nil.
	self
		addMessage: resultsMessage ;
		addMessage: removeMessage ;
		addMessage: progressMessage! !

!MauiContextMorph methodsFor: 'initializing' stamp: 'cmm 6/17/2008 22:54'!
addRefreshSourceMessage
	| fullRefreshMessage |
	fullRefreshMessage := self newMessageNamed: #refreshSource.
	fullRefreshMessage invocationStrategy selectNoResultTarget.
	self addViewLevelUserMessage: fullRefreshMessage! !

!MauiContextMorph methodsFor: 'initializing' stamp: 'cmm 3/7/2008 12:05'!
addSourceMessage
	| sourceMessage |
	sourceMessage := self addMessageNamed: #source.
	(sourceMessage selectStrategy: MauiAutoInvocationStrategy)
		resultView: #word ;
		producedView: nil! !

!MauiContextMorph methodsFor: 'accessing' stamp: 'cmm 7/13/2003 22:15'!
context

	^self object! !

!MauiContextMorph methodsFor: 'initializing' stamp: 'cmm 2/18/2009 14:23'!
initialKeyboardFocus
	| msg |
	msg := self messageNamed: #keywordsString:.
	msg ifNotNil: [ ActiveHand newKeyboardFocus: msg firstParameterHolder ]! !

!MauiContextMorph methodsFor: 'initializing' stamp: 'cmm 6/30/2013 16:19'!
initializeSubmorphs
	self
		addSourceMessage ;
		addInputPanel ;
		addOutputMessages ;
		addCopyMessage ;
		addRefreshSourceMessage! !

!MauiContextMorph methodsFor: 'initializing' stamp: 'cmm 6/30/2013 16:19'!
outputOnly
	"Show just the output results, not the keyword input fields."
	self
		clear ;
		addNameMessage ;
"		addSourceMessage ;"
		addOutputMessages! !

MauiDomainMorph subclass: #MauiDashboardMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Morphs'!

!MauiDashboardMorph methodsFor: 'as yet unclassified' stamp: 'cmm 11/19/2007 10:51'!
initializeSubmorphs
	| tabsPane |
	super initializeSubmorphs.
	tabsPane := self newPanel listDirection: #leftToRight.
	self addPanel: tabsPane.
	#(#packages #classes #preferences #world #registry ) do: [ : each | tabsPane addTab: each ]! !

MauiDomainMorph subclass: #MauiDirectoryEntryMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Morphs'!

MauiDirectoryEntryMorph subclass: #MauiDirectoryEntryDirectoryMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Morphs'!

!MauiDirectoryEntryDirectoryMorph methodsFor: 'as yet unclassified' stamp: 'cmm 2/9/2008 22:39'!
addAsFileDirectory
	((self addMessageNamed: #asFileDirectory) selectStrategy: MauiClickedInvocationStrategy)
		resultView: #panel ;
		producedView: nil ;
		selectHandResultTarget! !

!MauiDirectoryEntryDirectoryMorph methodsFor: 'as yet unclassified' stamp: 'cmm 10/5/2007 12:34'!
addCopyHere
	(self addMessageNamed: #copyHere:) invocationStrategy
		selectNoResultTarget ;
		producedView: nil! !

!MauiDirectoryEntryDirectoryMorph methodsFor: 'as yet unclassified' stamp: 'cmm 1/8/2008 12:18'!
addStatistics
	#(#directoryCountStat #fileCountStat ) do: 
		[ : each | 
		((self addMessageNamed: each) selectStrategy: MauiAutoInvocationStrategy) resultView: #panel ].
	(self addMessageNamed: #maTotalFileSizeString)
		selectStrategy: MauiAutoInvocationStrategy ;
		labelAt: 1
			put: 'Total Size:'! !

!MauiDirectoryEntryDirectoryMorph methodsFor: 'as yet unclassified' stamp: 'cmm 6/17/2008 22:54'!
appendAsFileDirectoryMessage
	| msg |
	msg := self newMessageNamed: #asFileDirectory.
	msg 
		labelAt: 1
		put: 'Open as a FileDirectory'.
	msg invocationStrategy
		resultView: #panel ;
		producedView: nil.
	self addViewLevelUserMessage: msg! !

!MauiDirectoryEntryDirectoryMorph methodsFor: 'as yet unclassified' stamp: 'cmm 1/20/2008 21:23'!
defaultListEntry
	super defaultListEntry appendAsFileDirectoryMessage! !

!MauiDirectoryEntryDirectoryMorph methodsFor: 'as yet unclassified' stamp: 'cmm 10/4/2007 17:04'!
initializeSubmorphs
	super initializeSubmorphs.
	self
		addStatistics ;
		addCopyHere ;
		addAsFileDirectory! !

!MauiDirectoryEntryDirectoryMorph methodsFor: 'as yet unclassified' stamp: 'cmm 10/7/2007 22:30'!
insertCopyHereFolderIcon: listEntry 
	| msg folderIcon |
	folderIcon := (self preferred: #iconSet) plainFolderIcon lock.
	msg := (listEntry newMessageNamed: #copyHere:)
		hideLabels ;
		yourself.
	msg firstParameterHolder dropMarker: ((self preferred: #iconSet) rightArrowIcon lock
			extent: folderIcon extent ;
			yourself).
	msg firstParameterHolder addMorph: folderIcon.
	msg invocationStrategy selectNoResultTarget.
	listEntry 
		addMessage: msg
		at: 1! !

MauiDirectoryEntryMorph subclass: #MauiDirectoryEntryFileMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Morphs'!

!MauiDirectoryEntryFileMorph methodsFor: 'as yet unclassified' stamp: 'cmm 6/17/2008 21:26'!
initializeSubmorphs
	| initialContentsMessage |
	super initializeSubmorphs.
	#(
		#name
		#containingDirectory
		#modificationDateAndTime
		#fileSize
	) do: [ : each | (self addMessageNamed: each) selectStrategy: MauiAutoInvocationStrategy ].
	initialContentsMessage := (self addMessageNamed: #initialContents)
		listDirection: #topToBottom ;
		yourself.
	(initialContentsMessage selectStrategy: MauiClickedInvocationStrategy) resultView: #wrapped! !

!MauiDirectoryEntryMorph methodsFor: 'as yet unclassified' stamp: 'cmm 1/20/2008 21:23'!
defaultListEntry
	| listEntry |
	listEntry := super defaultListEntry.
	self
"		insertCopyHereFolderIcon: listEntry ;"
		insertFolderIcon: listEntry! !

!MauiDirectoryEntryMorph methodsFor: 'accessing' stamp: 'cmm 11/30/2008 23:18'!
directoryEntry
	^ self object! !

!MauiDirectoryEntryMorph methodsFor: 'as yet unclassified' stamp: 'cmm 1/20/2008 21:36'!
insertFolderIcon: listEntry 
	| msg |
	msg := (listEntry newMessageNamed: #isDirectory)
		hideLabels ;
		lock ;
		yourself.
	(msg selectStrategy: MauiAutoInvocationStrategy)
		resultView: #folderIcon ;
		selectLocalResultTarget.
	listEntry 
		addMessage: msg
		at: 1! !

!MauiDomainMorph class methodsFor: 'private' stamp: 'cmm 1/27/2008 17:34'!
maNewFor: anObject 
	^ (super maNewFor: anObject)
		view: #clear ;
		initializeColor ;
		yourself! !

!MauiDomainMorph methodsFor: 'label bar' stamp: 'cmm 6/14/2007 11:01'!
addCloseBoxTo: aMorph

	aMorph
		addMorph: self createDeleteMessage
		asElementNumber: 1! !

!MauiDomainMorph methodsFor: 'menu' stamp: 'cmm 3/16/2010 11:35'!
addCodedViewsMenuTo: aMenu 
	aMenu addLine.
	self hasCodedPanelView ifTrue:
		[ aMenu addMenuItem:
			(MauiMenuItemMorph new
				 contents: 'panel' ;
				 target: self ;
				 selector: #openNewViewNamed: ;
				 arguments: {#panel}) ].
	self codedViewsDo:
		[ : each | aMenu addMenuItem:
			(MauiMenuItemMorph new
				 contents: each ;
				 target: self ;
				 selector: #openNewViewNamed: ;
				 arguments: {each}) ]! !

!MauiDomainMorph methodsFor: 'heading' stamp: 'cmm 8/22/2012 22:25'!
addColumn: columnIndex using: paneRowMorph 
	| sort exampleObject |
	exampleObject := paneRowMorph object.
	(columnIndex > exampleObject mauiSortableColumns size or: [ (sort := exampleObject mauiSortableColumns at: columnIndex) isNil ])
		ifTrue:
			[ |lbl| lbl:=(paneRowMorph submorphs at: columnIndex) mauiLabelString.
			self addMorphBack:
				((self createLabel: lbl)
					 hResizing: #spaceFill ;
					 vResizing: #spaceFill ;
					setBalloonText: lbl ;
					
					 yourself) ]
		ifFalse:
			[ self addPanel:
				(self
					createSortableColumn: columnIndex
					using: paneRowMorph) ]! !

!MauiDomainMorph methodsFor: 'menu' stamp: 'cmm 4/11/2009 18:09'!
addCustomViewsMenuTo: aMenu 
	self 
		addViewsMenuTo: aMenu
		private: false! !

!MauiDomainMorph methodsFor: 'initialize-release' stamp: 'cmm 6/23/2012 19:16'!
addDependents
	(object notNil and: [ object isMauiPrototype not ]) ifTrue:
		[ self requireChangedNotificationsForAutoRefresh ifTrue:
			[ object realObject addDependent: self.
			self messageMorphsDo: [ : each | object realObject addDependent: each ] ] ].
	self nearestOwningMauiDomainMorph ifNotNil:
		[ : owner | owner addDependents ]! !

!MauiDomainMorph methodsFor: 'menu' stamp: 'cmm 4/20/2010 21:16'!
addDeveloperViewsMenuTo: aMenu 
	aMenu addLine.
	self developerViewsDo: 
		[ : each | 
		aMenu addMenuItem: ((MauiMenuItemMorph new
				contents: each ;
				target: self ;
				selector: #openNewViewNamed: ;
				arguments: {  each  }) setBalloonText: (self class maFirstCommentOrNilAt: each)) ]! !

!MauiDomainMorph methodsFor: 'accessing' stamp: 'cmm 5/1/2009 14:51'!
addDomainMessageMorphsForThisReceiverTo: aCollection 
	self messageMorphsDo: 
		[ : each | 
		(each isMauiMessageMorph and: [ each isUiMessage not ]) ifTrue: [ aCollection add: each ] ].
	panels do: [ : each | each addDomainMessageMorphsForThisReceiverTo: aCollection ]! !

!MauiDomainMorph methodsFor: 'private' stamp: 'cmm 2/9/2013 17:25'!
addGlobalLevelUserMessage: aMauiMessageMorph 
	| messages |
	aMauiMessageMorph
		notificationHandler: self notificationHandler ;
		initializeResult ;
		resetResultMorphObjects ;
		lastModified: DateAndTime now.
	messages := self family contextMenuMessagesFor: object realObject maOriginalClass name.
	messages 
		maDetect: [ : each | each message sameEffectAs: aMauiMessageMorph message ]
		ifFound: 
			[ : foundMessageMorph | 
			messages 
				at: (messages indexOf: foundMessageMorph)
				put: aMauiMessageMorph copy ]
		ifNone: 
			[ "Don't modify their original message, make a copy of it."
			| msgToAdd |
			msgToAdd := aMauiMessageMorph copy
				receiver: aMauiMessageMorph receiver asMauiPrototype ;
				yourself.
			"Local result doesn't do any good for menu messages, so help the user out if they forgot to set this to something else."
			msgToAdd invocationStrategy wantsLocalResultTarget ifTrue: [ msgToAdd invocationStrategy selectHandResultTarget ].
			messages add: msgToAdd ]! !

!MauiDomainMorph methodsFor: 'private' stamp: 'cmm 3/16/2014 19:30'!
addMessage: customizedMessageMorph at: index 
	super
		addMessage: customizedMessageMorph
		at: index.
	self requireChangedNotificationsForAutoRefresh ifTrue:
		[ object ifNotNil: [ object addDependent: customizedMessageMorph ] ].
	customizedMessageMorph startStepping.
	^ customizedMessageMorph! !

!MauiDomainMorph methodsFor: 'api-panels' stamp: 'cmm 1/4/2005 20:28'!
addPanel: aMauiDomainMorph
	"To layout in multiple directions, add a copy of myself to me and layout messages inside that however you wish.  aMauiDomainMorph must represent the same object as me."

	^ self
		addPanel: aMauiDomainMorph
		at: (self submorphs size + 1)! !

!MauiDomainMorph methodsFor: 'api-panels' stamp: 'cmm 12/5/2007 22:31'!
addPanel: aMauiDomainMorph at: index 
	"To layout in multiple directions, add a copy of myself to me and layout messages inside that however you wish.  aMauiDomainMorph must represent the same object as me."
	({  (self object). self  } includes: aMauiDomainMorph object) ifFalse: 
		[ MauiUserError signal: 'Only another view of myself can integrate with me.  This is a view of a different object.' ].
	self == aMauiDomainMorph ifTrue: 
		[ MauiUserError signal: 'I cannot be added to myself.  To create a panel add a copy of me to myself.' ].
	(submorphs includes: aMauiDomainMorph) ifFalse: 
		[ self 
			addMorph: aMauiDomainMorph
			asElementNumber: index ].
	aMauiDomainMorph pickee: self pickee.
	^ panels add: aMauiDomainMorph! !

!MauiDomainMorph methodsFor: 'menu' stamp: 'cmm 4/11/2009 18:09'!
addPrivateViewsMenuTo: aMenu 
	self 
		addViewsMenuTo: aMenu
		private: true! !

!MauiDomainMorph methodsFor: 'menu' stamp: 'cmm 3/16/2010 11:35'!
addServicesMenuTo: menu 
	self object mauiServices do:
		[ : each | menu addMenuItem:
			(MenuItemMorph new
				 contents: each buttonLabel ;
				 target: each ;
				 selector: #performServiceFor: ;
				 arguments: (Array with: self object) ;
				 setBalloonText: each description) ]! !

!MauiDomainMorph methodsFor: 'api-panels' stamp: 'cmm 9/25/2007 16:35'!
addTab: outputView 
	"Add a tab labelled outputView to me that, when activated, will display the view also named outputView."
	^ self 
		addTab: outputView
		view: outputView! !

!MauiDomainMorph methodsFor: 'api-panels' stamp: 'cmm 3/18/2009 09:32'!
addTab: labelString selector: selectorSymbol view: outputView 
	"Add a tab to me labelled labelString that will activate selectorSymbol to present an object in the specified outputView."
	^ self 
		addTab: labelString
		selector: selectorSymbol
		view: outputView
		resultMorph: nil! !

!MauiDomainMorph methodsFor: 'api-panels' stamp: 'cmm 3/17/2009 19:55'!
addTab: labelString selector: selectorSymbol view: outputView resultMorph: aMauiDomainMorph 
	"Add a tab to me labelled labelString that will activate selectorSymbol to present an object in the specified outputView."
	| message |
	self isTabsPanel ifFalse: 
		[ MauiUserError signal: 'Tabs may only be added to a subpanel, because the output of the tabs is placed in the containing panel.' ].
	self wantsModality: true.
	message := self addMessageNamed: selectorSymbol.
	(message selectStrategy: MauiClickedInvocationStrategy)
		resultView: outputView ;
		producedView: nil.
	^ message
		resultHolderMorph: owner ;
		resultMorph: aMauiDomainMorph ;
		labelAt: 1
			put: labelString ;
		yourself! !

!MauiDomainMorph methodsFor: 'api-panels' stamp: 'cmm 9/25/2007 16:34'!
addTab: labelString view: outputView 
	"Add a tab labelled labelString to me that, when activated, will display the view named outputView."
	^ self 
		addTab: labelString
		selector: #yourself
		view: outputView! !

!MauiDomainMorph methodsFor: 'private' stamp: 'cmm 6/21/2012 15:47'!
addTabsTo: aDictionary atClassLevel: aClass 
	"aDictionary is keyed by the name of the tab (method category).  We do up to 10 tabs and up to 10 methods per tab, but we start at the lowest superclass.  We skip Object and 'private' methods."
	| finder |
	finder := MaBehaviorFinder new addElement: aClass.
	finder categories do: 
		[ : eachCategory | 
		({  'private'. '*'. 'initializ'. 'deprecated'. 'printing'  } anySatisfy: [ : eachPrefix | eachCategory beginsWith: eachPrefix ]) ifFalse: 
			[ | generatedPanel |
			generatedPanel := aDictionary 
				at: eachCategory
				ifAbsent: 
					[ aDictionary size < 10 ifTrue: 
						[ aDictionary 
							at: eachCategory
							put: (self newPanel view: #panel; yourself) ] ].
			generatedPanel ifNotNil: 
				[ | methodsStream |
				methodsStream := ((finder copy selectMethodsInCategory: eachCategory) methods asSortedCollection: [ : a : b | a selector < b selector ]) readStream.
				[ generatedPanel instructionCount < 10 and: [ methodsStream atEnd not ] ] whileTrue: [ generatedPanel addMessageNamed: methodsStream next selector ] ] ] ]! !

!MauiDomainMorph methodsFor: 'menu' stamp: 'cmm 2/14/2009 19:02'!
addUserMenuTo: aMenu 
	contextMenuMessages notEmpty ifTrue: [ aMenu addLine ].
	contextMenuMessages do: 
		[ : each | 
		| messageMorph |
		messageMorph := each copy
			receiver: self object ;
			notificationHandler: self notificationHandler.
		aMenu 
			add: (self mauiWorld nameFor: each concatenatedLabels)
			target: messageMorph
			selector: #invokeFromUserMenu ].
	aMenu addLine.
	self family 
		addGlobalChoicesFor: self
		to: aMenu! !

!MauiDomainMorph methodsFor: 'private' stamp: 'cmm 7/14/2008 17:42'!
addViewLevelUserMessage: aMauiMessageMorph 
	aMauiMessageMorph notificationHandler: self notificationHandler.
	contextMenuMessages 
		maDetect: [ : each | each message sameEffectAs: aMauiMessageMorph message ]
		ifFound: 
			[ : foundMessageMorph | 
			contextMenuMessages 
				at: (contextMenuMessages indexOf: foundMessageMorph)
				put: aMauiMessageMorph ]
		ifNone: 
			[ "Local result doesn't do any good for menu messages, so help the user out if they forgot to set this to something else."
			aMauiMessageMorph invocationStrategy wantsLocalResultTarget ifTrue: [ aMauiMessageMorph invocationStrategy selectHandResultTarget ].
			contextMenuMessages := contextMenuMessages copyWith: aMauiMessageMorph ]! !

!MauiDomainMorph methodsFor: 'menu' stamp: 'cmm 3/16/2010 11:37'!
addViewsMenuTo: aMenu private: privateSelection 
	aMenu addLine.
	self customViewsDo:
		[ : each | | menuItem sketch |
		each first isLowercase = privateSelection ifTrue:
			[ menuItem := MauiMenuItemMorph new
				 contents: each ;
				 target: self ;
				 selector: #openNewViewNamed: ;
				 arguments: {each}.
			sketch := (self family
				viewNamed: each
				for: self object) sketch.
			sketch ifNotNil:
				[ sketch scalePoint: (self preferred: #scalePoint).
				menuItem balloonContentsMorph: sketch ].
			aMenu addMenuItem: menuItem ] ]! !

!MauiDomainMorph methodsFor: 'accessing' stamp: 'cmm 2/22/2009 15:47'!
allDomainMessageMorphsForThisReceiver
	| answer |
	answer := OrderedCollection new.
	self addDomainMessageMorphsForThisReceiverTo: answer.
	^ answer! !

!MauiDomainMorph methodsFor: 'events and overrides' stamp: 'cmm 2/3/2014 22:37'!
allMauiMorphsDo: aBlock ifNotIn: anIdentitySet 
	"Make absolutely sure to get my panels, even if they're not part of the submorph tree"
	super
		allMauiMorphsDo: aBlock
		ifNotIn: anIdentitySet.
	panels do:
		[ : each | (anIdentitySet includes: each) ifFalse:
			[ aBlock value: each.
			each
				allMauiMorphsDo: aBlock
				ifNotIn: anIdentitySet ] ]! !

!MauiDomainMorph methodsFor: 'view' stamp: 'cmm 12/29/2004 15:15'!
as: viewName

	^ self beReplacedBy: (self asNewViewNamed: viewName)! !

!MauiDomainMorph methodsFor: 'view' stamp: 'cmm 7/29/2004 16:56'!
as: viewName resetTargetNamed: menuItemString in: aMenuMorph
	""
	| newTarget |
	newTarget := self as: viewName.
	aMenuMorph items do: [ : each | each target: newTarget ].
	^newTarget! !

!MauiDomainMorph methodsFor: 'view' stamp: 'cmm 3/14/2009 20:02'!
asListEntry
	"Make my shape and layout suitable to be an entry in a list (i.e., as in a Collection)."
	self
		ensureNoBar ;
		listDirection: #leftToRight.
	"Sigh, the listDirection doesn't update without a hard-coded cycle.  This shouldn't be!!!!"
	(owner notNil and: [ owner isPlayfieldLike ]) ifTrue: [ World doOneCycle ].
	self
		layoutPolicy: ProportionalLayout new ;
		cellInset: 0 ;
		layoutInset: 0 ;
		hResizing: #spaceFill ;
		cellPositioning: #leftCenter ;
		clipLayoutCells: true ;
		width: World width // 5 ;
		dropEnabled: false! !

!MauiDomainMorph methodsFor: 'Morphic' stamp: 'cmm 8/8/2012 14:54'!
balloonHelpString
	previewView ifNotNil: [ ^ nil ].
	self isSelfContained ifTrue: [ ^ nil ].
	self isShowingMauiName ifTrue: [ ^ nil ].
	^ view = #panel ifFalse: [ object mauiName contractTo: 300 ]! !

!MauiDomainMorph methodsFor: 'view' stamp: 'cmm 11/19/2010 11:02'!
beInvisible
	super beInvisible.
	self view = #word ifFalse:
		[ (self overridden: #colorScheme)
			 panelFill: Color transparent ;
			 messageFill: Color transparent ;
			 borderColor: Color transparent.
		(self overridden: #domainMorph)
			 borderColor: Color transparent ;
			 layoutInset: 0.
		(self overridden: #embeddedDomainMorph)
			 borderColor: Color transparent ;
			 layoutInset: 0.
		(self overridden: #messageMorph)
			 borderColor: Color transparent ;
			 color: Color transparent ]! !

!MauiDomainMorph methodsFor: 'view' stamp: 'cmm 7/2/2007 12:28'!
beLike: aMauiedMauiMorph 
	"INSTRUCTIONS:  Find another MauiMorph with the desired-look, open its tool menu and select 'maui this Morph'.  A MauiMorph for that view will appear on the hand, drag it to my parameter-holder."
	self beReplacedBy: (
		(aMauiedMauiMorph copyForNewObject: object)
			notificationHandler: self notificationHandler ;
			yourself)! !

!MauiDomainMorph methodsFor: 'optional parameters' stamp: 'cmm 8/2/2007 16:16'!
bePickable
	"Override my redButton handler to drop a copy of myself onto aMauiParameterHolderMorph."
	pickee optionalParametersMorph == self ifFalse: 
		[ self redButtonMessage: 
			(MauiMessage 
				receiver: pickee
				selector: #dropCopy:
				arguments: {  (self)  }) ]! !

!MauiDomainMorph methodsFor: 'private' stamp: 'cmm 1/8/2008 10:07'!
beReplacedBy: aMorph
	self owner
		replaceSubmorph: self
		by: aMorph.
	"deleting caused my object to no longer be a player, reinstate it for me now."
	aMorph mauiWorld 
		onePlayerFor: aMorph object 
		is: aMorph.
	^ aMorph! !

!MauiDomainMorph methodsFor: 'menu' stamp: 'cmm 2/18/2009 15:00'!
buildContextMenu
	| menu |
	menu := super buildContextMenu.
	self mauiWorld userStrategy 
		appendDomainMorphMenuItemsTo: menu
		for: self.
	self mauiWorld userStrategy 
		addViewsMenuTo: menu
		for: self.
	self
		addUserMenuTo: menu ;
		addServicesMenuTo: menu.
	^ menu! !

!MauiDomainMorph methodsFor: 'menu' stamp: 'cmm 8/29/2012 16:19'!
buildToolMenu
	| answer |
	answer := super buildToolMenu
		
		add:
			(self
				string: 'settings...' translated
				withKeyBindingFor: #keyForEdit)
		action: #openSettingsPanel ;
		
		add:
			(self
				string: 'design new view' translated
				withKeyBindingFor: #keyForDesignNewView)
		action: #designNewView.
	self isLikeListEntry
		ifTrue:
			[ answer
				add: 'edit list-entry' translated
				action: #editListEntry ]
		ifFalse:
			[ answer
				add: 'as list-entry' translated
				action: #asListEntry ].
	answer
		
		add: 'edit global context menu' translated
		action: #editGlobalContextMenu ;
		add: 'edit view context menu' translated
		action: #editViewContextMenu..
	self
		 addDeveloperViewsMenuTo: answer ;
		 addPrivateViewsMenuTo: answer.
	answer
		 addLine ;
		
		add:
			(self
				string: 'manage views...' translated
				withKeyBindingFor: #keyForSave)
		action: #openManageViewsDialog.
	^ answer! !

!MauiDomainMorph methodsFor: 'Morphic' stamp: 'cmm 4/9/2008 17:14'!
canDropInto: aMauiMorph 
	^ aMauiMorph isMauiDomainMorph and: 
		[ aMauiMorph object == self object and: 
			[ self mauiWorld userStrategy allowsMorphComposition and: [ aMauiMorph isDropGesturePresent ] ] ]! !

!MauiDomainMorph methodsFor: 'private' stamp: 'cmm 6/28/2007 12:13'!
checkForParameterCycle: aMauiMessageMorph 
	(self owner isMauiMorph and: [ self owner isMauiParameterHolderMorph ]) ifTrue: [ self owner optionalParametersStrategy customize: aMauiMessageMorph ]! !

!MauiDomainMorph methodsFor: 'copying' stamp: 'cmm 7/19/2008 15:18'!
cloneUi
	"Hand over a new user-interface for me."
	| clone |
	clone := super cloneUi.
	"In case I want to *do something* with the new view, tell it to ignoreMouseExit delete event.."
	clone ignoreMouseLeave.
	^ clone! !

!MauiDomainMorph methodsFor: 'view' stamp: 'cmm 4/11/2009 18:06'!
codedViewsDo: oneArgBlock 
	self object mauiCodedViews do: oneArgBlock! !

!MauiDomainMorph methodsFor: 'events and overrides' stamp: 'cmm 4/8/2008 22:25'!
comeToFrontWithFellowPlayers
	self comeToFrontWithFellowPlayersOf: object! !

!MauiDomainMorph methodsFor: 'label bar' stamp: 'cmm 12/10/2008 20:56'!
createDeleteMessage
	| msg |
	msg := (MauiMessage 
		receiver: self
		selector: #delete) asMauiMorphFor: self.
	(msg selectStrategy: MauiClickedInvocationStrategy) selectNoResultTarget.
	^ msg
		cornerStyle: #square ;
		hideLabels ;
		beInvisible ;
		addMorphBack: (SketchMorph withForm: (MauiMorph closeBoxImageForForegroundColor: self colorScheme standardTextColor)) ;
		yourself! !

!MauiDomainMorph methodsFor: 'view' stamp: 'cmm 7/10/2007 12:50'!
customViewsDo: oneArgBlock 
	self family 
		sortedViewsFor: self
		do: oneArgBlock! !

!MauiDomainMorph methodsFor: 'view' stamp: 'cmm 6/28/2007 12:13'!
customize: aMauiMessageMorph 
	self checkForParameterCycle: aMauiMessageMorph! !

!MauiDomainMorph methodsFor: 'events and overrides' stamp: 'cmm 12/11/2008 14:07'!
defaultBorderColor
	"A 3d border doesn't look right with a semi-transparent morph."
	^ (self owner ~= self world or: [ self color alpha < 0.95 and: [ self colorScheme borderColor isSymbol ] ]) 
		ifTrue: [ Color transparent ]
		ifFalse: [ super defaultBorderColor ]! !

!MauiDomainMorph methodsFor: 'list specification' stamp: 'cmm 12/9/2010 13:07'!
defaultListEntry
	"Change my shape to one suitable as a list-entry in a Collection.  Just add the messages you want as 'columns' first."
	self
		clear ;
		asListEntry ;
		view: #defaultListEntry ;
		producedView: self object mauiDefaultView.
	self object mauiDefaultColumns do: 
		[ : eachSelector | 
		| messageMorph |
		messageMorph := self addMessageNamed: eachSelector.
		messageMorph
			invocationStrategy: MauiAutoInvocationStrategy new ;
			hideLabels ;
			"lock is necessary to support combo-boxes, the users will definitely click on individual columns, we want the whole object (row)." 
			lock ]! !

!MauiDomainMorph methodsFor: 'private' stamp: 'cmm 3/11/2008 16:12'!
deleteOnMouseLeave
	self 
		on: #mouseLeave
		send: #deleteIfMouseTrulyLeft:
		to: self! !

!MauiDomainMorph methodsFor: 'Morphic' stamp: 'cmm 11/16/2009 14:25'!
delineateAllLikeSelf
	self isInWorld ifTrue: [ self mauiWorld delineateFrom: self ]! !

!MauiDomainMorph methodsFor: 'private' stamp: 'cmm 12/3/2009 13:33'!
delineateAllLikeSelfSoon
	self 
		addAlarm: #delineateAllLikeSelf
		after: self balloonHelpDelayTime! !

!MauiDomainMorph methodsFor: 'view' stamp: 'cmm 6/27/2007 15:28'!
designNewView
	"Create a new default view to be customized."
	^ (self asNewViewNamed: #panel)
		position: ActiveHand position ;
		openInHand! !

!MauiDomainMorph methodsFor: 'events and overrides' stamp: 'cmm 1/9/2008 16:02'!
desiredRefreshInterval
	^ 1000 "milliseconds"! !

!MauiDomainMorph methodsFor: 'view' stamp: 'cmm 4/11/2009 18:06'!
developerViewsDo: oneArgBlock 
	self object mauiDeveloperViews do: 
		[ : each | 
		each = #panel 
			ifTrue: [ self hasCodedPanelView ifTrue: [ oneArgBlock value: each ] ]
			ifFalse: [ oneArgBlock value: each ] ]! !

!MauiDomainMorph methodsFor: 'menu' stamp: 'cmm 12/10/2012 20:34'!
editGlobalContextMenu
	"Add, change or remove items from the global context menu for this type of object."
	| editableMenu className saveMessage |
	className := object realObject maOriginalClass name.
	editableMenu := self family
		newViewNamed: #clear
		for: object.
	editableMenu
		 ensureLabelBar ;
		 labelString: 'Global context-menu for any kind of ' , className.
	(self family contextMenuMessagesFor: className) do:
		[ : each | editableMenu addMessage:
			(each copy
				 receiver: object ;
				 yourself) ].
	saveMessage := editableMenu addMessage:
		((editableMenu newUiMessageNamed: #saveAsGlobalContextMenu)
			
			labelAt: 1
			put: 'Save!!' ;
			 yourself).
	saveMessage invocationStrategy postInvokeAction: #deleteParent.
	editableMenu openInHand! !

!MauiDomainMorph methodsFor: 'view' stamp: 'cmm 4/29/2009 14:07'!
editListEntry
	"Make my shape and layout suitable to be an entry in a list (i.e., as in a Collection)."
	| answer |
	answer := self asNewViewNamed: #clear.
	self submorphs do: [ : each | answer addMessage: each copy ].
	self openAdjacent: answer! !

!MauiDomainMorph methodsFor: 'menu' stamp: 'cmm 8/29/2012 17:19'!
editViewContextMenu
	"Add, change or remove items from the global context menu for this type of object."
	| editableMenu className |
	className := object realObject maOriginalClass name.
	editableMenu := self family
		newViewNamed: #clear
		for: object.
	editableMenu
		 ensureLabelBar ;
		 labelString: 'View-level menu for any kind of ' , className.
	contextMenuMessages do:
		[ : each | editableMenu addMessage: each copy ].
	(editableMenu addMessage:
		((editableMenu newUiMessageNamed: #saveAsViewContextMenu)
			
			labelAt: 1
			put: 'Save!!' ;
			 yourself)) invocationStrategy
		 selectNoResultTarget ;
		 postInvokeAction: #deleteParent.
	editableMenu
		
		setProperty: #contextMenuEditRequestor
		toValue: self ;
		 openInHand! !

!MauiDomainMorph methodsFor: 'accessing' stamp: 'cmm 12/8/2010 15:26'!
eligibleLevels
	"Answer the list of classes of my receviers superclass chain which can respond to all of my message selectors."
	| allMessages |
	allMessages := self allDomainMessageMorphsForThisReceiver.
	^ self object realObject maOriginalClass withAllSuperclasses
		select:
			[ : eachClass | allMessages allSatisfy:
				[ : eachMessage | eachClass canUnderstand: eachMessage selector ] ]
		thenCollect:
			[ : eachClass | eachClass name ]! !

!MauiDomainMorph methodsFor: 'label bar' stamp: 'cmm 7/10/2007 16:09'!
ensureBar
	self ensureLabelBar.
	(self preferred: #useCloseBoxes) 
		ifTrue: [ self ensureCloseBox ]
		ifFalse: [ self ensureNoCloseBox ]! !

!MauiDomainMorph methodsFor: 'label bar' stamp: 'cmm 6/15/2007 10:44'!
ensureCloseBox
	self hasCloseBox ifTrue: [ ^ self ].
	self addCloseBoxTo: 
		(self isLabelled 
			ifTrue: [ labelBar ]
			ifFalse: [ self ])! !

!MauiDomainMorph methodsFor: 'private' stamp: 'cmm 11/29/2007 22:02'!
ensureHasProducedView
	producedView ifNil: [ self producedView: object mauiDefaultView ]! !

!MauiDomainMorph methodsFor: 'label bar' stamp: 'cmm 11/29/2007 17:13'!
ensureLabelBar
	(submorphs includes: self labelBar) ifFalse: [ self addMorph: self labelBar ]! !

!MauiDomainMorph methodsFor: 'label bar' stamp: 'cmm 6/14/2007 11:02'!
ensureNoBar
	self
		ensureNoLabelBar ;
		ensureNoCloseBox! !

!MauiDomainMorph methodsFor: 'label bar' stamp: 'cmm 6/14/2007 11:01'!
ensureNoCloseBox

	self isLabelled ifTrue: [ self removeMyCloseBoxFromSubmorphsOf: labelBar ].
	self removeMyCloseBoxFromSubmorphsOf: self! !

!MauiDomainMorph methodsFor: 'label bar' stamp: 'cmm 6/14/2007 10:58'!
ensureNoLabelBar

	| needsCloseBox |
	needsCloseBox := self hasCloseBox.
	self ensureNoCloseBox.
	self isLabelled ifTrue: [ labelBar delete ].
	needsCloseBox ifTrue: [ self ensureCloseBox ]! !

!MauiDomainMorph methodsFor: 'spacer' stamp: 'cmm 6/14/2007 11:07'!
ensureNoSpacer

	self stopTrackingDropZones.
	spacer ifNotNil: [ spacer shrinkAndDelete ].
	spacer := nil! !

!MauiDomainMorph methodsFor: 'spacer' stamp: 'cmm 6/14/2007 11:07'!
ensureSpacerBehind: submorph

	| submorphIndex |
	submorphIndex := self submorphs indexOf: submorph.
	submorphIndex = 0 ifTrue: [ ^ self ].
	(self submorphs size > submorphIndex
	and: [ spacer == (self submorphs at: submorphIndex + 1) ]) ifTrue: [ ^ self ].
	self initializeSpacer.
	self addMorph: spacer behind: submorph! !

!MauiDomainMorph methodsFor: 'spacer' stamp: 'cmm 6/14/2007 11:07'!
ensureSpacerInFrontOf: submorph

	| submorphIndex |
	submorphIndex := self submorphs indexOf: submorph.
	submorphIndex = 0 ifTrue: [ ^ self ].
	(submorphIndex > 1 
	and: [ { spacer. labelBar } includes: (self submorphs at: submorphIndex - 1) ]) ifTrue: [ ^ self ].
	self initializeSpacer.
	self addMorph: spacer inFrontOf: submorph! !

!MauiDomainMorph methodsFor: 'Morphic' stamp: 'cmm 3/1/2012 21:30'!
externalName
	^ self isUserResizable 
		ifTrue: [ String empty ]
		ifFalse: [ super externalName ]! !

!MauiDomainMorph methodsFor: 'label bar' stamp: 'cmm 7/9/2008 19:20'!
findObject
	"Perform a keyword search for my subobjects."
	(self object maNewSearchContext asMauiMorph notificationHandler: notificationHandler) openNextTo: self! !

!MauiDomainMorph methodsFor: 'events and overrides' stamp: 'cmm 6/21/2008 23:39'!
goBehindWithFellowPlayers
	self goBehindWithFellowPlayersOf: object! !

!MauiDomainMorph methodsFor: 'view' stamp: 'cmm 5/29/2013 20:53'!
grabNewViewNamed: viewName 
	| newView |
	newView := (self asNewViewNamed: viewName)
		 position: ActiveHand position ;
		 openInHand.
	newView position: newView position + (newView extent / 2.1)! !

!MauiDomainMorph methodsFor: 'events and overrides' stamp: 'cmm 10/28/2009 14:16'!
handleDropMorph: anEvent 
	"really don't want to override this but.. This helps prevent accidental droppage of a Morph when all you wanted to do was drop move it to a different location."
	self shouldHandleDropMorph ifTrue: [ super handleDropMorph: anEvent ]! !

!MauiDomainMorph methodsFor: 'private' stamp: 'cmm 11/8/2009 21:10'!
handleRedButton
	self removeAlarm: #preview.
	self = self outerMostMauiMorph
		ifTrue: 
			[ producedView 
				ifNil: [ super handleRedButton ]
				ifNotNil: [ self grabNewViewNamed: self producedView ] ]
		ifFalse: 
			[ producedView
				ifNil: [ self outerMostMauiDomainMorph handleRedButton ]
				ifNotNil: [ self grabNewViewNamed: self producedView ] ]! !

!MauiDomainMorph methodsFor: 'events and overrides' stamp: 'cmm 5/1/2009 14:08'!
handlesMouseOverDragging: evt 
	"Answer whether #mouseEnterDragging: and #mouseLeaveDragging: should be called on me."
	| draggingMorph |
	draggingMorph := evt hand hasSubmorphs ifTrue: [ evt hand firstSubmorph renderedMorph ].
	"Require shiftPressed or the draggingMorph to be a message."
	(evt shiftPressed or: [ draggingMorph notNil and: [ draggingMorph isMauiInstructionMorph ] ]) ifTrue: [ self noteDropGesturePresent ].
	^ super handlesMouseOverDragging: evt! !

!MauiDomainMorph methodsFor: 'label bar' stamp: 'cmm 6/14/2007 11:01'!
hasCloseBox

	^ (self submorphs anySatisfy: [ : each | self isMyDeleteMessage: each ])
	or: 
		[ self isLabelled
		and: [ labelBar submorphs anySatisfy: [ : each | self isMyDeleteMessage: each ] ] ]! !

!MauiDomainMorph methodsFor: 'view' stamp: 'cmm 7/13/2009 18:11'!
hasCodedPanelView
	^ (self maOriginalClass lookupSelector: #initializeSubmorphs) methodClass ~= MauiDomainMorph! !

!MauiDomainMorph methodsFor: 'private' stamp: 'cmm 12/11/2008 10:55'!
hasLabelBar
	^ labelBar notNil and: [ labelBar hasOwner: self ]! !

!MauiDomainMorph methodsFor: 'spacer' stamp: 'cmm 6/14/2007 11:08'!
hasSubmorphsOtherThanSpacers
	^self submorphs notEmpty and: 
			[submorphs anySatisfy: [:each | each maOriginalClass ~= MauiSpacer	"ugh"]]! !

!MauiDomainMorph methodsFor: 'menu' stamp: 'cmm 6/19/2008 22:52'!
hasUserMessageWithSameEffectAs: aMauiMessageMorph 
	^ contextMenuMessages anySatisfy: [ : each | each message sameEffectAs: aMauiMessageMorph message ]! !

!MauiDomainMorph methodsFor: 'private' stamp: 'cmm 7/19/2008 15:09'!
ignoreMouseLeave
	self 
		on: #mouseLeave
		send: #yourself
		to: nil! !

!MauiDomainMorph methodsFor: 'events and overrides' stamp: 'cmm 2/18/2009 14:21'!
initialKeyboardFocus
	"Focus on the first non-Smalltalk evaluator parameter-holder, if there is one.  If not, focus on the first parameter-holder."
	self messageMorphsDo: 
		[ : each | 
		each parameterHolderMorphsDo: 
			[ : eachPh | 
			eachPh evaluator isSmalltalkInterpreter ifFalse: [ ^ ActiveHand newKeyboardFocus: eachPh ] ] ].
	self messageMorphsDo: 
		[ : each | 
		each parameterHolderMorphsDo: [ : eachPh | ^ ActiveHand newKeyboardFocus: eachPh ] ]! !

!MauiDomainMorph methodsFor: 'spacer' stamp: 'cmm 6/14/2007 11:08'!
initialMarkerExtentOf: aMauiSpacer

	self hasSubmorphsOtherThanSpacers ifFalse: [ ^ self extent - self layoutInset ].
	^ self listDirection = #topToBottom
		ifTrue:
			[ self primaryHand firstSubmorph width @ 0 ]
		ifFalse:
			[ "left-to-right"
			0 @ self primaryHand firstSubmorph height ]! !

!MauiDomainMorph methodsFor: 'initialize-release' stamp: 'cmm 12/10/2008 22:42'!
initialize
	self initializePanels.
	family := self mauiWorld family.
	super initialize.
	contextMenuMessages := Array new.	"of MauiMessageMorphs"
	wantsModality := false! !

!MauiDomainMorph methodsFor: 'initialize-release' stamp: 'cmm 11/12/2010 15:49'!
initializeBorder
	"Make my border according to the prototypes."
	super initializeBorder.
	self borderColor:
		((self wantsMargin and: [ self isContent not ]) 
			ifTrue: [ self colorScheme borderColor ]
			ifFalse: [ self prototype borderColor ])! !

!MauiDomainMorph methodsFor: 'initialize-release' stamp: 'cmm 12/29/2009 15:50'!
initializeColor
	| colorScheme |
	colorScheme := self colorScheme.
	super initializeColor.
	self fillStyle: 
		((#(#word #defaultListEntry ) includes: self view) 
			ifTrue: [ colorScheme wordFill ]
			ifFalse: [ colorScheme panelFill ]) copy.
	labelBar ifNotNil: 
		[ labelBar fillStyle: (self customizedFill: self labelFill) copy.
		self initializeLabelColor ].
	panels do: [ : each | each initializeColor ]! !

!MauiDomainMorph methodsFor: 'label bar' stamp: 'cmm 12/29/2009 15:47'!
initializeLabelBar
	labelBar := Morph new
		fillStyle: self labelFill copy ;
		layoutPolicy: TableLayout new ;
		hResizing: #shrinkWrap ;
		vResizing: #shrinkWrap ;
		listDirection: #leftToRight ;
		borderWidth: 0 ;
		layoutInset: (2@1) ;
		on: #mouseDown
			send: #mouseDown:
			to: self ;
		yourself! !

!MauiDomainMorph methodsFor: 'label bar' stamp: 'cmm 12/10/2008 10:27'!
initializeLabelColor
	label ifNotNil: 
		[ label
			color: self colorScheme standardTextColor ;
			font: Preferences windowTitleFont ]! !

!MauiDomainMorph methodsFor: 'label bar' stamp: 'cmm 4/13/2008 16:57'!
initializeLabelString
	"Reset my label to my objects #mauiName."
	object mauiName in: 
		[ : nm | 
		nm size > 60 ifTrue: [ self label setBalloonText: (nm contractTo: 300) ].
		self labelString: (nm contractTo: 60) ].
	self removeProperty: #hasCustomLabel! !

!MauiDomainMorph methodsFor: 'initialize-release' stamp: 'cmm 11/14/2007 15:16'!
initializePanels
	panels := Set new! !

!MauiDomainMorph methodsFor: 'spacer' stamp: 'cmm 10/1/2007 17:00'!
initializeSpacer
	spacer ifNotNil: [ spacer shrinkAndDelete ].
	spacer := self newDropMarker! !

!MauiDomainMorph methodsFor: 'events and overrides' stamp: 'cmm 7/27/2007 16:36'!
initializeSubmorphs
	"Subclasses implement their standard panel view.  The panel view is the standard operational view."! !

!MauiDomainMorph methodsFor: 'Morphic' stamp: 'cmm 12/8/2010 14:14'!
intoWorld: aWorld 
	super intoWorld: aWorld.
	aWorld ifNil: [ ^ self ].
	owner ifNil: [ ^ self ].
	"If I'm not embedded in a MauiPage and not a heading section of a super panel, "
	self shouldInitializeLabelString ifTrue: [ self initializeLabelString ].
	"This change was put in as of Maui-cmm.225 (7286b520-5bde-bb44-8b0c-44cfc4f7d6dd) but it caused the datePicker to get into a refresh-loop.  I think it was put in for MauiContext search morphs.."
	"	self requireChangedNotificationsForAutoRefresh ifTrue: [ self object changed]."
	self mauiWorld 
		onePlayerFor: object realObject
		is: self.
	owner isBalloonHelp ifTrue: [ owner mauiAdjustVertices ].
	self initialKeyboardFocus! !

!MauiDomainMorph methodsFor: 'spacer' stamp: 'cmm 6/14/2007 11:08'!
is: aPoint inFirstHalfOf: aMorph

	^ self listDirection = #topToBottom
		ifTrue: [ aPoint y < (aMorph position y + (aMorph height // 2)) ]
		ifFalse: [ aPoint x < (aMorph position x + (aMorph width // 2)) ]
			! !

!MauiDomainMorph methodsFor: 'testing' stamp: 'cmm 12/27/2008 15:04'!
isContent
	^ #(#word #defaultListEntry ) includes: self view! !

!MauiDomainMorph methodsFor: 'private' stamp: 'cmm 4/9/2008 16:12'!
isDropGesturePresent
	^ self hasProperty: #dropGesturePresent! !

!MauiDomainMorph methodsFor: 'testing' stamp: 'cmm 1/26/2008 15:55'!
isEmbeddedInText
	^ owner notNil and: [ owner isTextMorph ]! !

!MauiDomainMorph methodsFor: 'label bar' stamp: 'cmm 6/14/2007 10:58'!
isLabelled

	^ labelBar notNil and: [ labelBar owner == self ]! !

!MauiDomainMorph methodsFor: 'testing' stamp: 'cmm 7/23/2008 15:13'!
isLikeListEntry
	^ self listDirection = #leftToRight and: [ self layoutPolicy isProportionalLayout ]! !

!MauiDomainMorph methodsFor: 'testing' stamp: 'cmm 11/24/2003 00:18'!
isMauiDomainMorph

	^true! !

!MauiDomainMorph methodsFor: 'testing' stamp: 'cmm 9/17/2011 15:35'!
isOptimizedFor: anObject 
	"There's no guarantee the same messasge will return the same class of object.  Answer whether my class is specifically meant to support anObject."
	"It is important to ensure level is always intiailized before storage in the family, that way it doesn't come back out and get initialized to MauiPrototype."
	self levelClass
		ifNil: [ ^ false ]
		ifNotNil:
			[ : lvlClass | "Have we made it up to my levelClass yet?"
			lvlClass = anObject maOriginalClass ifTrue: [ ^ true ] ].
	anObject mauiMorphClass ~= self maOriginalClass ifTrue: [ ^ false ].
	"If my levelClass is a subclass of anObject, then I am not suitable because I may have extra methods that are only applicable to the subclass (or a different view depending on subclass, as in true/false)."
	self levelClass allSuperclassesDo: [ : each | each = anObject maOriginalClass ifTrue: [ ^ false ] ].
	"anObject is a subclass of my levelClass, I can be suitable unless my family has a more-specialized version for it.."
	anObject maOriginalClass withAllSuperclassesDo: 
		[ : each | 
		"Have we made it up to my levelClass yet?"
		each = self levelClass ifTrue: [ ^ true ].
		(self family 
			hasViewsAt: each
			named: view) ifTrue: [ ^ false ] ].
	"Not sure we should ever be able to get here, the safest thing to do is not try to reuse."
	^ false! !

!MauiDomainMorph methodsFor: 'private' stamp: 'cmm 2/18/2013 16:57'!
isShowingMauiName
	"Look for a Morph that is already showing my mauiName, but don't spend a lot of time on it because it could otherwise slow down the UI."
	| startTime mauiName |
	mauiName := object mauiName.
	startTime := Time millisecondClockValue.
	self allMorphsDo:
		[ : each | ((each respondsTo: #contents) and:
			[ each contents = mauiName and: [ each width - 3 <= each mauiClippingExtent x ] ]) ifTrue: [ ^ true ].
		(Time millisecondsSince: startTime) > 1 ifTrue: [ ^ false ] ].
	^ false! !

!MauiDomainMorph methodsFor: 'testing' stamp: 'cmm 7/7/2008 21:13'!
isTabsPanel
	^ owner isMauiMorph and: [ owner object == object ]! !

!MauiDomainMorph methodsFor: 'Morphic' stamp: 'cmm 11/30/2007 16:17'!
justDroppedInto: aMorph event: anEvent 
	"This message is sent to a dropped morph after it has been dropped on -- and been accepted by -- a drop-sensitive morph"
	aMorph == self world 
		ifTrue: 
			[ self mauiWorld 
				onePlayerFor: self object
				is: self ]
		ifFalse: [ self mauiWorld removePlayer: self ]! !

!MauiDomainMorph methodsFor: 'Morphic' stamp: 'cmm 12/3/2009 13:33'!
keyboardFocusChange: gainedFocus 
	super keyboardFocusChange: gainedFocus.
	gainedFocus 
		ifTrue: 
			[ self delineate.
			(self isInWorld and: [ owner ~= self activeHand and: [ self isSelfContained not ] ]) ifTrue: [ self delineateAllLikeSelfSoon ] ]
		ifFalse: 
			[ self removeAlarm: #delineateAllLikeSelf.
			self undelineate.
			self undelineateAllLikeSelf ]! !

!MauiDomainMorph methodsFor: 'label bar' stamp: 'cmm 12/9/2008 21:30'!
label
	^ label ifNil: 
		[ label := StringMorph new lock.
		self initializeLabelColor.
		label ]! !

!MauiDomainMorph methodsFor: 'label bar' stamp: 'cmm 12/2/2007 19:13'!
labelBar
	^ labelBar ifNil: 
		[ self initializeLabelBar.
		self labelBar addMorphBack: self label.
		labelBar ]! !

!MauiDomainMorph methodsFor: 'events and overrides' stamp: 'cmm 12/10/2008 10:27'!
labelFill
	^ self colorScheme labelBarFill! !

!MauiDomainMorph methodsFor: 'label bar' stamp: 'cmm 11/29/2007 17:30'!
labelString
	^ label contents! !

!MauiDomainMorph methodsFor: 'label bar' stamp: 'cmm 3/29/2008 23:43'!
labelString: aString 
	self label contents: aString.
	self noteHasCustomLabel! !

!MauiDomainMorph methodsFor: 'label bar' stamp: 'cmm 4/14/2008 12:34'!
labelledMenuString
	^ self 
		string: (self isLabelled 
				ifTrue: [ '<on>labelled' translated ]
				ifFalse: [ '<off>labelled' translated ])
		withKeyBindingFor: #keyForToggleLabelled! !

!MauiDomainMorph methodsFor: 'private' stamp: 'cmm 11/17/2010 14:23'!
level
	"My #level specifies which class, of a hierarchy of classes, my view supports.  It is common for subclasses to extend with additional capabilities, they may have additional messages that won't work for the more general (superclass) cases.
	I support instances of my level and all subclass instances."
	^ level ifNil: [ level := self suggestedLevel ]! !

!MauiDomainMorph methodsFor: 'private' stamp: 'cmm 3/18/2013 21:28'!
level: className 
	"My #level specifies which class, of a hierarchy of classes, my view supports.  It is common for subclasses to extend with additional capabilities, they may have additional messages that won't work for the more general (superclass) cases.
	I support instances of my level and all subclass instances."
	level := className isBehavior
		ifTrue: [ className name ]
		ifFalse: [ className ]! !

!MauiDomainMorph methodsFor: 'private' stamp: 'cmm 8/4/2010 16:12'!
levelClass
	"My #levelClass specifies which class, of a hierarchy of classes, my view supports.  It is common for subclasses to extend with additional capabilities, they may have additional messages that won't work for the more general (superclass) cases.
	I support instances of my level and all subclass instances."
	^ self level isBehavior
		ifTrue: [ level ]
		ifFalse: [ Smalltalk classNamed: level ]! !

!MauiDomainMorph methodsFor: 'view' stamp: 'cmm 4/20/2010 21:41'!
loaded
	"Generate a tabbed view with each tab being a method category.  The designer can then modify (add/change/delete) the tabs as desired."
	| tabsPane |
	self
		clear ;
		ensureBar ;
		view: #loaded.
	tabsPane := self newPanel listDirection: #leftToRight.
	self addPanel: tabsPane.
	self suggestedTabsDo: 
		[ : eachName : eachView | 
		tabsPane 
			addTab: eachName
			selector: #yourself
			view: #panel
			resultMorph: eachView ]! !

!MauiDomainMorph methodsFor: 'ma object serialization' stamp: 'cmm 4/10/2009 23:25'!
maTransientVariables
	^ super maTransientVariables , #('spacer' )! !

!MauiDomainMorph methodsFor: 'view' stamp: 'cmm 9/17/2011 15:43'!
makeAllLikeMe
	"Make my class of players with my view in my world look just like me."
	| tempPrototype classOfUpdatedView |
	tempPrototype := self copyForNewObject: self object asMauiPrototype.
	classOfUpdatedView := self family prototypeClassKeyFor: self object.
	self mauiWorld playersDo:
		[ : eachPlayer | (eachPlayer ~~ self and:
			[ (eachPlayer object isKindOf: classOfUpdatedView) and:
				[ view = eachPlayer view and:
					[ eachPlayer isInWorld and:
						[ (eachPlayer family
							player: (self family prototypeClassKeyFor: eachPlayer object)
							overridesView: view
							from: classOfUpdatedView) not ] ] ] ]) ifTrue:
			[ eachPlayer beReplacedBy:
				((tempPrototype copyForNewObject: eachPlayer object)
					 notificationHandler: eachPlayer notificationHandler ;
					 yourself) ] ].
	"Now update the resultMorphs in my family."
	self family allCurrentViewsDo:
		[ : eachPrototype | eachPrototype allMauiMorphsDo:
			[ : eachMorph | | eachResultMorph | eachMorph isMauiInstructionMorph ifTrue:
				[ eachResultMorph := eachMorph hasResult ifTrue: [ eachMorph resultMorph ].
				(eachResultMorph notNil and:
					[ | lvlClass |
					lvlClass := eachResultMorph levelClass.
					lvlClass notNil and:
						[ (lvlClass = classOfUpdatedView or: [ lvlClass inheritsFrom: classOfUpdatedView ]) and:
							[ view = eachResultMorph view and:
								[ (eachResultMorph family
									player: lvlClass
									overridesView: view
									from: classOfUpdatedView) not ] ] ] ]) ifTrue: [ eachMorph resultMorph: tempPrototype copy ] ] ] ]! !

!MauiDomainMorph methodsFor: 'private' stamp: 'cmm 3/14/2009 20:13'!
mauiCodedViews
	^ super mauiCodedViews , #(#beSketch )! !

!MauiDomainMorph methodsFor: 'Morphic' stamp: 'cmm 1/4/2005 19:49'!
mauiDropInto: aMauiDomainMorph event: event at: spacerPosition
	super
		mauiDropInto: aMauiDomainMorph 
		event: event 
		at: spacerPosition.
	aMauiDomainMorph addPanel: self! !

!MauiDomainMorph methodsFor: 'accessing' stamp: 'cmm 10/19/2007 16:21'!
mauiNameText
	^ object mauiName asText! !

!MauiDomainMorph methodsFor: 'Morphic' stamp: 'cmm 12/8/2010 14:19'!
mauiNoteOutOfWorld
	super mauiNoteOutOfWorld.
	self undelineateAllLikeSelf.
	self requireChangedNotificationsForAutoRefresh ifTrue: 
		[ object realObject removeDependent: self.
		self messageMorphsDo: [ : each | each removeDependent: self ] ]! !

!MauiDomainMorph methodsFor: 'list specification' stamp: 'cmm 6/9/2009 11:14'!
mergedColumns
	^ self valueOfProperty: #mergedColumns! !

!MauiDomainMorph methodsFor: 'list specification' stamp: 'cmm 6/9/2009 11:14'!
mergedColumns: anArrayOfIntervals 
	^ self 
		setProperty: #mergedColumns
		toValue: anArrayOfIntervals! !

!MauiDomainMorph methodsFor: 'private' stamp: 'cmm 12/8/2010 14:18'!
methodsInCategory: aString 
	^ MaBehaviorFinder new
		addClass: object realObject maOriginalClass ;
		selectMethodsInCategory: aString ;
		methods! !

!MauiDomainMorph methodsFor: 'Morphic' stamp: 'cmm 6/3/2009 14:52'!
mouseEnter: aMouseEvent 
	previewView ifNotNil: 
		[ self 
			addAlarm: #preview
			after: self balloonHelpDelayTime.
		aMouseEvent wasHandled: true ].
	^ super mouseEnter: aMouseEvent! !

!MauiDomainMorph methodsFor: 'events and overrides' stamp: 'cmm 11/28/2012 12:42'!
mouseEnterDragging: evt 
	"If Shift is not pressed MauiMessageMorphs act like a magic-decoder card.  Pressing Shift while dragging allows panel composition (with either messages or sub-panels)."
	| draggingMorph |
	draggingMorph := evt hand submorphs size = 1
		ifTrue: [ evt hand firstSubmorph renderedMorph ]
		ifFalse: [ ^ self ].
	draggingMorph canDropIntoMauiMorph ifFalse: [ ^ self ].
	(self
		wantsDroppedMorph: draggingMorph
		event: evt) ifFalse: [ ^ self ].
	draggingMorph isMauiInstructionMorph ifTrue:
		[ draggingMorph
			noteHoveringOver: self
			event: evt ].
	(evt shiftPressed or:
		[ draggingMorph isTransferMorph or: [ draggingMorph isMauiInstructionMorph ] ]) ifTrue:
		[ self noteDropGesturePresent.
		(self isCustomLayout not and:
			[ self
				wantsDroppedMorph: draggingMorph
				event: evt ]) ifTrue:
			[ self initializeSpacer.
			self hasSubmorphsOtherThanSpacers
				ifTrue: [ self startTrackingDropZones ]
				ifFalse:
					[ self submorphs isEmpty ifTrue: [ self addMorph: spacer ] ] ] ]! !

!MauiDomainMorph methodsFor: 'events and overrides' stamp: 'cmm 6/3/2009 15:12'!
mouseLeave: aMouseEvent 
	super mouseLeave: aMouseEvent.
	previewView ifNotNil: [ self removeAlarm: #preview ].
	self world ifNotNil: 
		[ self
			ensureNoSpacer ;
			removeDropGesturePresent ]! !

!MauiDomainMorph methodsFor: 'events and overrides' stamp: 'cmm 4/9/2008 16:40'!
mouseLeaveDragging: aMouseEvent 
	super mouseLeaveDragging: aMouseEvent.
	self world ifNotNil: 
		[ self
			removeDropGesturePresent ;
			ensureNoSpacer ]! !

!MauiDomainMorph methodsFor: 'private' stamp: 'cmm 4/9/2008 12:57'!
noteDropGesturePresent
	self 
		setProperty: #dropGesturePresent
		toValue: true! !

!MauiDomainMorph methodsFor: 'Morphic' stamp: 'cmm 11/12/2010 14:42'!
noteNewOwner: aMorph 
	(priorOwner ~= aMorph and: [ priorOwner isMauiDomainMorph ]) ifTrue: [ priorOwner removePanel: self ].
	super noteNewOwner: aMorph.
"	self owner isMauiInstructionMorph ifTrue: [ self ensureNoBar ]."
	self
		undelineate ;
		undelineateAllLikeSelf.
	(self bounds containsPoint: ActiveHand position) ifFalse: [ self initializeBorder ].
	self isSelfContained ifFalse: 
		[ self mauiWorld 
			onePlayerFor: object
			is: self ]! !

!MauiDomainMorph methodsFor: 'events and overrides' stamp: 'cmm 1/15/2008 11:20'!
noteRefreshNeeded
	super noteRefreshNeeded.
	needsRefreshed := true! !

!MauiDomainMorph methodsFor: 'events and overrides' stamp: 'cmm 7/9/2008 21:23'!
notificationHandler: aMaNotificationHandler 
	"Set the object which implements send: aMessage to: anObject.  That method is implemented by the application-programmer to answer aMessage sentTo: anObject, but handling various Notifications, Errors or other Exceptions as appropriate for the application.
	The default behavior, if this is not specified, is to simply display notifications to the Transcript."
	super notificationHandler: aMaNotificationHandler.
	contextMenuMessages do: [ : each | each notificationHandler: aMaNotificationHandler ].
	panels do: [ : each | each notificationHandler: aMaNotificationHandler ]! !

!MauiDomainMorph methodsFor: 'accessing' stamp: 'cmm 4/29/2014 17:12'!
object: anObject 
	| oldObject |
	(object == anObject and: [ anObject isMauiPrototype not ]) ifTrue: [ ^ self ].
	oldObject := object.
	super object: anObject.
	self allMauiMorphsDo:
		[ : each | each isMauiInstructionMorph
			ifTrue:
				[ each isUiMessage ifFalse:
					[ each
						updateReceiverFrom: oldObject
						to: anObject ;
					refreshData ] ]
			ifFalse:
				[ each isMauiDomainMorph ifTrue:
					[ each
						updateObjectFrom: oldObject
						to: anObject ] ] ]! !

!MauiDomainMorph methodsFor: 'private' stamp: 'cmm 12/11/2008 10:54'!
onDesktop
	^ owner notNil and: [ owner isPlayfieldLike or: [ owner isHandMorph ] ]! !

!MauiDomainMorph methodsFor: 'family' stamp: 'cmm 3/14/2009 23:04'!
openFamilyMessage
	".. to see the views in my family."
	self family maui! !

!MauiDomainMorph methodsFor: 'view' stamp: 'cmm 11/29/2007 22:11'!
openManageViewsDialog
	"... to remember this view, or revert to a past version."
	self asMauiMorph manageViews openNextTo: self! !

!MauiDomainMorph methodsFor: 'view' stamp: 'cmm 12/2/2007 22:41'!
openNewViewNamed: viewName 
	(self asNewViewNamed: viewName)
		position: self sensibleAdjacentPosition ;
		openInWorld! !

!MauiDomainMorph methodsFor: 'private' stamp: 'cmm 4/29/2009 13:08'!
openSettingsPanel
	| panel |
	panel := self asMauiMorph.
	self object addMessagesToMauiSettingsPanel: panel.
	panel openNextTo: self! !

!MauiDomainMorph methodsFor: 'view' stamp: 'cmm 6/12/2007 16:35'!
openView: viewName 
	^ (self asNewViewNamed: viewName) openInHand! !

!MauiDomainMorph methodsFor: 'optional parameters' stamp: 'cmm 7/12/2007 14:01'!
optionalParameters
	"Answer a collection of objects that are used to easily populate parameters morphs with MauiDomainMorph parameters."
	^ #()! !

!MauiDomainMorph methodsFor: 'view' stamp: 'cmm 7/3/2009 15:37'!
panel
	self
		clear ;
		view: #panel.
	self listDirection = #topToBottom ifTrue: [ self ensureBar ].
	self
		initializeBorder ;
		initializeColor ;
		initializeSubmorphs! !

!MauiDomainMorph methodsFor: 'view' stamp: 'cmm 12/8/2010 14:20'!
physical
	self
		clear ;
		view: #physical.
	self listDirection = #topToBottom ifTrue: [ self ensureBar ].
	self initializeColor.
	object realObject maOriginalClass isPointers ifFalse: [ ^ self ].
	object realObject maOriginalClass allInstVarNames do: 
		[ : each | 
		| msg nameHolder valueHolder |
		msg := self addMessageNamed: #instVarNamed:put:.
		(msg selectStrategy: MauiClickedInvocationStrategy) selectNoResultTarget.
		nameHolder := msg firstParameterHolder.
		valueHolder := msg secondParameterHolder.
		nameHolder setParameter: each asMauiMorph.
		valueHolder setParameter: 
			((object realObject instVarNamed: each) asMauiMorph word
				producedView: #word ;
				yourself) ].
	self addMorphBack: 'Note:  The message must be *clicked* to invoke the value change.' asMauiMorph! !

!MauiDomainMorph methodsFor: 'optional parameters' stamp: 'cmm 8/1/2007 12:52'!
pickee
	^ pickee! !

!MauiDomainMorph methodsFor: 'optional parameters' stamp: 'cmm 6/16/2009 10:17'!
pickee: aMauiParameterHolderMorph 
	pickee := aMauiParameterHolderMorph.
	panels do: [ : each | each pickee: aMauiParameterHolderMorph ].
	self messageMorphsDo: 
		[ : each | 
		each resultMorph ifNotNilDo: [ : resultMorph | resultMorph pickee: aMauiParameterHolderMorph ] ].
	aMauiParameterHolderMorph ifNotNil: [ self bePickable ]! !

!MauiDomainMorph methodsFor: 'initialize-release' stamp: 'cmm 12/8/2010 14:18'!
postInitialize
	"This method offers a subclass hook for initializing any object-dependent variables that could not be calculated in initialize."
	object isMauiPrototype ifFalse: [ self level: object realObject maOriginalClass name ]! !

!MauiDomainMorph methodsFor: 'view' stamp: 'cmm 11/8/2009 21:02'!
preview
	"Pop up my previewView in a balloon."
	previewView ifNotNil: 
		[ (self asNewViewNamed: previewView)
			position: self adjacentPosition ;
			mauiEnsureOnScreen ;
			deleteOnMouseLeave ;
			openInWorld ;
			yourself ]! !

!MauiDomainMorph methodsFor: 'view' stamp: 'cmm 6/3/2009 14:45'!
previewView
	"Answer the view previewed in a balloon when the hand hovers over me."
	^ previewView! !

!MauiDomainMorph methodsFor: 'view' stamp: 'cmm 6/3/2009 14:47'!
previewView: aString
	"Set the view previewed when the hand enters my bounds."
	previewView := aString! !

!MauiDomainMorph methodsFor: 'view' stamp: 'cmm 6/13/2007 12:36'!
producedView
	"Answer the view produced when I receive a red-button click."
	^ producedView! !

!MauiDomainMorph methodsFor: 'view' stamp: 'cmm 1/26/2008 19:25'!
producedView: aString
	"Set the view produced when I receive a red-button click (left mouse button)."
	producedView := aString! !

!MauiDomainMorph methodsFor: 'events and overrides' stamp: 'cmm 6/11/2009 10:35'!
prototype
	^ self isSelfContained 
		ifTrue: [ self preferred: #embeddedDomainMorph ]
		ifFalse: 
			[ self wantsMargin 
				ifTrue: [ self preferred: #domainMorph ]
				ifFalse: 
					[ self isContent 
						ifTrue: [ self preferred: #contentDomainMorph ]
						ifFalse: [ self preferred: #embeddedDomainMorph ] ] ]! !

!MauiDomainMorph methodsFor: 'events and overrides' stamp: 'cmm 2/20/2013 16:20'!
refreshData
	((label notNil and: [ label isInWorld ]) and: [ self hasCustomLabel not ]) ifTrue: [ self resetLabel ].
	needsRefreshed := false.
	self noteDataRefreshed! !

!MauiDomainMorph methodsFor: 'private' stamp: 'cmm 7/25/2007 11:00'!
removeAllResultMorphs
	self messageMorphsDo: [ : each | each hasResult ifTrue: [ each resultMorph delete ] ]! !

!MauiDomainMorph methodsFor: 'initialize-release' stamp: 'cmm 12/8/2010 14:21'!
removeDependents
	object ifNotNil: 
		[ "removeDependent: is hideously slow, so don't do it for objects that won't have any anyway.."
		self requireChangedNotificationsForAutoRefresh ifTrue: 
			[ object realObject removeDependent: self.
			self messageMorphsDo: [ : each | each removeDependent: self ] ] ]! !

!MauiDomainMorph methodsFor: 'private' stamp: 'cmm 4/9/2008 12:57'!
removeDropGesturePresent
	self removeProperty: #dropGesturePresent! !

!MauiDomainMorph methodsFor: 'api-panels' stamp: 'cmm 12/15/2008 20:31'!
removePanel: aMauiDomainMorph 
	"aMauiDomainMorph needs to have the same object as me."
	^ panels 
		remove: aMauiDomainMorph
		ifAbsent: 
			[ "Hmm.."
			 ]! !

!MauiDomainMorph methodsFor: 'view' stamp: 'cmm 6/16/2009 18:24'!
removePrototype: aString atLevel: className 
	"... and the menu option will go away for that view for any kind of aClass."
	self family 
		removeAllOf: aString
		for: className! !

!MauiDomainMorph methodsFor: 'testing' stamp: 'cmm 7/1/2012 12:46'!
requireChangedNotificationsForAutoRefresh
	"Messages with AutoInvocationStrategy's will listen for #changed message in the domain."
	^ true! !

!MauiDomainMorph methodsFor: 'view' stamp: 'cmm 12/2/2003 23:36'!
revertToPrototype
	"... discarding your latest customizations."

	self as: self view! !

!MauiDomainMorph methodsFor: 'accessing' stamp: 'cmm 12/8/2010 14:21'!
save
	"A quick save if my view has already been named and saved before.  Otherwise, openManageViewsDialog (the save dialog)."
	view isString ifTrue: 
		[ (object realObject maOriginalClass withAllSuperclasses copyWithoutAll: {  Object. ProtoObject  }) 
			maDetect: 
				[ : each | 
				self family 
					hasViewsAt: each name
					named: view ]
			ifFound: 
				[ : foundClass | 
				Cursor wait showWhile: 
					[ self 
						savePrototype: view
						atLevel: foundClass name ] ]
			ifNone: [ self openManageViewsDialog ].
		^ self ].
	self openManageViewsDialog! !

!MauiDomainMorph methodsFor: 'menu' stamp: 'cmm 8/28/2012 22:27'!
saveAsGlobalContextMenu
	"Drag and customize whatever messages into the menu, above.  Then click this button to save the above as the new global context menu for any object of this type.  Do not drag messages below this button."
	| messageList |
	messageList := self family contextMenuMessagesFor: object realObject maOriginalClass name.
	messageList removeAll.
	self messageMorphsDo:
		[ : each | each moveToGlobalContextMenu ].
	messageList removeLast! !

!MauiDomainMorph methodsFor: 'menu' stamp: 'cmm 8/29/2012 17:27'!
saveAsViewContextMenu
	"Drag and customize whatever messages into the menu, above.  Then click this button to save the above as the new additional context menu items for this view of this object.  You can then save the view for all objects of this type and view to have these items on their context menu."
	| target |
	target := (self valueOfProperty: #contextMenuEditRequestor) ifNil: [ ^ self ].
	self messageMorphs allButLast do:
		[ : each | target addViewLevelUserMessage: (each copy receiver: each receiver asMauiPrototype) ]! !

!MauiDomainMorph methodsFor: 'view' stamp: 'cmm 8/13/2010 17:16'!
savePrototype: aString atLevel: className
	"Remember me as a view named aString, that can then be applied to any kind of class named className."
	self
		 view: aString ;
		 savePrototypeAtLevel: className! !

!MauiDomainMorph methodsFor: 'view' stamp: 'cmm 2/29/2012 19:59'!
savePrototypeAtLevel: className 
	"... so that, going forward, objects of the specified class kind will look similar to me."
	self family
		remember: self
		atLevel:
			(className isBehavior
				ifTrue: [ className name ]
				ifFalse: [ className ]).
	self makeAllLikeMe! !

!MauiDomainMorph methodsFor: 'private' stamp: 'cmm 2/19/2014 21:34'!
setObject: anObject
	"Subclasses should extend my behavior to update any custom widgetry they may manage to reflect the new object.  This should be done, as much as possible, by setting those custom widgets object:, rather than by deleting/readding them."
	(object == anObject and: [ anObject isMauiPrototype not ]) ifTrue: [ ^ self ].
	"performance"
	self mauiWorld removePlayer: self.
	self
		 removeDependents ;
		 setUserMessagesReceiver: anObject.
	(anObject isMauiPrototype and: [ self isInWorld ]) ifTrue: [ self delete ].
	super setObject: anObject.
	self
		 name: anObject mauiName ;
		 postInitialize.
	self addDependents.
	view = #word ifTrue: [ self initializeLabelString ].
	self world ifNotNil:
		[ self mauiWorld
			onePlayerFor: anObject
			is: self ].
	self noteRefreshNeeded! !

!MauiDomainMorph methodsFor: 'initialize-release' stamp: 'cmm 2/3/2014 17:23'!
setUserMessagesReceiver: anObject 
	contextMenuMessages do:
		[ : each | each isDomainMessage ifTrue: [ each receiver: anObject ] ]! !

!MauiDomainMorph methodsFor: 'events and overrides' stamp: 'cmm 10/28/2009 14:12'!
shouldHandleDropMorph
	^ spacer notNil! !

!MauiDomainMorph methodsFor: 'testing' stamp: 'cmm 3/29/2008 23:14'!
shouldInitializeLabelString
	label ifNil: [ ^ true ].
	label hasContents not ifTrue: [ ^ true ].
	"If the label was customized, preserve the customizations until they #resetLabel.  Otherwise, initialize with the default label."
	^ self hasCustomLabel not! !

!MauiDomainMorph methodsFor: 'events and overrides' stamp: 'cmm 1/15/2008 11:17'!
shouldRefreshData
	^ needsRefreshed or: 
		[ self requireChangedNotificationsForAutoRefresh not and: [ super shouldRefreshData ] ]! !

!MauiDomainMorph methodsFor: 'spacer' stamp: 'cmm 6/14/2007 11:08'!
spacerPosition

	^ spacer
		ifNil: [ submorphs size + 1 ]
		ifNotNil: [ submorphs indexOf: spacer ifAbsent: [ submorphs size + 1 ] ]! !

!MauiDomainMorph methodsFor: 'spacer' stamp: 'cmm 6/14/2007 11:08'!
startTrackingDropZones

	self
		startStepping: #trackDropZones 
		at: Time millisecondClockValue
		arguments: nil 
		stepTime: 100! !

!MauiDomainMorph methodsFor: 'Morphic' stamp: 'cmm 2/4/2014 17:18'!
step
	super step.
	"Fix for making balloons display properly."
	(owner notNil and:
		[ owner isBalloonHelp and: [ self world notNil ] ]) ifTrue: [ owner mauiAdjustVertices ].
	object isMauiPrototype ifFalse:
		[ self shouldRefreshData ifTrue: [ self refreshData ] ]! !

!MauiDomainMorph methodsFor: 'spacer' stamp: 'cmm 6/14/2007 11:08'!
stopTrackingDropZones
	self stopSteppingSelector: #trackDropZones! !

!MauiDomainMorph methodsFor: 'accessing' stamp: 'cmm 11/17/2010 14:23'!
suggestedLevel
	"Answer the highest-level class of my receviers superclass chain which can respond to all selectors."
	^ self eligibleLevels ifNotEmptyDo: [ : classNames | classNames last ]! !

!MauiDomainMorph methodsFor: 'private' stamp: 'cmm 7/13/2009 18:14'!
suggestedTabsDo: twoArgBlock 
	"Interrogate my object and imagine useful tabs.  Value twoArgBlock with the tab name and the tab itself."
	"There is no way to guess the 'useful' tabs, so we just provide up to 10 method categories each with up to 10 methods."
	| tabs |
	tabs := Dictionary new.
	self object maOriginalClass withAllSuperclassesDo: 
		[ : eachClass | 
		({  Object. ProtoObject  } includes: eachClass) ifFalse: 
			[ self 
				addTabsTo: tabs
				atClassLevel: eachClass ] ].
	tabs keysAndValuesDo: 
		[ : eachTabName : eachView | 
		twoArgBlock 
			value: eachTabName
			value: eachView ]! !

!MauiDomainMorph methodsFor: 'view' stamp: 'cmm 7/13/2009 18:14'!
supportsView: viewName 
	^ viewName isSymbol 
		ifTrue: [ self respondsTo: viewName ]
		ifFalse: 
			[ self family 
				supportsViewNamed: viewName
				for: self object maOriginalClass ]! !

!MauiDomainMorph methodsFor: 'label bar' stamp: 'cmm 6/15/2007 10:37'!
toggleLabelled
	"Toggle my label on and off."
	self isLabelled 
		ifTrue: [ self ensureNoBar ]
		ifFalse: [ self ensureBar ]! !

!MauiDomainMorph methodsFor: 'spacer' stamp: 'cmm 9/30/2007 21:39'!
trackDropZones
	"I am called many times per second when a droppable Morph is hovering, ready to be dropped onto me.  Put a 'spacer' morph whereever the current morph *could* be dropped."
	| hand handPosition morphsUnderHand submorphUnderHand |
	hand :=self primaryHand.
	hand ifNil: [ ^ self ].
	hand submorphs isEmpty
		ifTrue:
			[ self stopTrackingDropZones.
			^ self ].
	handPosition := hand position.
	morphsUnderHand := self morphsAt: (self globalPointToLocal: handPosition).
	morphsUnderHand size > 1 ifFalse: [ ^ self ].
	submorphUnderHand := morphsUnderHand at: morphsUnderHand size - 1. "<-- the one held directly by me."
	submorphUnderHand == spacer ifTrue: [ ^ self ].
	((self is: handPosition inFirstHalfOf: submorphUnderHand)
	and: [ submorphUnderHand ~~ labelBar ])
		ifTrue: [ self ensureSpacerInFrontOf: submorphUnderHand ]
		ifFalse: [ self ensureSpacerBehind: submorphUnderHand ]! !

!MauiDomainMorph methodsFor: 'private' stamp: 'cmm 11/8/2009 17:17'!
undelineateAllLikeSelf
	self mauiWorld undelineateFrom: self! !

!MauiDomainMorph methodsFor: 'view' stamp: 'cmm 12/27/2009 19:44'!
unobtrusive
	object 
		ifNil: [ self wisp ]
		ifNotNil: [ self word ]! !

!MauiDomainMorph methodsFor: 'events and overrides' stamp: 'cmm 1/9/2008 16:04'!
update: dummy

	needsRefreshed := true! !

!MauiDomainMorph methodsFor: 'label bar' stamp: 'cmm 12/24/2007 20:56'!
updateLabel
	| newLabel |
	newLabel := UIManager default 
		request: 'Set label' translated
		initialAnswer: label contents string.
	newLabel ifNotEmpty: [ self labelString: newLabel ]! !

!MauiDomainMorph methodsFor: 'private' stamp: 'cmm 2/4/2014 17:26'!
updateObjectFrom: oldObject to: newObject 
	(newObject isMauiPrototype and: [ self isInWorld ]) ifTrue: [ self delete ].
	((object == oldObject and: [ self isOptimizedFor: newObject ]) or: [ newObject isMauiPrototype ]) ifTrue:
		[ self setObject: newObject..
		self
			 name: newObject mauiName ;
			 postInitialize ]! !

!MauiDomainMorph methodsFor: 'copying' stamp: 'cmm 3/1/2009 14:32'!
veryDeepInner: aDeepCopier 
	super veryDeepInner: aDeepCopier.
	contextMenuMessages := contextMenuMessages veryDeepCopyWith: aDeepCopier.
	panels := panels veryDeepCopyWith: aDeepCopier.
	labelBar := labelBar veryDeepCopyWith: aDeepCopier.
	label := label veryDeepCopyWith: aDeepCopier.
	pickee := pickee veryDeepCopyWith: aDeepCopier.
	"Don't inherit the delete-on-mouse-leave function."
	self removeLink: #mouseLeave.
	self noteRefreshNeeded! !

!MauiDomainMorph methodsFor: 'view' stamp: 'cmm 6/27/2007 15:28'!
view
	^ view 
		ifNil: [ #panel ]
		ifNotNil: [ view ]! !

!MauiDomainMorph methodsFor: 'private' stamp: 'cmm 1/3/2004 16:28'!
view: aString

	view := aString! !

!MauiDomainMorph methodsFor: 'events and overrides' stamp: 'cmm 2/18/2013 21:35'!
wantsBalloon
	"List entry's already typically showing their #mauiDefaultColumns, so let's not worry about traversing all that to just because Morphic wants to know if my balloonText isNil."
	^ view ~= #defaultListEntry! !

!MauiDomainMorph methodsFor: 'Morphic' stamp: 'cmm 12/11/2008 10:55'!
wantsMargin
	^ self onDesktop and: [ self hasLabelBar ]! !

!MauiDomainMorph methodsFor: 'testing' stamp: 'cmm 12/10/2008 22:42'!
wantsModality
	"Answer whether I want only one of my child MauiMessageMorphs to display a resultMorph at a time.  This is useful when I am a group container of drop-down menus or tabs."
	^ wantsModality! !

!MauiDomainMorph methodsFor: 'testing' stamp: 'cmm 8/1/2007 12:15'!
wantsModality: aBoolean
	"Set whether only one of messageMorphs should be displaying their result at a time.  This is used to simulate 'tabs', where clicking on the next message removes the 'pane' (resultMorph) of the prior message that was clicked."
	wantsModality := aBoolean! !

!MauiDomainMorph methodsFor: 'view' stamp: 'cmm 12/27/2009 19:52'!
wisp
	self wispOfColor: object mauiColor! !

!MauiDomainMorph methodsFor: 'view' stamp: 'cmm 12/27/2009 20:51'!
wispOfColor: aColor 
	self
		clear ;
		beInvisible ;
		view: #wisp ;
		extent: 12 @ 12 ;
		cellPositioning: #center.
	self colorScheme panelFill: aColor asFillStyle.
	self initializeColor.
	(self preferred: #embeddedDomainMorph) borderWidth: 0.
	self object ifNil: [ self lock ]! !

!MauiDomainMorph methodsFor: 'view' stamp: 'cmm 8/8/2012 15:28'!
word
	self
		clear ;
		view: #word ;
		producedView: (self object mauiDefaultView ~= #word ifTrue: [ self object mauiDefaultView ]) ;
		beInvisible ;
		listDirection: #topToBottom ;
		wrapDirection: #none ;
		cellPositioning: #leftCenter ;
		layoutInset: 0 ;
		initializeColor ;
		addMorphBack: 
			(self label
				contents: self labelString ;
				font: Preferences standardDefaultTextFont ;
				lock ;
				yourself)! !

MauiDomainMorph subclass: #MauiFamilyMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Morphs'!

!MauiFamilyMorph methodsFor: 'as yet unclassified' stamp: 'cmm 7/29/2013 09:38'!
initializeSubmorphs
	| classesMsg viewsMsg |
	super initializeSubmorphs.
	(self addMessageNamed: #name) asGetterSetter.
	classesMsg := self addMessageNamed: #classes.
	(classesMsg selectStrategy: MauiAutoInvocationStrategy) resultView: #panel.
	viewsMsg := self addMessageNamed: #viewsForClassNamed:.
	viewsMsg invocationStrategy resultView: #horizontalListView.
	viewsMsg resultHolderMorph: self.
	viewsMsg resultMorph:
		(SortedCollection new asMauiMorph
			 horizontalListView ;
			 elementsView: #beSketch ;
			 yourself).
	self
		 addViewLevelUserMessage: (self newMessageNamed: #fileOut) ;
		 addMessageNamed: #removeAllButMostRecent: ;
		 addMessageNamed: #removeAllOf:for: ;
		 addMessageNamed: #removeViewsFor: ;
		 addMessageNamed: #moveViewsNamed:forClassNamed:to:! !

MauiDomainMorph subclass: #MauiFileDirectoryMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Morphs'!

!MauiFileDirectoryMorph commentStamp: 'cmm 9/26/2007 09:59' prior: 0!
I provide out-of-the-box views to represent a FileDirectory within the Maui UI framework.!

!MauiFileDirectoryMorph methodsFor: 'private' stamp: 'cmm 1/8/2008 12:18'!
addContainingDirectoriesMessage
	| msg |
	msg := (self newMessageNamed: #maWithContainingDirectories)
		hideLabels ;
		listDirection: #topToBottom ;
		yourself.
	(msg selectStrategy: MauiAutoInvocationStrategy)
		resultView: #horizontalListView ;
		producedView: nil.
	msg resultMorph: ((MauiMorph newFor: OrderedCollection new)
			horizontalListView ;
			elementsView: #localName ;
			yourself).
	self addMessage: msg! !

!MauiFileDirectoryMorph methodsFor: 'private' stamp: 'cmm 9/27/2007 12:56'!
addFindMessage: selectorSymbol labelled: labels
	| findMsg |
	findMsg := (self addMessageNamed: selectorSymbol)
		resultHolderMorph: self ;
		yourself.
	labels withIndexDo: 
		[ : each : n | 
		findMsg 
			labelAt: n
			put: each ].
	findMsg invocationStrategy resultView: #panel! !

!MauiFileDirectoryMorph methodsFor: 'private' stamp: 'cmm 1/8/2008 12:18'!
addLocalNameMessage
	(self addMessageNamed: #mauiLocalName)
		selectStrategy: MauiAutoInvocationStrategy ;
		hideLabels ;
		lock! !

!MauiFileDirectoryMorph methodsFor: 'private' stamp: 'cmm 9/20/2007 17:41'!
addOptionalParameters: anArray defaultValue: defaultValue toMessageNamed: selectorSymbol parameterIndex: parameterIndex 
	((self messageNamed: selectorSymbol) parameterHolderMorphAt: parameterIndex)
		optionalParametersMorph: anArray asMauiMorph ;
		dropParameter: defaultValue asMauiMorph word! !

!MauiFileDirectoryMorph methodsFor: 'accessing' stamp: 'cmm 8/14/2007 11:56'!
directory
	^ self object! !

!MauiFileDirectoryMorph methodsFor: 'accessing' stamp: 'cmm 8/14/2007 11:56'!
directory: aFileDirectory
	self object: aFileDirectory! !

!MauiFileDirectoryMorph methodsFor: 'view' stamp: 'cmm 4/20/2010 23:00'!
entries
	"Display all of my immediate entries, sorted by a specified column."
	| entriesMsg sortOptionsMorph |
	self
		clear ;
		ensureNoBar.
	entriesMsg := (self addMessageNamed: #maEntriesBy:)
		resultHolderMorph: self ;
		yourself.
	sortOptionsMorph := (self possibleSortAttributes asMauiMorphFor: self) horizontalListView.

	entriesMsg firstParameterHolder
		optionalParametersMorph: sortOptionsMorph ;
		optionalParametersStrategy: MauiListSelectionStrategy new ;
		setParameter: #modificationTime asMauiMorph.
	entriesMsg 
		labelAt: 1
		put: 'Sort By:'.
	(entriesMsg selectStrategy: MauiAutoInvocationStrategy )
		resultView: #panel ;
		producedView: nil! !

!MauiFileDirectoryMorph methodsFor: 'view' stamp: 'cmm 12/15/2008 20:29'!
find
	"Allows searching for a file by its name, attributes or contents."
	| possibleSortAttributes |
	self
		clear ;
		ensureNoBar.
	possibleSortAttributes := self possibleSortAttributes.
	self 
		addFindMessage: #maFindEntriesMatching:sortBy:
		labelled: #('Find Entries Matching:' 'Sort By:' ).
	(self messageNamed: #maFindEntriesMatching:sortBy:) firstParameterHolder evaluator: MauiStringEvaluator.
	self 
		addOptionalParameters: possibleSortAttributes
		defaultValue: #modificationDateAndTime
		toMessageNamed: #maFindEntriesMatching:sortBy:
		parameterIndex: 2.
	self 
		addFindMessage: #maFindEntries:sortBy:
		labelled: #('Find Entries:' 'Sort By:' ).
	self 
		addOptionalParameters: possibleSortAttributes
		defaultValue: #modificationDateAndTime
		toMessageNamed: #maFindEntries:sortBy:
		parameterIndex: 2.
	self 
		addFindMessage: #filesContaining:caseSensitive:
		labelled: #('Find Files Containing:' 'Case Sensitive:' ).
	self 
		addOptionalParameters: #(true false )
		defaultValue: false
		toMessageNamed: #filesContaining:caseSensitive:
		parameterIndex: 2.
	(self messageNamed: #filesContaining:caseSensitive:) secondParameterHolder optionalParametersStrategy: MauiCycleParametersStrategy new! !

!MauiFileDirectoryMorph methodsFor: 'initialize' stamp: 'cmm 2/13/2009 14:26'!
initializeSubmorphs
	| tabsPanel entriesMsg |
	super initializeSubmorphs.
	self addContainingDirectoriesMessage.
	tabsPanel := self newPanel
		listDirection: #leftToRight ;
		yourself.
	self addPanel: tabsPanel.
	tabsPanel addTab: #find.
	entriesMsg := tabsPanel addTab: #entries.
	(entriesMsg selectStrategy: MauiAutoInvocationStrategy) postInvokeAction: #selectClickedStrategy! !

!MauiFileDirectoryMorph methodsFor: 'view' stamp: 'cmm 5/27/2012 21:32'!
localName
	self
		clear ;
		addLocalNameMessage ;
		producedView: #panel ;
		view: #localName! !

!MauiFileDirectoryMorph methodsFor: 'view' stamp: 'cmm 4/20/2010 22:53'!
possibleSortAttributes
	^ #(#name #modificationTime #totalFileSize )! !

MauiDomainMorph subclass: #MauiFillStyleMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Morphs'!

!MauiFillStyleMorph methodsFor: 'as yet unclassified' stamp: 'cmm 11/30/2008 20:14'!
horizontalIcon
	"A rectangle of my color, with a label to the right of it.  This form consumes less vertical screen space than verticalIcon."
	self
		iconListed: #leftToRight ;
		cellInset: 2 ;
		view: #horizontalIcon! !

!MauiFillStyleMorph methodsFor: 'private' stamp: 'cmm 12/11/2008 15:07'!
iconListed: listDirection 
	| fillBlob lbl |
	self
		clear ;
		beInvisible.
	fillBlob := self newPanel
		small ;
		producedView: #horizontalIcon ;
		borderWidth: 0 ;
		lock ;
		yourself.
	lbl := self newPanel
		word ;
		borderWidth: 0 ;
		lock.
	self
		cellPositioning: #center ;
		cellInset: 2 ;
		beInvisible ;
		listDirection: listDirection.
	self
		addPanel: fillBlob ;
		addPanel: lbl! !

!MauiFillStyleMorph methodsFor: 'as yet unclassified' stamp: 'cmm 12/8/2008 16:51'!
initializeColor
	view = #small 
		ifTrue: [ self representOwnFillStyle ]
		ifFalse: [ super initializeColor ]! !

!MauiFillStyleMorph methodsFor: 'as yet unclassified' stamp: 'cmm 11/30/2008 20:03'!
representOwnFillStyle
	self fillStyle: self object! !

!MauiFillStyleMorph methodsFor: 'view' stamp: 'cmm 12/10/2008 10:14'!
small
	self
		clear ;
		representOwnFillStyle ;
		view: #small! !

!MauiFillStyleMorph methodsFor: 'view' stamp: 'cmm 11/30/2008 20:16'!
verticalIcon
	"A rectangle of my color, with a label below it."
	self
		iconListed: #topToBottom ;
		view: #verticalIcon! !

MauiDomainMorph subclass: #MauiInvocationStrategyMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Kernel'!

!MauiInvocationStrategyMorph commentStamp: 'cmm 7/2/2007 12:55' prior: 0!
I render any kind of MauiInvocationStrategy.

Originally, MauiInvocationStrategy's were created simply as a customized MauiDomainMorph.  But when we discovered we wanted the ability for the *class* of an object to help determine its resultMorph, reusableResultMorphFor: had to start requiring the result of an invocation to be isKindOf: the resultMorph's object's class (for example, True / False checkboxes requires this).

So once that change was made, the "edit invocation strategy's" getter would no longer reflect shape of the resultMorph once the setter changed it to a different class.

Therefore, we created this so that all InvocationStrategy's will have a way to render themselves.!

!MauiInvocationStrategyMorph methodsFor: 'as yet unclassified' stamp: 'cmm 8/2/2008 12:51'!
initializeSubmorphs
	super initializeSubmorphs.
	object initializeSubmorphsFor: self! !

MauiDomainMorph subclass: #MauiKeyMapMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Morphs'!

!MauiKeyMapMorph methodsFor: 'initialize' stamp: 'cmm 12/3/2008 10:39'!
addKeyMapSelectorFor: aMethodReference 
	| getter setter |
	getter := self newMessageNamed: aMethodReference selector.
	setter := getter asGetterSetter.
	self addMessage: setter! !

!MauiKeyMapMorph methodsFor: 'initialize' stamp: 'cmm 4/17/2008 09:46'!
initializeSubmorphs
	super initializeSubmorphs.
	self wrapDirection: #none.
	self keyMap accessingMethods do: [ : each | self addKeyMapSelectorFor: each ].
	self
		wrapDirection: #leftToRight ;
		height: World height * 3 // 2! !

!MauiKeyMapMorph methodsFor: 'accessing' stamp: 'cmm 4/16/2008 23:21'!
keyMap
	^ self object! !

MauiDomainMorph subclass: #MauiMorphMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Morphs'!

!MauiMorphMorph commentStamp: 'cmm 8/15/2004 22:49' prior: 0!
This class is used to show a MauiMorph and operate it just like a domain object.!

!MauiMorphMorph methodsFor: 'manage views' stamp: 'cmm 9/11/2007 17:23'!
addBeLikeAnotherMessage
	| firstParameter message views |
	message := self addMessageNamed: #beLike:.
	message 
		labelAt: 1
		put: 'Revert to:'.
	message invocationStrategy selectNoResultTarget.
	firstParameter := message firstParameterHolder.
	views := self mauiMorph family 
		viewsNamed: self mauiMorph view
		for: self mauiMorph object maOriginalClass.
	views ifNotNil: 
		[ firstParameter optionalParametersMorph: (views collect: [ : each | each copy ]) asMauiMorph.
		firstParameter optionalParametersMorph elementsView: #beSketch ]! !

!MauiMorphMorph methodsFor: 'manage views' stamp: 'cmm 4/18/2009 20:50'!
addRemovePrototypeMessage
	| message firstParameter secondParameter amUserView customViews currentView eligibleClasses |
	message := self addMessageNamed: #removePrototype:atLevel:.
	message
		labelAt: 1
			put: 'Remove view:' ;
		labelAt: 2
			put: 'for all kinds of:'.
	message invocationStrategy selectNoResultTarget.
	firstParameter := message firstParameterHolder.
	amUserView := false.
	customViews := OrderedCollection new.
	currentView := nil.
	self mauiMorph family 
		customViewsFor: self mauiMorph object
		do: 
			[ : each | 
			customViews add: each.
			each = self mauiMorph view ifTrue: 
				[ amUserView := true.
				currentView := each ] ].
	firstParameter optionalParametersMorph: customViews asMauiMorph.
	currentView ifNotNil: [ firstParameter dropParameter: currentView asMauiMorph ].
	secondParameter := message secondParameterHolder.
	amUserView ifTrue: 
		[ eligibleClasses := OrderedCollection new.
		self mauiMorph object maOriginalClass withAllSuperclassesDo: 
			[ : each | 
			(self mauiMorph family 
				hasViewsAt: each name
				named: self mauiMorph view) ifTrue: [ eligibleClasses add: each name ] ].
		secondParameter optionalParametersMorph: eligibleClasses asMauiMorph ]! !

!MauiMorphMorph methodsFor: 'manage views' stamp: 'cmm 11/17/2010 14:23'!
addSavePrototypeMessage
	| saveMessage firstParameter secondParameter customViews currentView |
	saveMessage := self addMessageNamed: #savePrototype:atLevel:.
	saveMessage
		labelAt: 1
			put: 'Remember view as:' ;
		labelAt: 2
			put: 'for all kinds of:'.
	saveMessage invocationStrategy selectNoResultTarget.
	firstParameter := saveMessage firstParameterHolder.
	customViews := OrderedCollection new.
	currentView := nil.
	self mauiMorph family 
		customViewsFor: self mauiMorph object
		do: 
			[ : each | 
			each = self mauiMorph view ifTrue: [ currentView := each ].
			customViews add: each ].
	firstParameter
		optionalParametersMorph: customViews asMauiMorph ;
		evaluator: MauiStringEvaluator.
	secondParameter := saveMessage secondParameterHolder.
	secondParameter optionalParametersMorph: self mauiMorph eligibleLevels asMauiMorph.
	currentView ifNotNil: [ firstParameter dropParameter: currentView asMauiMorph ].
	self mauiMorph suggestedLevel ifNotNilDo: 
		[ : cls | 
		firstParameter hasParameter ifTrue: [ saveMessage selectClickedStrategy ].
		secondParameter dropParameter: cls asMauiMorph word ].
	saveMessage invocationStrategy postInvokeAction: #deleteParent! !

!MauiMorphMorph methodsFor: 'view' stamp: 'cmm 3/14/2009 21:21'!
beSketch
	"Shows how I looked when I was saved."
	self mauiMorph isMauiPrototype ifTrue: [ ^ self ].
	(self mauiMorph hasSketch and: [ self submorphs includes: self mauiMorph sketch ]) ifTrue: [ ^ self ].
	self
		clear ;
		extent: 16 @ 16 ;
		beInvisible ;
		addMorph: self object view asMauiMorph ;
		addMorph: (self mauiMorph sketch copy
				scalePoint: (self preferred: #scalePoint) ;
				yourself) ;
		cellPositioning: #center.
	self view: #beSketch! !

!MauiMorphMorph methodsFor: 'initialize-release' stamp: 'cmm 12/27/2008 14:29'!
initialize
	super initialize.
	object isMauiMorph ifTrue: [ self fillStyle: self colorScheme dialogFill ]! !

!MauiMorphMorph methodsFor: 'initialize-release' stamp: 'cmm 12/27/2008 15:26'!
initializeColor
	super initializeColor.
	self fillStyle: 
		(self isContent 
			ifTrue: [ self colorScheme contentFill ]
			ifFalse: [ self colorScheme dialogFill ])! !

!MauiMorphMorph methodsFor: 'appearance' stamp: 'cmm 12/10/2008 10:29'!
labelFill
	^ object isMauiMorph 
		ifTrue: [ self colorScheme dialogLabelBarFill ]
		ifFalse: [ super labelFill ]! !

!MauiMorphMorph methodsFor: 'manage views' stamp: 'cmm 7/13/2007 15:05'!
manageViews
	"Change myself to the Manage Views dialog view."
	self
		panel ;
		addSavePrototypeMessage ;
		addBeLikeAnotherMessage ;
		addRemovePrototypeMessage ;
		view: #manageViews! !

!MauiMorphMorph methodsFor: 'accessing' stamp: 'cmm 8/10/2004 22:34'!
mauiMorph

	^ self object! !

!MauiMorphMorph methodsFor: 'accessing' stamp: 'cmm 7/19/2007 16:04'!
object: aMauiMorph
	super object: aMauiMorph.
	"We are changing to a new MauiMorph as my underlying object, if my view is the sketch of my underlying, then be sure to replace it with the sketch of aMauiMorph instead."
	self view = #beSketch ifTrue: [ self beSketch ]! !

!MauiMorphMorph methodsFor: 'view' stamp: 'cmm 12/3/2007 20:59'!
presentMorph
	"My object is a Morph, so it can be rendered directly by the system."
	object isMorph ifTrue: 
		[ self
			clear ;
			addMorphBack: object ]! !

MauiDomainMorph subclass: #MauiPageMorph
	instanceVariableNames: 'editor showToolBar toolBar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Morphs'!

!MauiPageMorph methodsFor: 'private' stamp: 'cmm 10/9/2007 13:07'!
addAlignmentMessagesTo: panel 
	#(
		#alignLeft
		#alignCentered
		#alignRight
		#alignJustified
	) do: 
		[ : each | 
		| msg |
		msg := panel addMessageNamed: each.
		msg
			hideLabels ;
			addMorphFront: ((self preferred: #iconSet) perform: each).
		(msg selectStrategy: MauiClickedInvocationStrategy) selectNoResultTarget ]! !

!MauiPageMorph methodsFor: 'private' stamp: 'cmm 10/9/2007 13:07'!
addEmphasisMessagesTo: panel 
	#(
		#makeNormal
		#bold
		#italicize
		#underline
	) do: 
		[ : each | 
		| msg |
		msg := panel addMessageNamed: each.
		msg
			hideLabels ;
			addMorphFront: ((self preferred: #iconSet) perform: each).
		(msg selectStrategy: MauiClickedInvocationStrategy) selectNoResultTarget ]! !

!MauiPageMorph methodsFor: 'private' stamp: 'cmm 12/10/2008 20:54'!
addFontMessagesTo: panel 
	| setSelectionColorMsg |
	#(#chooseDefaultFont #chooseSelectionFont ) do: 
		[ : each | 
		| msg |
		msg := panel addMessageNamed: each.
		msg
			hideLabels ;
			addMorphFront: ((self preferred: #iconSet) perform: each).
		(msg selectStrategy: MauiClickedInvocationStrategy) selectNoResultTarget ].
	"Add the #setSelectionColor:, which requires an argument."
	setSelectionColorMsg := panel newMessageNamed: #setSelectionColor:.
	setSelectionColorMsg invocationStrategy selectNoResultTarget.
	setSelectionColorMsg
		hideLabels ;
		addMorphFront: (self preferred: #iconSet) setSelectionColor.
	setSelectionColorMsg firstParameterHolder optionalParametersMorph: (Color asMauiMorphFor: self) namedColors.
	panel addMessage: setSelectionColorMsg! !

!MauiPageMorph methodsFor: 'private' stamp: 'cmm 2/8/2008 16:23'!
addToolBar
	"This will make my owner grow vertically, so shrink the editor's height accordingy."
	self hasToolBar ifFalse: 
		[ editor height: editor height - self toolBar height - (editor borderWidth * 2) + 1.
		self 
			addPanel: self toolBar
			at: (submorphs indexOf: editor) ]! !

!MauiPageMorph methodsFor: 'private' stamp: 'cmm 11/29/2007 11:13'!
addToolBarIfNecessary
	self hasToolBar ifFalse: 
		[ (self wantsToolBar and: [ self canHaveToolBar ]) ifTrue: [ self addToolBar ] ]! !

!MauiPageMorph methodsFor: 'Morphic' stamp: 'cmm 12/26/2007 17:11'!
adjustEditorWidth
	"Make my editor the same width as me."
	editor width: (editor width max: self width - (borderWidth * 2) - (self layoutInset * 2)) - 1! !

!MauiPageMorph methodsFor: 'word processing' stamp: 'cmm 10/26/2007 13:54'!
alignCentered
	self setAlignment: #centered! !

!MauiPageMorph methodsFor: 'word processing' stamp: 'cmm 10/26/2007 13:54'!
alignJustified
	self setAlignment: #justified! !

!MauiPageMorph methodsFor: 'word processing' stamp: 'cmm 10/26/2007 13:54'!
alignLeft
	self setAlignment: #leftFlush! !

!MauiPageMorph methodsFor: 'word processing' stamp: 'cmm 10/26/2007 13:54'!
alignRight
	self setAlignment: #rightFlush! !

!MauiPageMorph methodsFor: 'accessing' stamp: 'cmm 12/26/2007 16:44'!
autoResize
	^ editor autoExtent! !

!MauiPageMorph methodsFor: 'accessing' stamp: 'cmm 10/29/2007 16:53'!
autoResize: aBoolean 
	editor autoExtent: aBoolean! !

!MauiPageMorph methodsFor: 'menu' stamp: 'cmm 12/26/2007 16:45'!
autoResizeEnabledMenuString
	^ self autoResize 
		ifTrue: [ '<on>automatic resize' ]
		ifFalse: [ '<off>automatic resize' ]! !

!MauiPageMorph methodsFor: 'word processing' stamp: 'cmm 10/26/2007 13:54'!
bold
	self setEmphasis: #bold! !

!MauiPageMorph methodsFor: 'menu' stamp: 'cmm 2/6/2008 16:18'!
buildContextMenu
	| menu |
	menu := super buildContextMenu.
	self mauiWorld userStrategy 
		appendMauiPageMenuItemsTo: menu
		for: self.
	^ menu! !

!MauiPageMorph methodsFor: 'private' stamp: 'cmm 11/20/2010 20:22'!
canHaveToolBar
	^ #(#panel #wrapped #light) includes: view! !

!MauiPageMorph methodsFor: 'word processing' stamp: 'cmm 10/26/2007 17:13'!
chooseDefaultFont
	"Choose the default font for this document.  All text will appear in this font unless adjusted via the #changeSelectionFont command."
	self textMorph chooseStyle! !

!MauiPageMorph methodsFor: 'word processing' stamp: 'cmm 10/26/2007 17:13'!
chooseSelectionFont
	"Change the font of the selected text."
	self textMorph chooseFont! !

!MauiPageMorph methodsFor: 'accessing' stamp: 'cmm 1/26/2004 16:20'!
document

	^self object! !

!MauiPageMorph methodsFor: 'Morphic' stamp: 'cmm 12/28/2008 20:20'!
handlesMouseOverDragging: evt 
	"I don't like the way, when trying to drag Morphs into the document, it tries to put them between the document and edge of the MauiMorph.  So disable dragging into the MauiPageMorph."
	^ editor isNil or: [ editor isInWorld not ]! !

!MauiPageMorph methodsFor: 'private' stamp: 'cmm 11/29/2007 22:24'!
hasEditor
	^ editor notNil and: [ editor isInWorld ]! !

!MauiPageMorph methodsFor: 'private' stamp: 'cmm 11/28/2007 00:52'!
hasToolBar
	^ toolBar notNil and: [ submorphs includes: toolBar ]! !

!MauiPageMorph methodsFor: 'initializing' stamp: 'cmm 11/28/2007 17:14'!
initialize
	super initialize.
	self layoutInset: 0.
	self extent: World extent // 4.
	showToolBar := true! !

!MauiPageMorph methodsFor: 'private' stamp: 'cmm 12/27/2008 18:46'!
initializeColor
	super initializeColor.
	editor ifNotNil: [ editor fillStyle: self colorScheme contentFill ]! !

!MauiPageMorph methodsFor: 'view' stamp: 'cmm 11/28/2007 00:18'!
initializeSubmorphs
	super initializeSubmorphs.
	self addMorphBack: editor! !

!MauiPageMorph methodsFor: 'Morphic' stamp: 'cmm 12/26/2007 17:15'!
intoWorld: aWorld 
	super intoWorld: aWorld.
	aWorld ifNil: [ ^ self ].
	self hasEditor ifTrue: 
		[ self adjustEditorWidth.
		"Set up with toolbar if hand is already in.."
		(self bounds containsPoint: ActiveHand position) ifTrue: [ self postOpenFocus ].
		"Morphic doesn't call intoWorld for embeddedMorphs.  Do it."
		editor text embeddedMorphs do: [ : each | each intoWorld: aWorld ] ]! !

!MauiPageMorph methodsFor: 'word processing' stamp: 'cmm 10/26/2007 13:55'!
italicize
	self setEmphasis: #italic! !

!MauiPageMorph methodsFor: 'view' stamp: 'cmm 11/20/2010 21:05'!
light
	"Skips the window, just the text and the tool-bar."
	self
		 clear ;
		 view: #light ;
		 beInvisible ;
		 initializeSubmorphs ;
		 extent: 240@120 ;
		 autoResize: false ;
		 useToolBar: true.
	self addMorphBack: editor.
	editor borderWidth: 0.
	(self toolBar overridden: #colorScheme)
		 dialogFill: (Color white alpha: 0.5) ;
		 messageFill: Color transparent.
(	self toolBar overridden: #embeddedDomainMorph)
		borderColor: (Color white alpha: 0.2) ;
		borderWidth: 2! !

!MauiPageMorph methodsFor: 'events and overrides' stamp: 'cmm 6/18/2011 15:06'!
maContextKeywordsDo: aBlock
	object maContextKeywordsDo: aBlock! !

!MauiPageMorph methodsFor: 'word processing' stamp: 'cmm 10/26/2007 13:55'!
makeNormal
	self setEmphasis: #normal! !

!MauiPageMorph methodsFor: 'accessing' stamp: 'cmm 7/16/2008 21:55'!
mauiPage
	^ self object! !

!MauiPageMorph methodsFor: 'events and overrides' stamp: 'cmm 4/8/2008 23:15'!
maybeMouseLeftBounds: aMouseEvent 
	self world ifNotNilDo: 
		[ : world | 
		((world rootMorphsAtGlobal: aMouseEvent position) includesAnyOf: {  self. (self halo)  }) ifFalse: [ self removeToolBar ] ]! !

!MauiPageMorph methodsFor: 'view' stamp: 'cmm 11/20/2010 19:49'!
minimal
	"Shows just the text, no window, no background, no resizer."
	self
		 clear ;
		 view: #minimal ;
		 beInvisible ;
		 initializeSubmorphs ;
		 extent: 10 @ 10 ;
		 autoResize: true ;
		 useToolBar: false.
	self addMorphBack: editor! !

!MauiPageMorph methodsFor: 'events and overrides' stamp: 'cmm 11/29/2007 11:13'!
mouseEnter: aMouseEvent 
	self addToolBarIfNecessary.
	super mouseEnter: aMouseEvent! !

!MauiPageMorph methodsFor: 'events and overrides' stamp: 'cmm 11/28/2007 12:42'!
mouseLeave: aMouseEvent 
	self maybeMouseLeftBounds: aMouseEvent.
	super mouseLeave: aMouseEvent! !

!MauiPageMorph methodsFor: 'events and overrides' stamp: 'cmm 12/24/2008 14:25'!
notificationHandler: aMaNotificationHandler 
	super notificationHandler: aMaNotificationHandler.
	self textMorph submorphs do: 
		[ : each | 
		each isMauiMorph ifTrue: [ each notificationHandler: aMaNotificationHandler ] ]! !

!MauiPageMorph methodsFor: 'private' stamp: 'cmm 4/18/2009 17:26'!
object: aMauiPage 
	| page |
	page := aMauiPage isMauiPrototype 
		ifTrue: [ MauiPage new ]
		ifFalse: [ aMauiPage ].
	editor 
		ifNil: 
			[ editor := MauiTextEditor 
				on: page
				text: #restoreText
				accept: #backupText:
				readSelection: nil
				menu: #buildMenu:shifted:.
			self initializeColor.
			self autoResize: (self preferred: #autoResizeEditor) ]
		ifNotNil: 
			[ editor
				model: page ;
				cancel ].
	super object: aMauiPage! !

!MauiPageMorph methodsFor: 'Morphic' stamp: 'cmm 12/26/2007 17:12'!
postOpenFocus
	self addToolBarIfNecessary.
	editor addHalo.
	ActiveHand newKeyboardFocus: self textMorph! !

!MauiPageMorph methodsFor: 'private' stamp: 'cmm 2/8/2008 16:24'!
removeToolBar
	self hasToolBar ifTrue: 
		[ toolBar delete.
		editor height: editor height + toolBar height + (editor borderWidth * 2) - 1 ]! !

!MauiPageMorph methodsFor: 'word processing' stamp: 'cmm 10/29/2007 17:00'!
setAlignment: alignmentSymbol 
	self textMorph editor setAlignment: alignmentSymbol.
	self updateAfterTextOperation! !

!MauiPageMorph methodsFor: 'word processing' stamp: 'cmm 10/29/2007 17:00'!
setEmphasis: emphasisSymbol 
	self textMorph editor setEmphasis: emphasisSymbol.
	self updateAfterTextOperation! !

!MauiPageMorph methodsFor: 'word processing' stamp: 'cmm 10/26/2007 17:13'!
setSelectionColor: aColor 
	"Change the color of the selected text."
	self textMorph editor replaceSelectionWith: (self textMorph selection asText addAttribute: (TextColor color: aColor))! !

!MauiPageMorph methodsFor: 'word processing' stamp: 'cmm 10/26/2007 13:56'!
strikeOut
	self setEmphasis: #struckOut! !

!MauiPageMorph methodsFor: 'private' stamp: 'cmm 10/26/2007 17:12'!
textMorph
	"The inner TextMorph widget which supports several of my necessary operations."
	^ editor textMorph! !

!MauiPageMorph methodsFor: 'private' stamp: 'cmm 12/26/2007 16:44'!
toggleAutoResize
	self autoResize: self autoResize not! !

!MauiPageMorph methodsFor: 'private' stamp: 'cmm 11/28/2007 23:19'!
toggleToolBar
	showToolBar := showToolBar not.
	(self wantsToolBar and: [ self canHaveToolBar ]) 
		ifTrue: [ self addToolBar ]
		ifFalse: [ self removeToolBar ]! !

!MauiPageMorph methodsFor: 'private' stamp: 'cmm 12/10/2008 20:54'!
toolBar
	^ toolBar ifNil: 
		[ "Add Bold, Italic, Centering, etc. icon bar."
		toolBar := (self asMauiMorphFor: self)
			listDirection: #leftToRight ;
			cellPositioning: #center ;
			yourself.
		self
			addEmphasisMessagesTo: toolBar ;
			addFontMessagesTo: toolBar ;
			addAlignmentMessagesTo: toolBar.

		"Adding the toolbar may have widened me, so don't let there be grayspace to the right of my editor."
		editor width < toolBar width ifTrue: [ editor width: toolBar width ].
		toolBar ]! !

!MauiPageMorph methodsFor: 'menu' stamp: 'cmm 11/28/2007 23:13'!
toolBarEnabledMenuString
	^ self wantsToolBar 
		ifTrue: [ '<on>tool bar' ]
		ifFalse: [ '<off>tool bar' ]! !

!MauiPageMorph methodsFor: 'word processing' stamp: 'cmm 10/26/2007 13:56'!
underline
	self setEmphasis: #underlined! !

!MauiPageMorph methodsFor: 'word processing' stamp: 'cmm 1/2/2012 11:11'!
updateAfterTextOperation
	self textMorph paragraph composeAll.
	self textMorph editor recomputeSelection.
	self textMorph updateFromParagraph! !

!MauiPageMorph methodsFor: 'accessing' stamp: 'cmm 12/2/2007 22:52'!
useToolBar: aBoolean 
	showToolBar := aBoolean.
	aBoolean 
		ifTrue: [ self addToolBar ]
		ifFalse: [ self removeToolBar ]! !

!MauiPageMorph methodsFor: 'copying' stamp: 'cmm 12/24/2008 17:36'!
veryDeepFixupWith: aDeepCopier 
	super veryDeepFixupWith: aDeepCopier.
	toolBar ifNotNil: [ toolBar object: self ].
	editor addDependent: self! !

!MauiPageMorph methodsFor: 'copying' stamp: 'cmm 4/10/2009 23:57'!
veryDeepInner: aDeepCopier 
	super veryDeepInner: aDeepCopier.
	editor := editor veryDeepCopyWith: aDeepCopier.
	toolBar := toolBar veryDeepCopyWith: aDeepCopier! !

!MauiPageMorph methodsFor: 'private' stamp: 'cmm 11/28/2007 23:14'!
wantsToolBar
	^ showToolBar ! !

!MauiPageMorph methodsFor: 'view' stamp: 'cmm 4/10/2008 16:41'!
wrapped
	self panel.
	view := #wrapped! !

MauiDomainMorph subclass: #MauiPreferencesMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Kernel'!

!MauiPreferencesMorph methodsFor: 'initialize' stamp: 'cmm 4/15/2008 22:13'!
addInheritMessage: overrideOrInheritPanel 
	"The user may wish to no longer override a preference and go back to inheriting it.."
	| inheritMessage |
	inheritMessage := overrideOrInheritPanel addMessageNamed: #inherit:.
	inheritMessage firstParameterHolder optionalParametersMorph: self object specifiedPreferences asMauiMorph! !

!MauiPreferencesMorph methodsFor: 'initialize' stamp: 'cmm 3/18/2009 10:29'!
addOverrideMessage: overrideOrInheritPanel 
	"Offer the user a chance to override any preference."
	| overrideMessage |
	overrideMessage := overrideOrInheritPanel addMessageNamed: #override:.
	overrideMessage invocationStrategy selectNoResultTarget.
	overrideMessage firstParameterHolder optionalParametersMorph: self object overridablePreferences asMauiMorph! !

!MauiPreferencesMorph methodsFor: 'initialize' stamp: 'cmm 4/17/2008 13:34'!
addTabs
	| tabsPanel |
	tabsPanel := self newPanel listDirection: #leftToRight.
	self addPanel: tabsPanel.
	(self object specifies: #colorScheme) ifTrue: 
		[ tabsPanel 
			addTab: 'Colors'
			selector: #colorScheme
			view: #panel ].
	(self object specifies: #keyMap) ifTrue: 
		[ tabsPanel 
			addTab: 'Hot Keys'
			selector: #keyMap
			view: #panel ].
	self object specifiedUsabilityPreferences ifNotEmpty: 
		[ tabsPanel 
			addTab: 'Usability'
			view: #usabilitySettings ].
	self object specifiedPrototypePreferences ifNotEmpty: 
		[ tabsPanel 
			addTab: 'Prototypes'
			view: #prototypes ]! !

!MauiPreferencesMorph methodsFor: 'initialize' stamp: 'cmm 12/8/2008 22:02'!
addTargetMessage
	^ (self addMessageNamed: #target) selectStrategy: MauiAutoInvocationStrategy ! !

!MauiPreferencesMorph methodsFor: 'initialize' stamp: 'cmm 12/10/2008 10:30'!
initialize
	super initialize.
	self fillStyle: self colorScheme dialogFill! !

!MauiPreferencesMorph methodsFor: 'initialize' stamp: 'cmm 12/8/2008 22:02'!
initializeSubmorphs
	"Specified preferences"
	| overrideOrInheritPanel |
	super initializeSubmorphs.
	self object isGlobal ifFalse: 
		[ self addTargetMessage.
		overrideOrInheritPanel := self addPanel: (self newPanel listDirection: #leftToRight).
		"Offer the user a chance to override any preference."
		self
			addOverrideMessage: overrideOrInheritPanel ;
			addInheritMessage: overrideOrInheritPanel.
		((self addMessageNamed: #nextPreferences) selectStrategy: MauiAutoInvocationStrategy) producedView: #panel ].
	self object hasValues ifTrue: [ self addTabs ]! !

!MauiPreferencesMorph methodsFor: 'views' stamp: 'cmm 4/17/2008 13:21'!
prototypes
	"Specify alternative primitive widgets for Maui panels."
	self
		clear ;
		ensureBar ;
		labelString: 'Prototypes'.
	self object specifiedPrototypePreferences do: [ : each | (self addMessageNamed: each) asGetterSetter ].
	self view: #prototypeSettings! !

!MauiPreferencesMorph methodsFor: 'views' stamp: 'cmm 12/10/2008 21:24'!
refreshData
	super refreshData.
	view = #panel ifTrue: [ self perform: view ].
	MauiWorld current playersDo: [ : each | each initializeColor ]! !

!MauiPreferencesMorph methodsFor: 'views' stamp: 'cmm 4/17/2008 13:20'!
usabilitySettings
	"Adjustments to usability preferences."
	self
		clear ;
		ensureBar ;
		labelString: 'Usability'.
	self object specifiedUsabilityPreferences do: [ : each | (self addMessageNamed: each) asGetterSetter ].
	self view: #usabilitySettings! !

MauiDomainMorph subclass: #MauiProgressorMorph
	instanceVariableNames: 'progressBar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Morphs'!

!MauiProgressorMorph methodsFor: 'view' stamp: 'cmm 3/3/2008 16:30'!
addDescriptionMessage
	self addMessage: ((self newMessageNamed: #description)
			hideLabels ;
			selectStrategy: MauiAutoInvocationStrategy ;
			yourself)! !

!MauiProgressorMorph methodsFor: 'view' stamp: 'cmm 4/6/2013 15:57'!
addDetails
	"Add progress bar, message, rate and remaining time."
	self
		addProgressMessage ;
		addRateMessage.
	object knowsTaskSize ifTrue: [ self ensureRemainingTime ]! !

!MauiProgressorMorph methodsFor: 'view' stamp: 'cmm 3/3/2008 15:46'!
addProgressMessage
	self addMessage: ((self newMessageNamed: #progressMessage)
			hideLabels ;
			selectStrategy: MauiAutoInvocationStrategy ;
			yourself)! !

!MauiProgressorMorph methodsFor: 'view' stamp: 'cmm 3/3/2008 16:30'!
addRateMessage
	self addMessage: ((self newMessageNamed: #rateMessage)
			hideLabels ;
			selectStrategy: MauiAutoInvocationStrategy ;
			yourself)! !

!MauiProgressorMorph methodsFor: 'view' stamp: 'cmm 4/6/2013 16:06'!
detailedProgress
	"A view that shows all information about the progress."
	self clear.
	object knowsTaskSize
		ifTrue: [ self ensureProgressBar ]
		ifFalse: [ self ensureNoProgressBar ].
	(self overridden: #embeddedDomainMorph) borderWidth: 0.
	self
		 addDescriptionMessage ;
		 addDetails ;
		 view: #detailedProgress! !

!MauiProgressorMorph methodsFor: 'view' stamp: 'cmm 4/6/2013 16:07'!
details
	"A view that shows the progress message, rate and remainingTime."
	self clear.
	(self overridden: #embeddedDomainMorph) borderWidth: 0.
	self
		 addDetails ;
		 view: #details! !

!MauiProgressorMorph methodsFor: 'view' stamp: 'cmm 11/20/2007 15:13'!
ensureNoProgressBar
	progressBar ifNotNil: [ progressBar delete ].
	progressBar := nil! !

!MauiProgressorMorph methodsFor: 'view' stamp: 'cmm 5/30/2013 14:59'!
ensureNoRemainingTime
	self removeMessageNamed: #remainingTimeString! !

!MauiProgressorMorph methodsFor: 'view' stamp: 'cmm 11/20/2007 15:13'!
ensureProgressBar
	progressBar ifNil: [ progressBar := MaProgressBarMorph new ].
	(self submorphs includes: progressBar) ifFalse: [ self addMorph: progressBar ]! !

!MauiProgressorMorph methodsFor: 'view' stamp: 'cmm 5/30/2013 18:31'!
ensureRemainingTime
	| msg |
	(self hasMessageNamed: #remainingTimeString) ifFalse:
		[ msg := self addMessage: (self newMessageNamed: #remainingTimeString).
		(msg
			 removeLabels ;
			 selectStrategy: MauiAutoInvocationStrategy) producedView: nil ]! !

!MauiProgressorMorph methodsFor: 'view' stamp: 'cmm 4/4/2013 22:37'!
initializeSubmorphs
	self clear.
	view := #panel.
	self
		 ensureProgressBar ;
		 addDescriptionMessage! !

!MauiProgressorMorph methodsFor: 'Morphic' stamp: 'cmm 1/7/2008 15:14'!
intoWorld: aWorld 
	super intoWorld: aWorld.
	aWorld ifNotNil: 
		[ self startStepping.
		progressBar ifNotNil: [ progressBar startStepping ] ]! !

!MauiProgressorMorph methodsFor: 'accessing' stamp: 'cmm 8/7/2003 16:59'!
progressor

	^object! !

!MauiProgressorMorph methodsFor: 'Morphic' stamp: 'cmm 4/6/2013 17:19'!
refreshData
	super refreshData.
	(self progressor knowsTaskSize and: [ self progressor isComplete not ]) ifTrue:
		[ self progressor runningTime > 5 seconds ifTrue:
			[ view caseOf: {
				[ #panel ] -> 
					[ self
						 ensureProgressBar ;
						 ensureNoRemainingTime ].
				[ #detailedProgress ] -> 
					[ self
						 ensureProgressBar ;
						 ensureRemainingTime ].
				[ #details ] -> 
					[ self
						 ensureRemainingTime ;
						 ensureNoProgressBar ]}
				 otherwise: [  ] ] ].
	progressBar ifNotNil: [ progressBar percent: self progressor percentComplete ]! !

!MauiProgressorMorph methodsFor: 'copying' stamp: 'cmm 6/15/2007 10:34'!
veryDeepInner: aDeepCopier 
	super veryDeepInner: aDeepCopier.
	progressBar := progressBar veryDeepCopyWith: aDeepCopier! !

MauiDomainMorph subclass: #MauiSketchMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Morphs'!

!MauiSketchMorph methodsFor: 'as yet unclassified' stamp: 'cmm 6/28/2012 12:04'!
image
	self object isMauiPrototype ifTrue: [ ^ self ].
	self
		 clear ;
		 beInvisible ;
		 addMorph: self object ;
		 view: #image! !

MauiDomainMorph subclass: #MauiStringMorph
	instanceVariableNames: 'useSmalltalkNotation stringMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Morphs'!

!MauiStringMorph methodsFor: 'view' stamp: 'cmm 3/11/2009 16:32'!
beInvisible
	self
		borderColor: Color transparent ;
		cellInset: 0 ;
		color: Color transparent.
	self messageMorphsDo: [ : each | each beInvisible ]! !

!MauiStringMorph methodsFor: 'accessing' stamp: 'cmm 10/19/2007 17:24'!
contentsWidth
	^ stringMorph width! !

!MauiStringMorph methodsFor: 'events and overrides' stamp: 'cmm 11/22/2010 12:46'!
defaultListEntry
	"Change my shape to one suitable as a list-entry in a Collection.  Just add the messages you want as 'columns' first."
	self
		 word ;
		 view: #defaultListEntry! !

!MauiStringMorph methodsFor: 'events and overrides' stamp: 'cmm 12/10/2008 10:30'!
delineate
	stringMorph class = StringMorph ifTrue: [ stringMorph color: self colorScheme highlightedTextColor ]! !

!MauiStringMorph methodsFor: 'accessing' stamp: 'cmm 11/29/2007 14:29'!
font: aFont
	stringMorph font: aFont! !

!MauiStringMorph methodsFor: 'view' stamp: 'cmm 7/12/2007 17:47'!
horizontalIcon
	"This method is required only because the borderColor can be either a Color or a Symbol.  We assume it is a color and set its view to horizontalIcon, but if it's not, we can't have it blowing up."
	^ self word! !

!MauiStringMorph methodsFor: 'initializing' stamp: 'cmm 3/1/2012 21:31'!
initialize
	super initialize.
	useSmalltalkNotation := false.
	stringMorph := (StringMorph contents: String empty)
		color: self colorScheme standardTextColor ;
		yourself! !

!MauiStringMorph methodsFor: 'events and overrides' stamp: 'cmm 8/16/2007 13:01'!
initializeColor
	self view = #word 
		ifTrue: [ self beInvisible ]
		ifFalse: [ super initializeColor ]! !

!MauiStringMorph methodsFor: 'accessing' stamp: 'cmm 10/19/2007 17:54'!
object: aString 
	super object: aString.
	self refreshData! !

!MauiStringMorph methodsFor: 'initializing' stamp: 'cmm 12/27/2004 16:49'!
postInitialize

	super postInitialize.
	self resetContents! !

!MauiStringMorph methodsFor: 'Morphic' stamp: 'cmm 10/19/2007 17:28'!
refreshData
	super refreshData.
	self resetContents! !

!MauiStringMorph methodsFor: 'accessing' stamp: 'cmm 7/12/2013 11:06'!
representation
	^ (self string isNil or: [ self string isMauiPrototype ]) 
		ifTrue: [ String empty ]
		ifFalse: 
			[ useSmalltalkNotation 
				ifTrue: [ self string printString ]
				ifFalse: [ self string asString ] ]! !

!MauiStringMorph methodsFor: 'initializing' stamp: 'cmm 1/24/2008 12:25'!
resetContents
	self shouldWrap 
		ifTrue: [ self resetContentsWrapped ]
		ifFalse: [ self resetContentsAsIs ]! !

!MauiStringMorph methodsFor: 'initializing' stamp: 'cmm 2/11/2008 12:28'!
resetContentsAsIs
	stringMorph class = StringMorph ifFalse: 
		[ stringMorph ifNotNil: [ stringMorph delete ].
		stringMorph := StringMorph new.
		self addMorphBack: stringMorph ].
	stringMorph contents: self representation! !

!MauiStringMorph methodsFor: 'initializing' stamp: 'cmm 4/9/2009 13:30'!
resetContentsWrapped
	stringMorph class = MauiTextEditor ifFalse: 
		[ stringMorph ifNotNil: [ stringMorph delete ].
		stringMorph := (MauiTextEditor 
			on: nil
			text: nil
			accept: nil)
			extent: World extent // 4 ;
			autoExtent: self string size < 100.
		self addMorphBack: stringMorph ].
	stringMorph
		editString: self representation ;
		startStepping! !

!MauiStringMorph methodsFor: 'accessing' stamp: 'cmm 1/24/2008 12:07'!
setEmphasis: emphasisSelector 
	stringMorph emphasis: (TextEmphasis perform: emphasisSelector) emphasisCode! !

!MauiStringMorph methodsFor: 'events and overrides' stamp: 'cmm 3/13/2008 10:17'!
shouldRefreshData
	"Strings are used so much, and almost *never* change.  Therefore, Maui doesn't add dependents nor does it want to have to refresh them on every step."
	^ false! !

!MauiStringMorph methodsFor: 'initializing' stamp: 'cmm 4/9/2008 22:38'!
shouldWrap
	^ self string isMauiPrototype not and: [ view = #wrapped ]! !

!MauiStringMorph methodsFor: 'accessing' stamp: 'cmm 11/11/2003 22:55'!
string

	^self object! !

!MauiStringMorph methodsFor: 'accessing' stamp: 'cmm 7/16/2004 14:57'!
string: aString

	self object: aString! !

!MauiStringMorph methodsFor: 'accessing' stamp: 'cmm 4/15/2014 15:59'!
textColor: aFont
	stringMorph color: aFont! !

!MauiStringMorph methodsFor: 'events and overrides' stamp: 'cmm 11/16/2009 09:29'!
undelineate
	self removeAlarm: #delineateAllLikeSelf.
	stringMorph ifNotNil: 
		[ stringMorph class = StringMorph ifTrue: [ stringMorph color: self colorScheme standardTextColor ] ]! !

!MauiStringMorph methodsFor: 'accessing' stamp: 'cmm 11/20/2003 22:17'!
useSmalltalkNotation: aBoolean

	useSmalltalkNotation := aBoolean! !

!MauiStringMorph methodsFor: 'copying' stamp: 'cmm 3/4/2008 16:32'!
veryDeepCopy
	"This is a copy of the superclass implementation minus the call to #fixDependents, which horrendously slows down updating of lists and is unnecessary for this class."
	| copier new |
	copier := DeepCopier new initialize: self initialDeepCopierSize.
	new := self veryDeepCopyWith: copier.
	copier mapUniClasses.
	copier references associationsDo: [ : assoc | assoc value veryDeepFixupWith: copier ].
	^ new! !

!MauiStringMorph methodsFor: 'copying' stamp: 'cmm 10/19/2007 17:49'!
veryDeepInner: aDeepCopier 
	super veryDeepInner: aDeepCopier.
	stringMorph := stringMorph veryDeepCopyWith: aDeepCopier! !

!MauiStringMorph methodsFor: 'events and overrides' stamp: 'cmm 4/10/2008 13:15'!
wantsSteps
	^ false! !

!MauiStringMorph methodsFor: 'events and overrides' stamp: 'cmm 10/19/2007 17:49'!
word
	"This override is an optimisation; I'm already a StringMorph, so there's no need to add a copy of myself to myself."
	self
		view: #word ;
		beInvisible ;
		layoutInset: 0.
	(self includesMorphAnywhere: stringMorph) ifFalse: [ self addMorphBack: stringMorph ]! !

!MauiStringMorph methodsFor: 'view' stamp: 'cmm 4/9/2008 22:38'!
wrapped
	"A view allowing multiple lines and providing a scroll-bar."
	view := #wrapped.
	self resetContents! !

MauiDomainMorph subclass: #MauiTimespanMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Morphs'!

MauiTimespanMorph subclass: #MauiDateMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Morphs'!

!MauiDateMorph methodsFor: 'view' stamp: 'cmm 12/9/2007 11:41'!
dayOfMonth
	self
		clear ;
		view: #dayOfMonth ;
		beInvisible ;
		listDirection: #topToBottom ;
		wrapDirection: #none ;
		cellPositioning: #center ;
		layoutInset: 0 ;
		producedView: #word ;
		yourself.
	self addMorph: 
		(self date dayOfMonth asString asMauiMorph
			ensureNoLabelBar ;
			layoutInset: 0 ;
			lock ;
			yourself)! !

!MauiDateMorph methodsFor: 'initialize' stamp: 'cmm 12/9/2007 11:40'!
initializeColor
	"The dayOfMonth is specially initialized by MauiMonthMorph.  Don't override it."
	self view = #dayOfMonth ifFalse: [ super initializeColor ]! !

MauiTimespanMorph subclass: #MauiMonthMorph
	instanceVariableNames: 'weekMorphs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Morphs'!

!MauiMonthMorph methodsFor: 'initializing' stamp: 'cmm 11/14/2007 15:18'!
clear
	self initializeWeekMorphs.
	super clear! !

!MauiMonthMorph methodsFor: 'initializing' stamp: 'cmm 12/19/2007 11:33'!
colorForThisMonth
	^ self color lighter! !

!MauiMonthMorph methodsFor: 'initializing' stamp: 'cmm 12/19/2007 11:33'!
colorForToday
	^ Color yellow twiceDarker alpha: 0.4! !

!MauiMonthMorph methodsFor: 'private' stamp: 'cmm 7/31/2007 13:17'!
dateMorphsDo: oneArgBlock 
	"Value oneArgBlock with each of my weeks dateMorphs."
	self weekMorphsDo: [ : each | each dateMorphsDo: oneArgBlock ]! !

!MauiMonthMorph methodsFor: 'initializing' stamp: 'cmm 11/14/2007 15:18'!
initialize
	super initialize.
	self initializeWeekMorphs! !

!MauiMonthMorph methodsFor: 'initializing' stamp: 'cmm 12/10/2008 10:28'!
initializeColor
	"Override because we delineate each day of my month; the gradient makes it kind of messy looking."
	self view = #panel 
		ifTrue: 
			[ self fillStyle: (SolidFillStyle color: self colorScheme panelFill asColor) ]
		ifFalse: 
			[ self view = #word 
				ifTrue: [ self beInvisible ]
				ifFalse: [ super initializeColor ] ]! !

!MauiMonthMorph methodsFor: 'initializing' stamp: 'cmm 12/15/2008 22:08'!
initializeSubmorphs
	| firstWeek |
	super initializeSubmorphs.
	self listDirection: #topToBottom.
	"		cellInset: 0 ;"
	firstWeek := true.
"	self addMonthName."
	self month weeksDo: 
		[ : eachWeek | 
		| weekMorph |
		weekMorph := eachWeek asMauiMorph.
		firstWeek ifTrue: 
			[ weekMorph withHeader.
			firstWeek := false ].
		weekMorph producedView: #word.
		self addMorphBack: (weekMorphs add: weekMorph) ].
	self 
		emphasize: Date today asMonth
		color: self colorForThisMonth.
	self 
		emphasize: Date today
		color: self colorForToday! !

!MauiMonthMorph methodsFor: 'initializing' stamp: 'cmm 11/14/2007 15:18'!
initializeWeekMorphs
	weekMorphs := OrderedCollection new: 6! !

!MauiMonthMorph methodsFor: 'initializing' stamp: 'cmm 7/27/2007 17:37'!
intoWorld: aWorld 
	super intoWorld: aWorld.
	aWorld ifNotNil: 
		[ aWorld doOneCycle.
		self width: self height ]! !

!MauiMonthMorph methodsFor: 'initializing' stamp: 'cmm 7/27/2007 17:05'!
object: aMonth 
	| weeksStream |
	super object: aMonth.
	aMonth isMauiPrototype ifTrue: [ ^ self ].
	weeksStream := self month weeks readStream.
	self weekMorphsDo: [ : each | each object: weeksStream next ]! !

!MauiMonthMorph methodsFor: 'optional parameters' stamp: 'cmm 12/9/2007 12:08'!
pickee: aMauiParameterHolderMorph 
	pickee := aMauiParameterHolderMorph.
	self weekMorphsDo: [ : each | each pickee: aMauiParameterHolderMorph ]! !

!MauiMonthMorph methodsFor: 'copying' stamp: 'cmm 11/14/2007 12:21'!
veryDeepInner: aDeepCopier 
	super veryDeepInner: aDeepCopier.
	weekMorphs := weekMorphs veryDeepCopyWith: aDeepCopier! !

!MauiMonthMorph methodsFor: 'accessing' stamp: 'cmm 11/13/2007 16:58'!
weekMorphsDo: oneArgBlock 
	weekMorphs do: oneArgBlock! !

!MauiTimespanMorph methodsFor: 'private' stamp: 'cmm 12/19/2007 15:29'!
addMonth: aMonth 
	| answer |
	self addMorphBack: (answer := aMonth asMauiMorph).
	answer 
		emphasize: self timespan
		color: self colorForTimespan.
	^ answer! !

!MauiTimespanMorph methodsFor: 'private' stamp: 'cmm 12/9/2007 16:13'!
addMonthName
	self addMorphFront: (self createLabel: self month mauiName)! !

!MauiTimespanMorph methodsFor: 'view' stamp: 'cmm 12/19/2007 11:35'!
colorForTimespan
	^ Color 
		r: 0.33
		g: 0.123
		b: 0.615
		alpha: 0.4! !

!MauiTimespanMorph methodsFor: 'accessing' stamp: 'cmm 12/9/2007 13:35'!
date
	^ self object! !

!MauiTimespanMorph methodsFor: 'view' stamp: 'cmm 12/9/2007 13:15'!
datePicker
	"A view of monthly calendars."
	self panel.
	self
		addPanel: self newPanel threeMonth ;
		addPanel: self newPanel navigation ;
		view: #datePicker! !

!MauiTimespanMorph methodsFor: 'private' stamp: 'cmm 12/9/2007 13:37'!
emphasize: aTimespan color: aColor 
	self dateMorphsDo: 
		[ : eachDateMorph | 
		(aTimespan includes: eachDateMorph date) ifTrue: [ eachDateMorph color: aColor ] ]! !

!MauiTimespanMorph methodsFor: 'accessing' stamp: 'cmm 12/9/2007 13:35'!
month
	^ self object! !

!MauiTimespanMorph methodsFor: 'private' stamp: 'cmm 12/10/2008 20:55'!
navigation
	"Buttons to scroll forward or backward through the calendar."
	| backMsg forwardMsg gotoMsg |
	self view: #navigation.
	self listDirection: #leftToRight.
	backMsg := (self addMessageNamed: #backwardDays:) 
		labelAt: 1
		put: '< Backward'.
	backMsg reverseTableCells: true.
	backMsg firstParameterHolder
		optionalParametersMorph: self newNavSelections ;
		optionalParametersStrategy: MauiListSelectionStrategy new.
	backMsg invocationStrategy selectNoResultTarget.
	gotoMsg := (self addMessageNamed: #maStart:) 
		labelAt: 1
		put: 'Jump To:'.
	gotoMsg firstParameterHolder
		evaluator: MauiDateEvaluator ;
		optionalParametersMorph: ({  (Date today)  } asMauiMorphFor: self) horizontalListView ;
		optionalParametersStrategy: MauiListSelectionStrategy new.
	forwardMsg := (self addMessageNamed: #forwardDays:) 
		labelAt: 1
		put: 'Forward >'.
	forwardMsg firstParameterHolder
		optionalParametersMorph: self newNavSelections ;
		optionalParametersStrategy: MauiListSelectionStrategy new.
	forwardMsg invocationStrategy resultHolderTarget: 'none'! !

!MauiTimespanMorph methodsFor: 'private' stamp: 'cmm 12/26/2007 14:47'!
newNavSelections
	"Answer the morph used to provide the forward and backward navigation selections."
	^ #(30 90 365 ) asMauiMorph horizontalListView! !

!MauiTimespanMorph methodsFor: 'view' stamp: 'cmm 12/19/2007 15:23'!
oneMonth
	| monthMorph |
	self
		clear ;
		view: #oneMonth.
	monthMorph := self addMonth: self timespan start asMonth.
	monthMorph producedView: #word! !

!MauiTimespanMorph methodsFor: 'optional parameters' stamp: 'cmm 12/26/2007 14:22'!
pickee: aMauiParameterHolderMorph 
	view = #datePicker 
		ifTrue: 
			[ pickee := aMauiParameterHolderMorph.
			self resetPickee: aMauiParameterHolderMorph ]
		ifFalse: 
			[ view = #timespanPicker 
				ifTrue: [ pickee := aMauiParameterHolderMorph ]
				ifFalse: [ super pickee: aMauiParameterHolderMorph ] ]! !

!MauiTimespanMorph methodsFor: 'override' stamp: 'cmm 12/26/2007 15:00'!
refreshData
	super refreshData.
	(#(#timespanPicker #datePicker ) includes: view) ifTrue: 
		[ self perform: view.
		view = #datePicker ifTrue: [ self resetPickee: pickee ].
		self startStepping ]! !

!MauiTimespanMorph methodsFor: 'optional parameters' stamp: 'cmm 2/13/2014 17:08'!
resetPickee: aMauiParameterHolderMorph 
	self allMauiMorphsDo: 
		[ : each | 
		(each isMauiDomainMorph and: [ each view = #dayOfMonth ]) ifTrue: [ each pickee: aMauiParameterHolderMorph ] ]! !

!MauiTimespanMorph methodsFor: 'private' stamp: 'cmm 11/15/2007 08:21'!
selectEndpoints
	| selectionPanel |
	selectionPanel := self newPanel listDirection: #leftToRight.
	#(#maStart: #maEnd: ) do: 
		[ : each | 
		| eachMessage eachLabel |
		eachMessage := selectionPanel addMessageNamed: each.
		eachLabel := (eachMessage labelAt: 1) string.
		eachMessage 
			labelAt: 1
			put: (eachLabel 
					copyFrom: 3
					to: eachLabel size) ].
	^ selectionPanel! !

!MauiTimespanMorph methodsFor: 'view' stamp: 'cmm 1/28/2012 12:41'!
threeMonth
	"A view of monthly calendars."
	self
		clear ;
		view: #threeMonth ;
		ensureNoBar ;
		listDirection: #leftToRight ;
		cellPositioning: #topCenter.
	self timespan withSurroundingMonthsDo: [ : each | (self addMonth: each) ensureNoCloseBox ]! !

!MauiTimespanMorph methodsFor: 'accessing' stamp: 'cmm 7/30/2007 12:28'!
timespan
	^ self object! !

!MauiTimespanMorph methodsFor: 'view' stamp: 'cmm 12/9/2007 13:15'!
timespanPicker
	"A view of monthly calendars allowing selection of a date range."
	self
		panel ;
		cellPositioning: #center ;
		addPanel: self newPanel threeMonth ;
		addPanel: self newPanel selectEndpoints ;
		addPanel: self newPanel navigation ;
		view: #timespanPicker! !

!MauiTimespanMorph methodsFor: 'accessing' stamp: 'cmm 12/9/2007 13:35'!
week
	^ self object! !

MauiTimespanMorph subclass: #MauiWeekMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Morphs'!

!MauiWeekMorph methodsFor: 'private' stamp: 'cmm 12/8/2009 10:39'!
add7Morphs: anArray 
	anArray withIndexDo: 
		[ : each : x | 
		| layoutFrame |
		layoutFrame := LayoutFrame new
			leftFraction: (x - 1) / 7.0 ;
			rightFraction: x / 7.0 ;
			yourself.
		self addMorphBack: (each
				layoutFrame: layoutFrame ;
				yourself) ]! !

!MauiWeekMorph methodsFor: 'private' stamp: 'cmm 12/10/2008 20:55'!
addDates
	self add7Morphs: (self week dates collect: [ : each | (each asMauiMorphFor: self) dayOfMonth ])! !

!MauiWeekMorph methodsFor: 'initialize' stamp: 'cmm 7/27/2007 15:48'!
addHeader
	self add7Morphs: (#('S' 'M' 'T' 'W' 'T' 'F' 'S' ) collect: [ : each | each asMauiMorph ])! !

!MauiWeekMorph methodsFor: 'private' stamp: 'cmm 2/13/2014 17:08'!
dateMorphsDo: aBlock 
	self allMauiMorphsDo: 
		[ : each | 
		(each object isKindOf: Date) ifTrue: [ aBlock value: each ] ]! !

!MauiWeekMorph methodsFor: 'private' stamp: 'cmm 7/30/2007 10:02'!
defaultBorderColor
	^ Color transparent ! !

!MauiWeekMorph methodsFor: 'initialize' stamp: 'cmm 7/30/2007 16:41'!
initialize
	super initialize.
	self
		beInvisible ;
		layoutPolicy: ProportionalLayout new ;
		listDirection: #leftToRight ;
		cellInset: 0 ;
		hResizing: #spaceFill ;
		cellPositioning: #center.
	self width: '22   23   24   25   26   27' asMauiMorph contentsWidth * 2! !

!MauiWeekMorph methodsFor: 'initialize' stamp: 'cmm 12/10/2008 10:30'!
initializeColor
	"Override because we delineate each day of my month; the gradient makes it kind of messy looking."
	self view = #panel 
		ifTrue: 
			[ self fillStyle: (SolidFillStyle color: self colorScheme panelFill asColor) ]
		ifFalse: [ super initializeColor ]! !

!MauiWeekMorph methodsFor: 'view' stamp: 'cmm 7/30/2007 16:47'!
initializeSubmorphs
	super initializeSubmorphs.
	self
		layoutInset: 0 ;
		cellInset: 0 ;
		addDates! !

!MauiWeekMorph methodsFor: 'initialize' stamp: 'cmm 7/27/2007 16:56'!
object: aWeek 
	| datesStream |
	super object: aWeek.
	aWeek isMauiPrototype ifTrue: [ ^ self ].
	datesStream := aWeek dates readStream.
	self dateMorphsDo: [ : each | each object: datesStream next ]! !

!MauiWeekMorph methodsFor: 'optional parameters' stamp: 'cmm 12/9/2007 12:07'!
pickee: aMauiParameterHolderMorph 
	pickee := aMauiParameterHolderMorph.
	self dateMorphsDo: [ : each | each pickee: aMauiParameterHolderMorph ]! !

!MauiWeekMorph methodsFor: 'view' stamp: 'cmm 12/19/2007 15:15'!
withHeader
	| header dates |
	self
		clear ;
		view: #withHeader.
	header := self newPanel.
	dates := self newPanel panel.
	self
		layoutPolicy: TableLayout new ;
		listDirection: #topToBottom ;
		vResizing: #shrinkWrap.
	header addHeader.
	self addPanel: header.
	self addPanel: dates! !

MauiDomainMorph subclass: #MauiUserErrorMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Morphs'!

!MauiUserErrorMorph methodsFor: 'as yet unclassified' stamp: 'cmm 2/21/2009 15:57'!
initializeSubmorphs
	| msg |
	super initializeSubmorphs.
	(msg := self addMessageNamed: #page)
		hideLabels ;
		resultMorph: (MauiPage new asMauiMorph
				autoResize: true ;
				useToolBar: false ;
				ensureNoBar ;
				notificationHandler: self notificationHandler ;
				yourself).
	(msg selectStrategy: MauiAutoInvocationStrategy)
		selectLocalResultTarget ;
		resultView: #panel ;
		producedView: nil! !

!MauiUserErrorMorph methodsFor: 'as yet unclassified' stamp: 'cmm 2/21/2009 15:55'!
userError
	^ self object! !

MauiMorph subclass: #MauiInstructionMorph
	instanceVariableNames: 'labels parameterHolderMorphs resultMorph resultHolderMorph invocationStrategy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Morphs'!

!MauiInstructionMorph commentStamp: 'cmm 5/1/2009 12:01' prior: 0!
A MauiInstructionMorph is the abstract superclass for a widget that invokes an instruction; either a Message or a Block, and outputs the result according to its invocationStrategy.

Instance Variables
	invocationStrategy:		<Object>
	labels:		<Object>
	parameterHolderMorphs:		<Object>
	resultHolderMorph:		<Object>
	resultMorph:		<Object>

invocationStrategy
	- xxxxx

labels
	- xxxxx

parameterHolderMorphs
	- xxxxx

resultHolderMorph
	- xxxxx

resultMorph
	- xxxxx
!

MauiInstructionMorph subclass: #MauiBlockMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Morphs'!

!MauiBlockMorph commentStamp: 'cmm 5/1/2009 12:05' prior: 0!
A MauiBlockMorph is a special-case for Maui where keyword messages wish to be used as unary messages (for a better UI experience).  

A MauiBlock is always a one-argument block that is valued with the object its MauiBlockMorph resides on.!

!MauiBlockMorph class methodsFor: 'as yet unclassified' stamp: 'cmm 5/1/2009 15:42'!
mauiBlock: aMauiBlock
	^ self maNewFor: aMauiBlock! !

!MauiBlockMorph class methodsFor: 'as yet unclassified' stamp: 'cmm 5/1/2009 15:43'!
receiver: anObject block: aMauiBlock 
	^ self mauiBlock: 
		(MauiBlock 
			receiver: anObject
			block: aMauiBlock)! !

!MauiBlockMorph methodsFor: 'events and overrides' stamp: 'cmm 2/3/2014 22:37'!
allMauiMorphsDo: aBlock ifNotIn: anIdentitySet 
	super
		allMauiMorphsDo: aBlock
		ifNotIn: anIdentitySet.
	self mauiBlock
		allMauiMorphsDo: aBlock
		ifNotIn: anIdentitySet! !

!MauiBlockMorph methodsFor: 'events and overrides' stamp: 'cmm 2/15/2014 17:58'!
allMorphsDo: aBlock 
	super allMorphsDo: aBlock.
	self block referencesDo:
		[ : each | each isMorph ifTrue: [ aBlock value: each ] ]! !

!MauiBlockMorph methodsFor: 'accessing' stamp: 'cmm 5/1/2009 12:12'!
block
	"The underlying block."
	^ self mauiBlock block! !

!MauiBlockMorph methodsFor: 'accessing' stamp: 'cmm 5/1/2009 12:11'!
mauiBlock
	^ self object! !

!MauiBlockMorph methodsFor: 'private' stamp: 'cmm 5/1/2009 13:40'!
mauiLabelString
	^ self block mauiName! !

!MauiBlockMorph methodsFor: 'initialize-release' stamp: 'cmm 7/4/2013 17:19'!
mauiNoteOutOfWorld
	| cntx |
	super mauiNoteOutOfWorld.
	cntx := self block outerContext.
	cntx removeSelf.
	1
		to: cntx basicSize
		do:
			[ : slot | (cntx at: slot) isMauiDomainMorph ifTrue:
				[ (cntx at: slot)
					 mauiNoteOutOfWorld ;
					 resetObject ] ]! !

!MauiBlockMorph methodsFor: 'private' stamp: 'cmm 5/1/2009 12:09'!
messagePartsDo: oneArgBlock
	oneArgBlock value: self block printString! !

!MauiBlockMorph methodsFor: 'events and overrides' stamp: 'cmm 2/16/2014 19:36'!
notificationHandler: aMauiNotificationHandler 
	notificationHandler == aMauiNotificationHandler ifFalse:
		[ super notificationHandler: aMauiNotificationHandler.
		self block referencesDo:
			[ : each | each isMauiMorph ifTrue: [ each notificationHandler: aMauiNotificationHandler ] ] ]! !

!MauiBlockMorph methodsFor: 'events and overrides' stamp: 'cmm 6/11/2009 10:35'!
prototype
	^ self preferred: #blockMorph! !

!MauiBlockMorph methodsFor: 'private' stamp: 'cmm 5/1/2009 13:47'!
selectorInFocus
	^ self block method messages ifNotEmptyDo: [ : msgs | msgs atRandom ]! !

!MauiInstructionMorph methodsFor: 'accessing' stamp: 'cmm 2/3/2014 22:34'!
allMauiMorphsDo: aBlock ifNotIn: anIdentitySet 
	super
		allMauiMorphsDo: aBlock
		ifNotIn: anIdentitySet.
	resultMorph ifNotNil:
		[ (anIdentitySet includes: resultMorph) ifFalse:
			[ anIdentitySet add: resultMorph.
			aBlock value: resultMorph.
			resultMorph
				allMauiMorphsDo: aBlock
				ifNotIn: anIdentitySet ] ]! !

!MauiInstructionMorph methodsFor: 'Morphic' stamp: 'cmm 5/1/2009 13:49'!
asMauiMessageUsing: aMauiMorph 
	self instruction receiver: aMauiMorph object.
	^ self! !

!MauiInstructionMorph methodsFor: 'ide' stamp: 'cmm 5/1/2009 14:00'!
browseSenders
	PointerFinder on: self block! !

!MauiInstructionMorph methodsFor: 'menu' stamp: 'cmm 5/1/2009 12:21'!
buildContextMenu

	| menu |
	menu := super buildContextMenu
		defaultTarget: self;
		yourself.
	self mauiWorld userStrategy
		appendMessageMorphItemsTo: menu
		for: self.
	^ menu! !

!MauiInstructionMorph methodsFor: 'menu' stamp: 'cmm 8/29/2012 17:28'!
buildToolMenu
	| menu |
	menu := super buildToolMenu.
	menu 
		addUpdating: #hasLabelsMenuString
		action: #toggleLabels.
	menu addLine.
	(self canBeGetter and: [ self isGetter not ]) ifTrue: 
		[ menu 
			add: 'be a getter' translated
			target: self
			selector: #asGetter ].
	(self canBeGetterSetter and: [ self isGetterSetter not ]) ifTrue: 
		[ menu 
			add: 'be a getter/setter' translated
			target: self
			selector: #addAsGetterSetter ].
	menu 
		add: (self 
				string: 'settings...' translated
				withKeyBindingFor: #keyForEdit)
		target: self
		selector: #openSettingsPanel.
	menu 
		addUpdating: #debugModeMenuString
		action: #toggleDebugMode.
	menu 
		addUpdating: #profileModeMenuString
		action: #toggleProfileMode.
	menu 
		add: (self 
				string: 'view senders' translated
				withKeyBindingFor: #keyForBrowseSenders)
		target: self
		selector: #browseSenders.
	^ menu! !

!MauiInstructionMorph methodsFor: 'testing' stamp: 'cmm 5/1/2009 12:06'!
canBeGetter
	^ false! !

!MauiInstructionMorph methodsFor: 'testing' stamp: 'cmm 5/1/2009 12:47'!
canBeGetterSetter
	^ false! !

!MauiInstructionMorph methodsFor: 'events and overrides' stamp: 'cmm 5/1/2009 12:56'!
canDropInto: aMauiMorph 
	^ true! !

!MauiInstructionMorph methodsFor: 'testing' stamp: 'cmm 6/29/2012 11:02'!
canInvoke
	"Don't invoke if my receiver is not a domain object or if this message invokes on MouseOver but is currently in the hand (that situation results in a required image kill without this guard)."
	^ self instruction receiver isMauiPrototype not and:
		[ (self invocationStrategy isMouseOver and:
			[ self owner notNil and: [ self owner isHandMorph ] ]) not ]! !

!MauiInstructionMorph methodsFor: 'private' stamp: 'cmm 5/1/2009 12:56'!
classInFocus
	^ self instruction implementorClass! !

!MauiInstructionMorph methodsFor: 'accessing' stamp: 'cmm 6/1/2009 11:04'!
cloneUi
	""
	| clone |
	clone := self copy
		notificationHandler: self notificationHandler ;
		yourself.
	"There's no reason to keep the resultMorph around.  It pops up with MauiPrototypes which is confusing."
	clone hasResult ifTrue: [ clone removeResult ].
	^ clone openInHand! !

!MauiInstructionMorph methodsFor: 'accessing' stamp: 'cmm 5/1/2009 13:35'!
comeToFrontWithFellowPlayers
	"Causes all views of the receiver in the current World to rise to the surface, making them visible if they were previously covered by a window."
	self comeToFrontWithFellowPlayersOf: self receiver! !

!MauiInstructionMorph methodsFor: 'labels' stamp: 'cmm 5/1/2009 12:59'!
concatenatedLabels
	^ String streamContents: 
		[ : stream | 
		self labelsDo: 
			[ : each | 
			"If it is iconic, it probably won't have #contents"
			(each respondsTo: #contents) ifTrue: [ stream nextPutAll: each contents ] ] ]! !

!MauiInstructionMorph methodsFor: 'labels' stamp: 'cmm 5/1/2009 13:31'!
createLabel: aString 
	^ StringMorph new
		color: self colorScheme standardTextColor ;
		contents: aString ;
		emphasis: TextEmphasis bold emphasisCode ;
		lock ;
		yourself! !

!MauiInstructionMorph methodsFor: 'menu' stamp: 'cmm 5/1/2009 15:55'!
debugModeMenuString
	^ self instruction debugMode 
		ifTrue: [ '<on>debug' ]
		ifFalse: [ '<off>debug' ]! !

!MauiInstructionMorph methodsFor: 'events and overrides' stamp: 'cmm 5/1/2009 14:31'!
defaultBorderColor
	^ Color transparent! !

!MauiInstructionMorph methodsFor: 'events and overrides' stamp: 'cmm 2/14/2012 10:03'!
delineate
	| standardColor highlightColor |
	super delineate.
	standardColor := (self preferred: #colorScheme) messageFill.
	highlightColor := standardColor isColor
		ifTrue: [ standardColor muchDarker alpha: 0.4 ]
		ifFalse: [ Color white alpha: 0.3 ].
	self color: highlightColor! !

!MauiInstructionMorph methodsFor: 'Morphic' stamp: 'cmm 3/7/2013 14:57'!
desiredRefreshInterval
	^ self stepTime ifNil: [ 1000 ]! !

!MauiInstructionMorph methodsFor: 'private' stamp: 'cmm 5/1/2009 12:32'!
determineResultHolder
	^ resultHolderMorph ifNil: [ invocationStrategy resultTargetFor: self ]! !

!MauiInstructionMorph methodsFor: 'private' stamp: 'cmm 5/1/2009 13:39'!
goBehindWithFellowPlayers
	self goBehindWithFellowPlayersOf: self receiver! !

!MauiInstructionMorph methodsFor: 'keyboard' stamp: 'cmm 4/23/2014 10:37'!
handleMessageKeyboardEvent: aKeyboardEvent
	"Answer whether aKeyboardEvent was consumed."
	| keyPressed |
	keyPressed := aKeyboardEvent keyCharacter.
	keyPressed = (self preferred: #keyMap) keyForRefresh ifTrue: 
		[ self refreshResult.
		^ true ].
	keyPressed = (self preferred: #keyMap) keyForBrowseSenders ifTrue: 
		[ self browseSenders.
		^ true ].
	^ false! !

!MauiInstructionMorph methodsFor: 'events and overrides' stamp: 'cmm 5/1/2009 14:33'!
handlesMouseOverDragging: evt

	^false! !

!MauiInstructionMorph methodsFor: 'events and overrides' stamp: 'cmm 2/10/2013 13:28'!
handlesMouseStillDown: aMouseEvent 
	^ invocationStrategy repeat! !

!MauiInstructionMorph methodsFor: 'labels' stamp: 'cmm 5/1/2009 13:32'!
hasLabels

	^labels allSatisfy: [ : each | self submorphs includes: each ]! !

!MauiInstructionMorph methodsFor: 'labels' stamp: 'cmm 5/1/2009 13:36'!
hasLabelsMenuString
	^ self hasLabels 
		ifTrue: 
			[ self 
				string: '<on>labelled'
				withKeyBindingFor: #keyForToggleLabelled ]
		ifFalse: 
			[ self 
				string: '<off>labelled'
				withKeyBindingFor: #keyForToggleLabelled ]! !

!MauiInstructionMorph methodsFor: 'testing' stamp: 'cmm 5/1/2009 12:31'!
hasLocalResult
	"Answers whether my result-Morph is contained as part of me or my receiverMorph."
	^ self hasResult and: [ self isLocal: resultMorph ]! !

!MauiInstructionMorph methodsFor: 'testing' stamp: 'cmm 5/1/2009 14:03'!
hasLocalResultHolder
	"Answers whether my resultHolderMorph is contained as part of me or my receiverMorph."
	^ resultHolderMorph notNil and: [ self isLocal: resultHolderMorph ]! !

!MauiInstructionMorph methodsFor: 'testing' stamp: 'cmm 5/1/2009 12:30'!
hasResult

	^resultMorph notNil! !

!MauiInstructionMorph methodsFor: 'labels' stamp: 'cmm 5/1/2009 13:32'!
hideLabels

	self labelsDo: [ : each | each delete ]! !

!MauiInstructionMorph methodsFor: 'initialize' stamp: 'cmm 4/30/2009 21:25'!
initialize
	labels := OrderedCollection new.
	super initialize.
	"Blank out notificationHandler for messages, unless overridden, the lazy-init will fall back to my receiverMorphs notificationHandler."
	notificationHandler := nil.
	self
		listDirection: #leftToRight ;
		wrapDirection: #none ;
		hResizing: #shrinkWrap ;
		layoutInset: 4 @ 0 ;
		cellInset: 4 ;
		cellPositioning: #leftCenter! !

!MauiInstructionMorph methodsFor: 'initialize' stamp: 'cmm 4/30/2009 21:25'!
initializeColor
	| colorScheme |
	colorScheme := self colorScheme.
	self
		fillStyle: colorScheme messageFill ;
		labelsDo: [ : each | each color: colorScheme standardTextColor ] ;
		parameterHolderMorphsDo: [ : each | each initializeColor ].
	self hasResult ifTrue: [ resultMorph initializeColor ]! !

!MauiInstructionMorph methodsFor: 'initialize' stamp: 'cmm 5/1/2009 15:16'!
initializeInvocationStrategy
	invocationStrategy := self instruction isUnary 
		ifTrue: 
			[ MauiClickedInvocationStrategy new
				selectLocalResultTarget ;
				resultView: #word ;
				producedView: #word ]
		ifFalse: 
			[ | auto |
			MauiAutoInvocationStrategy new
				selectHandResultTarget ;
				resultView: #panel ;
				producedView: nil ;
				yourself ]! !

!MauiInstructionMorph methodsFor: 'initialize' stamp: 'cmm 5/1/2009 12:08'!
initializeLabelString
	"Reset my label to my selector."
	| n |
	n := 1.
	self messagePartsDo: 
		[ : each | 
		self 
			labelAt: n
			put: each.
		n := n + 1 ].
	self removeProperty: #hasCustomLabel! !

!MauiInstructionMorph methodsFor: 'result' stamp: 'cmm 6/1/2009 11:03'!
initializeResult
	self removeResult.
	"Nil out my resultMorph and fall back on the defined views rendition."
	resultMorph := nil! !

!MauiInstructionMorph methodsFor: 'accessing' stamp: 'cmm 5/1/2009 12:26'!
instruction
	^ self object! !

!MauiInstructionMorph methodsFor: 'Morphic' stamp: 'cmm 5/1/2009 13:49'!
intoWorld: aWorld 
	super intoWorld: aWorld.
	aWorld ifNil: [ ^ self ].
	self startStepping! !

!MauiInstructionMorph methodsFor: 'invocation' stamp: 'cmm 5/1/2009 15:01'!
invocationStrategy
	"My current MauiInvocationStrategy, an object that specifies which view is desired for my result when I invoke, and also where that result should be placed."
	^ invocationStrategy! !

!MauiInstructionMorph methodsFor: 'accessing' stamp: 'cmm 5/1/2009 14:40'!
invocationStrategy: aMauiInvocationStrategy
	"Share an invocationStrategy directly with another so updates may happen in one place.  Set my strategy directly from another message's strategy."
	invocationStrategy := aMauiInvocationStrategy.
	invocationStrategy postInitialize: self! !

!MauiInstructionMorph methodsFor: 'invocation' stamp: 'cmm 4/29/2014 16:24'!
invoke
	| result |
	[ self receiverMorph in:
		[ : receiverMorph | (receiverMorph notNil and: [ receiverMorph wantsModality ]) ifTrue: [ receiverMorph removeAllResultMorphs ] ].
	result := self privateInvoke realObject.
	result maIsException
		ifTrue:
			[ self instruction debugMode: true.
			result maui notificationHandler: self notificationHandler ]
		ifFalse:
			[ (resultHolderMorph isNil and: [ invocationStrategy wantsNoResultTarget ]) ifFalse:
				[ invocationStrategy wantsInjectedResultTarget
					ifTrue:
						[ "Inject result into the outermost MauiMorph."
						self receiverMorph in:
							[ : receiverMorph | receiverMorph outerMostMauiMorph object: result ] ]
					ifFalse: [ self produceResultMorphFor: result ] ].
			resultMorph ifNotNil: [ resultMorph notificationHandler: self notificationHandler ] ] ] ensure:
		[ self instruction resetArguments.
		invocationStrategy postInvokeCleanup: self ].
	invocationStrategy noteInvocationComplete: self! !

!MauiInstructionMorph methodsFor: 'invocation' stamp: 'cmm 5/1/2009 15:01'!
invokeFromUserMenu

	invocationStrategy invokedFromUserMenu: self! !

!MauiInstructionMorph methodsFor: 'invocation' stamp: 'cmm 5/1/2009 12:54'!
invokeIfPossible

	self canInvoke ifTrue: [ self invoke ]! !

!MauiInstructionMorph methodsFor: 'testing' stamp: 'cmm 5/1/2009 15:56'!
isDomainMessage
	| rcvrMorph |
	^ (rcvrMorph := self receiverMorph) 
		ifNil: [ self isUiMessage not ]
		ifNotNil: [ self instruction receiver == rcvrMorph object ]! !

!MauiInstructionMorph methodsFor: 'testing' stamp: 'cmm 5/1/2009 14:07'!
isMauiInstructionMorph
	^ true! !

!MauiInstructionMorph methodsFor: 'testing' stamp: 'cmm 5/1/2009 15:56'!
isUiMessage
	"Answers whether my message is directed at a MauiMorph.  Note a ui-message can also be an isDomainMessage if my receiverMorphs object is also the same MauiMorph."
	^ self instruction receiver isMauiMorph! !

!MauiInstructionMorph methodsFor: 'keyboard' stamp: 'cmm 4/23/2014 10:36'!
keyStroke: aKeyboardEvent 
	(self mauiWorld userStrategy
		handleMessageKeyboardEvent: aKeyboardEvent
		for: self) ifFalse: [ super keyStroke: aKeyboardEvent ]! !

!MauiInstructionMorph methodsFor: 'events and overrides' stamp: 'cmm 5/1/2009 14:33'!
keyboardFocusChange: gainedFocus

	gainedFocus
		ifTrue: [ self delineate ]
		ifFalse: "lost focus" [ self undelineate ]! !

!MauiInstructionMorph methodsFor: 'labels' stamp: 'cmm 5/1/2009 13:36'!
labelAt: anInteger 
	^ labels at: anInteger! !

!MauiInstructionMorph methodsFor: 'labels' stamp: 'cmm 5/1/2009 13:36'!
labelAt: anInteger put: aStringOrMorph 
	"Used to customize the default parameter label for a message."
	| needToShow |
	(aStringOrMorph isString or: [ aStringOrMorph isMorph ]) ifFalse: 
		[ MauiUserError signal: 'You must specify a String or a Morph as the label.' ].
	(needToShow := self hasLabels) ifTrue: [ self hideLabels ].
	[ labels size < anInteger ] whileTrue: [ labels add: nil ].
	labels 
		at: anInteger
		put: (aStringOrMorph isMorph 
				ifTrue: [ aStringOrMorph ]
				ifFalse: [ self createLabel: aStringOrMorph ]).
	needToShow ifTrue: [ self showLabels ].
	self noteHasCustomLabel! !

!MauiInstructionMorph methodsFor: 'labels' stamp: 'cmm 5/1/2009 13:36'!
labelledMenuString
	^ self 
		string: (self hasLabels 
				ifTrue: [ '<on>labelled' translated ]
				ifFalse: [ '<off>labelled' translated ])
		withKeyBindingFor: #keyForLabel! !

!MauiInstructionMorph methodsFor: 'labels' stamp: 'cmm 5/1/2009 12:58'!
labelsDo: oneArgBlock 
	labels copy do: oneArgBlock! !

!MauiInstructionMorph methodsFor: 'settings panel' stamp: 'cmm 5/1/2009 15:04'!
makeGetStrategyMessage
	| answer |
	answer := (MauiMessage 
		receiver: self
		selector: #invocationStrategy) asMauiMorphFor: self.
	answer
		listDirection: #topToBottom ;
		selectStrategy: MauiAutoInvocationStrategy.
	answer invocationStrategy
		repeat: true ;
		resultView: #panel ;
		producedView: #word.
	^ answer! !

!MauiInstructionMorph methodsFor: 'settings panel' stamp: 'cmm 5/1/2009 15:04'!
makeSelectStrategyMessage
	| answer |
	answer := (MauiMessage 
		receiver: self
		selector: #selectStrategy:) asMauiMorphFor: self.
	answer invocationStrategy selectNoResultTarget.
	answer firstParameterHolder optionalParametersMorph: MauiInvocationStrategy allSubclasses asArray asMauiMorph.
	^ answer! !

!MauiInstructionMorph methodsFor: 'settings panel' stamp: 'cmm 5/1/2009 15:04'!
makeSetResultHolderMorphMessage
	^ ((MauiMessage 
		receiver: self
		selector: #resultHolderMorph) asMauiMorphFor: self) asGetterSetter! !

!MauiInstructionMorph methodsFor: 'settings panel' stamp: 'cmm 5/1/2009 15:04'!
makeSetResultMorphMessage
	^ ((MauiMessage 
		receiver: self
		selector: #resultMorph) asMauiMorphFor: self) asGetterSetter! !

!MauiInstructionMorph methodsFor: 'settings panel' stamp: 'cmm 5/1/2009 15:04'!
makeSetStrategyMessage
	^ ((MauiMessage 
		receiver: self
		selector: #invocationStrategy) asMauiMorphFor: self) asGetterSetter! !

!MauiInstructionMorph methodsFor: 'result' stamp: 'cmm 5/29/2013 20:47'!
materializeResult: containingMorph 
	(self hasResult and: [ resultMorph isInWorld not ]) ifTrue:
		[ containingMorph == ActiveHand
			ifTrue:
				[ resultMorph openInHand.
				resultMorph position: resultMorph position + (resultMorph extent / 2.1) ]
			ifFalse:
				[ containingMorph == World
					ifTrue: [ resultMorph openAdjacentTo: self ]
					ifFalse:
						[ containingMorph isBalloonHelp
							ifTrue: [ self spawnBalloon: containingMorph ]
							ifFalse: [ containingMorph addMorphBack: resultMorph ] ] ] ]! !

!MauiInstructionMorph methodsFor: 'events and overrides' stamp: 'cmm 5/1/2009 14:33'!
mauiDropInto: aMauiDomainMorph event: event at: spacerPosition 
	aMauiDomainMorph 
		addMessage: self
		at: spacerPosition.
	self position: event hand position - (0 @ self height).
	self instruction receiver: aMauiDomainMorph object! !

!MauiInstructionMorph methodsFor: 'events and overrides' stamp: 'cmm 6/3/2009 10:56'!
mouseDown: aMouseButtonEvent 
	aMouseButtonEvent redButtonPressed 
		ifTrue: 
			[ owner layoutPolicy isNil ifTrue: [ self comeToFront ].
			self root comeToFront.
			invocationStrategy 
				mouseDown: aMouseButtonEvent
				for: self ]
		ifFalse: [ super mouseDown: aMouseButtonEvent ]! !

!MauiInstructionMorph methodsFor: 'events and overrides' stamp: 'cmm 5/1/2009 14:34'!
mouseEnter: aMouseEvent

	super mouseEnter: aMouseEvent.
	invocationStrategy
		mouseEntered: aMouseEvent
		for: self! !

!MauiInstructionMorph methodsFor: 'events and overrides' stamp: 'cmm 5/1/2009 14:34'!
mouseLeave: aMouseEvent

	super mouseLeave: aMouseEvent.
	invocationStrategy
		mouseLeft: aMouseEvent
		for: self! !

!MauiInstructionMorph methodsFor: 'events and overrides' stamp: 'cmm 2/10/2013 13:29'!
mouseStillDown: aMouseButtonEvent 
	aMouseButtonEvent redButtonPressed 
		ifTrue: 
			[ owner layoutPolicy isNil ifTrue: [ self comeToFront ].
			self root comeToFront.
			invocationStrategy 
				mouseDown: aMouseButtonEvent
				for: self ]
		ifFalse: [ super mouseStillDown: aMouseButtonEvent ]! !

!MauiInstructionMorph methodsFor: 'events and overrides' stamp: 'cmm 2/10/2013 12:57'!
mouseUp: aMouseButtonEvent 
	invocationStrategy
		mouseUp: aMouseButtonEvent
		for: self! !

!MauiInstructionMorph methodsFor: 'menu' stamp: 'cmm 5/1/2009 14:01'!
moveToGlobalContextMenu
	"Add me to the context menu for all views of these kinds of objects."
	self receiverMorph addGlobalLevelUserMessage: self copy! !

!MauiInstructionMorph methodsFor: 'preferences' stamp: 'cmm 5/1/2009 15:04'!
nextPreferenceSource
	^ self receiverMorph ifNil: [ super nextPreferenceSource ]! !

!MauiInstructionMorph methodsFor: 'events and overrides' stamp: 'cmm 5/1/2009 14:34'!
noteHoveringOver: aMauiMorph event: event
	"To get here, we know aMauiMorph can add me."

	^ invocationStrategy
		note: self
		hoveringOver: aMauiMorph
		event: event! !

!MauiInstructionMorph methodsFor: 'Morphic' stamp: 'cmm 5/1/2009 13:49'!
noteNewOwner: aMorph 
	invocationStrategy 
		noteNewOwner: aMorph
		for: self.
	super noteNewOwner: aMorph! !

!MauiInstructionMorph methodsFor: 'accessing' stamp: 'cmm 7/26/2009 20:08'!
notificationHandler
	| rcvrMorph |
	^ notificationHandler ifNil: 
		[ (rcvrMorph := self receiverMorph) 
			ifNil: [ MauiNotificationHandler default ]
			ifNotNil: 
				[ notificationHandler := rcvrMorph notificationHandler ifNil: [ MauiNotificationHandler default ] ] ]! !

!MauiInstructionMorph methodsFor: 'accessing' stamp: 'cmm 2/16/2014 19:36'!
notificationHandler: aMauiNotificationHandler 
	notificationHandler == aMauiNotificationHandler ifFalse:
		[ super notificationHandler: aMauiNotificationHandler.
		self hasResult ifTrue: [ resultMorph notificationHandler: aMauiNotificationHandler ] ]! !

!MauiInstructionMorph methodsFor: 'accessing' stamp: 'cmm 2/19/2014 21:34'!
object: aMauiInstruction 
	(object == aMauiInstruction and: [ aMauiInstruction isMauiPrototype not ]) ifTrue: [ ^ self ].
	super object: aMauiInstruction.
	self allMauiMorphsDo:
		[ : each | (each isMauiInstructionMorph and: [ each isUiMessage not ]) ifTrue: [ each setObject: aMauiInstruction ] ].
	self initializeInvocationStrategy! !

!MauiInstructionMorph methodsFor: 'Morphic' stamp: 'cmm 5/1/2009 13:49'!
openInHand
	| receiverMorph |
	receiverMorph := self receiverMorph.
	super openInHand.
	(receiverMorph notNil and: [ self world notNil ]) ifTrue: 
		[ (receiverMorph containsPoint: self currentHand position) ifTrue: 
			[ "Allow drop on the original receiver without the drop-gesture (Shift) so that simply reordering is not so difficult"
			receiverMorph
				noteDropGesturePresent ;
				startTrackingDropZones ] ]! !

!MauiInstructionMorph methodsFor: 'menu' stamp: 'cmm 9/20/2012 20:10'!
openLabelSetter
	| dialog |
	dialog := self asMauiMorph
		listDirection: #topToBottom ;
		initializeColor ;
		yourself.
	1 
		to: (self instruction numberOfArguments max: 1)
		do: 
			[ : n | 
			| msg |
			msg := dialog addMessage: ((MauiMessage 
					receiver: self
					selector: #labelAt:put:) asMauiMorphFor: self).
			msg firstParameterHolder dropParameter: n asMauiMorph.
			msg invocationStrategy postInvokeAction: #deleteParent ].
	dialog openNextTo: self! !

!MauiInstructionMorph methodsFor: 'menu' stamp: 'cmm 5/1/2009 14:02'!
openSettingsPanel
	"Alter how and when I invoke."
	^ self asMauiMorph
		addMessage: self makeGetStrategyMessage ;
		addMessage: self makeSelectStrategyMessage ;
		addMessage: self makeSetStrategyMessage ;
		addMessage: self makeSetResultHolderMorphMessage ;
		addMessage: self makeSetResultMorphMessage ;
		openNextTo: self! !

!MauiInstructionMorph methodsFor: 'view' stamp: 'cmm 5/1/2009 15:05'!
panel
	"Nothing to do for standard InstructionMorphs."! !

!MauiInstructionMorph methodsFor: 'private' stamp: 'cmm 5/1/2009 14:19'!
parameterHolderMorphsDo: aBlock 
	"For now, MauiBlocks are like unary messages, they accept no arguments from the user.  The underlying Block is always valued with the receiver object.
	Therefore, currently only MauiMessageMorphs need parameterHolders."! !

!MauiInstructionMorph methodsFor: 'invocation' stamp: 'cmm 7/18/2013 14:23'!
privateInvoke
	^ 
	[ self instruction debugMode ifTrue: [ self stopStepping ].
	self mauiWorld ifNotNilDo: [ : mw | mw logInvocation: self instruction ].
	self instruction invokeUsing: self notificationHandler ] 
		maOn: MaUserError
		do: [ : err | err ]
		on: Error
		do: 
			[ : err | 
			invocationStrategy repeat ifTrue: [ invocationStrategy repeat: false ].
			err pass ]! !

!MauiInstructionMorph methodsFor: 'invocation' stamp: 'cmm 5/1/2009 12:34'!
produceResultMorphFor: result 
	"Obtain the view."
	| resultHolder |
	resultMorph := (self reusableResultMorphFor: result) ifNil: 
		[ "We tried to harvest the existing resultMorph, but couldn't.  Build a new view."
		self hasLocalResult ifTrue: 
			[ "an unusable local result, bye bye.."
			resultMorph delete ].
		self family 
			newViewNamed: invocationStrategy resultView
			for: result ].
	(resultHolder := self determineResultHolder) ifNotNil: 
		[ self materializeResult: resultHolder.
		(resultHolder == self and: [ self receiverMorph notNil ]) ifTrue: [ resultMorph pickee: self receiverMorph pickee ].
		resultMorph customize: self ]! !

!MauiInstructionMorph methodsFor: 'menu' stamp: 'cmm 6/8/2009 12:07'!
profileModeMenuString
	^ self instruction profileMode 
		ifTrue: [ '<on>profile' ]
		ifFalse: [ '<off>profile' ]! !

!MauiInstructionMorph methodsFor: 'accessing' stamp: 'cmm 5/1/2009 14:42'!
receiver
	^ object receiver! !

!MauiInstructionMorph methodsFor: 'accessing' stamp: 'cmm 2/4/2014 15:52'!
receiver: anObject 
	self instruction receiver == anObject ifTrue: [ ^ self ].
	self
		updateReceiverFrom: self receiver
		to: anObject.
	"Getter instructions are embedded into their setters.  Be sure to adjust their receiver too."
	self allInstructionMorphsDo: [ : each | each receiver: anObject ]! !

!MauiInstructionMorph methodsFor: 'events and overrides' stamp: 'cmm 5/1/2009 14:35'!
receiverChanged
	self receiver changed! !

!MauiInstructionMorph methodsFor: 'accessing' stamp: 'cmm 7/6/2009 19:30'!
receiverMorph
	"Answer the MauiMorph of my receiver, whether that receiver is the underlying domain or its MauiMorph.  If I am a lone message on the context menu, or in the hand, answer nil."
	^ (self nearestOwnerThat: 
		[ : morph | 
		morph isMauiMorph and: 
			[ "domain msg"
			morph object == self instruction receiver or: 
				[ "ui msg"
				morph == self instruction receiver ] ] ]) ifNil: [ self valueOfProperty: #receiverMorph ]! !

!MauiInstructionMorph methodsFor: 'accessing' stamp: 'cmm 7/6/2009 19:34'!
receiverMorph: aMauiDomainMorph 
	"Set the #backup #receiverMorph property for cases when the receiver wants to be invoked, but not embedded in any MauiDomainMorph.  This is unusual, but possible, such as adding me to the global-context menu choices.  This allows my receiverMorph to answer the morph on which the context menu was activated."
	^ self 
		setProperty: #receiverMorph
		toValue: aMauiDomainMorph! !

!MauiInstructionMorph methodsFor: 'invocation' stamp: 'cmm 5/1/2009 15:02'!
refreshData
	invocationStrategy ifNotNil: [ invocationStrategy refreshData: self ].
	"Getter/Setters have the getter embedded in the setter.  Make sure it refreshes too."
	self
		messageMorphsDo: [ : each | each refreshData ] ;
		noteDataRefreshed! !

!MauiInstructionMorph methodsFor: 'invocation' stamp: 'cmm 5/1/2009 15:03'!
refreshResult
	"Delete the result, rebuild it from the prototype.  Start stepping to ensure I notice it."
	self
		initializeResult ;
		startStepping! !

!MauiInstructionMorph methodsFor: 'labels' stamp: 'cmm 5/1/2009 13:36'!
removeLabel: aMauiStringMorph

	(labels remove: aMauiStringMorph) delete! !

!MauiInstructionMorph methodsFor: 'labels' stamp: 'cmm 5/1/2009 13:36'!
removeLabels

	labels copy do: [ : each | self removeLabel: each ]! !

!MauiInstructionMorph methodsFor: 'result' stamp: 'cmm 2/15/2014 18:05'!
removeResult
	resultMorph ifNotNil: [ resultMorph delete ]! !

!MauiInstructionMorph methodsFor: 'initialize' stamp: 'cmm 5/1/2009 12:36'!
resetParameterHolderMorphs
	"Nothing to do at this level, overridden by MauiMessageMorph."! !

!MauiInstructionMorph methodsFor: 'private' stamp: 'cmm 5/1/2009 13:41'!
resetReceiver
	self stopStepping.
	self receiver: MauiPrototype current! !

!MauiInstructionMorph methodsFor: 'result' stamp: 'cmm 4/30/2009 21:24'!
resultHolderMorph

	^resultHolderMorph! !

!MauiInstructionMorph methodsFor: 'result' stamp: 'cmm 6/3/2012 22:06'!
resultHolderMorph: aMorph 
	"Note:  This message allows custom panels to be built.  Select any local panel to be my resultHolder and use the 'maui this morph' function to obtain the droppable object.

NOTE:  This setting overrides my invocationStrategy's #resultHolderTarget.  Leave or set this nil if you want the invocationStrategy to put the result on the desktop, in a balloon, attached to the mouse pointer or not at all. "
	aMorph ifNotNil:
		[ (self isLocal: aMorph) ifFalse:
			[ MauiUserError signalPage:
				(MauiPage streamContents:
					[ : stream | stream
						 nextPut: aMorph ;
						 nextPutAll: ' is not local to ' ;
						 nextPut: self ]) ] ].
	resultHolderMorph := aMorph! !

!MauiInstructionMorph methodsFor: 'result' stamp: 'cmm 4/30/2009 21:24'!
resultHolderTarget
	^ invocationStrategy resultHolderTarget! !

!MauiInstructionMorph methodsFor: 'accessing' stamp: 'cmm 5/1/2009 12:37'!
resultMorph

	^resultMorph! !

!MauiInstructionMorph methodsFor: 'accessing' stamp: 'cmm 5/1/2009 14:42'!
resultMorph: aMauiMorph
	"Use this to pre-set a custom MauiMorph configuration.  Normally, a named configuration would be used, but this would be useful for a dynamic 'generated' view."
	resultMorph := aMauiMorph! !

!MauiInstructionMorph methodsFor: 'private' stamp: 'cmm 7/13/2009 18:16'!
reusableResultMorphFor: resultObject 
	"The user may have customized the current resultMorph; preserve those customizations.  If we have or can copy their existing resultMorph that can be merely refreshed, return it, otherwise nil."
	^ self hasResult ifTrue: 
		[ (resultMorph view = invocationStrategy resultView and: 
			[ (resultObject isKindOf: resultMorph object maOriginalClass) or: [ resultMorph object isMauiPrototype ] ]) 
			ifTrue: 
				[ "Is the resultMorph still suitable for the class of resultObject?"
				(resultMorph isOptimizedFor: resultObject) ifTrue: 
					[ (self hasLocalResult or: [ resultMorph isInWorld not ]) 
						ifTrue: 
							[ "reuse the existing morph"
							resultMorph
								object: resultObject ;
								yourself ]
						ifFalse: 
							[ "otherwise we have to copy it"
							resultMorph copyForNewObject: resultObject ] ] ]
			ifFalse: 
				[ "It's possible we may already have a resultMorph that cannot be represented in the desired 'invocationStrategy resultView' (because, for example, the message result was nil), in which case we know we will have simply shown the #mauiDefaultView view.  If the resultMorph is already the mauiDefaultView then we *can* reuse it."
				"Man, I hate this.."
				"(resultMorph view = resultObject mauiDefaultView and: 
					[ (invocationStrategy resultView isSymbol and: 
						[ (resultObject mauiMorphClass canUnderstand: invocationStrategy resultView) not ]) or: 
						[ invocationStrategy resultView isSymbol not and: 
							[ (self family 
								supportsViewNamed: invocationStrategy resultView
								for: resultObject class) not ] ] ]) ifTrue: 
					[ resultMorph
						object: resultObject ;
						yourself ] "
				 ] ]! !

!MauiInstructionMorph methodsFor: 'events and overrides' stamp: 'cmm 5/1/2009 14:35'!
save
	self receiverMorph save! !

!MauiInstructionMorph methodsFor: 'invocation' stamp: 'cmm 5/1/2009 15:03'!
selectClickedStrategy
	"Select a new strategy that controls when the message is invoked."
	self selectStrategy: MauiClickedInvocationStrategy! !

!MauiInstructionMorph methodsFor: 'invocation' stamp: 'cmm 5/1/2009 15:03'!
selectStrategy: mauiInvocationStrategyClass 
	"Select a new strategy that controls when the message is invoked."
	^ (self invocationStrategy newBehavingAs: mauiInvocationStrategyClass) in: 
		[ : strategy | 
		self invocationStrategy: strategy.
		strategy ]! !

!MauiInstructionMorph methodsFor: 'labels' stamp: 'cmm 5/1/2009 13:35'!
showLabels

	| x |
	self hasLabels ifTrue: [ ^ self ].
	x := 1.
	self labelsDo:
		[ : each |
		self
			addMorph: each
			asElementNumber: x.
		x := x + 2 ]! !

!MauiInstructionMorph methodsFor: 'debugging' stamp: 'cmm 5/1/2009 15:56'!
signalWhereInvalid
	super signalWhereInvalid.
	(self receiverMorph notNil and: 
		[ self instruction receiver == self receiverMorph object or: [ self instruction receiver == self receiverMorph ] ]) ifFalse: [ MauiSoftwareError signal ]! !

!MauiInstructionMorph methodsFor: 'Morphic' stamp: 'cmm 5/1/2009 13:50'!
step
	self shouldRefreshData ifTrue: [ self refreshData ]! !

!MauiInstructionMorph methodsFor: 'Morphic' stamp: 'cmm 5/1/2009 15:03'!
stepTime
	^ invocationStrategy repeatInterval! !

!MauiInstructionMorph methodsFor: 'ide' stamp: 'cmm 5/1/2009 15:56'!
toggleDebugMode
	"... trace the execution of this instruction in the debugger the next time it is invoked."
	self instruction debugMode: self instruction debugMode not! !

!MauiInstructionMorph methodsFor: 'labels' stamp: 'cmm 5/1/2009 13:37'!
toggleLabelled

	self toggleLabels! !

!MauiInstructionMorph methodsFor: 'labels' stamp: 'cmm 5/1/2009 13:37'!
toggleLabels

	^ self hasLabels
		ifTrue: [ self hideLabels ]
		ifFalse: [ self showLabels ]! !

!MauiInstructionMorph methodsFor: 'ide' stamp: 'cmm 6/8/2009 12:07'!
toggleProfileMode
	"... trace the execution of this instruction in the TimeProfileBrowser the next time it is invoked."
	self instruction profileMode: self instruction profileMode not! !

!MauiInstructionMorph methodsFor: 'events and overrides' stamp: 'cmm 2/13/2012 22:09'!
undelineate
	super undelineate.
	self color: (self preferred: #colorScheme) messageFill! !

!MauiInstructionMorph methodsFor: 'invocation' stamp: 'cmm 5/1/2009 15:03'!
update: updatedObject 
	WorldState addDeferredUIMessage: [ self startStepping ]! !

!MauiInstructionMorph methodsFor: 'labels' stamp: 'cmm 5/1/2009 13:37'!
updateLabel
	self openLabelSetter! !

!MauiInstructionMorph methodsFor: 'private' stamp: 'cmm 2/16/2014 21:29'!
updateObjectFrom: oldObject to: newObject 
	((object == oldObject) or: [ newObject isMauiPrototype "<-- currently newObject would only ever be a MauiInstruction, but that might change in the future." ]) ifTrue:
		[ self setObject: newObject..
		self
			 name: newObject mauiName ;
			 postInitialize ]! !

!MauiInstructionMorph methodsFor: 'private' stamp: 'cmm 2/16/2014 18:31'!
updateReceiverFrom: oldReceiver to: newReceiver 
	| owner |
	self receiver == newReceiver ifTrue: [ ^ self ].
	owner := self nearestOwningMauiDomainMorph.
	self removeResult.
	(newReceiver isMauiPrototype or:
		[ self receiver == oldReceiver or: [ owner isNil or: [ owner isOptimizedFor: newReceiver ] ] ]) ifTrue:
		[ self instruction receiver: newReceiver.
		newReceiver isMauiPrototype ifFalse: [ self noteRefreshNeeded ] ]! !

!MauiInstructionMorph methodsFor: 'copying' stamp: 'cmm 5/1/2009 14:36'!
veryDeepInner: aDeepCopier 
	super veryDeepInner: aDeepCopier.
	labels := labels veryDeepCopyWith: aDeepCopier.
	self mauiWorld userStrategy adjustLabelsOf: self.
	parameterHolderMorphs := parameterHolderMorphs veryDeepCopyWith: aDeepCopier.
	object := object veryDeepCopyWith: aDeepCopier.
	resultHolderMorph := self hasLocalResultHolder ifTrue: [ resultHolderMorph veryDeepCopyWith: aDeepCopier ].
	invocationStrategy := invocationStrategy veryDeepCopyWith: aDeepCopier.
	resultMorph := resultMorph veryDeepCopyWith: aDeepCopier! !

!MauiInstructionMorph methodsFor: 'ide' stamp: 'cmm 5/1/2009 13:54'!
viewMethod
	"Currently MauiBlocks are special-purpose, only methods can be viewed."! !

!MauiInstructionMorph methodsFor: 'Morphic' stamp: 'cmm 5/1/2009 13:50'!
wantsBalloonResult

	^ self hasResult
	and: [ invocationStrategy wantsBalloonResultTarget
	and: [ invocationStrategy handlesMouseOver ] ]! !

!MauiInstructionMorph methodsFor: 'events and overrides' stamp: 'cmm 5/1/2009 14:35'!
wantsDroppedMorph: aMorph event: event 
	^ false! !

MauiInstructionMorph subclass: #MauiMessageMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Morphs'!

!MauiMessageMorph commentStamp: 'cmm 5/2/2007 17:40' prior: 0!
A MauiMessageMorph represents a MauiMorph for a MauiMessage, which is basically just like a MessageSend.

My 'invocationStrategy' tells me when I execute:

	- MauiImmediateInvocationStrategy = once, when initially opened in the world.
	- MauiClickedInvocationStrategy = when the user mouses down on me.
	- MauiMouseOverInvocationStrategy = every time the mouse wanders over me.
	- MauiRepeatingInvocationStrategy = every time I #step.

	labels:		<Object>
	parameterHolderMorphs:		<Object>
	resultHolderMorph:		<Object>
	resultMorph:		<Object>

invocationStrategy
	- xxxxx

labels
	- xxxxx

parameterHolderMorphs
	- xxxxx

resultHolderMorph
	- xxxxx

resultMorph
	- xxxxx
!

!MauiMessageMorph class methodsFor: 'private' stamp: 'cmm 12/4/2008 22:30'!
maNewFor: aMauiMessageOrMethodReference 
	^ super maNewFor: aMauiMessageOrMethodReference asMauiMessage! !

!MauiMessageMorph class methodsFor: 'creation' stamp: 'cmm 8/6/2004 10:10'!
mauiMessage: aMauiMessage

	^ self maNewFor: aMauiMessage! !

!MauiMessageMorph class methodsFor: 'creation' stamp: 'cmm 7/22/2004 11:48'!
receiver: anObject selector: selectorSymbol
	"Ui messages will need to be created via this method."

	^ self mauiMessage:
		(MauiMessage 
			receiver: anObject 
			selector: selectorSymbol)! !

!MauiMessageMorph methodsFor: 'initialize' stamp: 'cmm 2/10/2013 15:02'!
addAsGetterSetter
	"... allows drop of a new value, and always reflects the current value without having to refresh."
	"capture these now, because asGetterSetter potentially changes my structure."
	self asGetterSetter position: self position! !

!MauiMessageMorph methodsFor: 'private' stamp: 'cmm 10/1/2003 20:47'!
arguments

	^parameterHolderMorphs collect: [ : each | each parameterMorph object ]! !

!MauiMessageMorph methodsFor: 'converting' stamp: 'cmm 7/12/2007 16:30'!
asCheckBox
	self isGetterSetter ifFalse: 
		[ MauiUserError signal: 'I must first be a getter/setter before I can be a checkbox' ].
	self firstParameterHolder
		optionalParametersStrategy: MauiCycleParametersStrategy new ;
		optionalParametersMorph: {  true. false  } asMauiMorph! !

!MauiMessageMorph methodsFor: 'private' stamp: 'cmm 2/15/2013 13:13'!
asGetter
	"A short-cut way of selecting the Auto-Invocation strategy."
	(self selectStrategy: MauiAutoInvocationStrategy) repeat: true! !

!MauiMessageMorph methodsFor: 'converting' stamp: 'cmm 1/27/2008 17:25'!
asGetterSetter
	"Answer the setter message."
	| answer |
	self canBeGetterSetter ifFalse: 
		[ MauiUserError signal: 'I don''t have everything needed to be a getter setter.' ].
	answer := self message selector isUnary 
		ifTrue: 
			[ | receiverMorph newMessage |
			receiverMorph := self receiverMorph.
			resultMorph := nil.
			newMessage := self endowWithSetter.
			receiverMorph ifNotNil: [ receiverMorph addMessage: newMessage ].
			newMessage ]
		ifFalse: 
			[ self endowWithGetter.
			self ].
	answer invocationStrategy selectNoResultTarget.
	^ answer! !

!MauiMessageMorph methodsFor: 'private' stamp: 'cmm 8/26/2012 21:56'!
asGetterSetterFor: setterMessageMorph 
	setterMessageMorph addMessage: self.
	self
		resultHolderMorph: setterMessageMorph firstParameterHolder ;
		invocationStrategy: 
			((self invocationStrategy newBehavingAs: MauiAutoInvocationStrategy)
				selectNoResultTarget ;
				repeat: true ;
				yourself) ;
		extent: 0 @ 0 ;
		hideLabels ;
		borderWidth: 0 ;
		hide ;
		lock.
	^ setterMessageMorph! !

!MauiMessageMorph methodsFor: 'Morphic' stamp: 'cmm 7/13/2009 18:18'!
balloonHelpString
	self message isValid ifFalse: [ ^ 'This message is not valid.' ].
	self wantsBalloonResult ifTrue: [ ^ nil ].
	^ 
	[ self message selector = #yourself 
		ifTrue: 
			[ invocationStrategy resultView isSymbol ifTrue: 
				[ self owner maOriginalClass maFirstCommentOrNilAt: invocationStrategy resultView ] ]
		ifFalse: 
			[ | answer |
			answer := String streamContents: 
				[ : stream | 
				(self hasLabels and: [ self concatenatedLabels = self message selector ]) ifFalse: 
					[ stream
						nextPutAll: (self mauiWorld userStrategy nameFor: self message selector) ;
						cr ].
				stream nextPutAll: (self mauiWorld userStrategy nameFor: (self message implementorClass maFirstCommentAt: self message selector)) ].
			answer isEmpty 
				ifTrue: [ nil ]
				ifFalse: [ answer ] ] ] 
		on: Error
		do: 
			[ : err | 
			String streamContents: 
				[ : stream | 
				stream
					maPrint: err messageText ;
					cr ;
					maPrint: err signalerContext longStack ] ]! !

!MauiMessageMorph methodsFor: 'view' stamp: 'cmm 11/19/2010 11:05'!
beInvisible
	super beInvisible.
	self
		 color: Color transparent ;
		 borderColor: Color transparent.
	(self overridden: #messageMorph)
		 borderColor: Color transparent ;
		 color: Color transparent! !

!MauiMessageMorph methodsFor: 'events and overrides' stamp: 'cmm 7/6/2009 19:36'!
beNotificationHandler
	self resultMorph beNotificationHandler! !

!MauiMessageMorph methodsFor: 'private' stamp: 'cmm 8/15/2003 00:00'!
binaryMessagePartsDo: oneArgBlock

	oneArgBlock value: self message selector! !

!MauiMessageMorph methodsFor: 'ide' stamp: 'cmm 2/12/2009 14:18'!
browseSenders
	(self message selector = #yourself and: [ self invocationStrategy resultView isSymbol ]) 
		ifTrue: 
			[ self systemNavigation browseAllCallsOn: self invocationStrategy resultView ]
		ifFalse: [ self systemNavigation browseAllCallsOn: self message selector ]! !

!MauiMessageMorph methodsFor: 'menu' stamp: 'cmm 5/1/2009 14:01'!
buildToolMenu
	| menu |
	menu := super buildToolMenu.
	menu 
		add: (self 
				string: 'view method' translated
				withKeyBindingFor: #keyForViewMethod)
		target: self
		selector: #viewMethod.
	^ menu! !

!MauiMessageMorph methodsFor: 'testing' stamp: 'cmm 11/6/2003 22:42'!
canBeGetter

	^self message selector isUnary! !

!MauiMessageMorph methodsFor: 'testing' stamp: 'cmm 10/9/2003 22:03'!
canBeGetterSetter

	^self message selector isUnary
		ifTrue: [ self message hasCorrespondingSetter ]
		ifFalse: [ (self message selector occurrencesOf: $:) = 1 and: [ self message hasCorrespondingGetter ] ]! !

!MauiMessageMorph methodsFor: 'events and overrides' stamp: 'cmm 2/16/2009 16:09'!
canDropInto: aMauiMorph 
	((aMauiMorph respondsTo: self message selector) or: [ aMauiMorph object respondsTo: self message selector ]) ifFalse: [ ^ false ].
	^ true! !

!MauiMessageMorph methodsFor: 'testing' stamp: 'cmm 5/1/2009 12:48'!
canInvoke
	^ super canInvoke and: [ self hasAllParameters ]! !

!MauiMessageMorph methodsFor: 'private' stamp: 'cmm 12/10/2008 21:11'!
createParameterMorph
	^ parameterHolderMorphs add: (self preferred: #parameterHolderMorph) copy! !

!MauiMessageMorph methodsFor: 'private' stamp: 'cmm 7/12/2007 10:15'!
endowWithGetter
	"I am a setter.  Wrap a new getter inside me."
	| getter |
	getter := MauiMessageMorph 
		receiver: self message receiver
		selector: (self message selector copyWithout: $:) asSymbol.
	^ getter asGetterSetterFor: self! !

!MauiMessageMorph methodsFor: 'private' stamp: 'cmm 12/10/2008 20:57'!
endowWithSetter
	"I am a getter.  Wrap me inside a setter message and then return the setter."
	| setter |
	setter := (MauiMessage 
		receiver: self message receiver
		selector: (self message selector copyWith: $:) asSymbol) asMauiMorphFor: self.
	^ self asGetterSetterFor: setter! !

!MauiMessageMorph methodsFor: 'accessing' stamp: 'cmm 7/12/2007 14:37'!
firstParameterHolder
	^ self parameterHolderMorphAt: 1! !

!MauiMessageMorph methodsFor: 'accessing' stamp: 'cmm 7/12/2007 14:37'!
fourthParameterHolder
	^ self parameterHolderMorphAt: 4! !

!MauiMessageMorph methodsFor: 'keyboard' stamp: 'cmm 4/28/2014 15:26'!
handleMessageKeyboardEvent: aKeyboardEvent 
	| keyPressed |
	^ (super handleMessageKeyboardEvent: aKeyboardEvent) or:
		[ keyPressed := aKeyboardEvent keyCharacter.
		keyPressed = (self preferred: #keyMap) keyForViewMethod and:
			[ self viewMethod.
			true ] ]! !

!MauiMessageMorph methodsFor: 'accessing' stamp: 'cmm 2/22/2004 19:21'!
hasAllParameters

	^parameterHolderMorphs allSatisfy: [ : e | e hasParameter ]! !

!MauiMessageMorph methodsFor: 'accessing' stamp: 'cmm 2/5/2004 00:18'!
indexOfHolder: aMauiParameterHolderMorph

	^parameterHolderMorphs indexOf: aMauiParameterHolderMorph! !

!MauiMessageMorph methodsFor: 'initialize' stamp: 'cmm 6/29/2012 16:45'!
initializeInvocationStrategy
	super initializeInvocationStrategy.
	"If intent appears to be to answer no value, then select no result target."
	(self receiver maOriginalClass lookupSelector: self selector) ifNotNilDo: 
		[ : cm | 
		(cm maSourceString includes: $^) ifFalse: [ invocationStrategy selectNoResultTarget ] ]! !

!MauiMessageMorph methodsFor: 'initialize' stamp: 'cmm 7/27/2004 13:51'!
initializeParameterHolderMorphs

	parameterHolderMorphs ifNotNil: [ parameterHolderMorphs do: [ : each | each delete ] ].
	self removeLabels.
	parameterHolderMorphs := OrderedCollection new.
	self messagePartsDo:
		[ : eachPart |
		labels add: (self createLabel: eachPart).
		(eachPart last = $: or: [ eachPart first isLetter not "binary message" ])
			ifTrue:
				[ self addMorphBack: self createParameterMorph ] ].
	parameterHolderMorphs := parameterHolderMorphs asArray.
	self showLabels! !

!MauiMessageMorph methodsFor: 'Morphic' stamp: 'cmm 2/9/2014 17:42'!
intoWorld: aWorld
	super intoWorld: aWorld.
	aWorld ifNil: [ ^ self ].
	self message fixReferenceIfNecessaryAndPossible! !

!MauiMessageMorph methodsFor: 'invocation' stamp: 'cmm 5/1/2009 12:40'!
invoke
	self message isValid ifFalse: [ ^ self ].
	self message arguments: self arguments.
	super invoke! !

!MauiMessageMorph methodsFor: 'testing' stamp: 'cmm 11/6/2003 23:24'!
isGetter

	^self message selector isUnary and: [ invocationStrategy isSuitableForGetter ]! !

!MauiMessageMorph methodsFor: 'testing' stamp: 'cmm 10/21/2003 23:15'!
isGetterSetter

	| getterName getterSymbol |
	getterSymbol := nil.
	getterName := self message selector copyWithout: $:.
	^(self message selector occurrencesOf: $:) = 1
		and: [ (Symbol hasInterned: getterName ifTrue: [ :sym | getterSymbol := sym ])
		and: [ self hasMessageNamed: getterSymbol ] ]! !

!MauiMessageMorph methodsFor: 'testing' stamp: 'cmm 8/18/2003 21:12'!
isMauiMessageMorph

	^true! !

!MauiMessageMorph methodsFor: 'private' stamp: 'cmm 12/27/2010 19:58'!
mauiLabelString
	^ self selector in:
		[ : sel | sel = #yourself
			ifTrue: [ String empty ]
			ifFalse: [ sel ] ]! !

!MauiMessageMorph methodsFor: 'accessing' stamp: 'cmm 7/1/2003 21:57'!
message

	^self object! !

!MauiMessageMorph methodsFor: 'private' stamp: 'cmm 8/14/2003 23:59'!
messagePartsDo: oneArgBlock

	self message selector first isLetter
		ifTrue: [ self nonBinaryMessagePartsDo: oneArgBlock ]
		ifFalse: [ self binaryMessagePartsDo: oneArgBlock ]! !

!MauiMessageMorph methodsFor: 'private' stamp: 'cmm 8/14/2003 23:58'!
nonBinaryMessagePartsDo: oneArgBlock

	| stream |
	stream := ReadStream on: self message selector.
	[ stream atEnd ]
		whileFalse:
			[ oneArgBlock value: (stream maUpToIncluding: $:) ]! !

!MauiMessageMorph methodsFor: 'accessing' stamp: 'cmm 5/1/2009 14:41'!
object: aMauiMessage 
	super object: aMauiMessage.
	self initializeParameterHolderMorphs! !

!MauiMessageMorph methodsFor: 'view' stamp: 'cmm 12/4/2008 15:13'!
panel
	self initializeParameterHolderMorphs ! !

!MauiMessageMorph methodsFor: 'invocation' stamp: 'cmm 7/28/2003 12:16'!
parameterDropped

	invocationStrategy parameterDropped: self! !

!MauiMessageMorph methodsFor: 'accessing' stamp: 'cmm 12/3/2008 16:00'!
parameterHolderMorphAt: anInteger 
	"Answer the MauiParameterHolderMorph so that users may customize it."
	^ parameterHolderMorphs 
		at: anInteger
		ifAbsent: [ nil ]! !

!MauiMessageMorph methodsFor: 'private' stamp: 'cmm 12/10/2008 23:04'!
parameterHolderMorphsDo: aBlock 
	parameterHolderMorphs ifNotNil: [ parameterHolderMorphs do: aBlock ]! !

!MauiMessageMorph methodsFor: 'events and overrides' stamp: 'cmm 6/11/2009 10:23'!
prototype
	^ self preferred: #messageMorph! !

!MauiMessageMorph methodsFor: 'initialize' stamp: 'cmm 12/10/2008 13:07'!
receiver: anObject selector: selectorSymbol 
	"This is used to initialize the prototype copies."
	self object: 
		(MauiMessage 
			receiver: anObject
			selector: selectorSymbol)! !

!MauiMessageMorph methodsFor: 'initialize' stamp: 'cmm 8/30/2005 10:21'!
resetParameterHolderMorphs

	parameterHolderMorphs do: [ : each | each reset ]! !

!MauiMessageMorph methodsFor: 'accessing' stamp: 'cmm 7/12/2007 14:37'!
secondParameterHolder
	^ self parameterHolderMorphAt: 2! !

!MauiMessageMorph methodsFor: 'accessing' stamp: 'cmm 8/3/2008 22:16'!
selector
	^ self message selector! !

!MauiMessageMorph methodsFor: 'private' stamp: 'cmm 7/14/2004 17:24'!
selectorInFocus

	^ self message selector! !

!MauiMessageMorph methodsFor: 'debugging' stamp: 'cmm 5/1/2009 15:05'!
signalWhereInvalid
	super signalWhereInvalid.
	parameterHolderMorphs do: [ : each | (self submorphs includes: each) ifFalse: [ MauiSoftwareError signal ] ]! !

!MauiMessageMorph methodsFor: 'accessing' stamp: 'cmm 7/12/2007 14:37'!
thirdParameterHolder
	^ self parameterHolderMorphAt: 3! !

!MauiMessageMorph methodsFor: 'ide' stamp: 'cmm 2/12/2009 14:17'!
viewMethod
	"View the details about how this method works."
	self message receiver 
		ifNil: 
			[ self systemNavigation browseAllImplementorsOf: ((self message selector = #yourself and: [ self invocationStrategy resultView isSymbol ]) 
					ifTrue: [ self invocationStrategy resultView ]
					ifFalse: [ self message selector ]) ]
		ifNotNilDo: 
			[ : rcvr | 
			(self message selector = #yourself and: [ self invocationStrategy resultView isSymbol ]) 
				ifTrue: 
					[ self systemNavigation 
						methodHierarchyBrowserForClass: self receiverMorph maOriginalClass
						selector: self invocationStrategy resultView ]
				ifFalse: 
					[ self systemNavigation 
						methodHierarchyBrowserForClass: rcvr maOriginalClass
						selector: self message selector ] ]! !

!MauiMorph class methodsFor: 'factory' stamp: 'cmm 6/15/2007 10:47'!
blackCloseBoxImage
	"Supplied here because we don't necessarily have ComicBold"
	^ BlackCloseBoxImage ifNil: 
		[ BlackCloseBoxImage := (Form
	extent: 10@10
	depth: 32
	fromArray: #( 0 0 0 0 0 0 0 0 0 0 0 3326099520 3330310272 0 0 0 0 0 0 0 0 4144038145 3326099520 3330310272 0 0 0 4144038145 3326099520 0 0 0 4227924225 3326099520 3330310272 0 4144038145 3326099520 3330310272 0 0 0 0 4144038145 3326099520 4144038145 3326099520 3330310272 3336494814 0 0 0 0 0 4227924225 3326099520 3330310272 3336494814 0 0 0 0 0 4144038145 3326099520 4144038145 3326099520 3330310272 3336494814 0 0 0 4144038145 3326099520 3330310272 3336494814 4144038145 3326099520 3330310272 0 0 4144038145 3326099520 3330310272 3336494814 0 0 4144038145 3326099520 0 0 0 3330310272 3336494814 0 0 0 0 0 0)
	offset: 0@0) ]! !

!MauiMorph class methodsFor: 'factory' stamp: 'cmm 6/15/2007 10:53'!
closeBoxImageForForegroundColor: aColor 
	^ aColor brightness > 0.5 
		ifTrue: [ self whiteCloseBoxImage ]
		ifFalse: [ self blackCloseBoxImage ]! !

!MauiMorph class methodsFor: 'testing' stamp: 'cmm 12/10/2008 16:21'!
isSpecialized
	^ self inheritsFrom: MauiDomainMorph! !

!MauiMorph class methodsFor: 'private' stamp: 'cmm 7/12/2007 17:50'!
maNewFor: anObject 
	^ self new
		object: anObject ;
		yourself! !

!MauiMorph class methodsFor: 'factory' stamp: 'cmm 12/10/2008 19:58'!
newFor: anObject
	"The generic construction method for any kind of object."
	^ anObject mauiMorphClass maNewFor: anObject! !

!MauiMorph class methodsFor: 'factory' stamp: 'cmm 6/15/2007 10:48'!
whiteCloseBoxImage
	"Supplied here because we don't necessarily have ComicBold"
	^ WhiteCloseBoxImage ifNil: 
		[ WhiteCloseBoxImage := (Form
	extent: 10@10
	depth: 32
	fromArray: #( 0 0 0 0 0 0 0 0 0 0 0 3326099520 3330310272 0 0 0 0 0 0 0 0 4144038145 3326099520 3330310272 0 0 0 4144038145 3326099520 0 0 0 4227924225 3326099520 3330310272 0 4144038145 3326099520 3330310272 0 0 0 0 4144038145 3326099520 4144038145 3326099520 3330310272 3336494814 0 0 0 0 0 4227924225 3326099520 3330310272 3336494814 0 0 0 0 0 4144038145 3326099520 4144038145 3326099520 3330310272 3336494814 0 0 0 4144038145 3326099520 3330310272 3336494814 4144038145 3326099520 3330310272 0 0 4144038145 3326099520 3330310272 3336494814 0 0 4144038145 3326099520 0 0 0 3330310272 3336494814 0 0 0 0 0 0)
	offset: 0@0)

	mapColor: Color black
	to: Color white; 
	yourself ]! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 8/13/2004 00:06'!
acceptDroppingMorph: droppingMorph event: event
	"droppingMorph should be either a MauiMessageMorph or, if dragged directly out of one of the IDE browsers, a TransformMorph."

	droppingMorph
		mauiDropInto: self
		event: event
		at: self spacerPosition.
	self ensureNoSpacer! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 11/25/2003 23:41'!
addHalo
	"... present Morphic tools for graphical manipulation."

	"(Comment overridden for balloon help)."
	^super addHalo! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 2/14/2009 18:39'!
addHandlesTo: aHaloMorph box: box 
	"Add halo handles to the halo.  Apply the halo filter if appropriate"
	| wantsIt aSelector haloBox commandPressed |
	haloBox := self isUserResizable 
		ifTrue: [ self bounds insetBy: 20 @ 7 ]
		ifFalse: [ box ].
	aHaloMorph haloBox: haloBox.
	commandPressed := Sensor commandKeyPressed.
	Preferences haloSpecifications do: 
		[ : aSpec | 
		aSelector := aSpec addHandleSelector.
		wantsIt := commandPressed or: 
			[ self 
				wantsHaloHandleWithSelector: aSelector
				inHalo: aHaloMorph ].
		wantsIt ifTrue: 
			[ aHaloMorph 
				perform: aSelector
				with: aSpec.
			(#(#addGrowHandle: #addScaleHandle: ) includes: aSelector) ifTrue: 
				[ aHaloMorph 
					on: #mouseLeave
					send: #maybeMouseLeftBounds:
					to: self ] ] ].
	aHaloMorph innerTarget 
		addOptionalHandlesTo: aHaloMorph
		box: haloBox! !

!MauiMorph methodsFor: 'api-messages' stamp: 'cmm 7/26/2004 17:34'!
addMessage: customizedMessageMorph

	^ self
		addMessage: customizedMessageMorph
		at: (self submorphs size + 1)! !

!MauiMorph methodsFor: 'api-messages' stamp: 'cmm 8/22/2007 15:58'!
addMessage: customizedMessageMorph at: index 
	customizedMessageMorph position: self position + self layoutInset.
	self 
		addMorph: customizedMessageMorph
		asElementNumber: index.
	^ customizedMessageMorph! !

!MauiMorph methodsFor: 'api-messages' stamp: 'cmm 8/15/2004 20:33'!
addMessageNamed: selectorSymbol

	^ self addMessage: (self newMessageNamed: selectorSymbol)! !

!MauiMorph methodsFor: 'private' stamp: 'cmm 12/23/2008 12:53'!
addResizeHandle
	self addHalo! !

!MauiMorph methodsFor: 'private' stamp: 'cmm 7/23/2008 15:19'!
adjacentPosition
	^ (self owner notNil and: [ self owner listDirection = #topToBottom ]) 
		ifTrue: [ self starboardPosition ]
		ifFalse: [ self underneathPosition ]! !

!MauiMorph methodsFor: 'debugging' stamp: 'cmm 2/3/2014 17:40'!
allInstructionMorphs
	^ Array streamContents:
		[ : stream | self allInstructionMorphsDo:
			[ : each | stream nextPut: each ] ]! !

!MauiMorph methodsFor: 'messages' stamp: 'cmm 2/3/2014 17:40'!
allInstructionMorphsDo: oneArgBlock 
	self allMauiMorphsDo: [ : each | each isMauiInstructionMorph ifTrue: [ oneArgBlock value: each ] ]! !

!MauiMorph methodsFor: 'debugging' stamp: 'cmm 2/3/2014 22:41'!
allMauiMorphs
	^ Array streamContents:
		[ : stream | self allMauiMorphsDo:
			[ : each | stream nextPut: each ] ]! !

!MauiMorph methodsFor: 'accessing' stamp: 'cmm 2/3/2014 21:03'!
allMauiMorphsDo: aBlock 
	"Same as allMorphsDo:, but also includes resultMorphs of my message morphs, even if they are not part of the morph subtree."
	self
		allMauiMorphsDo: aBlock
		ifNotIn: IdentitySet new! !

!MauiMorph methodsFor: 'accessing' stamp: 'cmm 2/3/2014 17:55'!
allMauiMorphsDo: aBlock ifNotIn: anIdentitySet 
	self submorphsDo:
		[ : each | each isMauiMorph ifTrue:
			[ (anIdentitySet includes: each) ifFalse:
				[ anIdentitySet add: each.
				aBlock value: each.
				each
					allMauiMorphsDo: aBlock
					ifNotIn: anIdentitySet ] ] ]! !

!MauiMorph methodsFor: 'menu-layout' stamp: 'cmm 1/20/2004 21:53'!
arrangementMenu

	^MenuMorph new

		addUpdating: #usingLeftToRightLayoutString target: self selector: #listDirection: argumentList: #(leftToRight) ;

		addUpdating: #usingTopToBottomLayoutString target: self selector: #listDirection: argumentList: #(topToBottom) ;

		yourself! !

!MauiMorph methodsFor: 'converting' stamp: 'cmm 12/29/2004 15:16'!
asNewViewNamed: aString

	^ (self family
		newViewNamed: aString
		for: object)

		view: aString ;
		notificationHandler: self notificationHandler ;
		yourself! !

!MauiMorph methodsFor: 'accessing' stamp: 'cmm 5/1/2009 11:56'!
balloonHelpString
	^ nil! !

!MauiMorph methodsFor: 'api-messages' stamp: 'cmm 12/3/2009 13:26'!
beInvisible
	self
		borderColor: Color transparent ;
		layoutInset: 0 ;
		color: Color transparent! !

!MauiMorph methodsFor: 'domain notifications' stamp: 'cmm 1/31/2008 00:36'!
beNotificationHandler
	self notificationHandler: self object! !

!MauiMorph methodsFor: 'keyboard' stamp: 'cmm 1/14/2004 23:39'!
beTabStop: aBoolean

	self
		setProperty: #isTabStop
		toValue: aBoolean! !

!MauiMorph methodsFor: 'effects' stamp: 'cmm 10/28/2011 15:41'!
beginMauiEffect: aMauiEffect

	self runningMauiEffects
		at: aMauiEffect selector
		ifPresent: [ : existingEffect | existingEffect terminate ]
		ifAbsent: [ "nothing to terminate" ].
self maMarked: 'dev'.  "Potential timing problem? (e.g., 1) hasRunningEffects 2) last effect terminates 3) ifFalse:..  Ehh, no way..  it's all single-threaded anyway.  Symptom would be; dropped effects..?"
	self hasRunningEffects ifFalse:
		[ self
			startStepping: #stepAllEffects
			at: Time millisecondClockValue
			arguments: nil
			stepTime: (self preferred: #transitionDuration) // 3 ].
	self runningMauiEffects
		at: aMauiEffect selector
		put: aMauiEffect! !

!MauiMorph methodsFor: 'ide' stamp: 'cmm 7/14/2004 17:26'!
browseDomainClass
	"View some of my messages and how they work."

	Browser 
		newOnClass: self classInFocus
		selector: self selectorInFocus! !

!MauiMorph methodsFor: 'ide' stamp: 'cmm 7/14/2004 17:26'!
browseDomainFull
	"Shows where in the package-structure I and objects like me reside."

	Browser 
		fullOnClass: self classInFocus
		selector: self selectorInFocus! !

!MauiMorph methodsFor: 'ide' stamp: 'cmm 12/3/2008 17:45'!
browseDomainHierarchy
	"View all of my messages and how they work, arranged by my superclasses."
	self systemNavigation
		spawnHierarchyForClass: self classInFocus
		selector: self selectorInFocus! !

!MauiMorph methodsFor: 'ide' stamp: 'cmm 4/10/2005 18:00'!
browseUiClass
	"View some of my user-interface messages and how they work."

	Browser newOnClass: self maOriginalClass selector: nil! !

!MauiMorph methodsFor: 'ide' stamp: 'cmm 4/10/2005 18:00'!
browseUiFull
	"Shows where in the package-structure where my user-interface class resides."

	Browser fullOnClass: self maOriginalClass selector: nil! !

!MauiMorph methodsFor: 'ide' stamp: 'cmm 12/3/2008 17:45'!
browseUiHierarchy
	"View all of my user-interface messages and how they work, arranged by my superclasses."
	self systemNavigation
		spawnHierarchyForClass: self maOriginalClass
		selector: nil! !

!MauiMorph methodsFor: 'menu-messages' stamp: 'cmm 12/15/2008 22:22'!
buildBehaviorMenu
	| menu |
	menu := MenuMorph new defaultTarget: self.
	menu 
		add: (self 
				string: 'find for domain...'
				withKeyBindingFor: #keyForFindMessage)
		target: self
		action: #openDomainBehaviorFinder.
	menu 
		add: (self 
				string: 'open class hierarchy'
				withKeyBindingFor: #keyForOpenHierarchy)
		action: #browseDomainHierarchy.
	menu 
		add: (self 
				string: 'open package browser'
				withKeyBindingFor: #keyForOpenPackage)
		action: #browseDomainFull.
	menu addLine.
	menu
		add: 'find for ui...'
			target: self
			action: #openUiBehaviorFinder ;
		add: 'close-box'
			action: #ensureCloseBox ;
		add: 'browse ui class'
			action: #browseUiClass ;
		add: 'browse ui hierarchy'
			action: #browseUiHierarchy ;
		add: 'browse ui full'
			action: #browseUiFull.
	self setUpBalloonHelpIn: menu.
	^ menu! !

!MauiMorph methodsFor: 'menu' stamp: 'cmm 7/16/2004 14:40'!
buildContextMenu

	| menu |
	menu := (MenuMorph entitled: (object mauiName contractTo: 20))
		addStayUpIcons.
	self mauiWorld userStrategy
		appendStandardMenuItemsTo: menu
		for: self.
	^ menu! !

!MauiMorph methodsFor: 'menu-layout' stamp: 'cmm 8/9/2004 23:55'!
buildLayoutMenu

	| menu |
	menu := MenuMorph new defaultTarget: self.
	menu
		addUpdating: #usingShrinkWrappedLayoutString action: #setShrinkWrapView;
		addUpdating: #usingCustomLayoutString action: #setCustomizableView.
	self isCustomLayout 
		ifFalse: 
			[ menu add: 'arrange' subMenu: self arrangementMenu.
			menu add: 'wrap' subMenu: self wrapMenu ].
	self setUpBalloonHelpIn: menu.
	^menu! !

!MauiMorph methodsFor: 'menu' stamp: 'cmm 3/14/2009 23:04'!
buildToolMenu
	| menu |
	menu := (MenuMorph entitled: (object mauiName contractTo: 20))
		defaultTarget: self ;
		addStayUpIcons.
	menu 
		add: 'maui this Morph'
		action: #maui.
	menu addLine.
	menu 
		add: 'behavior'
		subMenu: self buildBehaviorMenu.
	menu 
		add: 'layout'
		subMenu: self buildLayoutMenu.
	menu addLine.
	menu 
		add: (self 
				string: 'explore object'
				withKeyBindingFor: #keyForExploreObject)
		action: #exploreObject.
	menu 
		add: (self 
				string: 'explore ui'
				withKeyBindingFor: #keyForExploreMorph)
		action: #exploreUi.
	menu addLine.
	menu 
		add: 'be invisible'
		action: #beInvisible.
	menu
		addLine ;
		add: 'family...'
			action: #openFamilyMessage.
	self canBeNotificationHandler ifTrue: 
		[ menu 
			add: 'handle notifications'
			action: #beNotificationHandler ].
	^ menu! !

!MauiMorph methodsFor: 'domain notifications' stamp: 'cmm 2/2/2008 16:09'!
canBeNotificationHandler
	^ self object respondsTo: #send:to:! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 2/18/2004 20:23'!
canDropInto: aMauiMorph
	"You can't generally drop any MauiMorph into any other MauiMorph.  It just doesn't make sense.."

	^ false! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 12/29/2004 22:13'!
canHaveFillStyles
	"Superclass says I can't.  Hey, this ain't Java, so we do it because we can."

	^ true! !

!MauiMorph methodsFor: 'sketch' stamp: 'cmm 1/27/2008 12:16'!
captureSketch

	self sketch: (SketchMorph withForm: self imageForm)! !

!MauiMorph methodsFor: 'private' stamp: 'cmm 12/8/2010 14:12'!
classInFocus
	^object realObject maOriginalClass! !

!MauiMorph methodsFor: 'initializing' stamp: 'cmm 4/20/2010 21:17'!
clear
	"Empty view."
	"Note this doesn't use removeAllMorphs so it goes through all of the proper player removal, etc."
	submorphs copy do: [ : each | each delete ].
	self
		initializePanels ;
		view: #clear! !

!MauiMorph methodsFor: 'copying' stamp: 'cmm 1/1/2005 16:58'!
cloneUi
	"Hand over a new user-interface for me."

	^ (self copyForNewObject: object)
		notificationHandler: self notificationHandler ;
		openInHand! !

!MauiMorph methodsFor: 'accessing' stamp: 'cmm 12/9/2008 21:23'!
colorScheme
	^ self preferred: #colorScheme! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 12/15/2008 21:42'!
comeToFront
	"Raise this panel above all so it will not be covered.  Use the Shifted command to bring this and all other instances of this object on the desktop to the surface."
	^ super comeToFront! !

!MauiMorph methodsFor: 'private' stamp: 'cmm 4/8/2008 22:25'!
comeToFrontWithFellowPlayersOf: anObject 
	(self mauiWorld playersFor: anObject) do: [ : each | each isInWorld ifTrue: [ each root comeToFront ] ].
	self root comeToFront! !

!MauiMorph methodsFor: 'copying' stamp: 'cmm 10/8/2003 22:16'!
copyForNewObject: anObject

	^self copy
		object: anObject;
		yourself! !

!MauiMorph methodsFor: 'labelling' stamp: 'cmm 6/21/2012 11:20'!
createLabel: aString 
	^ (self preferred: #label) copy
		contents: aString ;
		lock ;
		yourself! !

!MauiMorph methodsFor: 'messages' stamp: 'cmm 1/6/2005 17:31'!
customize: aMauiMessageMorph
	"This method is called when I become the local result of aMauiMessageMorph.  At this point it may be useful to customize the aMauiMessageMorph to accomodate me living there now."! !

!MauiMorph methodsFor: 'private' stamp: 'cmm 12/11/2008 15:17'!
customizedFill: aFillStyle 
	^ aFillStyle asFillStyle
		customizeForMauiMorph: self ;
		yourself! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 12/15/2008 21:54'!
cut
	"Cut me from the screen."
	self delete.
	MauiWorld current clipboard: self! !

!MauiMorph methodsFor: 'initializing' stamp: 'cmm 12/11/2008 00:06'!
defaultBorderColor
	^ #complexRaised! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 1/10/2005 23:29'!
delete
	"Remove me from the screen."
	super delete.

self maMarked: 'dev'.
"Oops, this leaves me in a transparent state, which makes me hard to see after reopening."
"
	(MauiEffect
		target: self
		selector: #maAllMorphsAlpha:
		range: (1.0 to: 0.0)
		duration: (self preferred: #transitionDuration)
		finally: [ super delete ]) begin
"! !

!MauiMorph methodsFor: 'events and overrides' stamp: 'cmm 3/11/2008 16:12'!
deleteIfMouseTrulyLeft: aMouseEvent 
	(self bounds containsPoint: aMouseEvent position) ifFalse: [ self delete ]! !

!MauiMorph methodsFor: 'effects' stamp: 'cmm 4/12/2008 20:43'!
delineate
	"indicate my borders."
	owner ifNil: 
		[ "forget it"
		^ self ].
	(owner isWorldMorph and: [ self borderWidth > 2 ]) 
		ifTrue: [ self underlampOn ]
		ifFalse: [ self highlightBorder ]! !

!MauiMorph methodsFor: 'effects' stamp: 'cmm 1/1/2005 14:10'!
endMauiEffect: aMauiEffect

	self runningMauiEffects
		removeKey: aMauiEffect selector
		ifAbsent: [ "shouldn't happen, but who cares" ].
	self hasRunningEffects ifFalse: [ self stopSteppingSelector: #stepAllEffects ]! !

!MauiMorph methodsFor: 'preferences' stamp: 'cmm 4/13/2008 11:18'!
ensurePreferences
	^ preferences ifNil: 
		[ preferences := self nextPreferenceSource ensurePreferences newOverrideFor: self ]! !

!MauiMorph methodsFor: 'debugging' stamp: 'cmm 11/19/2003 23:07'!
exploreObject
	"... presents an expandable tree view of me."

	object explore! !

!MauiMorph methodsFor: 'debugging' stamp: 'cmm 11/19/2003 23:11'!
exploreUi
	"... presents an expandable tree-view of the Morphic user-interface object you see on the screen."

	self explore! !

!MauiMorph methodsFor: 'drag and drop' stamp: 'cmm 6/14/2007 17:20'!
extentOfDraggedMorph

	^ self primaryHand firstSubmorph extent! !

!MauiMorph methodsFor: 'accessing' stamp: 'cmm 12/25/2003 12:12'!
externalName

	^self name! !

!MauiMorph methodsFor: 'accessing' stamp: 'cmm 6/28/2007 13:37'!
family

	^ family ifNil: [ self mauiWorld family ]! !

!MauiMorph methodsFor: 'family' stamp: 'cmm 6/28/2007 13:37'!
family: aMauiFamily

	family := aMauiFamily! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 12/29/2009 15:45'!
fillStyle: aFillStyle 
	^ super fillStyle: (self customizedFill: aFillStyle) copy! !

!MauiMorph methodsFor: 'private' stamp: 'cmm 1/8/2004 00:25'!
findRemainingFocus

	| ownerChain |
	ownerChain := owner
		ifNil: [ priorOwner ifNil: [ #() ] ifNotNil: [ priorOwner ownerChain ] ]
		ifNotNil: [ owner ownerChain ].
	^ownerChain isEmpty
		ifFalse:
			[ ownerChain 
				detect: [ : e | e notNil and: [ e isMauiMorph ] ]
				ifNone: [ nil ] ]! !

!MauiMorph methodsFor: 'keyboard' stamp: 'cmm 1/16/2004 01:01'!
focusOnNextPlayerUsing: aKeyboardEvent

	aKeyboardEvent hand newKeyboardFocus: self nextTabStop! !

!MauiMorph methodsFor: 'keyboard' stamp: 'cmm 1/16/2004 00:33'!
focusOnPreviousPlayerUsing: aKeyboardEvent

	aKeyboardEvent hand newKeyboardFocus: self priorTabStop  ! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 12/15/2008 21:42'!
goBehind
	"Send this panel below all panels it covers.  Use the Shifted command to send this and all other occurrences of this object to the bottom."
	super goBehind.
	self underlamp ifNotNilDo: [ : underlamp | underlamp goBehind ]! !

!MauiMorph methodsFor: 'private' stamp: 'cmm 6/22/2008 20:43'!
goBehindWithFellowPlayersOf: anObject 
	| players |
	players := (self mauiWorld playersFor: anObject) select: [ : each | each isInWorld ].
	"First do the ones that are not roots."
	players do: [ : each | each ~~ each root ifTrue: [ each root goBehind ] ].
	"Now put the roots behind them."
	players do: [ : each | each == each root ifTrue: [ each root goBehind ] ].
	"Finally, put the receiver at the very back."
	self root goBehind! !

!MauiMorph methodsFor: 'accessing' stamp: 'cmm 1/3/2010 23:12'!
grab
	ActiveHand grabMorph: self outerMostMauiMorph! !

!MauiMorph methodsFor: 'accessing' stamp: 'cmm 1/14/2010 21:45'!
grabFocusedObject
	ActiveHand grabMorph: self! !

!MauiMorph methodsFor: 'events and overrides' stamp: 'cmm 1/8/2005 12:59'!
handleRedButton

	self isSticky ifFalse: [ self grab ]! !

!MauiMorph methodsFor: 'keyboard' stamp: 'cmm 1/6/2004 21:22'!
handlesKeyboard: aKeyboardEvent

	^self containsPoint: aKeyboardEvent position! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 12/21/2003 23:26'!
handlesMouseDown: aMouseButtonEvent

	aMouseButtonEvent yellowButtonPressed ifTrue: [ ^true ].
	aMouseButtonEvent redButtonPressed ifTrue: [ ^true ].
	^super handlesMouseDown: aMouseButtonEvent! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 6/28/2007 12:36'!
handlesMouseOver: aMouseEvent

	^ true! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 11/28/2012 12:42'!
handlesMouseOverDragging: evt
	"Answer whether #mouseEnterDragging: and #mouseLeaveDragging: should be called on me."
	"Make sure the hand has one object attached to it."
	^ true! !

!MauiMorph methodsFor: 'labelling' stamp: 'cmm 3/29/2008 23:31'!
hasCustomLabel
	^ self hasProperty: #hasCustomLabel! !

!MauiMorph methodsFor: 'api-messages' stamp: 'cmm 5/1/2009 14:25'!
hasMessageNamed: selectorSymbol 
	self messageMorphsDo: 
		[ : each | 
		"#messageMorphsDo: enumerates all InstructionMorphs, but this only looks at the MessageMorphs at this point."
		(each isMauiMessageMorph and: [ each message selector = selectorSymbol ]) ifTrue: [ ^ true ] ].
	^ false! !

!MauiMorph methodsFor: 'preferences' stamp: 'cmm 4/14/2008 21:19'!
hasOverriddenPreferences
	^ preferences notNil and: [ preferences hasValues ]! !

!MauiMorph methodsFor: 'effects' stamp: 'cmm 12/30/2004 13:06'!
hasRunningEffects
	^ runningEffects notNil and: [ runningEffects notEmpty ]! !

!MauiMorph methodsFor: 'sketch' stamp: 'cmm 1/27/2008 12:17'!
hasSketch

	^ self sketch notNil! !

!MauiMorph methodsFor: 'testing' stamp: 'cmm 5/1/2009 14:27'!
hasUnfinishedInvocations
	self messageMorphsDo: 
		[ : each | 
		(each instruction isValid and: [ each invocationStrategy isSuitableForGetter ]) ifTrue: 
			[ (each hasResult and: 
				[ each resultMorph isInWorld and: [ each resultMorph hasUnfinishedInvocations not ] ]) ifFalse: [ ^ true ] ] ].
	^ false! !

!MauiMorph methodsFor: 'menu' stamp: 'cmm 7/27/2004 12:28'!
hasUserMessageWithSameEffectAs: aMauiMessageMorph
	"Only MauiDomainMorphs have user messages."

	^ false! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 7/28/2007 16:30'!
heightOf: submorphCollection
	^ (submorphCollection
		inject: 0
		into: [ : sum : each | sum + each height + self cellInset ]) + self cellInset! !

!MauiMorph methodsFor: 'effects' stamp: 'cmm 12/10/2008 10:28'!
highlightBorder
	"For morphs embedded into other MauiMorphs, simply highlight their border."
	"If already delineated, skip the transition becuase its distracting."
	self borderColor = self colorScheme highlightColor ifTrue: [ ^ self ].
	self borderColor: (self colorScheme highlightColor alpha: 0.0).
	(MauiEffect 
		target: self
		selector: #maBorderColorAlpha:
		range: (0.0 to: self colorScheme highlightColor alpha)
		duration: (self preferred: #transitionDuration)
		finally: 
			[ "nothing more"
			 ]) begin! !

!MauiMorph methodsFor: 'testing' stamp: 'cmm 6/1/2004 00:56'!
includesMorphAnywhere: aMorph

	self allMorphsDo: [ : each | each == aMorph ifTrue: [ ^ true ] ].
	^ false! !

!MauiMorph methodsFor: 'initializing' stamp: 'cmm 2/15/2013 12:51'!
initialize
	super initialize.
	self initializeNotificationHandler.
	self
		balloonTextSelector: #balloonHelpString ;
		extent: 16 @ 16 ;
		clipSubmorphs: true ;
		cellPositioning: #leftCenter ;
		layoutPolicy: TableLayout new ;
		hResizing: #shrinkWrap ;
		vResizing: #shrinkWrap ;
		listDirection: #topToBottom ;
		wrapDirection: #none ;
		layoutInset: 0 ;
		cellInset: 1 ;
		cellPositioning: #topLeft ;
		borderWidth: 1 ;
		initializeColor ;
		borderColor: self defaultBorderColor.
	self
		noteRefreshNeeded ;
		beTabStop: true ;
		initializeRedButtonMessage.
	object := self.
	lastRefreshTime := 0! !

!MauiMorph methodsFor: 'initializing' stamp: 'cmm 6/20/2012 17:47'!
initializeBorder
	"Make my border according to the prototypes."
"self==Y ifTrue: [ self halt ]."
	self prototype in:
		[ : proto | self
			 layoutInset: proto layoutInset ;
			 borderColor: proto borderColor ;
			 borderWidth: proto borderWidth ;
			 cornerStyle: proto cornerStyle ;
			 cellInset: proto cellInset ]! !

!MauiMorph methodsFor: 'initializing' stamp: 'cmm 12/8/2008 22:48'!
initializeColor
	self messageMorphsDo: [ : each | each initializeColor ]! !

!MauiMorph methodsFor: 'initializing' stamp: 'cmm 12/6/2009 14:35'!
initializeExtent
	"Included for compatibility with MauiParameterHolderMorph."! !

!MauiMorph methodsFor: 'initializing' stamp: 'cmm 1/2/2005 16:15'!
initializeNotificationHandler

	notificationHandler := MauiNotificationHandler default! !

!MauiMorph methodsFor: 'initializing' stamp: 'cmm 7/22/2004 17:30'!
initializeRedButtonMessage

	self redButtonMessage:
		(MauiMessage 
			receiver: self
			selector: #handleRedButton)! !

!MauiMorph methodsFor: 'effects' stamp: 'cmm 12/30/2004 13:03'!
initializeRunningEffects

	runningEffects := Dictionary new! !

!MauiMorph methodsFor: 'messages' stamp: 'cmm 2/3/2014 16:59'!
instructionCount
	^ submorphs count:
		[ : each | each isMauiInstructionMorph ]! !

!MauiMorph methodsFor: 'messages' stamp: 'cmm 2/3/2014 16:56'!
instructionMorphsDo: oneArgBlock 
	self submorphsDo:
		[ : each | each isMauiInstructionMorph ifTrue:
			[ oneArgBlock value: each.
			each hasResult ifTrue: [ each resultMorph instructionMorphsDo: oneArgBlock ] ] ]! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 2/11/2012 17:09'!
intoWorld: aWorld 
	super intoWorld: aWorld.
	aWorld ifNil: [ ^ self ].
	"Not sure why this happens, but it can.."
	owner ifNil: [ ^ self ].
	owner isPlayfieldLike ifTrue:
		[ World doOneCycle.
		self mauiEnsureOnScreen ].
	self
		 initializeColor ;
		 initializeBorder.
	"If font used for message labels increased (such as for a demo), they are truncated based on their original width.  I hope this won't cause any bad side-effects.."
	submorphs do:
		[ : each | each maIsStringMorph ifTrue: [ each fitContents ] ].
	self canBeNotificationHandler ifTrue: [ self beNotificationHandler ]! !

!MauiMorph methodsFor: 'messages' stamp: 'cmm 5/22/2013 21:20'!
invoke: aString 
	self
		invoke: aString
		withArguments: Array empty! !

!MauiMorph methodsFor: 'messages' stamp: 'cmm 2/3/2014 17:40'!
invoke: aString withArguments: anArray 
	self allInstructionMorphsDo:
		[ : eachMsg | ((aString isSymbol and: [ eachMsg isMauiMessageMorph ])
			ifTrue: [ eachMsg selector ]
			ifFalse: [ eachMsg concatenatedLabels ]) = aString ifTrue:
			[ anArray withIndexDo:
				[ : eachParameter : index | (eachMsg parameterHolderMorphAt: index) setParameter: eachParameter asMauiMorph ].
			eachMsg invoke.
			World doOneCycle ] ]! !

!MauiMorph methodsFor: 'testing' stamp: 'cmm 10/13/2003 22:38'!
isCustomLayout

	^self layoutPolicy isNil! !

!MauiMorph methodsFor: 'testing' stamp: 'cmm 12/30/2004 12:57'!
isInvisible
	^ self color = Color transparent! !

!MauiMorph methodsFor: 'testing' stamp: 'cmm 4/29/2009 12:03'!
isLocal: aMorph 
	"Answers whether aMorph is contained as part of me or my receiverMorph."
	| myOutermostPanel hisOutermostPanel |
	myOutermostPanel := self outerMostMauiMorph.
	hisOutermostPanel := aMorph outerMostMauiMorph.
	^ myOutermostPanel notNil and: [ myOutermostPanel == hisOutermostPanel ]! !

!MauiMorph methodsFor: 'testing' stamp: 'cmm 11/24/2003 00:19'!
isMauiDomainMorph

	^false! !

!MauiMorph methodsFor: 'testing' stamp: 'cmm 7/10/2003 22:22'!
isMauiMorph

	^true! !

!MauiMorph methodsFor: 'testing' stamp: 'cmm 11/2/2003 20:17'!
isMauiParameterHolderMorph

	^false! !

!MauiMorph methodsFor: 'private' stamp: 'cmm 8/11/2004 15:34'!
isMyDeleteMessage: aMorph

	^ aMorph isMauiMessageMorph
	and: [ aMorph message selector = #delete
	and: [ aMorph message receiver == self ] ]! !

!MauiMorph methodsFor: 'testing' stamp: 'cmm 6/5/2009 12:02'!
isOutermostMauiDomainMorph
	^ self outerMostMauiDomainMorph == self! !

!MauiMorph methodsFor: 'testing' stamp: 'cmm 12/19/2007 11:16'!
isSelfContained
	"Answer if I am contained by another MauiMorph with the same object."
	self allOwnersDo: [ : each | (each isMauiMorph and: [ each object = self object ]) ifTrue: [ ^ true ] ].
	^ false! !

!MauiMorph methodsFor: 'keyboard' stamp: 'cmm 1/14/2004 23:38'!
isTabStop

	^self valueOfProperty: #isTabStop! !

!MauiMorph methodsFor: 'testing' stamp: 'cmm 11/27/2007 17:03'!
isUserResizable
	self layoutPolicy ifNil: [ ^ true ].
	self layoutPolicy isProportionalLayout ifTrue: [ ^ false ].
	(#(#shrinkWrap #spaceFill ) includes: self hResizing) ifFalse: [ ^ true ].
	(#(#shrinkWrap #spaceFill ) includes: self vResizing) ifFalse: [ ^ true ].
	^ false! !

!MauiMorph methodsFor: 'keyboard' stamp: 'cmm 4/21/2014 16:21'!
keyStroke: aKeyboardEvent 
	self mauiWorld userStrategy
		handleStandardKeyboardEvent: aKeyboardEvent
		for: self! !

!MauiMorph methodsFor: 'family' stamp: 'cmm 8/27/2012 13:59'!
lastModified
	"Pertains to prototypes in the family.  The last time this view was saved to the Family."
	^ self valueOfProperty: #lastModified! !

!MauiMorph methodsFor: 'family' stamp: 'cmm 8/28/2012 20:26'!
lastModified: aDateAndTime 
	"Pertains to prototypes in the family.  The last time this view was saved to the Family."
	self
		setProperty: #lastModified
		toValue: aDateAndTime! !

!MauiMorph methodsFor: 'private' stamp: 'cmm 7/19/2007 16:17'!
listDirectionPerpendicularTo: directionSymbol 
	^ directionSymbol = #topToBottom 
		ifTrue: [ #leftToRight ]
		ifFalse: [ #topToBottom ]! !

!MauiMorph methodsFor: 'ma object serialization' stamp: 'cmm 4/10/2009 23:24'!
maTransientVariables
	^ super maTransientVariables , #(
			'notificationHandler'
			'priorOwner'
			'runningEffects'
			'family'
			'lastRefreshTime'
		)! !

!MauiMorph methodsFor: 'converting' stamp: 'cmm 12/11/2008 16:13'!
makeList
	"Create a new OrderedCollection with this object."
	^ (self family 
		newViewNamed: #listEditor
		for: (OrderedCollection with: self object)) openInHand! !

!MauiMorph methodsFor: 'converting' stamp: 'cmm 12/1/2007 22:01'!
makeWord
	"Hand over a word view with my label (window title) as the word."
	(self asNewViewNamed: #word)
		position: ActiveHand position ;
		labelString: (self isLabelled 
				ifTrue: [ self labelString ]
				ifFalse: [ object mauiName ]) ;
		openInHand! !

!MauiMorph methodsFor: 'converting' stamp: 'cmm 1/26/2008 19:23'!
maui
	"Open a maui panel on this on-screen Morph UI object."
	self captureSketch.
	super maui beSketch! !

!MauiMorph methodsFor: 'private' stamp: 'cmm 4/29/2009 17:45'!
mauiLabelString
	^ object mauiName! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 2/22/2013 15:30'!
mauiNoteOutOfWorld
	super mauiNoteOutOfWorld.
	priorOwner:=nil.
	self
		initializeNotificationHandler ;
		underlampOff! !

!MauiMorph methodsFor: 'private' stamp: 'cmm 12/6/2003 14:43'!
mauiWorld

	| myWorld |
	^MauiWorld for:
		((myWorld := self world)
			ifNil: [ World ]
			ifNotNil: [ myWorld ])! !

!MauiMorph methodsFor: 'events and overrides' stamp: 'cmm 12/23/2008 12:56'!
maybeMouseLeftBounds: aMouseEvent 
	"Maui presents the resize haloMorph slightly within the bounds, but still causes the mouseLeave: event.  But we don't want to remove it unless they truly left the area."
	self world ifNotNilDo: 
		[ : world | 
		((world rootMorphsAtGlobal: aMouseEvent position) includesAnyOf: {  self. (self halo)  }) ifFalse: [ self isUserResizable ifTrue: [ self removeResizeHandle ] ] ]! !

!MauiMorph methodsFor: 'messages' stamp: 'cmm 8/29/2012 16:46'!
messageMorphs
	^ Array streamContents:
		[ : stream | self messageMorphsDo:
			[ : each | stream nextPut: each ] ]! !

!MauiMorph methodsFor: 'messages' stamp: 'cmm 8/22/2007 15:47'!
messageMorphsDo: oneArgBlock 
	self submorphsDo: [ : each | each isMauiMessageMorph ifTrue: [ oneArgBlock value: each ] ]! !

!MauiMorph methodsFor: 'api-messages' stamp: 'cmm 5/1/2009 14:29'!
messageNamed: selectorSymbol 
	self messageMorphsDo: 
		[ : each | 
		(each isMauiMessageMorph and: [ each message selector = selectorSymbol ]) ifTrue: [ ^ each ] ].
	^ nil! !

!MauiMorph methodsFor: 'events and overrides' stamp: 'cmm 4/10/2009 23:21'!
millisecondsSinceLastRefresh
	^ lastRefreshTime 
		ifNil: [ self desiredRefreshInterval + 1 ]
		ifNotNil: [ Time millisecondsSince: lastRefreshTime ]! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 3/20/2008 16:47'!
minExtent
	"Override from superclass so we can size proportional-layout windows down as small as the user wants.."
	| calculatedExtent politeWidth |
	calculatedExtent := super minExtent.
	politeWidth := Display width // 3.
	^ (self layoutPolicy isNil or: [ self layoutPolicy isProportionalLayout not ]) 
		ifTrue: [ calculatedExtent ]
		ifFalse: [ (calculatedExtent x min: politeWidth) @ self height+1 ]! !

!MauiMorph methodsFor: 'events and overrides' stamp: 'cmm 7/31/2010 18:32'!
mouseDown: aMouseButtonEvent 
	aMouseButtonEvent yellowButtonPressed ifTrue: [ self yellowButtonActivity: aMouseButtonEvent shiftPressed ].
	aMouseButtonEvent redButtonPressed ifTrue:
		[ redButtonMessage invokeUsing: self notificationHandler.
		aMouseButtonEvent wasHandled: true ]! !

!MauiMorph methodsFor: 'events and overrides' stamp: 'cmm 12/23/2008 12:54'!
mouseEnter: aMouseEvent 
	super mouseEnter: aMouseEvent.
	aMouseEvent hand newKeyboardFocus: self.
	self isUserResizable ifTrue: [ self addResizeHandle ]! !

!MauiMorph methodsFor: 'events and overrides' stamp: 'cmm 11/27/2007 17:02'!
mouseLeave: aMouseEvent 
	super mouseLeave: aMouseEvent.
	aMouseEvent hand newKeyboardFocus: self findRemainingFocus.
	self maybeMouseLeftBounds: aMouseEvent! !

!MauiMorph methodsFor: 'events and overrides' stamp: 'cmm 11/28/2012 12:45'!
mouseLeaveDragging: evt 
	self
		 maybeMouseLeftBounds: evt ;
		 ensureNoSpacer! !

!MauiMorph methodsFor: 'accessing' stamp: 'cmm 6/23/2012 19:15'!
nearestOwningMauiDomainMorph
	^ self nearestOwnerThat:
		[ : each | each isMauiDomainMorph ]! !

!MauiMorph methodsFor: 'drag and drop' stamp: 'cmm 10/1/2007 17:00'!
newDropMarker
	^ MauiSpacer 
		for: self
		targetExtent: self extentOfDraggedMorph! !

!MauiMorph methodsFor: 'api-messages' stamp: 'cmm 12/10/2008 20:58'!
newMessageNamed: selectorSymbol 
	^ (MauiMessage 
		receiver: self object
		selector: selectorSymbol) asMauiMorphFor: self! !

!MauiMorph methodsFor: 'api-messages' stamp: 'cmm 12/10/2008 20:54'!
newPanel
	^ self object asMauiMorphFor: self! !

!MauiMorph methodsFor: 'api-messages' stamp: 'cmm 8/28/2012 22:08'!
newUiMessageNamed: selectorSymbol 
	^ (MauiMessage 
		receiver: self
		selector: selectorSymbol) asMauiMorphFor: self! !

!MauiMorph methodsFor: 'preferences' stamp: 'cmm 8/11/2004 21:58'!
nextPreferenceSource

	^ self family! !

!MauiMorph methodsFor: 'keyboard' stamp: 'cmm 1/15/2004 23:43'!
nextSibling

	| siblings myPosition |
	owner ifNil: [ ^nil ].
	siblings := owner submorphs.
	myPosition := siblings indexOf: self.
	^myPosition = siblings size 
		ifTrue: [ nil ] 
		ifFalse: 
			[ myPosition+1 to: siblings size do:
				[ : submorphIndex | 
				(siblings at: submorphIndex) isMauiMorph 
					ifTrue: [ ^ siblings at: submorphIndex ] ].
			nil ]! !

!MauiMorph methodsFor: 'keyboard' stamp: 'cmm 1/15/2004 22:36'!
nextTabStop

	^self nextTabStop: false! !

!MauiMorph methodsFor: 'keyboard' stamp: 'cmm 2/3/2014 20:59'!
nextTabStop: includeMyself

	| nextTry |
	includeMyself ifTrue: [ self isTabStop ifTrue: [ ^self ] ].
	self allMauiMorphsDo: [ : each | each isTabStop ifTrue: [ ^ each ] ].
	(nextTry := self nextSibling) ifNotNil: [ ^nextTry ].
	nextTry := (nextTry := self nextMauiOwner) ifNotNil: [ nextTry nextSibling ].
	^nextTry
		ifNil: [ self outermostMorphThat: [ : each | each isMauiMorph ] ]
		ifNotNil: [ nextTry nextTabStop: true ]! !

!MauiMorph methodsFor: 'events and overrides' stamp: 'cmm 1/15/2008 11:14'!
noteDataRefreshed
	lastRefreshTime := Time millisecondClockValue! !

!MauiMorph methodsFor: 'labelling' stamp: 'cmm 3/29/2008 23:44'!
noteHasCustomLabel
	self 
		setProperty: #hasCustomLabel
		toValue: true! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 12/3/2004 16:22'!
noteNewOwner: aMorph
	"Override in subclasses, prior to calling super you have the priorOwner."

	(priorOwner notNil
	and: [ priorOwner isMauiMorph
	and: [ aMorph ~~ priorOwner ] ]) 
		ifTrue: 
			[ priorOwner noteNoLongerOwning: aMorph ].
	super noteNewOwner: aMorph.
	"When you do 'MyClass maui' and drop it on the desktop, transfer keyboard focus to the newly created Morph."
	priorOwner == ActiveHand ifTrue: [ ActiveHand newKeyboardFocus: self ].
	priorOwner := aMorph! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 8/2/2004 21:37'!
noteNoLongerOwning: aMorph
	"I used to own aMorph, now it has moved on.  If interested, subclasses may override."! !

!MauiMorph methodsFor: 'events and overrides' stamp: 'cmm 3/5/2008 12:32'!
noteRefreshNeeded
	lastRefreshTime := 0.
	self messageMorphsDo: [ : each | each noteRefreshNeeded ]! !

!MauiMorph methodsFor: 'domain notifications' stamp: 'cmm 11/17/2009 11:30'!
notificationHandler
	"Special handling for MagmaForwardingProxy's.  ForwardingProxy's are a door to an entirely different repository, so changes to those should be handled under their own session."
	"If its the same *type* of handler, but just different instances, use the correct one."
	^ notificationHandler 
		ifNil: [ MauiNotificationHandler default ]
		ifNotNil: [ notificationHandler maChooseNotificationHandlerUsing: self ]! !

!MauiMorph methodsFor: 'domain notifications' stamp: 'cmm 2/3/2014 23:17'!
notificationHandler: aMaNotificationHandler 
	"Set the object which implements send: aMessage to: anObject.  That method is implemented by the application-programmer to answer aMessage sentTo: anObject, but handling various Notifications, Errors or other Exceptions as appropriate for the application.
	The default behavior, if this is not specified, is to simply display notifications to the Transcript."
	notificationHandler := aMaNotificationHandler.
	self instructionMorphsDo: [ : each | each notificationHandler: aMaNotificationHandler ]! !

!MauiMorph methodsFor: 'accessing' stamp: 'cmm 6/2/2003 00:13'!
object

	^object! !

!MauiMorph methodsFor: 'accessing' stamp: 'cmm 2/16/2014 21:22'!
object: anObject 
	self setObject: anObject! !

!MauiMorph methodsFor: 'private' stamp: 'cmm 12/15/2008 22:32'!
openAdjacent: aMauiMorph 
	aMauiMorph
		position: self adjacentPosition ;
		openInWorld ;
		mauiEnsureOnScreen! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 12/19/2010 16:55'!
openAdjacentTo: anotherMorph 
	self
		 position: anotherMorph adjacentPosition ;
		 mauiEnsureOnScreen.
	self openInWorld! !

!MauiMorph methodsFor: 'menu' stamp: 'cmm 11/18/2003 23:44'!
openContextMenu

	| menu |
	menu := self buildContextMenu.
	self
		setUpBalloonHelpIn: menu.
	menu popUpInWorld! !

!MauiMorph methodsFor: 'menu-messages' stamp: 'cmm 12/8/2010 14:12'!
openDomainBehaviorFinder
	"Open a MauiBehaviorFinder on my object."
	self openAdjacent: (((MauiBehaviorFinder object: object realObject)
			addCommonBehaviorForClass: self classInFocus ;
			yourself) asMauiMorph
			notificationHandler: self notificationHandler ;
			yourself)! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 1/1/2005 16:35'!
openInHand

	super openInHand.
	self owner = ActiveHand ifTrue: [ ActiveHand newKeyboardFocus: self ]! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 11/29/2007 22:11'!
openNextTo: aMorph 
	self
		position: aMorph sensibleAdjacentPosition ;
		openInWorld! !

!MauiMorph methodsFor: 'preferences' stamp: 'cmm 12/15/2008 22:34'!
openPreferencesPanel
	self openAdjacent: self ensurePreferences asMauiMorph! !

!MauiMorph methodsFor: 'menu' stamp: 'cmm 8/11/2004 18:06'!
openToolMenu
	"... for customizing me."

	| menu |
	menu := self buildToolMenu.
	self setUpBalloonHelpIn: menu.
	menu popUpInWorld! !

!MauiMorph methodsFor: 'menu-messages' stamp: 'cmm 12/15/2008 22:32'!
openUiBehaviorFinder
	"Open a MauiBehaviorFinder on this UI panel."
	self openAdjacent: ((MauiBehaviorFinder object: self)
			addElement: self ;
			yourself) asMauiMorph! !

!MauiMorph methodsFor: 'accessing' stamp: 'cmm 8/2/2007 17:55'!
outerMostMauiDomainMorph
	self allOwners reverseDo: [ : each | each isMauiDomainMorph ifTrue: [ ^ each ] ].
	^ self! !

!MauiMorph methodsFor: 'accessing' stamp: 'cmm 7/16/2007 13:34'!
outerMostMauiMorph
	self allOwners reverseDo: [ : each | each isMauiMorph ifTrue: [ ^ each ] ].
	^ self! !

!MauiMorph methodsFor: 'domain notifications' stamp: 'cmm 11/23/2010 17:17'!
outerParentBeNotificationHandler
	self outerMostMauiMorph beNotificationHandler! !

!MauiMorph methodsFor: 'preferences' stamp: 'cmm 6/14/2009 22:01'!
overridden: preferenceSelector 
	"Ensure an override for preferenceSelector exists.  Create it if necessary, otherwise answer the existing."
	^ self ensurePreferences overridden: preferenceSelector! !

!MauiMorph methodsFor: 'initializing' stamp: 'cmm 1/9/2008 16:00'!
postInitialize
	"This method offers a subclass hook for initializing any object-dependent variables that could not be calculated in initialize."! !

!MauiMorph methodsFor: 'copying' stamp: 'cmm 2/13/2014 17:11'!
postVeryDeepCopy
	"Delete all resultMorphs to enforce the copy to reinvoke to re-produce the resultMorph again.  This helps us avoid having resultMorphs with MauiPrototypes as the object on Clicked invocationStrategy's."
self maMarked: 'delete'.
	self allMorphsDo: 
		[ : each | 
		each isMauiInstructionMorph ifTrue: [ each hasResult ifTrue: [ each resultMorph delete ] ] ]! !

!MauiMorph methodsFor: 'preferences' stamp: 'cmm 4/14/2008 21:50'!
preferences
	"Answer the nearest (overridden) preferences or the global preferences if there are no overrides."
	^ preferences ifNil: [ self nextPreferenceSource preferences ]! !

!MauiMorph methodsFor: 'preferences' stamp: 'cmm 4/14/2008 16:30'!
preferencesMenuText
	^ self hasOverriddenPreferences 
		ifTrue: [ 'preferences' translated ]
		ifFalse: [ 'override preferences' translated ]! !

!MauiMorph methodsFor: 'preferences' stamp: 'cmm 8/5/2004 15:55'!
preferred: preferenceSelector

	^ self preferences preferred: preferenceSelector! !

!MauiMorph methodsFor: 'private' stamp: 'cmm 12/7/2007 12:25'!
priorOwner
	^ priorOwner! !

!MauiMorph methodsFor: 'keyboard' stamp: 'cmm 1/16/2004 00:29'!
priorSibling

	| siblings myPosition |
	owner ifNil: [ ^nil ].
	siblings := owner submorphs.
	myPosition := siblings indexOf: self.
	myPosition < 2 ifTrue: [ ^nil ].
	myPosition-1 to: 1 by: -1 do:
		[ : submorphIndex |
		(siblings at: submorphIndex) isMauiMorph ifTrue: [ ^ siblings at: submorphIndex ] ].
	^nil! !

!MauiMorph methodsFor: 'keyboard' stamp: 'cmm 1/16/2004 00:21'!
priorTabStop

	^self priorTabStop: false! !

!MauiMorph methodsFor: 'keyboard' stamp: 'cmm 1/16/2004 00:33'!
priorTabStop: includeMyself

	includeMyself ifTrue: [ self isTabStop ifTrue: [ ^self ] ].
	^(self priorSibling
		ifNil: [ self nextMauiOwner ifNil: [ ^nil ] ]) priorTabStop: true! !

!MauiMorph methodsFor: 'private' stamp: 'cmm 8/3/2004 16:00'!
privateAddMorph: aMorph atIndex: index

	| needsNewOwnerSignal |
	needsNewOwnerSignal := aMorph world isNil.
	super 
		privateAddMorph: aMorph
		atIndex: index.
	needsNewOwnerSignal ifTrue: [ aMorph noteNewOwner: self ].
	^ aMorph! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 12/27/2004 23:05'!
privateDelete
	"Unfortunately, I see no easier way to hook when I am deleted reliably (replaceSubmorph:by: doesn't call #delete)."

	super privateDelete.
	self allMorphsDo: [ : each | each mauiNoteOutOfWorld ]! !

!MauiMorph methodsFor: 'preferences' stamp: 'cmm 6/11/2009 10:50'!
prototype
	self subclassResponsibility! !

!MauiMorph methodsFor: 'initializing' stamp: 'cmm 7/13/2004 17:09'!
redButtonMessage: aMauiMessage

	redButtonMessage := aMauiMessage! !

!MauiMorph methodsFor: 'api-messages' stamp: 'cmm 1/9/2008 16:41'!
removeMessageNamed: selectorSymbol 
	(self messageNamed: selectorSymbol) in: [ : msg | msg ifNotNil: [ msg delete ] ]! !

!MauiMorph methodsFor: 'private' stamp: 'cmm 8/11/2004 16:49'!
removeMyCloseBoxFromSubmorphsOf: aMorph

	aMorph submorphs
		maDetect: [ : each | (self isMyDeleteMessage: each) ]
		ifFound: [ : deleteMessage | deleteMessage delete ]
		ifNone: [ "didn't have one, no problem." ]! !

!MauiMorph methodsFor: 'private' stamp: 'cmm 12/23/2008 12:56'!
removeResizeHandle
	self removeHalo! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 9/10/2007 17:28'!
replaceSubmorph: subMorph by: newMorph
	"Look for a message and modify its invocation-strategy to use newMorph's view."
	self messageMorphsDo:
		[ : each |
		each resultMorph == subMorph
			ifTrue:
				[ each resultMorph: newMorph.
				each invocationStrategy resultView: newMorph view ] ].
	super
		replaceSubmorph: subMorph 
		by: newMorph! !

!MauiMorph methodsFor: 'labelling' stamp: 'cmm 3/29/2008 23:39'!
resetLabel
	self
		removeProperty: #hasCustomLabel ;
		initializeLabelString! !

!MauiMorph methodsFor: 'private' stamp: 'cmm 7/21/2004 18:16'!
resetObject

	self object: object asMauiPrototype! !

!MauiMorph methodsFor: 'preferences' stamp: 'cmm 8/9/2004 23:25'!
resetPreferences

	preferences := nil! !

!MauiMorph methodsFor: 'private' stamp: 'cmm 2/3/2014 17:40'!
resetResultMorphObjects
	self allInstructionMorphsDo: 
		[ : each | 
		each isDomainMessage ifTrue: 
			[ each hasResult ifTrue: 
				[ each resultMorph
					resetResultMorphObjects ;
					resetObject ] ] ]! !

!MauiMorph methodsFor: 'effects' stamp: 'cmm 12/30/2004 13:05'!
resetRunningEffects

	runningEffects := nil! !

!MauiMorph methodsFor: 'effects' stamp: 'cmm 12/30/2004 14:45'!
runningMauiEffects
	^ runningEffects ifNil: [ runningEffects := Dictionary new ]! !

!MauiMorph methodsFor: 'private' stamp: 'cmm 7/14/2004 17:23'!
selectorInFocus

	^ nil! !

!MauiMorph methodsFor: 'private' stamp: 'cmm 11/29/2007 22:11'!
sensibleAdjacentPosition
	"Answer either my #starboardPosition or my #beneathPosition depending on which has more space available."
	^ Display extent x - self bounds right > (Display extent y - self bounds bottom) 
		ifTrue: [ self starboardPosition ]
		ifFalse: [ self underneathPosition ]! !

!MauiMorph methodsFor: 'menu-layout' stamp: 'cmm 11/19/2003 23:37'!
setCustomizableView
	"Let's you place messages anywhere you wish."

	self 
		layoutPolicy: nil;
		hResizing: #rigid;
		vResizing: #rigid! !

!MauiMorph methodsFor: 'private' stamp: 'cmm 3/9/2014 12:33'!
setObject: anObject 
	object := anObject.
	object isMauiPrototype ifTrue: [ self mauiNoteOutOfWorld ]! !

!MauiMorph methodsFor: 'menu-layout' stamp: 'cmm 11/19/2003 23:37'!
setShrinkWrapView
	"Widgets are arranged automatically in rows or columns for you.  They cannot be moved."

	self 
		layoutPolicy: TableLayout new;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap! !

!MauiMorph methodsFor: 'menu' stamp: 'cmm 11/30/2008 23:45'!
setUpBalloonHelpIn: aMenu 
	"Set up the balloon-help for aMenu accounting for my usability-preferences."
	aMenu submorphs do: 
		[ : each | 
		(each maIsMenuItemMorph and: [ each maCanInvoke ]) ifTrue: 
			[ each balloonText ifNil: 
				[ each setBalloonText: (self preferences preferenceOrMenuBalloonMessage: each mauiBalloonText) ] ] ]! !

!MauiMorph methodsFor: 'private' stamp: 'cmm 7/12/2007 12:50'!
setupRedButtonOverride: aMessageSend using: aMauiMorph 
	aMessageSend
		arguments: {  aMauiMorph  } ;
		value! !

!MauiMorph methodsFor: 'keyboard' stamp: 'cmm 1/16/2004 00:55'!
shiftFocus: aKeyboardEvent

	aKeyboardEvent shiftPressed
		ifTrue: [ self focusOnPreviousPlayerUsing: aKeyboardEvent ]
		ifFalse: [ self focusOnNextPlayerUsing: aKeyboardEvent ].
	aKeyboardEvent wasHandled: true! !

!MauiMorph methodsFor: 'events and overrides' stamp: 'cmm 1/15/2008 11:17'!
shouldRefreshData
	"This 'between' check accounts for when the millisecondClock value changes dramatically lower (like when moving the image to another machine or if it rolls)"
	^ (self millisecondsSinceLastRefresh 
		between: 0
		and: self desiredRefreshInterval) not! !

!MauiMorph methodsFor: 'events and overrides' stamp: 'cmm 12/3/2007 00:04'!
showBalloon: msgString hand: aHand 
	"Pop up a balloon containing the given string,
	first removing any existing BalloonMorphs in the world."
	^ msgString 
		ifNil: [ self ]
		ifNotNil: 
			[ super 
				showBalloon: msgString
				hand: aHand ]! !

!MauiMorph methodsFor: 'debugging' stamp: 'cmm 1/15/2008 12:26'!
signalWhereInvalid
	super signalWhereInvalid.
	(preferences notNil and: [ preferences target ~~ self ]) ifTrue: [ MauiSoftwareError signal ]! !

!MauiMorph methodsFor: 'sketch' stamp: 'cmm 1/27/2008 12:17'!
sketch

	^ self valueOfProperty: #sketch! !

!MauiMorph methodsFor: 'sketch' stamp: 'cmm 1/27/2008 12:17'!
sketch: aSketchMorph

	self 
		setProperty: #sketch
		toValue: aSketchMorph! !

!MauiMorph methodsFor: 'private' stamp: 'cmm 6/3/2009 15:42'!
spawnBalloon: aBalloonMorph 
	self world ifNotNilDo: 
		[ : world | 
		| hand |
		hand := world activeHand ifNil: [ ActiveHand ].
		hand ifNotNil: [ hand spawnMauiBalloon: aBalloonMorph ] ]! !

!MauiMorph methodsFor: 'private' stamp: 'cmm 11/29/2007 21:44'!
starboardPosition
	^ (self localPointToGlobal: self position) + (self width @ 0)! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 12/8/2010 14:05'!
step
	(object realObject isMauiPrototype or: [ self world isNil ]) ifTrue: 
		[ self stopStepping.	"we're not valid to be stepping!!"
		self mauiWorld removePlayer: self ]! !

!MauiMorph methodsFor: 'effects' stamp: 'cmm 12/30/2004 14:47'!
stepAllEffects
	self runningMauiEffects do: [ : each | each step ]! !

!MauiMorph methodsFor: 'effects' stamp: 'cmm 12/31/2004 17:01'!
stepEffect: aMauiEffect

	aMauiEffect step! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 1/1/2005 14:33'!
stepTime
	"This value affects the smoothness of the animation effects."
	^ 1000! !

!MauiMorph methodsFor: 'keyboard' stamp: 'cmm 4/15/2008 23:07'!
string: menuItemString withKeyBindingFor: keyBindingSymbol 
	^ String streamContents: 
		[ : stream | 
		stream
			nextPutAll: menuItemString translated ;
			nextPutAll: '  (' ;
			maPrint: (((self preferred: #keyMap) perform: keyBindingSymbol) in: 
					[ : hotKey | 
					hotKey = $  
						ifTrue: [ 'space' ]
						ifFalse: [ hotKey ] ]) ;
			nextPut: $) ]! !

!MauiMorph methodsFor: 'effects' stamp: 'cmm 11/16/2009 09:29'!
undelineate
	self removeAlarm: #delineateAllLikeSelf.
	owner ifNil: [ ^ self ].
	"Make sure borderColor is a color so MauiEffect, below, won't blow up."
	self
		unhighlightBorder ;
		underlampOff! !

!MauiMorph methodsFor: 'effects' stamp: 'cmm 4/12/2008 18:35'!
underlamp
	^ self valueOfProperty: #underlamp! !

!MauiMorph methodsFor: 'effects' stamp: 'cmm 4/12/2008 18:36'!
underlamp: aMorph 
	aMorph 
		ifNil: [ self removeProperty: #underlamp ]
		ifNotNil: 
			[ self 
				setProperty: #underlamp
				toValue: aMorph ]! !

!MauiMorph methodsFor: 'effects' stamp: 'cmm 4/12/2008 20:21'!
underlampOff
	self underlamp ifNotNilDo: 
		[ : underlamp | 
		underlamp delete.
		self underlamp: nil ]! !

!MauiMorph methodsFor: 'effects' stamp: 'cmm 11/23/2010 21:38'!
underlampOn
	"For morphs directly on the desktop, highlighting their border looks too extreme because the border is thick (so its 3d effect is well-delineated)."
	| underlamp color1 color2 preferredConnector |
	self underlampOff.
	color1 := self colorScheme highlightColor alpha: 0.6.
	color2 := color1 alpha: 0.01.
	preferredConnector := self preferred: #connector.
	underlamp := Morph new
		bounds: (self bounds outsetBy: (preferredConnector 
					ifNil: [ 3 ]
					ifNotNilDo: [ : conn | conn lineWidth ])) ;
		color: color1 ;
		cornerStyle: #rounded ;
		lock.
	"	fill := (GradientFillStyle ramp: {  (0.01 -> color1). (1.0 -> color2)  })
		radial: true ;
		origin: self bounds center ;
		direction: self extent ;
		normal: nil.
	underlamp fillStyle: fill."
	self underlamp: underlamp.
	self world 
		addMorph: underlamp
		behind: self! !

!MauiMorph methodsFor: 'private' stamp: 'cmm 11/29/2007 21:45'!
underneathPosition
	^ (self localPointToGlobal: self position) + (0 @ self height)! !

!MauiMorph methodsFor: 'effects' stamp: 'cmm 12/11/2008 13:06'!
unhighlightBorder
	"Make sure borderColor is a color so MauiEffect, below, won't blow up."
	self borderColor isColor ifFalse: [ self borderColor: self colorScheme highlightColor ].
	(MauiEffect 
		target: self
		selector: #maBorderColorAlpha:
		range: (self borderColor alpha to: 0.0)
		duration: (self preferred: #transitionDuration)
		finally: [ self initializeBorder ]) begin! !

!MauiMorph methodsFor: 'menu-layout' stamp: 'cmm 9/4/2003 00:58'!
usingCustomLayoutString

	^self layoutPolicy
		ifNil: [ '<on>custom' ]
		ifNotNil: [ '<off>custom' ]! !

!MauiMorph methodsFor: 'menu-layout' stamp: 'cmm 1/20/2004 21:51'!
usingLeftToRightLayoutString

	^self listDirection = #leftToRight
		ifTrue: [ '<on>left-to-right' ]
		ifFalse: [ '<off>left-to-right' ]! !

!MauiMorph methodsFor: 'menu-layout' stamp: 'cmm 1/20/2004 21:56'!
usingNoWrapString

	^self wrapDirection = #none
		ifTrue: [ '<on>none' ]
		ifFalse: [ '<off>none' ]! !

!MauiMorph methodsFor: 'menu-layout' stamp: 'cmm 11/18/2003 22:21'!
usingShrinkWrappedLayoutString

	^self layoutPolicy
		ifNil: [ '<off>automatic' ]
		ifNotNil: [ '<on>automatic' ]! !

!MauiMorph methodsFor: 'menu-layout' stamp: 'cmm 1/20/2004 21:51'!
usingTopToBottomLayoutString

	^self listDirection = #topToBottom
		ifTrue: [ '<on>top-to-bottom' ]
		ifFalse: [ '<off>top-to-bottom' ]! !

!MauiMorph methodsFor: 'menu-layout' stamp: 'cmm 1/20/2004 22:03'!
usingWrapBottomToTopString

	^self wrapDirection = #bottomToTop
		ifTrue: [ '<on>bottom-to-top' ]
		ifFalse: [ '<off>bottom-to-top' ]! !

!MauiMorph methodsFor: 'menu-layout' stamp: 'cmm 1/20/2004 21:58'!
usingWrapLeftToRightString

	^self wrapDirection = #leftToRight
		ifTrue: [ '<on>left-to-right' ]
		ifFalse: [ '<off>left-to-right' ]! !

!MauiMorph methodsFor: 'menu-layout' stamp: 'cmm 1/20/2004 22:00'!
usingWrapRightToLeftString

	^self wrapDirection = #rightToLeft
		ifTrue: [ '<on>right-to-left' ]
		ifFalse: [ '<off>right-to-left' ]! !

!MauiMorph methodsFor: 'menu-layout' stamp: 'cmm 1/20/2004 22:02'!
usingWrapTopToBottomString

	^self wrapDirection = #topToBottom
		ifTrue: [ '<on>top-to-bottom' ]
		ifFalse: [ '<off>top-to-bottom' ]! !

!MauiMorph methodsFor: 'copying' stamp: 'cmm 2/13/2014 17:11'!
veryDeepCopy
	^ super veryDeepCopy "postVeryDeepCopy"! !

!MauiMorph methodsFor: 'copying' stamp: 'cmm 8/12/2008 13:43'!
veryDeepInner: aDeepCopier 
	super veryDeepInner: aDeepCopier.
	priorOwner := nil.
	redButtonMessage := redButtonMessage veryDeepCopyWith: aDeepCopier.
	self underlamp: (self underlamp veryDeepCopyWith: aDeepCopier).
	self
		initializeNotificationHandler ;
		resetRunningEffects ;
		formerOwner: nil.
	preferences := preferences veryDeepCopyWith: aDeepCopier! !

!MauiMorph methodsFor: 'copying' stamp: 'cmm 12/24/2003 14:40'!
view

	^'n/a'! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 3/12/2010 10:48'!
wantsDroppedMorph: aMorph event: aDropEvent 
	aMorph isMauiMorph ifTrue: [ ^aMorph canDropInto: self ].
	aMorph isTransferMorph ifTrue:
		[ (#(#messageList #dragTransferPlus ) includes: aMorph dragTransferType) ifTrue: [ ^aMorph canBeMauiMessageFor: self ].
		^false ].
	"a pinball Morph?  Why not?"
	^true! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 2/14/2009 18:32'!
wantsHaloHandleWithSelector: aSelector inHalo: aHaloMorph 
	"Answer whether the receiver would like to offer the halo handle with the given selector (e.g. #addCollapseHandle:)"
	^ self isUserResizable 
		ifTrue: 
			[  #(#addGrowHandle: #addScaleHandle: ) includes: aSelector ]
		ifFalse: 
			[ super 
				wantsHaloHandleWithSelector: aSelector
				inHalo: aHaloMorph ]! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 7/14/2003 21:46'!
wantsSteps

	^true! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 2/11/2008 12:41'!
wantsYellowButtonMenu
	^ true! !

!MauiMorph methodsFor: 'menu-layout' stamp: 'cmm 1/20/2004 22:06'!
wrapMenu

	^MenuMorph new

		addUpdating: #usingNoWrapString target: self selector: #wrapDirection: argumentList: #(none) ;

		addUpdating: #usingWrapLeftToRightString target: self selector: #wrapDirection: argumentList: #(leftToRight) ;

		addUpdating: #usingWrapRightToLeftString target: self selector: #wrapDirection: argumentList: #(rightToLeft) ;

		addUpdating: #usingWrapTopToBottomString target: self selector: #wrapDirection: argumentList: #(topToBottom) ;

		addUpdating: #usingWrapBottomToTopString target: self selector: #wrapDirection: argumentList: #(bottomToTop) ;

		yourself! !

!MauiMorph methodsFor: 'Morphic' stamp: 'cmm 8/16/2007 16:35'!
yellowButtonActivity: shiftPressed 
	self mauiWorld userStrategy 
		yellowDown: shiftPressed
		on: self! !

MauiMorph subclass: #MauiParameterHolderMorph
	instanceVariableNames: 'parameterMorph optionalParametersMorph optionalParametersStrategy dropMarker stringEditor evaluator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Messages'!

!MauiParameterHolderMorph class methodsFor: 'accessing' stamp: 'cmm 1/4/2004 20:33'!
parameterHolderExtent

	^24@16! !

!MauiParameterHolderMorph methodsFor: 'Morphic' stamp: 'cmm 5/27/2012 18:12'!
acceptDroppingMorph: aMorph event: event
	aMorph isTransferMorph
		ifTrue:
			[ | possibleTransfers |
			possibleTransfers := aMorph passenger possibleTransfers.
			possibleTransfers size = 1
				ifTrue: [ self dropParameter: possibleTransfers anyOne asMauiMorph ]
				ifFalse:
					[ | selectionDialog |
					selectionDialog := possibleTransfers asMauiMorph.
					selectionDialog addMorph:
						(StringMorph new contents: 'Choose the form of ', aMorph dragTransferType ; yourself).
					event hand attachMorph: selectionDialog ] ]
		ifFalse: [ self dropParameter: aMorph ]! !

!MauiParameterHolderMorph methodsFor: 'accessing' stamp: 'cmm 7/16/2004 13:15'!
argumentIndex

	^ self myMessageMorph indexOfHolder: self! !

!MauiParameterHolderMorph methodsFor: 'accessing' stamp: 'cmm 4/18/2009 16:44'!
argumentName
	^ self message isValid 
		ifTrue: [ self message argumentNameAt: self argumentIndex ]
		ifFalse: [ '' ]! !

!MauiParameterHolderMorph methodsFor: 'accessing' stamp: 'cmm 2/14/2009 18:25'!
argumentType

	^Utilities
		classFromPattern: self argumentName
		withCaption: 'Choose:'! !

!MauiParameterHolderMorph methodsFor: 'Morphic' stamp: 'cmm 2/4/2008 09:00'!
balloonHelpString
	| argName |
	^ (argName := self argumentName) 
		ifNil: [ 'This parameter is not valid because the message is not valid.' ]
		ifNotNil: 
			[ String streamContents: 
				[ : stream | 
				stream
					nextPutAll: 'Drag ' ;
					nextPutAll: (self mauiWorld userStrategy nameFor: argName) ;
					nextPutAll: ' here or type a ' ;
					nextPutAll: evaluator interpretation ;
					nextPut: $. ] ]! !

!MauiParameterHolderMorph methodsFor: 'private' stamp: 'cmm 3/1/2012 21:31'!
blankText
	^ String empty asText! !

!MauiParameterHolderMorph methodsFor: 'actions' stamp: 'cmm 12/3/2008 17:45'!
browseParameterHierarchy
	| type |
	type := self argumentType.	"answers the class of the argument"
	type ifNil: [ ^ self ].
	self systemNavigation
		spawnHierarchyForClass: type
		selector: self message selector! !

!MauiParameterHolderMorph methodsFor: 'menu' stamp: 'cmm 7/16/2004 14:40'!
buildContextMenu

	| answer |
	answer := MenuMorph new.
	self mauiWorld userStrategy
		appendParameterHolderMenuItemsTo: answer
		for: self.
	^ answer! !

!MauiParameterHolderMorph methodsFor: 'menu' stamp: 'cmm 8/2/2007 17:16'!
buildToolMenu
	| menu |
	menu := (MenuMorph entitled: object mauiName)
		defaultTarget: self ;
		yourself.
	menu 
		add: 'picker...'
		target: self
		selector: #specifyPicker.
	menu 
		add: 'evaluator...'
		target: self
		selector: #specifyEvaluator.
	^ menu! !

!MauiParameterHolderMorph methodsFor: 'string editor' stamp: 'cmm 12/10/2008 20:59'!
currentSelectorMessageFor: answer 
	| currentSelectorMessage |
	currentSelectorMessage := (MauiMessage 
		receiver: answer object
		selector: #optionalParametersMorph) asMauiMorphFor: self.
	currentSelectorMessage invocationStrategy resultView: #beSketch.
	^ currentSelectorMessage asGetterSetter! !

!MauiParameterHolderMorph methodsFor: 'actions' stamp: 'cmm 1/1/2005 14:57'!
defaultBorderColor

	^ #complexInset! !

!MauiParameterHolderMorph methodsFor: 'actions' stamp: 'cmm 2/23/2004 23:04'!
deleteParameterMorph

	self hasParameter
		ifTrue:
			[ parameterMorph delete.
			parameterMorph := nil ]! !

!MauiParameterHolderMorph methodsFor: 'private' stamp: 'cmm 3/18/2009 13:23'!
delineate
	super delineate.
	self showBalloon: self balloonText! !

!MauiParameterHolderMorph methodsFor: 'actions' stamp: 'cmm 10/8/2007 16:54'!
dropCopy: aMorphOrMauiMorph
	self dropParameter: aMorphOrMauiMorph copy word! !

!MauiParameterHolderMorph methodsFor: 'private' stamp: 'cmm 10/23/2007 17:07'!
dropExpression: aText 
	"user wants to drop the result of contents of aMauiTextEditor."
	self
		dropParameter: (self evaluateContents: aText string) asMauiMorph ;
		ensureNoStringEditor! !

!MauiParameterHolderMorph methodsFor: 'drop marker' stamp: 'cmm 10/5/2007 11:52'!
dropMarker: aMorph
	"Specialize my dropMarker to any Morph, otherwise, the default dropMarker, MauiSpacer will be used."
	dropMarker := aMorph! !

!MauiParameterHolderMorph methodsFor: 'actions' stamp: 'cmm 1/10/2005 23:33'!
dropParameter: aMorphOrMauiMorph

	self setParameter: aMorphOrMauiMorph.
	[ self myMessageMorph parameterDropped ]
		ensure:
			[ optionalParametersStrategy 
				parameterDropped: aMorphOrMauiMorph
				into: self.
	self hideDropMarker ]! !

!MauiParameterHolderMorph methodsFor: 'optional parameters' stamp: 'cmm 8/8/2004 21:27'!
ensureNoOptionalParametersMorph

	optionalParametersMorph ifNotNil: [ optionalParametersMorph delete ]! !

!MauiParameterHolderMorph methodsFor: 'string editor' stamp: 'cmm 10/24/2007 12:26'!
ensureNoStringEditor
	stringEditor ifNotNil: 
		[ stringEditor delete.
		stringEditor := nil.
		self initializeExtent ]! !

!MauiParameterHolderMorph methodsFor: 'string editor' stamp: 'cmm 10/24/2007 12:24'!
ensureStringEditor
	(stringEditor isNil or: [ (submorphs includes: stringEditor) not ]) ifTrue: 
		[ self initializeStringEditor.
		self addMorph: stringEditor ]! !

!MauiParameterHolderMorph methodsFor: 'private' stamp: 'cmm 7/2/2008 16:11'!
evaluateContents: aString 
	"Answer an object the result of evaluating my contents.  If it is an uncompilable expression, then return the exacly entered expression as a String."
	^ evaluator 
		evaluate: aString
		for: self message receiver! !

!MauiParameterHolderMorph methodsFor: 'string editor' stamp: 'cmm 11/13/2007 09:33'!
evaluator
	^ evaluator ! !

!MauiParameterHolderMorph methodsFor: 'string editor' stamp: 'cmm 12/3/2008 15:37'!
evaluator: aMauiStringEvaluatorClass 
	evaluator := aMauiStringEvaluatorClass! !

!MauiParameterHolderMorph methodsFor: 'Morphic' stamp: 'cmm 3/10/2009 20:58'!
handleDropMorph: anEvent 
	"really don't want to override this but.. This helps prevent accidental droppage of a Morph when all you wanted to do was drop move it to a different location."
	self hasDropMarker ifTrue: 
		[ self hideDropMarker.
		super handleDropMorph: anEvent ]! !

!MauiParameterHolderMorph methodsFor: 'string editor' stamp: 'cmm 4/16/2008 10:05'!
handleKeystroke: aKeyboardEvent 
	"This is handled upon the first initial keystroke on me, before an editor has been placed."
	| keyPressed |
	aKeyboardEvent wasHandled ifTrue: [ ^ self ].
	self mauiWorld userStrategy 
		handleParameterHolderKeyboardEvent: aKeyboardEvent
		for: self.
	aKeyboardEvent wasHandled ifTrue: [ ^ self ].
	keyPressed := aKeyboardEvent keyCharacter.
	keyPressed = (self preferred: #keyMap) keyForCancelEdit ifTrue: [ ^ self ].
	keyPressed = (self preferred: #keyMap) keyForAccept ifTrue: [ ^ self ].
	keyPressed = (self preferred: #keyMap) keyForFocusShift ifTrue: [ ^ self shiftFocus: aKeyboardEvent ].
	self ensureStringEditor.
	aKeyboardEvent hand newKeyboardFocus: stringEditor textMorph.
	stringEditor textMorph handleKeystroke: aKeyboardEvent! !

!MauiParameterHolderMorph methodsFor: 'Morphic' stamp: 'cmm 12/19/2010 17:07'!
handleRedButton
	optionalParametersMorph
		ifNil:
			[ evaluator logicalPicker
				ifNil:
					[ self ensureStringEditor.
					ActiveHand newKeyboardFocus: stringEditor ]
				ifNotNilDo:
					[ : picker | picker openAdjacentTo: self ] ]
		ifNotNil: [ self selectOptionalParameters ]! !

!MauiParameterHolderMorph methodsFor: 'testing' stamp: 'cmm 12/15/2008 15:57'!
hasDropMarker
	^ dropMarker notNil and: [ self submorphs includes: dropMarker ]! !

!MauiParameterHolderMorph methodsFor: 'testing' stamp: 'cmm 1/7/2005 17:44'!
hasParameter

	^ parameterMorph notNil and: [ parameterMorph owner == self ]! !

!MauiParameterHolderMorph methodsFor: 'drop marker' stamp: 'cmm 12/6/2009 11:49'!
hideDropMarker
	dropMarker ifNotNil: 
		[ dropMarker isMauiSpacer 
			ifTrue: [ dropMarker shrinkAndDelete ]
			ifFalse: [ dropMarker delete ].
		self initializeExtent ]! !

!MauiParameterHolderMorph methodsFor: 'drop marker' stamp: 'cmm 8/3/2004 16:31'!
initialMarkerExtentOf: aMauiSpacer

	^ self extent - (self layoutInset*2+2)! !

!MauiParameterHolderMorph methodsFor: 'initializing' stamp: 'cmm 6/11/2009 10:57'!
initialize
	super initialize.
	self
		initializeExtent ;
		cellInset: 2 ;
		dropEnabled: true ;
		listDirection: #leftToRight ;
		evaluator: MauiSmalltalkEvaluator.
	self object: self.	"I will invoke any messages added to me."
	optionalParametersStrategy := MauiClickAndPickParameterStrategy new! !

!MauiParameterHolderMorph methodsFor: 'initializing' stamp: 'cmm 12/29/2009 15:52'!
initializeColor
	self fillStyle: self colorScheme parameterHolderFill copy! !

!MauiParameterHolderMorph methodsFor: 'initializing' stamp: 'cmm 9/18/2003 00:52'!
initializeExtent

	self extent: self class parameterHolderExtent! !

!MauiParameterHolderMorph methodsFor: 'string editor' stamp: 'cmm 10/26/2007 16:47'!
initializeStringEditor
	stringEditor ifNotNil: [ self ensureNoStringEditor ].
	stringEditor := (MauiTextEditor 
		on: self
		text: #blankText
		accept: #dropExpression:) autoExtent: true.
	stringEditor textMorph 
		on: #keyStroke
		send: #keyStroke:
		to: self! !

!MauiParameterHolderMorph methodsFor: 'testing' stamp: 'cmm 11/2/2003 20:17'!
isMauiParameterHolderMorph

	^true! !

!MauiParameterHolderMorph methodsFor: 'string editor' stamp: 'cmm 2/14/2009 16:18'!
keyStroke: aKeyboardEvent 
	"This is signaled from MauiTextMorph>>#handleKeystroke:.  I get first chance to handle aKeyboardEvent, if I don't handle it, my signaler will."
	| keyPressed |
	keyPressed := aKeyboardEvent keyCharacter.
	"For 'memo' fields we want Return/Tab to add a carriage-return/tab into the entry and Shift to accept the memo entry.  In that case, modifierForFocusShift is true.  But for short entry fields, we want Return/Tab to just accept the value, in which case modifierForFocusShift is false."
	(({ 
		((self preferred: #keyMap) keyForFocusShift).
		((self preferred: #keyMap) keyForAccept)
	 } includes: keyPressed) and: 
		[ aKeyboardEvent shiftPressed = (self preferred: #keyMap) modifierForAccept ]) ifTrue: 
		[ self
			dropExpression: stringEditor text ;
			ensureNoStringEditor.
		aKeyboardEvent hand newKeyboardFocus: (aKeyboardEvent shiftPressed 
				ifTrue: [ self priorTabStop ]
				ifFalse: [ self nextTabStop ]).
		aKeyboardEvent wasHandled: true.
		^ self ].
	keyPressed = (self preferred: #keyMap) keyForCancelEdit ifTrue: 
		[ self ensureNoStringEditor.
		aKeyboardEvent wasHandled: true.
		^ self ].
	stringEditor ifNotNil: [ stringEditor keyStroke: aKeyboardEvent ]! !

!MauiParameterHolderMorph methodsFor: 'Morphic' stamp: 'cmm 12/31/2004 16:28'!
keyboardFocusChange: gainedFocus

	gainedFocus
		ifTrue: [ self delineate ]
		ifFalse: "lost focus" [ self undelineate ]! !

!MauiParameterHolderMorph methodsFor: 'ma object serialization' stamp: 'cmm 4/10/2009 23:30'!
maTransientVariables
	^ super maTransientVariables , #('dropMarker' )! !

!MauiParameterHolderMorph methodsFor: 'accessing' stamp: 'cmm 5/1/2009 12:27'!
message
	^ self myMessageMorph instruction! !

!MauiParameterHolderMorph methodsFor: 'Morphic' stamp: 'cmm 11/28/2012 12:58'!
mouseEnterDragging: evt
	| submorph |
	evt hand submorphs size = 1 ifFalse: [ ^ self ].
	submorph := evt hand firstSubmorph renderedMorph.
	"Disallow certain kinds of Morphs, like menus and windows."
	submorph canDropIntoMauiMorph ifFalse: [ ^ self ].
	(self 
		wantsDroppedMorph: submorph
		event: evt) ifFalse: [ ^ self ].
	self showDropMarker! !

!MauiParameterHolderMorph methodsFor: 'Morphic' stamp: 'cmm 10/22/2007 16:38'!
mouseLeave: aMouseMoveEvent 
	super mouseLeave: aMouseMoveEvent.
	(stringEditor notNil and: [ stringEditor text isEmpty ]) ifTrue: [ self ensureNoStringEditor ]! !

!MauiParameterHolderMorph methodsFor: 'Morphic' stamp: 'cmm 1/8/2004 00:08'!
mouseLeaveDragging: evt

	self
		hideDropMarker;
		initializeExtent! !

!MauiParameterHolderMorph methodsFor: 'private' stamp: 'cmm 9/26/2003 00:17'!
myMessageMorph

	^self owner! !

!MauiParameterHolderMorph methodsFor: 'preferences' stamp: 'cmm 12/9/2008 17:16'!
nextPreferenceSource
	^ self myMessageMorph ifNil: [ super nextPreferenceSource ]! !

!MauiParameterHolderMorph methodsFor: 'string editor' stamp: 'cmm 2/5/2004 21:44'!
nextTabStop

	^super nextTabStop nextTabStop ! !

!MauiParameterHolderMorph methodsFor: 'Morphic' stamp: 'cmm 8/2/2004 21:37'!
noteNoLongerOwning: aMorph

	aMorph == parameterMorph ifTrue: [ parameterMorph := nil ]! !

!MauiParameterHolderMorph methodsFor: 'optional parameters' stamp: 'cmm 7/12/2007 14:02'!
optionalParameters
	^ optionalParametersMorph 
		ifNil: 
			[ #() ]
		ifNotNil: [ optionalParametersMorph optionalParameters ]! !

!MauiParameterHolderMorph methodsFor: 'optional parameters' stamp: 'cmm 7/12/2007 14:20'!
optionalParametersMorph
	^ optionalParametersMorph! !

!MauiParameterHolderMorph methodsFor: 'optional parameters' stamp: 'cmm 12/13/2008 13:27'!
optionalParametersMorph: aMauiDomainMorph 
	"Specify the Morph to open when this parameter-holder is clicked.  To specify the Morph itself, invoke its tools menu, then select 'maui this morph' and drop that result here."
	(aMauiDomainMorph notNil and: [ aMauiDomainMorph isMauiDomainMorph not ]) ifTrue: 
		[ MauiUserError signal: 'Please supply a MauiDomainMorph by selecting "maui this morph" from the tools menu.' ].
	optionalParametersMorph ifNotNil: [ optionalParametersMorph delete ].
	optionalParametersMorph := aMauiDomainMorph copy.
	optionalParametersMorph ifNotNil: [ optionalParametersMorph pickee: self ].
	^ optionalParametersMorph! !

!MauiParameterHolderMorph methodsFor: 'optional parameters' stamp: 'cmm 12/22/2003 22:11'!
optionalParametersStrategy

	^optionalParametersStrategy! !

!MauiParameterHolderMorph methodsFor: 'optional parameters' stamp: 'cmm 11/19/2007 16:16'!
optionalParametersStrategy: aMauiOptionalParametersStrategy 
	optionalParametersStrategy := aMauiOptionalParametersStrategy.
	aMauiOptionalParametersStrategy initializeUsing: self.
	"Make some space where user can type into me."
	self
		layoutInset: 4 @ 1 ;
		cellPositioning: #rightCenter! !

!MauiParameterHolderMorph methodsFor: 'optional parameters' stamp: 'cmm 12/10/2008 20:59'!
optionalParametersStrategyMessageFor: aMauiMorph 
	| answer |
	answer := (MauiMessage 
		receiver: aMauiMorph object
		selector: #optionalParametersStrategy:) asMauiMorphFor: self.
	answer firstParameterHolder optionalParametersMorph: (MauiOptionalParametersStrategy allSubclasses asArray collect: [ : eachInvocationStrategyClass | eachInvocationStrategyClass new ]) asMauiMorph.
	answer firstParameterHolder optionalParametersStrategy: MauiClickAndPickParameterStrategy new.
	answer
		invocationStrategy: (MauiAutoInvocationStrategy new
				resultView: #word ;
				yourself) ;
		asGetterSetter.
	^ answer! !

!MauiParameterHolderMorph methodsFor: 'accessing' stamp: 'cmm 10/1/2003 20:47'!
parameterMorph

	^parameterMorph! !

!MauiParameterHolderMorph methodsFor: 'preferences' stamp: 'cmm 6/11/2009 10:24'!
prototype
	^ self preferred: #parameterHolderMorph! !

!MauiParameterHolderMorph methodsFor: 'actions' stamp: 'cmm 9/4/2003 23:46'!
reset

	self deleteParameterMorph.
	self initializeExtent! !

!MauiParameterHolderMorph methodsFor: 'optional parameters' stamp: 'cmm 12/22/2003 22:11'!
selectOptionalParameters

	self optionalParametersStrategy selectUsing: self! !

!MauiParameterHolderMorph methodsFor: 'actions' stamp: 'cmm 12/7/2009 17:35'!
setParameter: aMauiMorph 
	self deleteParameterMorph.
	dropMarker ifNotNil: [ dropMarker delete ].
	parameterMorph := aMauiMorph.
	self addMorphFront: parameterMorph.
	"doOneCycle because sometimes otherwise Morphic doesn't always resize if I grew."
	World doOneCycle! !

!MauiParameterHolderMorph methodsFor: 'drop marker' stamp: 'cmm 10/5/2007 12:03'!
showDropMarker
	dropMarker 
		ifNil: [ dropMarker := self newDropMarker ]
		ifNotNil: 
			[ dropMarker isMauiSpacer ifTrue: [ dropMarker targetExtent: self extentOfDraggedMorph ] ].
	self addMorphFront: dropMarker.
	dropMarker isMauiSpacer ifTrue: [ dropMarker startStepping ]! !

!MauiParameterHolderMorph methodsFor: 'debugging' stamp: 'cmm 1/7/2005 17:45'!
signalWhereInvalid

	super signalWhereInvalid.
self maMarked: 'dev'.  "This check is no longer necessary."
	self hasParameter 
		ifTrue: 
			[ (self submorphs includes: parameterMorph) ifFalse: [ MauiSoftwareError signal ] ].
	optionalParametersMorph ifNotNil: [ optionalParametersMorph signalWhereInvalid ]! !

!MauiParameterHolderMorph methodsFor: 'string editor' stamp: 'cmm 8/5/2013 14:43'!
specifyEvaluator
	"to interpret expressions typed directly into the parameter-holder."
	| answer currentEvaluatorMessage |
	answer := self asMauiMorph.
	answer
		 listDirection: #topToBottom ;
		 wrapDirection: #none.
	currentEvaluatorMessage := (MauiMessage
		receiver: answer object
		selector: #evaluator:) asMauiMorphFor: self.
	currentEvaluatorMessage listDirection: #topToBottom.
	currentEvaluatorMessage invocationStrategy
		 resultView: #word ;
		 postInvokeAction: #deleteParent.
	currentEvaluatorMessage firstParameterHolder optionalParametersMorph: MauiStringEvaluator withAllSubclasses asArray asMauiMorph.
	currentEvaluatorMessage firstParameterHolder optionalParametersStrategy: MauiListSelectionStrategy new.
	currentEvaluatorMessage asGetterSetter.
	answer addMessage: currentEvaluatorMessage.
	answer
		 position: self sensibleAdjacentPosition ;
		 openInWorld! !

!MauiParameterHolderMorph methodsFor: 'string editor' stamp: 'cmm 12/3/2007 10:53'!
specifyPicker
	"Specify the MauiMorph that will be used as a selector for me."
	| answer |
	answer := self asMauiMorph.
	answer
		listDirection: #topToBottom ;
		wrapDirection: #none.
	answer
		addMessage: (self currentSelectorMessageFor: answer) ;
		addMessage: (self optionalParametersStrategyMessageFor: answer) ;
		position: self sensibleAdjacentPosition ;
		openInWorld! !

!MauiParameterHolderMorph methodsFor: 'copying' stamp: 'cmm 7/23/2004 15:13'!
veryDeepFixupWith: aDeepCopier

	super veryDeepFixupWith: aDeepCopier.
	"These are 'dynamic' things, not part of the desired save, so we clean them up, just in case."
	self 
		ensureNoStringEditor ;
		hideDropMarker! !

!MauiParameterHolderMorph methodsFor: 'copying' stamp: 'cmm 12/6/2007 21:28'!
veryDeepInner: aDeepCopier 
	super veryDeepInner: aDeepCopier.
	"We allow sharing of optional parameters, so we don't want to ruin that if the user has decided to share."
	optionalParametersMorph := optionalParametersMorph veryDeepCopyWith: aDeepCopier.
	optionalParametersStrategy := optionalParametersStrategy veryDeepCopyWith: aDeepCopier.
	parameterMorph := parameterMorph veryDeepCopyWith: aDeepCopier.
	dropMarker := nil.
	stringEditor := stringEditor veryDeepCopyWith: aDeepCopier! !

!MauiParameterHolderMorph methodsFor: 'Morphic' stamp: 'cmm 5/1/2009 14:10'!
wantsDroppedMorph: aMorph event: event 
	self myMessageMorph isDomainMessage ifFalse: [ ^ true ].
	aMorph isTransferMorph ifTrue: [ ^ true ].
	aMorph isMauiMorph ifFalse: [ ^ false ].
	aMorph isMauiInstructionMorph ifTrue: [ ^ false ].	"so reordering isn't so clunky"
	^ aMorph view = #word or: [ event isDropEvent or: [ event shiftPressed ] ]! !

RectangleMorph subclass: #MauiSpacer
	instanceVariableNames: 'targetExtent firstStepTime deltaExtent delete client originalExtent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Widgets'!

!MauiSpacer class methodsFor: 'test' stamp: 'cmm 7/30/2004 17:14'!
example2

	[ | s |
	s := 
		self
			originalExtent: 4@4
			targetExtent: 200@20.
	s openInWorld; position: 50@50.
	"wait until opened"
	[ s world isNil ] whileTrue: [ ].
	(Delay forMilliseconds: 90) wait.
	s shrinkAndDelete ] fork! !

!MauiSpacer class methodsFor: 'create' stamp: 'cmm 8/2/2004 10:29'!
for: aMauiMorph targetExtent: targetExtentPoint

	^ self new
		client: aMauiMorph ;
		targetExtent: targetExtentPoint ;
		yourself! !

!MauiSpacer methodsFor: 'initialize' stamp: 'cmm 8/3/2004 21:56'!
client: aMauiMorph

	client := aMauiMorph.
	self originalExtent: (aMauiMorph initialMarkerExtentOf: self)! !

!MauiSpacer methodsFor: 'operate' stamp: 'cmm 8/2/2004 12:02'!
delete: aBoolean

	delete := aBoolean! !

!MauiSpacer methodsFor: 'private' stamp: 'cmm 8/2/2004 23:16'!
desiredDuration

	^ 111 "milliseconds"! !

!MauiSpacer methodsFor: 'private' stamp: 'cmm 8/1/2004 23:41'!
elapsedTime

	^ (Time millisecondClockValue - firstStepTime) max: 1! !

!MauiSpacer methodsFor: 'initialize' stamp: 'cmm 8/2/2004 12:03'!
initialize

	super initialize.
	self
		delete: false ;
		borderWidth: 1 ;
		color: Color transparent ;
		borderColor: Color transparent! !

!MauiSpacer methodsFor: 'testing' stamp: 'cmm 10/5/2007 11:49'!
isMauiSpacer
	^ true! !

!MauiSpacer methodsFor: 'initialize' stamp: 'cmm 8/2/2004 10:30'!
originalExtent: aPoint

	originalExtent := aPoint.
	self extent: aPoint! !

!MauiSpacer methodsFor: 'private' stamp: 'cmm 8/1/2004 23:44'!
reachedTargetExtent

	^ delete
		ifTrue: [ self extent <= targetExtent ]
		ifFalse: [ self extent >= targetExtent ]! !

!MauiSpacer methodsFor: 'initialize' stamp: 'cmm 8/2/2004 10:38'!
reset
	"I have not reachedTargetExtent, prepare to step my way there."
	self
		color: Color transparent ;
		borderColor: Color transparent.
	deltaExtent := targetExtent - self extent.
	"since we are resetting our extents, we need to reset the flag that allows the animation."
	firstStepTime := nil! !

!MauiSpacer methodsFor: 'operate' stamp: 'cmm 8/2/2004 12:04'!
shrinkAndDelete

	self world 
		ifNil: [ self delete ]
		ifNotNil:
			[ self
				targetExtent: originalExtent ;
				delete: true ;
				startStepping ]! !

!MauiSpacer methodsFor: 'Morphic' stamp: 'cmm 12/6/2009 14:35'!
step
	firstStepTime ifNil: [ firstStepTime := Time millisecondClockValue ].
	self extent: (delete 
			ifTrue: 
				[ originalExtent + deltaExtent abs + (deltaExtent * self elapsedTime // self desiredDuration) ]
			ifFalse: 
				[ originalExtent + (deltaExtent * self elapsedTime // self desiredDuration) ]).
	(self elapsedTime > self desiredDuration or: [ self reachedTargetExtent ]) ifTrue: 
		[ self extent: targetExtent.
		World doOneCycle.	"gotta make sure it happens."
		self stopStepping.
		delete 
			ifTrue: 
				[ self delete.
				client initializeExtent ]
			ifFalse: [ self borderColor: client colorScheme highlightColor ] ]! !

!MauiSpacer methodsFor: 'Morphic' stamp: 'cmm 7/30/2004 16:31'!
stepTime

	^ 0! !

!MauiSpacer methodsFor: 'accessing' stamp: 'cmm 8/3/2004 16:31'!
targetExtent

	^ targetExtent! !

!MauiSpacer methodsFor: 'operate' stamp: 'cmm 8/2/2004 12:04'!
targetExtent: aPoint

	targetExtent := aPoint.
	self delete: false.
	self reset! !

!MauiSpacer methodsFor: 'copying' stamp: 'cmm 8/1/2004 21:54'!
veryDeepInner: aDeepCopier

	super veryDeepInner: aDeepCopier.
	client := client veryDeepCopyWith: aDeepCopier! !

!DirectoryEntryFile methodsFor: '*maui-core' stamp: 'cmm 9/26/2007 13:34'!
allContents
	"Answer a String of my entire contents."
	^ self contentsTo: self fileSize ! !

!DirectoryEntryFile methodsFor: '*maui-core' stamp: 'cmm 12/8/2008 15:56'!
asBitmapFillStyle
	| stream |
	stream := self readStream.
	^ stream ifNotNil: 
		[ [ BitmapFillStyle fromForm: (Form fromBinaryStream: stream) ] ensure: [ stream close ] ]! !

!DirectoryEntryFile methodsFor: '*maui-core' stamp: 'cmm 12/8/2008 15:57'!
bitmapFillStyleService 
	^  SimpleServiceEntry
		provider: self 
		label: 'open as BitmapFillStyle'
		selector: #mauiBitmapFillStyle
		description: 'Reads the graphic file and instantiates a BitmapFillStyle'
		buttonLabel: 'get fillstyle'! !

!DirectoryEntryFile methodsFor: '*maui-core' stamp: 'cmm 2/19/2009 14:17'!
editFileService 
	^  SimpleServiceEntry
		provider: self 
		label: 'open file in a text editor'
		selector: #mauiOpenInEditor
		description: 'Opens the file in a standard Squeak text editor which may edited and resaved.'
		buttonLabel: 'edit'! !

!DirectoryEntryFile methodsFor: '*maui-core' stamp: 'cmm 5/22/2008 16:53'!
initialContents
	^ self contentsTo: 50000! !

!DirectoryEntryFile methodsFor: '*maui-core' stamp: 'cmm 9/26/2007 17:00'!
launch
	"Launch this file using its associated program defined in the MauiRegistry.  Requires OSProcess."
	"Do not let Maui require a dependency on OSProcess, because loading and initializing OSProcess is platform dependent."
	(Smalltalk hasClassNamed: #OSProcess) ifFalse: [ MauiUserError signal: 'OSProcess must be loaded before this function can be used.'].

				self maMarked: 'dev'  "I'll do this later."! !

!DirectoryEntryFile methodsFor: '*maui-core' stamp: 'cmm 12/8/2008 15:59'!
mauiBitmapFillStyle
	^ self asBitmapFillStyle ifNotNilDo: [ : fill | fill maui small ]! !

!DirectoryEntryFile methodsFor: '*maui-core' stamp: 'cmm 8/8/2010 15:27'!
mauiOpenInEditor
	^ (FileList 
		openEditorOn: self readStream
		editString: nil) openInWorld! !

!DirectoryEntryFile methodsFor: '*maui-core' stamp: 'cmm 4/21/2009 18:46'!
mauiServices
	^ super mauiServices , {  (self bitmapFillStyleService). (self editFileService)  } , (FileList itemsForFile: self fullName)! !

!TextStream methodsFor: '*maui-core' stamp: 'cmm 12/21/2007 00:09'!
nextPut: anObject 
	self 
		nextPut: anObject
		labelled: anObject mauiName! !

!TextStream methodsFor: '*maui-core' stamp: 'cmm 4/19/2009 16:14'!
nextPut: anObject labelled: aString 
	self 
		nextPut: anObject
		labelled: aString
		produce: #word! !

!TextStream methodsFor: '*maui-core' stamp: 'cmm 4/19/2009 16:13'!
nextPut: anObject labelled: aString produce: producedView 
	anObject isCharacter 
		ifTrue: [ super nextPut: anObject ]
		ifFalse: 
			[ self nextPutMorph: (anObject isMauiMorph 
					ifTrue: [ anObject ]
					ifFalse: 
						[ (MauiMorph newFor: anObject)
							labelString: aString ;
							word ;
							initializeColor ;
							producedView: producedView ;
							yourself ]) ]! !

!TextStream methodsFor: '*maui-core' stamp: 'cmm 2/16/2009 16:12'!
nextPutMorph: aMorph 
	"Embed aMorph as the next character in my text.  Make it transparent otherwise the Character 1 appears as a box beginning in Squeak 3.9."
	self nextPutAll: 
		(Text 
			string: (String value: 1)
			attributes: { 
					(TextAnchor new anchoredMorph: aMorph).
					(TextColor color: Color transparent)
				 })! !

!TextAnchor methodsFor: '*maui-core' stamp: 'cmm 10/25/2007 13:28'!
veryDeepInner: aDeepCopier
	super veryDeepInner: aDeepCopier.
	anchoredMorph := anchoredMorph veryDeepCopyWith: aDeepCopier! !

!StringMorph methodsFor: '*maui-core' stamp: 'cmm 11/29/2007 23:13'!
hasContents
	"Answer whether my contents have ever been set.  See my #fullBounds method to see where the literal comes from."
	^ contents ~= nil and: [ contents ~= 'String Morph' ]! !

!StringMorph methodsFor: '*maui-core' stamp: 'cmm 12/20/2010 09:52'!
maContextKeywordsDo: aBlock
	self contents maContextKeywordsDo: aBlock! !

!StringMorph methodsFor: '*maui-core' stamp: 'cmm 1/10/2010 19:45'!
maIsStringMorph
	^ true! !

!Date methodsFor: '*maui-core' stamp: 'cmm 11/14/2007 16:49'!
maEnd: aDateAndTime 
	"All Dates are a duration of 1 day, their duration cannot be adjusted."
"comment above serves as early-warning balloon help."
	MauiUserError signal: 'All Dates are a duration of 1 day, their duration cannot be adjusted.'! !

!Date methodsFor: '*maui-core' stamp: 'cmm 11/14/2007 16:47'!
maHasVariableDuration
	^ false! !

TestCase subclass: #MauiTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-SUnit tests'!

!MauiTestCase methodsFor: 'private' stamp: 'cmm 8/15/2003 17:20'!
runTestBinaryMessages

	self
		sendBinaryMessages: #(&)
		with: true
		to: false.
	self
		sendBinaryMessages: #(+)
		with: (1 to: 100) asArray
		to: (101 to: 200).
	self
		sendBinaryMessages: #( * + - / )
		with: 2.111
		to: 3.1415926535! !

!MauiTestCase methodsFor: 'private' stamp: 'cmm 8/15/2003 17:21'!
runTestKeywordMessages

	self
		sendKeywordMessages: #(and: eqv: or: xor:) 
		with: true
		to: false.
	self
		sendKeywordMessages: #(detect: count:)
		with: [ : each | each even ]
		to: (1 to: 100) asArray! !

!MauiTestCase methodsFor: 'private' stamp: 'cmm 8/15/2003 17:02'!
runTestUnaryMessages

	self
		sendUnaryMessages: #(not)
		to: false.
	self
		sendUnaryMessages: #(size anyOne)
		to: (101 to: 200).
	self
		sendUnaryMessages: #(abs negated reciprocal)
		to: 3.1415926535.
	self
		sendUnaryMessages: #(asFloat asOop even odd)
		to: 3.
	self
		sendUnaryMessages: #(name scanProcess atEnd)
		to: (MaCollectionContext collection: (1 to: 100) asArray).
	self
		sendUnaryMessages: #(asUppercase asLowercase size)
		to: 'hello'.
	self
		sendUnaryMessages: #(isNil)
		to: nil! !

!MauiTestCase methodsFor: 'private' stamp: 'cmm 8/23/2003 18:23'!
sendBinaryMessages: selectors with: arg to: anObject

	| mauiMorph binaries |
	binaries := OrderedCollection new.
	mauiMorph := anObject asMauiMorph openInWorld.
	selectors
		do:
			[ : eachSelector |  | binaryMessage |
			binaryMessage :=
				(MauiMessageMorph
					receiver: anObject
					selector: eachSelector)
						invocationStrategy: MauiClickedInvocationStrategy new;
						yourself.
			binaryMessage resultHolderMorph: binaryMessage.
			binaries add: (mauiMorph addMessage: binaryMessage) ].
	mauiMorph world doOneCycleNow.
	binaries
		do:
			[ : eachMessage |
			(eachMessage parameterHolderMorphAt: 1) acceptDroppingMorph: arg asMauiMorph event: nil.
			self shouldnt: [ eachMessage hasResult ].
			eachMessage mouseDown: nil.
			self should: [ eachMessage result object = (eachMessage object sentTo: anObject) ] ].
	mauiMorph delete! !

!MauiTestCase methodsFor: 'private' stamp: 'cmm 1/8/2008 12:19'!
sendKeywordMessages: selectors with: arg to: receiver

	| mauiMorph keywords |
	keywords := OrderedCollection new.
	mauiMorph := receiver asMauiMorph openInWorld.
	selectors
		do:
			[ : eachSelector |  | keywordMessage |
			keywordMessage :=
				(MauiMessageMorph
					receiver: receiver
					selector: eachSelector)
						invocationStrategy: MauiAutoInvocationStrategy new;
						yourself.
			keywordMessage resultHolderMorph: keywordMessage.
			keywords add: (mauiMorph addMessage: keywordMessage) ].
	mauiMorph world doOneCycleNow.
	keywords
		do:
			[ : eachMessage |
			(eachMessage parameterHolderMorphAt: 1) acceptDroppingMorph: arg asMauiMorph event: nil.
			self should: [ eachMessage result object = (eachMessage object sentTo: receiver) ] ].
	mauiMorph delete! !

!MauiTestCase methodsFor: 'private' stamp: 'cmm 11/12/2003 23:24'!
sendUnaryMessages: selectors to: anObject

	| mauiMorph actions getters |
	"Test these unary's as both actions and getters."
	actions := OrderedCollection new.
	getters := OrderedCollection new.
	mauiMorph := anObject asMauiMorph openInWorld.
	selectors
		do:
			[ : eachSelector | 
			actions add: (mauiMorph addMessage: (mauiMorph newActionMessage: eachSelector receiver: anObject)).
			getters add: (mauiMorph addMessage: (mauiMorph newGetter: eachSelector)) ].
	mauiMorph world doOneCycleNow.
	getters do: [ : each | self should: [ each result object = (each object sentTo: anObject) ] ].
	actions 
		do: 
			[ : each | 
			each mouseDown: nil.
			self should: [ each resultHolderMorph isNil ].
			self shouldnt: [ each hasResult ] ].
	mauiMorph delete! !

!MauiTestCase methodsFor: 'tests' stamp: 'cmm 8/15/2003 16:53'!
testMauiMessages

	self
		runTestUnaryMessages;
		runTestBinaryMessages;
		runTestKeywordMessages! !

MaSoftwareError subclass: #MauiSoftwareError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Exceptions'!

!MaClientProcess methodsFor: '*maui-core' stamp: 'cmm 4/9/2013 17:24'!
mauiCodedViews
	^ super mauiCodedViews, #(console)! !

PluggableTextMorph subclass: #MauiTextEditor
	instanceVariableNames: 'autoExtent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Widgets'!

!MauiTextEditor methodsFor: 'event handling' stamp: 'cmm 8/29/2012 13:55'!
acceptTextInModel
	^ model isInMagma
		ifTrue:
			[ [ super acceptTextInModel ]
				on: MagmaSessionRequest
				do:
					[ : req | req handleAndResumeUsing: model magmaSession ] ]
		ifFalse: [ super acceptTextInModel ]! !

!MauiTextEditor methodsFor: 'Morphic' stamp: 'cmm 11/19/2010 13:04'!
addHandlesTo: aHaloMorph box: box 
	"Add halo handles to the halo.  Apply the halo filter if appropriate"
	| haloBox |
	haloBox := self bounds insetBy: 7 @ 7.
	aHaloMorph haloBox: haloBox.
	Preferences haloSpecifications do: 
		[ : aSpec | | wantsIt aSelector |
		aSelector := aSpec addHandleSelector.
		wantsIt := self 
			wantsHaloHandleWithSelector: aSelector
			inHalo: aHaloMorph.
		wantsIt ifTrue: 
			[ aHaloMorph 
				perform: aSelector
				with: aSpec.
			(#(#addGrowHandle: #addScaleHandle: ) includes: aSelector) ifTrue: 
				[ aHaloMorph
					on: #mouseLeave
						send: #maybeMouseLeftBounds: 
						to: self ] ] ].
	aHaloMorph innerTarget 
		addOptionalHandlesTo: aHaloMorph
		box: haloBox! !

!MauiTextEditor methodsFor: 'auto extent-private' stamp: 'cmm 10/24/2007 12:06'!
adjustExtent
	self adjustWidthSelector in: 
		[ : widthSelector | 
		widthSelector 
			ifNil: 
				[ self adjustHeightSelector in: 
					[ : heightSelector | 
					heightSelector 
						ifNil: [ self stopStepping ]
						ifNotNil: 
							[ "Can't easily know when height adjustment will make a difference, easiest just to check if it did."
							| priorHeight |
							priorHeight := self height.
							self perform: heightSelector.
							self height = priorHeight ifTrue: [ self stopStepping ] ] ] ]
			ifNotNil: [ self perform: widthSelector ] ]! !

!MauiTextEditor methodsFor: 'auto extent-private' stamp: 'cmm 10/18/2007 16:02'!
adjustHeightSelector
	"Answer #increaseHeight if the width should be increased, #decreaseHeight if it should be decreased, or nil if it should be left alone."
	(self height < textMorph height and: [ self height < self maxExtent y and: [ self bottom < World bottom ] ]) ifTrue: [ ^ #increaseHeight ].
	(self height > textMorph height) ifTrue: [ ^ #decreaseHeight ].
	^ nil! !

!MauiTextEditor methodsFor: 'auto extent-private' stamp: 'cmm 11/6/2007 17:05'!
adjustWidthSelector
	"Answer #increaseWidth if the width should be increased, #decreaseWidth if it should be decreased, or nil if it should be left alone."
	| shortContentsWidthPlusMargin |
	shortContentsWidthPlusMargin := textMorph shortContentsExtent in: 
		[ : shortContentsExtent | 
		shortContentsExtent key 
			ifTrue: [ shortContentsExtent value x + 30 ]
			ifFalse: [ nil ] ].
	"If less than one-line worth of text, increase if my currentWidth is less than the width of the contents plus a small margin."
	(shortContentsWidthPlusMargin notNil and: [ shortContentsWidthPlusMargin < textMorph maxOneLineWidth ]) ifTrue: 
		[ ^ self innerWidth < shortContentsWidthPlusMargin 
			ifTrue: [ self right < self world right ifTrue: [ #increaseWidth ] ]
			ifFalse: 
				[ self innerWidth > (shortContentsWidthPlusMargin max: 34) ifTrue: 
					[ "the minimum innerWidth, see #extent:"
					#decreaseWidth ] ] ].
	"Ok, we have more than one-line of contents.."
	self innerWidth < textMorph maxOneLineWidth ifTrue: [ ^ self right < self world right ifTrue: [ #increaseWidth ] ].
	self innerWidth > self maxExtent x ifTrue: [ ^ #decreaseWidth ].
	"My innerWidth is within a valid range.  If it is, adjust my width to between a 3/4 - 7/8 width:height ratio."
	(self width / self height < (3 / 4) and: [ self innerWidth < self maxExtent x ]) ifTrue: [ ^ self right < self world right ifTrue: [ #increaseWidth ] ].
	(self width / self height >= 1 and: [ self innerWidth > textMorph maxOneLineWidth ]) ifTrue: [ ^ #decreaseWidth ].
	^ nil! !

!MauiTextEditor methodsFor: 'auto extent' stamp: 'cmm 12/26/2007 16:43'!
autoExtent
	^ autoExtent! !

!MauiTextEditor methodsFor: 'auto extent' stamp: 'cmm 10/29/2007 17:21'!
autoExtent: aBoolean 
	"Specify whether my window will try to conserve real-estate automatically.  It will remain small unless there is sufficient contents, upon where it will expand up to my maxExtent (about half the screen) before a vertical scroll-bar appears."
	autoExtent := aBoolean.
	aBoolean 
		ifTrue: 
			[ textMorph 
				on: #keyStroke
				send: #keyStroke:
				to: self.
			self isInWorld 
				ifTrue: [ self startStepping ]
				ifFalse: [ self extent: 36 @ 16 ] ]
		ifFalse: [ textMorph eventHandler: nil ]! !

!MauiTextEditor methodsFor: 'Morphic' stamp: 'cmm 2/21/2009 13:46'!
cursorEnd
	"Position cursor to the end of my existing text."
	self textMorph cursorEnd! !

!MauiTextEditor methodsFor: 'auto extent-private' stamp: 'cmm 10/17/2007 19:34'!
decreaseHeight
	self height: self height-1! !

!MauiTextEditor methodsFor: 'auto extent-private' stamp: 'cmm 10/17/2007 17:31'!
decreaseWidth
	self width: self width-1! !

!MauiTextEditor methodsFor: 'Morphic' stamp: 'cmm 11/28/2007 00:13'!
externalName
	^ String streamContents: 
		[ : stream | 
		stream
			nextPutAll: textMorph paragraph lines size asString ;
			nextPutAll: ' lines, ' ;
			nextPutAll: self text size asString ;
			nextPutAll: ' characters.' ]! !

!MauiTextEditor methodsFor: 'private' stamp: 'cmm 10/29/2007 17:29'!
findRemainingFocus
	^ self ownerChain 
		detect: [ : e | e notNil and: [ e isMauiMorph ] ]
		ifNone: [ nil ]! !

!MauiTextEditor methodsFor: 'private' stamp: 'cmm 10/30/2007 17:14'!
hasEditingConflicts: aBoolean
	super hasEditingConflicts: aBoolean.
	self changed! !

!MauiTextEditor methodsFor: 'auto extent-private' stamp: 'cmm 10/17/2007 19:34'!
increaseHeight
	self height: self height+1! !

!MauiTextEditor methodsFor: 'auto extent-private' stamp: 'cmm 11/6/2007 17:17'!
increaseWidth
	| shortContentsExtent newWidth |
	"When increasing width, don't let the user overrun the (slowly-expanding) width up to the first line, which causes a scroll-bar to appear prematurely."
	shortContentsExtent := textMorph shortContentsExtent.
	newWidth := shortContentsExtent key 
		ifTrue: [ shortContentsExtent value x + 30 min: textMorph maxOneLineWidth - 1 ]
		ifFalse: [ self width + 1 ].
	self width: newWidth! !

!MauiTextEditor methodsFor: 'initialize' stamp: 'cmm 10/29/2007 17:53'!
initialize
	super initialize.
	"304 is the width of the toolbar, ."
	self extent: (304 max: World width//4) @ (World height // 4).
	autoExtent := false! !

!MauiTextEditor methodsFor: 'private' stamp: 'cmm 10/17/2007 16:38'!
innerWidth
	^ self innerBounds width! !

!MauiTextEditor methodsFor: 'Morphic' stamp: 'cmm 12/24/2007 20:08'!
intoWorld: aWorld 
	aWorld ifNil: [ ^ self ].
	textMorph ifNotNil: [ textMorph composeToBounds ]! !

!MauiTextEditor methodsFor: 'event handling' stamp: 'cmm 10/24/2007 16:12'!
keyStroke: aKeyboardEvent
	"This is called only by having set myself up as a listener of my textMorph, which receives the KeyboardEvents first, then passes them to me.  That's why we don't call super here.
	For MauiParameterHolderMorphs, *they* are set up as the listener, so it calls this directly."
	self startStepping! !

!MauiTextEditor methodsFor: 'event handling' stamp: 'cmm 11/28/2007 22:49'!
mauiIt
	"Called from the context menu item, 'maui it'."
	| result |
	self handleEdit: 
		[ result := textMorph editor evaluateSelection.
		((result isKindOf: FakeClassPool) or: [ result == #failedDoit ]) 
			ifTrue: [ self flash ]
			ifFalse: [ result maui ] ]! !

!MauiTextEditor methodsFor: 'auto extent-private' stamp: 'cmm 10/16/2007 16:04'!
maxExtent
	"The biggest I will get before requiring scrolling."
	^ (World height//2) @ (World height//1.5)! !

!MauiTextEditor methodsFor: 'event handling' stamp: 'cmm 4/8/2008 23:14'!
maybeMouseLeftBounds: aMouseEvent 
	self world ifNotNilDo: 
		[ : world | 
		((world rootMorphsAtGlobal: aMouseEvent position) includesAnyOf: {  self. (self halo)  }) ifFalse: [ self removeHalo ] ]! !

!MauiTextEditor methodsFor: 'Morphic' stamp: 'cmm 12/19/2009 11:22'!
mouseEnter: aMouseEvent 
	super mouseEnter: aMouseEvent.
	aMouseEvent hand newKeyboardFocus: textMorph.
	self isInWorld ifTrue: [ self addHalo ].
	"Place cursor at end, not beginning upon initial mouse-enter."
	self textMorph editor selectionInterval = (1 to: 0) ifTrue: [ self textMorph cursorEnd ]! !

!MauiTextEditor methodsFor: 'event handling' stamp: 'cmm 11/27/2007 15:56'!
mouseLeave: aMouseEvent 
	super mouseLeave: aMouseEvent.
	aMouseEvent hand newKeyboardFocus: (self firstOwnerSuchThat: [ : each | each isMauiMorph ]).
	self maybeMouseLeftBounds: aMouseEvent! !

!MauiTextEditor methodsFor: 'private' stamp: 'cmm 10/18/2007 12:55'!
scrollSelectionIntoView: event 
	"Only allow myself to scroll only if I have a scroll bar."
	^ self vIsScrollbarShowing 
		ifTrue: [ super scrollSelectionIntoView: event ]
		ifFalse: [ false ]! !

!MauiTextEditor methodsFor: 'event handling' stamp: 'cmm 10/29/2007 13:35'!
step
	autoExtent 
		ifTrue: [ self adjustExtent ]
		ifFalse: [ self stopStepping ]! !

!MauiTextEditor methodsFor: 'event handling' stamp: 'cmm 10/17/2007 17:35'!
stepTime
	^ 0! !

!MauiTextEditor methodsFor: 'private' stamp: 'cmm 10/16/2007 22:36'!
textMorphClass
	"Answer the class used to create the receiver's textMorph"
	^ MauiTextMorph! !

!MauiTextEditor methodsFor: 'private' stamp: 'cmm 10/18/2007 12:56'!
vExtraScrollRange
	^ 0! !

!MauiTextEditor methodsFor: 'Morphic' stamp: 'cmm 2/14/2009 18:46'!
wantsHaloHandleWithSelector: aSelector inHalo: aHaloMorph 
	"Answer whether the receiver would like to offer the halo handle with the given selector (e.g. #addCollapseHandle:)"
	^  #(#addGrowHandle: #addScaleHandle: ) includes: aSelector! !

!PluggableTextMorph methodsFor: '*maui-core' stamp: 'cmm 10/30/2007 13:42'!
veryDeepInner: aDeepCopier 
	super veryDeepInner: aDeepCopier.
	textMorph := textMorph veryDeepCopyWith: aDeepCopier.
	selectionInterval := selectionInterval veryDeepCopyWith: aDeepCopier! !

!Week methodsFor: '*maui-core' stamp: 'cmm 7/28/2007 16:01'!
mauiDefaultView
	^ #panel! !

!Symbol methodsFor: '*maui-core' stamp: 'cmm 2/8/2004 23:41'!
mauiName

	^self asString! !

!FillInTheBlankMorph methodsFor: '*maui-core' stamp: 'cmm 11/29/2007 21:30'!
canDropIntoMauiMorph
	^ false! !

!TransferMorph methodsFor: '*maui-core' stamp: 'cmm 12/8/2010 14:47'!
asMauiMessageUsing: aMauiMorph 
	"Convert myself to a MauiMessageMorph as well as possible.  I calculate the correct class based on the message being dragged."
	| receiver selector |
	transferType = #messageList
		ifTrue: [ selector := self passenger value ]
		ifFalse:
			[ (transferType = #dragTransferPlus and: [ passenger isCompiledMethod ])
				ifTrue: [ selector := passenger selector ]
				ifFalse: [ selector := #yourself ] ].
	selector isSymbol ifFalse: [ selector := #yourself ].
	receiver := (aMauiMorph object realObject respondsTo: selector)
		ifTrue: [ "domain message drag"
			aMauiMorph object realObject ]
		ifFalse: [ "let the ui handle it."
			aMauiMorph ].
	^(receiver class lookupSelector: selector) ifNotNil:
		[ (MauiMessage
			receiver: receiver
			selector: selector) asMauiMorphFor: aMauiMorph ]! !

!TransferMorph methodsFor: '*maui-core' stamp: 'cmm 2/19/2004 22:35'!
canBeMauiMessageFor: aMauiMorph
	"Convert myself to a MauiMessageMorph as well as possible.  I calculate the correct class based on the message being dragged."
	^ (self mauiReceiverSelectorFor: aMauiMorph) notNil! !

!TransferMorph methodsFor: '*maui-core' stamp: 'cmm 2/12/2004 00:26'!
isTransferMorph

	^ true! !

!TransferMorph methodsFor: '*maui-core' stamp: 'cmm 8/13/2004 00:06'!
mauiDropInto: aMauiMorph event: event at: spacerPosition

	| message |
	message := self asMauiMessageUsing: aMauiMorph.
	aMauiMorph
		addMessage: message 
		at: spacerPosition.
	message position: event hand position - (0@message height)! !

!TransferMorph methodsFor: '*maui-core' stamp: 'cmm 12/8/2010 14:46'!
mauiReceiverSelectorFor: aMauiMorph 
	| receiver class selector |
	self dragTransferType = #dragTransferPlus
		ifTrue:
			[ (#(#methodClass #selector ) allSatisfy:
				[ : each |  self passenger respondsTo: each ]) ifFalse: [ ^nil ].
			class := self passenger methodClass.
			selector := self passenger selector ]
		ifFalse:
			[ (self passenger isVariableBinding) ifFalse: [ ^nil ].
			class := self passenger key.
			selector := self passenger value ].
	selector isSymbol ifFalse: [ ^nil ].
	receiver := (aMauiMorph isKindOf: class)
		ifTrue: [ "a ui message is being dragged"
			aMauiMorph ]
		ifFalse:
			[ "domain message drag"
			(aMauiMorph object realObject isKindOf: class) ifTrue: [ aMauiMorph object realObject ] ].
	^receiver ifNotNil:
		[ (receiver class lookupSelector: selector) ifNotNil: [ receiver -> selector ] ]! !

!DirectoryEntry methodsFor: '*maui-core' stamp: 'cmm 2/12/2009 18:50'!
findInFileList
	^ (SimpleServiceEntry 
		provider: self
		label: 'open in a new FileList'
		selector: #openInFileList:
		description: 'Opens a standard file-list browser on this directory'
		buttonLabel: 'open file-list here')
		argumentGetter: #yourself ;
		yourself! !

!DirectoryEntry methodsFor: '*maui-core' stamp: 'cmm 2/9/2008 22:34'!
mauiDefaultColumns
	^#( name modificationDateAndTime maFileSizeString )! !

!DirectoryEntry methodsFor: '*maui-core' stamp: 'cmm 9/27/2007 16:03'!
mauiName
	^ directory fullNameFor: self name! !

!DirectoryEntry methodsFor: '*maui-core' stamp: 'cmm 2/12/2009 16:39'!
mauiServices
	^ super mauiServices , {  (self findInFileList)  }! !

!DirectoryEntry methodsFor: '*maui-core' stamp: 'cmm 6/20/2012 15:48'!
mauiSortableColumns
	^#(name modificationDateAndTime fileSize)! !

!DirectoryEntry methodsFor: '*maui-core' stamp: 'cmm 2/12/2009 18:56'!
openInFileList: aFileDirectoryEntry 
	(FileList2 morphicViewOnDirectory: (FileDirectory on: aFileDirectoryEntry directoryName)) openInWorld! !

!GradientFillStyle methodsFor: '*maui-core' stamp: 'cmm 11/30/2008 20:46'!
customizeForMauiMorph: aMauiMorph 
	self
		radial: true ;
		origin: aMauiMorph topLeft ;
		direction: aMauiMorph extent // 2 ;
		normal: nil! !

!MethodReference methodsFor: '*maui-core' stamp: 'cmm 12/4/2008 22:15'!
asMauiMessage
	^ MauiMessage reference: self! !

!MethodReference methodsFor: '*maui-core' stamp: 'cmm 4/17/2014 15:39'!
asValid
	^ self isValid
		ifTrue: [ self ]
		ifFalse:
			[ (self environment classNamed: classSymbol) withAllSuperclasses
				detect:
					[ : each | (self class
						class: each
						selector: self selector
						environment: self environment) isValid ]
				ifFound:
					[ : foundClass | self class
						class: foundClass
						selector: self selector
						environment: self environment ]
				ifNone: [ self ] ]! !

!FileDirectory methodsFor: '*maui-core' stamp: 'cmm 9/12/2008 14:12'!
maAllContainingDirectoriesDo: oneArgBlock 
	(#('/' '' ) includes: self pathName) ifTrue: [ ^ self ].
	self containingDirectory in: 
		[ : containing | 
		oneArgBlock value: containing.
		containing maAllContainingDirectoriesDo: oneArgBlock ]! !

!FileDirectory methodsFor: '*maui-core' stamp: 'cmm 9/20/2007 17:29'!
maEntriesBy: sortSelector 
	"Answer my #entries as a SortedCollection, sorted by sortSelector.  Sort ascending or descending depending on which sortSelector is specified."
	^ self 
		maSort: self entries
		by: sortSelector! !

!FileDirectory methodsFor: '*maui-core' stamp: 'cmm 9/20/2007 17:30'!
maFindEntries: oneArgBlock sortBy: sortSelector 
	"Traverse my directory and answer a SortedCollection of DirectoryEntry's, by sortSelector, whose path of DirectoryEntry's causes oneArgBlock to value true."
	^ self 
		maSort: (self maFindEntries: oneArgBlock)
		by: sortSelector! !

!FileDirectory methodsFor: '*maui-core' stamp: 'cmm 9/20/2007 17:32'!
maFindEntriesMatching: substring sortBy: sortSelector 
	"Traverse my directory and answer an OrderedCollection of DirectoryEntry's whose names contain substring."
	"This method focuses on user-convenience; eschewing complex wild-card matching in favor of 'type-and-go'.  But without punishing engineers who still want to use wild-card matching."
	^ self 
		maSort: (self maFindEntriesMatching: substring)
		by: sortSelector! !

!FileDirectory methodsFor: '*maui-core-private' stamp: 'cmm 4/20/2010 22:56'!
maSort: entriesCollection by: sortSelector 
	"Answer my #entries as a SortedCollection, sorted by sortSelector.  Sort ascending or descending depending on which sortSelector is specified."
	| comparisonOperator |
	comparisonOperator := (#(#name ) includes: sortSelector) 
		ifTrue: [ #< ]
		ifFalse: [ #> ].
	^ entriesCollection sort: 
		[ : a : b | 
		(a isDirectory xor: b isDirectory) 
			ifTrue: [ a isDirectory ]
			ifFalse: 
				[ (a perform: sortSelector) 
					perform: comparisonOperator
					with: (b perform: sortSelector) ] ]! !

!FileDirectory methodsFor: '*maui-core' stamp: 'cmm 9/19/2007 16:46'!
maWithContainingDirectories
	| answer |
	answer := OrderedCollection with: self copy.
	self maAllContainingDirectoriesDo: [ : each | answer add: each ].
	^ answer reverse! !

!FileDirectory methodsFor: '*maui-core' stamp: 'cmm 9/26/2007 10:00'!
mauiCodedViews
	^ super mauiCodedViews , #(
			#localName
			#find
			#entries
		)! !

!FileDirectory methodsFor: '*maui-core' stamp: 'cmm 9/14/2007 13:18'!
mauiLocalName
	^ self localName in: 
		[ : ln | 
		ln isEmpty 
			ifTrue: [ 'My Computer' ]
			ifFalse: [ ln ] ]! !

!FileDirectory methodsFor: '*maui-core' stamp: 'cmm 9/14/2007 13:13'!
mauiName
	^ self fullName isEmpty 
		ifTrue: [ 'my computer' ]
		ifFalse: [ self fullName ]! !

!Month methodsFor: '*maui-core' stamp: 'cmm 7/28/2007 16:01'!
mauiDefaultView
	^ #panel! !

!Month methodsFor: '*maui-core' stamp: 'cmm 7/27/2007 19:15'!
mauiName
	^ self printString! !

!CompiledMethod methodsFor: '*maui-core' stamp: 'cmm 5/27/2012 17:48'!
mauiMorphForDesktopFrom: aTransferMorph 
	| mauiMorph |
	self methodClass isMeta
		ifTrue:
			[ mauiMorph := self methodClass theNonMetaClass asMauiMorph.
			mauiMorph
				 addMessage: (aTransferMorph asMauiMessageUsing: mauiMorph) ;
				 yourself ]
		ifFalse: [ mauiMorph := (MauiPage text: 'Hello.
Instance methods can only be dragged onto instances of objects, not the desktop.') asMauiMorph ].
	^ mauiMorph! !

!CompiledMethod methodsFor: '*maui-core' stamp: 'cmm 12/2/2008 23:24'!
mauiName

	^String streamContents:
		[ : stream |
		stream 
			nextPutAll: self methodClass name;
			nextPutAll: '>>#';
			nextPutAll: self selector ]! !

!True methodsFor: '*maui-core' stamp: 'cmm 10/7/2007 22:31'!
addMauiFolderIconTo: aMauiMorph
	aMauiMorph addMorph: (aMauiMorph preferred: #iconSet) plainFolderIcon! !

!Text class methodsFor: '*maui-core' stamp: 'cmm 2/5/2012 13:57'!
fixNonUnboldableTexts
	self identifyNonUnboldableTexts do:
		[ : eachText | eachText fixNonUnboldableText ]! !

!Text class methodsFor: '*maui-core' stamp: 'cmm 2/5/2012 13:57'!
identifyNonUnboldableTexts
	^ Text allInstances select:
		[ : e | e runs anySatisfy:
			[ : eachRun | eachRun anySatisfy:
				[ : eAttr | (eAttr respondsTo: #font) and: [ eAttr font derivativeFonts isEmpty ] ] ] ]! !

!Text methodsFor: '*maui-core' stamp: 'cmm 2/11/2012 15:13'!
fixNonUnboldableText
	self
		removeAttributesThat:
			[ : each | false ]
		replaceAttributesThat:
			[ : each | (each respondsTo: #font) and: [ each font derivativeFonts isEmpty ] ]
		by:
			[ : unboldableFontRef | TTCFont registry
				at: unboldableFontRef font familyName asSymbol
				ifPresent:
					[ : foundFonts | | sorted |
					sorted := foundFonts copy sort:
						[ : a : b | (a pointSize - unboldableFontRef font pointSize) abs < (b pointSize - unboldableFontRef font pointSize) abs ].
					TextFontReference toFont: sorted first ]
				ifAbsent: [ unboldableFontRef ] ]! !

!Text methodsFor: '*maui-core' stamp: 'cmm 7/8/2004 20:45'!
mauiName

	^ self asString! !

!Text methodsFor: '*maui-core' stamp: 'cmm 10/25/2007 13:26'!
veryDeepInner: aDeepCopier
	super veryDeepInner: aDeepCopier.
	string := string veryDeepCopyWith: aDeepCopier.
	runs := runs veryDeepCopyWith: aDeepCopier! !

!MessageSend methodsFor: '*maui-core-copying' stamp: 'cmm 7/14/2004 13:32'!
maIndependentCopy
	"To make an independentCopy of me, I should have argument independent of the instance I was copied from."

	^ self copy
		arguments: arguments copy ;
		yourself! !

!SketchMorph methodsFor: '*maui-core' stamp: 'cmm 6/28/2012 12:00'!
mauiCodedViews
	^ super mauiCodedViews , #(#image )! !

!SketchMorph methodsFor: '*maui-core' stamp: 'cmm 6/28/2012 12:06'!
mauiDefaultView
	^ #image! !

!UUID methodsFor: '*maui-core' stamp: 'cmm 12/21/2008 23:47'!
mauiName
	^ self asString! !

MaBehaviorFinder subclass: #MauiBehaviorFinder
	instanceVariableNames: 'object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Tools'!

!MauiBehaviorFinder class methodsFor: 'create' stamp: 'cmm 12/4/2008 11:13'!
object: anObject 
	^ self new
		object: anObject ;
		yourself! !

!MauiBehaviorFinder methodsFor: 'accessing' stamp: 'cmm 12/4/2008 11:13'!
object
	^object! !

!MauiBehaviorFinder methodsFor: 'initializing' stamp: 'cmm 12/4/2008 11:13'!
object: anObject
	object := anObject! !

!MauiBehaviorFinder methodsFor: 'accessing' stamp: 'cmm 12/8/2008 21:08'!
sortedMethods
	"Answer my methods sorted by selector."
	^ super sortedMethods collect: 
		[ : each | 
		each asMauiMessage
			receiver: object ;
			yourself ]! !

!ByteArray methodsFor: '*maui-core' stamp: 'cmm 7/8/2004 20:41'!
mauiName

	^ super mauiName "gonna try this.."
"
	^'a ', self size printString, '-byte ByteArray.'"! !

!Behavior methodsFor: '*maui-core' stamp: 'cmm 2/20/2004 17:59'!
maLowestCommonSuperclassWith: aClass

	| startClass other |
	self allSuperclasses size > aClass allSuperclasses size
		ifTrue: [ startClass := aClass.  other := self. ]
		ifFalse: [ startClass := self.  other := aClass ].
	startClass withAllSuperclassesDo:
		[ : each |
		(other inheritsFrom: each)
			ifTrue:
				[ ^ each ] ].
	MaSoftwareError signal: 'Didn''t expect to not find a common supeclass.'! !

!Behavior methodsFor: '*maui-core' stamp: 'cmm 5/27/2012 17:43'!
mauiMorphForDesktopFrom: aTransferMorph 
	^ self theNonMetaClass asMauiMorph! !

!Behavior methodsFor: '*maui-core' stamp: 'cmm 3/18/2009 13:53'!
mauiServices
	"No services for classes, but we need this so context menu-generation doesn't blow up."
	^ #()! !

!ScrollPane methodsFor: '*maui-core' stamp: 'cmm 10/30/2007 13:43'!
veryDeepInner: aDeepCopier 
	super veryDeepInner: aDeepCopier.
	scrollBar := scrollBar veryDeepCopyWith: aDeepCopier.
	scroller := scroller veryDeepCopyWith: aDeepCopier.
	retractableScrollBar := retractableScrollBar veryDeepCopyWith: aDeepCopier.
	hScrollBar := hScrollBar veryDeepCopyWith: aDeepCopier! !

MaSingleton subclass: #MauiPrototype
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Kernel'!

!MauiPrototype commentStamp: 'cmm 5/25/2007 16:15' prior: 0!
The purpose of this class is to substitute for the object of a MauiMorph which is a prototype.  The Prototypes should not have real domain objects.!

!MauiPrototype methodsFor: 'as yet unclassified' stamp: 'cmm 7/26/2004 13:42'!
isMauiPrototype
	^ true! !

Clipboard subclass: #MauiClipboard
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Widgets'!

!MauiClipboard class methodsFor: 'as yet unclassified' stamp: 'cmm 4/20/2010 22:38'!
default: aClipboard
	"Duplicating this for potential Pharo compatibility.  They removed #default:, so I don't know how I am supposed to specify my clipboard.."
self maMarked: 'otherPackageSupport'.
	Default := aClipboard.! !

!MauiClipboard class methodsFor: 'as yet unclassified' stamp: 'cmm 10/31/2007 17:05'!
initialize
	super initialize.
	self default: self new! !

!MauiClipboard class methodsFor: 'as yet unclassified' stamp: 'cmm 10/31/2007 17:03'!
unload
	self default: superclass new! !

!MauiClipboard methodsFor: 'as yet unclassified' stamp: 'cmm 11/1/2007 16:38'!
clipboardText
	"To support text with embedded morphs, we must copy those morphs otherwise, when we paste, they will be removed from the place we copied them from.  We copy going both in and out of the clipboard because they could potentially do multiple consecutive pastes."
	^ super clipboardText veryDeepCopy! !

!MauiClipboard methodsFor: 'as yet unclassified' stamp: 'cmm 10/31/2007 17:00'!
clipboardText: aText 
	"To support text with embedded morphs, we must copy those morphs otherwise, when we paste, they will be removed from the place we copied them from."
	^ super clipboardText: aText veryDeepCopy! !

MaUserError subclass: #MauiUserError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Exceptions'!

!MauiUserError methodsFor: 'accessing' stamp: 'cmm 6/5/2012 22:03'!
mauiName
	^ 'Error'! !

MaObject subclass: #MauiColorScheme
	instanceVariableNames: 'colors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Domain'!

!MauiColorScheme class methodsFor: 'hardcoded themes' stamp: 'cmm 6/11/2009 14:50'!
conservative
	^ self new
		color1: Color lightGray twiceLighter
			color2: Color lightGray lighter ;
		labelBarFill: (SolidFillStyle color: Color blue muchLighter twiceDarker) ;
		borderColor: #complexRaised ;
		highlightColor: Color green ;
		wordFill: (SolidFillStyle color: (Color blue muchLighter twiceDarker alpha: 0.5)) ;
		messageFill: (SolidFillStyle color: Color lightGray twiceLighter) ;
		contentFill: (SolidFillStyle color: (Color yellow muchLighter alpha: 0.9)) ;
		dialogFill: (SolidFillStyle color: Color gray) ;
		dialogLabelBarFill: (SolidFillStyle color: Color lightRed) ;
		standardTextColor: Color black ;
		highlightedTextColor: Color black lighter ;
		parameterHolderFill: (SolidFillStyle color: Color white) ;
		editorBackgroundColor: (Color green twiceLighter alpha: 0.4) ;
		editorForegroundColor: Color black ;
		yourself! !

!MauiColorScheme class methodsFor: 'hardcoded themes' stamp: 'cmm 11/23/2010 17:05'!
light
	^ self new
		color1: Color white slightlyDarker slightlyDarker
			color2: (Color white darker slightlyDarker alpha: 0.9) ;
		labelBarFill: (SolidFillStyle color: (Color blue muchLighter twiceDarker alpha: 0.5)) ;
		borderColor: (Color white slightlyDarker alpha: 0.9) ;
		highlightColor: ((Color yellow twiceLighter twiceLighter twiceLighter twiceLighter) "alpha: 0.8") ;
		wordFill: (SolidFillStyle color: (Color blue muchLighter twiceDarker alpha: 0.5)) ;
		messageFill: (Color transparent) ;
		contentFill: (SolidFillStyle color: (Color r: 0.975 g: 0.948 b: 0.74 alpha: 0.6)) ;
		dialogFill: (SolidFillStyle color: ((Color lightBlue adjustSaturation: -0.1 brightness: -0.2) alpha: 0.88)) ;
		dialogLabelBarFill: (SolidFillStyle color: (Color yellow adjustSaturation: -0.75 brightness: 0.0)) ;
		standardTextColor: Color black ;
		highlightedTextColor: Color green muchDarker ;
		parameterHolderFill: (SolidFillStyle color: Color white) ;
		editorBackgroundColor: (Color green twiceLighter alpha: 0.4) ;
		editorForegroundColor: Color black ;
		yourself! !

!MauiColorScheme class methodsFor: 'hardcoded themes' stamp: 'cmm 6/11/2009 14:50'!
orangeSlate
	^ self new
		color1: (Color 
					h: 50.0
					s: 0.62
					v: 1.0)
			color2: (Color 
					h: 25.0
					s: 0.73
					v: 0.8) ;
		labelBarFill: (SolidFillStyle color: (Color 
					r: 0.028
					g: 0.384
					b: 0.472)) ;
		borderColor: #complexRaised ;
		highlightColor: Color blue ;
		messageFill: (SolidFillStyle color: Color darkGray) ;
		contentFill: (SolidFillStyle color: Color darkGray) ;
		dialogFill: (SolidFillStyle color: (Color 
					r: 0.028
					g: 0.384
					b: 0.472)) ;
		dialogLabelBarFill: (SolidFillStyle color: Color darkGray) ;
		wordFill: (SolidFillStyle color: (Color blue muchLighter twiceDarker alpha: 0.5)) ;
		standardTextColor: Color white darker ;
		highlightedTextColor: Color white ;
		parameterHolderFill: (SolidFillStyle color: Color black) ;
		editorBackgroundColor: (Color 
				r: 0.1
				g: 0
				b: 0.8
				alpha: 0.7) ;
		editorForegroundColor: Color white ;
		yourself	"tan"	"orange"	"grayish blue"! !

!MauiColorScheme class methodsFor: 'utils' stamp: 'cmm 6/13/2009 19:57'!
quickCenterGradientColor1: color1 color2: color2 
	"Convenience method to obtain a usable two-color gradient, originating in the upper-left to reinforce that directional light-source / energy flow."
	| fill |
	fill := GradientFillStyle ramp: {  (0.5 -> color1). (1.0 -> color2)  }.
	fill radial: true.
"	fill origin: self center."
"	fill direction: nil."
	fill normal: nil.
	^ fill! !

!MauiColorScheme class methodsFor: 'utils' stamp: 'cmm 6/13/2009 20:00'!
quickCenterGradientColor1: color1 color2: color2  origin: aPoint
	"Convenience method to obtain a usable two-color gradient, originating in the upper-left to reinforce that directional light-source / energy flow."
	| fill |
	fill := GradientFillStyle ramp: {  (0.5 -> color1). (1.0 -> color2)  }.
	fill radial: true.
	fill origin: aPoint.
	fill direction: 0@0.
	fill normal: nil.
	^ fill! !

!MauiColorScheme class methodsFor: 'utils' stamp: 'cmm 12/21/2008 20:40'!
quickGradientColor1: color1 color2: color2 
	"Convenience method to obtain a usable two-color gradient, originating in the upper-left to reinforce that directional light-source / energy flow."
	| fill |
	fill := GradientFillStyle ramp: {  (0.5 -> color1). (1.0 -> color2)  }.
	fill radial: true.
	fill origin: 0 @ 0.
	fill direction: 150 @ 150.
	fill normal: nil.
	^ fill! !

!MauiColorScheme methodsFor: 'private' stamp: 'cmm 2/20/2014 13:27'!
accessingMethods
	"Answer the getter messages for each thing in Maui that can have its own color."
	| category allMethods |
	category := (self maOriginalClass >> #messageFill) methodReference category.
	allMethods := self maOriginalClass methodReferencesInCategory: category.
	^ allMethods select: [ : each | each selector isUnary ]! !

!MauiColorScheme methodsFor: 'accessing' stamp: 'cmm 12/11/2008 15:12'!
borderColor
	"The border color for *Domain* morphs.  borderColor for messageMorphs, parameterHolderMorphs, and contentMorphs, is pulled from their respective prototypes."
	^ self colorFor: #borderColor! !

!MauiColorScheme methodsFor: 'accessing' stamp: 'cmm 12/11/2008 15:12'!
borderColor: aColor 
	"The border color for *Domain* morphs.  borderColor for messageMorphs, parameterHolderMorphs, and contentMorphs, is pulled from their respective prototypes."
	self 
		colorAt: #borderColor
		put: aColor! !

!MauiColorScheme methodsFor: 'accessing' stamp: 'cmm 12/21/2008 20:41'!
color1: color1 color2: color2 
	"Convenience method to set my fillStyle to a gradient originating in the upper-left."
	self panelFill:
		(self class 
			quickGradientColor1: color1
			color2: color2)! !

!MauiColorScheme methodsFor: 'private' stamp: 'cmm 12/10/2008 21:55'!
colorAt: aSymbol put: anObject 
	colors 
		at: aSymbol
		put: anObject copy  "Never ever use a FillStyle in more than one place!!  It will lead to VM crashes.".
	self changed! !

!MauiColorScheme methodsFor: 'private' stamp: 'cmm 8/5/2004 14:38'!
colorFor: selectorSymbol

	^ colors
		at: selectorSymbol
		ifAbsent: [ self randomColor ]! !

!MauiColorScheme methodsFor: 'accessing' stamp: 'cmm 11/30/2008 17:11'!
contentFill
	^ self colorFor: #contentFill! !

!MauiColorScheme methodsFor: 'accessing' stamp: 'cmm 12/10/2008 21:55'!
contentFill: aFillStyle 
	self 
		colorAt: #contentFill
		put: aFillStyle! !

!MauiColorScheme methodsFor: 'accessing' stamp: 'cmm 11/30/2008 15:19'!
dialogFill
	^ self colorFor: #dialogFill! !

!MauiColorScheme methodsFor: 'accessing' stamp: 'cmm 12/10/2008 21:56'!
dialogFill: aFillStyle 
	self 
		colorAt: #dialogFill
		put: aFillStyle ! !

!MauiColorScheme methodsFor: 'accessing' stamp: 'cmm 11/30/2008 17:14'!
dialogLabelBarFill
	^ self colorFor: #dialogLabelBarFill! !

!MauiColorScheme methodsFor: 'accessing' stamp: 'cmm 12/10/2008 21:56'!
dialogLabelBarFill: aFillStyle 
	self 
		colorAt: #dialogLabelBarFill
		put: aFillStyle ! !

!MauiColorScheme methodsFor: 'accessing' stamp: 'cmm 5/21/2007 12:40'!
editorBackgroundColor
	^ self colorFor: #editorBackgroundColor! !

!MauiColorScheme methodsFor: 'accessing' stamp: 'cmm 12/10/2008 21:54'!
editorBackgroundColor: aColor 
	self 
		colorAt: #editorBackgroundColor
		put: aColor! !

!MauiColorScheme methodsFor: 'accessing' stamp: 'cmm 5/21/2007 12:39'!
editorForegroundColor
	^ self colorFor: #editorForegroundColor! !

!MauiColorScheme methodsFor: 'accessing' stamp: 'cmm 12/10/2008 21:53'!
editorForegroundColor: aColor 
	self 
		colorAt: #editorForegroundColor
		put: aColor! !

!MauiColorScheme methodsFor: 'accessing' stamp: 'cmm 8/5/2004 14:39'!
highlightColor

	^ self colorFor: #highlightColor! !

!MauiColorScheme methodsFor: 'accessing' stamp: 'cmm 12/10/2008 21:54'!
highlightColor: aColor 
	self 
		colorAt: #highlightColor
		put: aColor! !

!MauiColorScheme methodsFor: 'accessing' stamp: 'cmm 5/10/2007 12:31'!
highlightedTextColor
	^ self colorFor: #highlightedTextColor! !

!MauiColorScheme methodsFor: 'accessing' stamp: 'cmm 12/10/2008 21:54'!
highlightedTextColor: aColor 
	self 
		colorAt: #highlightedTextColor
		put: aColor! !

!MauiColorScheme methodsFor: 'initialize' stamp: 'cmm 8/5/2004 14:58'!
initialize

	super initialize.
	colors := Dictionary new! !

!MauiColorScheme methodsFor: 'accessing' stamp: 'cmm 11/30/2008 17:09'!
labelBarFill
	^ self colorFor: #labelBarFill! !

!MauiColorScheme methodsFor: 'accessing' stamp: 'cmm 12/10/2008 21:56'!
labelBarFill: aFillStyle 
	self 
		colorAt: #labelBarFill
		put: aFillStyle! !

!MauiColorScheme methodsFor: 'accessing' stamp: 'cmm 11/30/2008 17:04'!
messageFill
	^ self colorFor: #messageFill! !

!MauiColorScheme methodsFor: 'accessing' stamp: 'cmm 12/10/2008 21:56'!
messageFill: aFillStyle 
	self 
		colorAt: #messageFill
		put: aFillStyle! !

!MauiColorScheme methodsFor: 'accessing' stamp: 'cmm 11/30/2008 19:55'!
panelFill
	^ self colorFor: #panelFill! !

!MauiColorScheme methodsFor: 'accessing' stamp: 'cmm 12/10/2008 21:56'!
panelFill: aFillStyle 
	self 
		colorAt: #panelFill
		put: aFillStyle ! !

!MauiColorScheme methodsFor: 'accessing' stamp: 'cmm 11/30/2008 17:06'!
parameterHolderFill
	^ self colorFor: #parameterHolderFill! !

!MauiColorScheme methodsFor: 'accessing' stamp: 'cmm 12/10/2008 21:57'!
parameterHolderFill: aFillStyle 
	self 
		colorAt: #parameterHolderFill
		put: aFillStyle ! !

!MauiColorScheme methodsFor: 'private' stamp: 'cmm 8/5/2004 14:38'!
randomColor

	| r |
	r := Random seed: Time millisecondClockValue.
	^ Color
		r: r next
		g: r next
		b: r next! !

!MauiColorScheme methodsFor: 'accessing' stamp: 'cmm 5/10/2007 12:31'!
standardTextColor
	^ self colorFor: #standardTextColor! !

!MauiColorScheme methodsFor: 'accessing' stamp: 'cmm 12/10/2008 21:53'!
standardTextColor: aColor 
	self 
		colorAt: #standardTextColor
		put: aColor! !

!MauiColorScheme methodsFor: 'copying' stamp: 'cmm 4/8/2008 12:49'!
veryDeepInner: aDeepCopier
	super veryDeepInner: aDeepCopier.
	colors := colors veryDeepCopyWith: aDeepCopier! !

!MauiColorScheme methodsFor: 'accessing' stamp: 'cmm 11/30/2008 16:01'!
wordFill
	^ self colorFor: #wordFill! !

!MauiColorScheme methodsFor: 'accessing' stamp: 'cmm 12/10/2008 21:57'!
wordFill: aFillStyle 
	self 
		colorAt: #wordFill
		put: aFillStyle ! !

MaObject subclass: #MauiDashboard
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Domain'!

!MauiDashboard commentStamp: 'cmm 7/18/2007 18:02' prior: 0!
A MauiDashboard is a starting point for Maui usage.  It provides access to the global preferences, registrations, and instance-access and creation.
!

!MauiDashboard methodsFor: 'as yet unclassified' stamp: 'cmm 7/19/2007 16:28'!
classes
	^ Smalltalk allClasses ! !

!MauiDashboard methodsFor: 'as yet unclassified' stamp: 'cmm 7/19/2007 16:28'!
packages
	^ 'needs implemented'! !

!MauiDashboard methodsFor: 'as yet unclassified' stamp: 'cmm 7/18/2007 18:04'!
preferences
	^ MauiPreferences global! !

!MauiDashboard methodsFor: 'as yet unclassified' stamp: 'cmm 7/19/2007 16:28'!
registry
	^ MauiRegistry global ! !

!MauiDashboard methodsFor: 'as yet unclassified' stamp: 'cmm 7/19/2007 16:29'!
world
	"A place to configure the MauiMorphs associated with this World."
	^ MauiWorld current ! !

MaObject subclass: #MauiEffect
	instanceVariableNames: 'target selector range duration finally startTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Widgets'!

!MauiEffect commentStamp: 'cmm 12/30/2004 11:10' prior: 0!
I am used by MauiMorphs to slide a particular visual-property, denoted by my 'selector' from one value to another over a period of time.  I calculate the proper value based on linear position of the duration that we are in.  MauiMorphs invoke me in their step method and I do the work.!

!MauiEffect class methodsFor: 'create' stamp: 'cmm 6/26/2007 16:41'!
target: aMauiMorph selector: selectorSymbol range: anInterval duration: millisecondsInteger finally: aBlock
	^ self new
		target: aMauiMorph ;
		selector: selectorSymbol ;
		range: anInterval ;
		duration: millisecondsInteger ;
		finally: aBlock ;
		yourself! !

!MauiEffect methodsFor: 'api' stamp: 'cmm 12/30/2004 14:47'!
begin

	duration = 0
		ifTrue: [ self jumpToEnd ]
		ifFalse: [ target beginMauiEffect: self ]! !

!MauiEffect methodsFor: 'initialize-release' stamp: 'cmm 12/30/2004 14:37'!
duration: millisecondsInteger
	duration := millisecondsInteger! !

!MauiEffect methodsFor: 'private' stamp: 'cmm 12/30/2004 14:36'!
ensureStarted
	startTime ifNil: [ startTime := Time millisecondClockValue ]! !

!MauiEffect methodsFor: 'initialize-release' stamp: 'cmm 12/30/2004 14:22'!
finally: aBlock
	finally := aBlock! !

!MauiEffect methodsFor: 'private' stamp: 'cmm 1/27/2008 12:15'!
jumpToEnd
	target 
		perform: selector
		with: range last.
	finally value! !

!MauiEffect methodsFor: 'initialize-release' stamp: 'cmm 12/30/2004 13:01'!
range: anInterval
	range := anInterval! !

!MauiEffect methodsFor: 'private' stamp: 'cmm 12/30/2004 14:36'!
runningTime

	^ Time millisecondClockValue - startTime! !

!MauiEffect methodsFor: 'accessing' stamp: 'cmm 12/30/2004 13:02'!
selector
	^ selector! !

!MauiEffect methodsFor: 'initialize-release' stamp: 'cmm 12/30/2004 13:01'!
selector: aSymbol
	selector := aSymbol! !

!MauiEffect methodsFor: 'private' stamp: 'cmm 12/8/2009 10:38'!
step
	| runningTime |
	self ensureStarted.
	runningTime := self runningTime.
	runningTime < duration 
		ifTrue: 
			[ | currentValue |
			currentValue := (range last - range first) * (runningTime / duration asFloat) + range first.
			target 
				perform: selector
				with: currentValue ]
		ifFalse: 
			[ "ensure we end up at the final value."
			self
				jumpToEnd ;
				terminate ]! !

!MauiEffect methodsFor: 'initialize-release' stamp: 'cmm 12/30/2004 13:00'!
target: aMauiMorph
	target := aMauiMorph! !

!MauiEffect methodsFor: 'api' stamp: 'cmm 12/30/2004 14:48'!
terminate
	"Sometimes, an effect is in the middle of its animation when something occurs that should make it go the other way (i.e., entering and then leaving a MauiMorph causes a delineate followed by undelineate, but the delineate animation may not yet be completed)."

	target endMauiEffect: self! !

MaObject subclass: #MauiFamily
	instanceVariableNames: 'name views preferences contextMenuMessages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Domain'!

!MauiFamily commentStamp: 'cmm 12/2/2003 20:54' prior: 0!
I know the visual-representation of a set of classes whose instances are displayed as MauiMorphs.  My main responsibilities are:

	- keep track of the views, class 

	!

!MauiFamily class methodsFor: 'file-in' stamp: 'cmm 4/21/2009 18:25'!
fileExtension
	^ 'MauiFamily'! !

!MauiFamily class methodsFor: 'file-in' stamp: 'cmm 6/8/2009 13:50'!
fileInFileNamed: filename 
	(FileDirectory maDirectoryEntryFor: filename) containingDirectory 
		maFileNamed: filename
		do: 
			[ : stream | 
			stream binary.
			self fileInFromStream: stream ]! !

!MauiFamily class methodsFor: 'file-in' stamp: 'cmm 8/27/2012 20:03'!
fileInFromStream: aReadStream 
	MauiWorld current family merge: (MaObjectSerializer objectFromStream: aReadStream)! !

!MauiFamily class methodsFor: 'file-in' stamp: 'cmm 4/24/2009 14:49'!
fileInMauiFamilyService 
	^  SimpleServiceEntry
		provider: self 
		label: 'file-in the MauiFamily'
		selector: #fileInFileNamed:
		description: 'Loads the file as the current MauiWorlds family of screens, replacing the current MauiFamily of panels for this world.'
		buttonLabel: 'install'! !

!MauiFamily class methodsFor: 'file-in' stamp: 'cmm 4/24/2009 12:15'!
fileReaderServicesForFile: fullName suffix: suffix 
	^ suffix = self fileExtension asLowercase
		ifTrue: 
			[ {  (self fileInMauiFamilyService)  } ]
		ifFalse: 
			[ {   } ]! !

!MauiFamily class methodsFor: 'class initialization' stamp: 'cmm 4/21/2009 18:14'!
initialize
	super initialize.
	self registerSelfAsFileReader! !

!MauiFamily class methodsFor: 'create' stamp: 'cmm 9/12/2004 20:58'!
newNamed: aString

	^self new
		name: aString;
		yourself! !

!MauiFamily methodsFor: 'private' stamp: 'cmm 10/28/2011 15:41'!
addGlobalChoicesFor: aMauiDomainMorph to: aMenu 
	"Add menu choices to aMenu for the user has specified for aClass."
	aMauiDomainMorph object maOriginalClass withAllSuperclassesDo: 
		[ : eachClass | 
		contextMenuMessages 
			at: eachClass name
			ifPresent: 
				[ : foundChoices | 
				foundChoices do: 
					[ : each | 
					| messageMorph |
					messageMorph := each copy
						receiverMorph: aMauiDomainMorph ;
						receiver: aMauiDomainMorph object ;
						notificationHandler: aMauiDomainMorph notificationHandler.
					aMenu 
						add: (MauiWorld current nameFor: messageMorph concatenatedLabels)
						target: messageMorph
						selector: #invokeFromUserMenu ] ]
			ifAbsent: 
				[ "do nothing"
				 ] ]! !

!MauiFamily methodsFor: 'enumerate' stamp: 'cmm 1/17/2010 21:48'!
allCurrentViewsDo: oneArgBlock 
	"Enumerate all current views.  This is used to assist writing migration scripts."
	self classNamesDo: 
		[ : each | 
		(self viewsAt: each) do: [ : eachViews | eachViews ifNotEmpty: [ oneArgBlock value: eachViews first ] ] ]! !

!MauiFamily methodsFor: 'enumerate' stamp: 'cmm 4/11/2009 17:37'!
allViewsDo: oneArgBlock 
	"Enumerate all views.  This is used to assist writing migration scripts."
	self classNamesDo: 
		[ : each | 
		(self viewsAt: each) do: [ : eachViews | eachViews do: oneArgBlock ] ]! !

!MauiFamily methodsFor: 'save/load' stamp: 'cmm 4/24/2013 20:41'!
baseProtocol
	"There may be more that needs to be added to the baseProtocol, but we want to keep it tight to ensure exported families only reference the types of objects they should, e.g., not any domain objects.
	Domain-specific classes needed for pick-lists can be put in via the #extendedProtocol: setter."
	^ {MauiFamily. DateAndTime. Duration. RectangleMorph. BorderedMorph. Morph. Rectangle. Point. MauiMessageMorph. MauiInstructionMorph. SketchMorph. Color. MorphExtension. IdentityDictionary. WeakMessageSend. WeakArray. Form. DisplayMedium. DisplayObject. SolidFillStyle. FillStyle. LargePositiveInteger. TableLayout. LayoutPolicy. TableLayoutProperties. LayoutProperties. SimpleBorder. BorderStyle. TranslucentColor. MauiMessage. MauiInstruction. MethodReference. StringMorph. MauiClickedInvocationStrategy. MauiInvocationStrategy. DiskProxy. StrikeFont. AbstractFont. EventHandler. MauiPrototype. MaSingleton. ComplexBorder. MauiPreferences. GradientFillStyle. OrientedFillStyle. Association. LookupKey. MauiColorScheme. MauiCollectionMorph. MauiStringMorph. LayoutFrame. ProportionalLayout. Bitmap. MauiScrollBar. ScrollBar. Slider. MorphicModel. ImageMorph. InsetBorder. MauiAutoInvocationStrategy. MauiDateMorph. MauiTimespanMorph. MauiParameterHolderMorph. MauiClickAndPickParameterStrategy. MauiOptionalParametersStrategy. MauiSmalltalkEvaluator. MauiStringEvaluator. MauiMouseOverInvocationStrategy. TextMorph. TextStyle. Text. RunArray. TextEmphasis. TextAttribute. TextFontReference. TextFontChange. MultiNewParagraph. NewParagraph. TextLine. MauiCycleParametersStrategy. MauiBlockMorph. ColorForm. ColorArray. MauiBlock. BlockClosure. MethodContext. ContextPart. InstructionStream. CompiledMethod. ReadOnlyVariableBinding. MauiMorphMorph. MauiColorMorph. StrikeFontSet. ActorState. UnscriptedPlayer. Player. Model. MauiFileDirectoryMorph. MauiFillStyleMorph. MauiBooleanMorph. MauiDirectoryEntryEvaluator. MauiListSelectionStrategy. MauiFileDirectoryEvaluator. MauiDateEvaluator. TransformationMorph. TransformMorph. MorphicTransform. DisplayTransform. MauiPageMorph. MauiTextEditor. PluggableTextMorph. ScrollPane. MauiTextMorph. TextMorphForEditView. MauiPage. Interval. MauiColorPickerMorph. MaAttributableObject. FormCanvas. Canvas. FlattenEncoder. NullEncoder. GrafPort. BitBlt. BitmapFillStyle. MauiIconSet. MauiKeyMap. ClassBinding}! !

!MauiFamily methodsFor: 'enumerate' stamp: 'cmm 9/4/2012 17:05'!
classNamesDo: oneArgBlock 
	"Enumerate the classes for which I have views."
	| done |
	done := Set new.
	views keysDo:
		[ : each | done add: each.
		oneArgBlock value: each ].
	contextMenuMessages keysDo:
		[ : each | (done includes: each) ifFalse: [ oneArgBlock value: each ] ]! !

!MauiFamily methodsFor: 'access' stamp: 'cmm 4/11/2009 17:39'!
classes
	"Enumerate the classes for which I have views."
	| withViews |
	withViews := views keys select: [ : each | (self viewsForClassNamed: each) notEmpty ].
	^ withViews asSortedCollection! !

!MauiFamily methodsFor: 'private' stamp: 'cmm 7/3/2009 20:54'!
contextMenuClassNames
	^ contextMenuMessages keys asArray! !

!MauiFamily methodsFor: 'enumerate' stamp: 'cmm 2/9/2013 17:21'!
contextMenuMessagesDo: aBlock 
	contextMenuMessages do:
		[ : eachCollection | eachCollection do: aBlock ]! !

!MauiFamily methodsFor: 'private' stamp: 'cmm 8/28/2012 16:12'!
contextMenuMessagesFor: className 
	^ contextMenuMessages 
		at: className
		ifAbsentPut: [ OrderedCollection new: 1 ]! !

!MauiFamily methodsFor: 'move/copy' stamp: 'cmm 8/28/2012 16:00'!
copyViewsForClassNamed: className to: aMauiFamily 
	aMauiFamily == self ifTrue: [ MauiUserError signal: 'Why copy to itself?' ].
	(self viewsForClassNamed: className) do:
		[ : eachView | aMauiFamily
			remember: eachView
			atLevel: eachView level ].
	aMauiFamily changed! !

!MauiFamily methodsFor: 'enumerate' stamp: 'cmm 7/10/2007 15:40'!
customViewsFor: anObject do: oneArgBlock 
	self 
		viewsFrom: (self prototypeClassKeyFor: anObject)
		do: 
			[ : each | 
			(anObject mauiCodedViews includes: each) ifFalse: [ oneArgBlock value: each ] ]! !

!MauiFamily methodsFor: 'save/load' stamp: 'cmm 2/9/2013 17:22'!
ensureLastModifiedPopulated
	| now |
	now := DateAndTime now.
	self allViewsDo:
		[ : each | each lastModified ifNil: [ each lastModified: now ] ].
	self contextMenuMessagesDo:
		[ : each | each lastModified ifNil: [ each lastModified: now ] ]! !

!MauiFamily methodsFor: 'preferences' stamp: 'cmm 4/14/2008 21:52'!
ensurePreferences
	^ preferences ifNil: 
		[ preferences := self nextPreferenceSource ensurePreferences newOverrideFor: self ]! !

!MauiFamily methodsFor: 'private' stamp: 'cmm 10/13/2012 16:50'!
ensureViewsAt: className 
	^ views 
		at: className
		ifAbsentPut: [ Dictionary new ]! !

!MauiFamily methodsFor: 'private' stamp: 'cmm 10/13/2012 12:19'!
ensureViewsAt: className named: aString 
	^ (self ensureViewsAt: className) 
		at: aString
		ifAbsentPut: [ OrderedCollection new ]! !

!MauiFamily methodsFor: 'save/load' stamp: 'cmm 8/28/2012 16:17'!
extendedProtocol
	"The additional protocol required  by these UI panels.  In practice, it is possible for some 'domain' objects used as options in a pick-list to cause the protocol to be extended.  For example, often the domain *class* is used as an argument for creation."
	^ MauiMorph withAllSubclasses , MauiStringEvaluator withAllSubclasses! !

!MauiFamily methodsFor: 'save/load' stamp: 'cmm 12/11/2013 15:38'!
familiesByPackage
	"Split the views of this Family into a Dictionary of new MauiFamilies which contain only views for classes of the same Package colocated in the Family values."
	| familiesByPackage |
	familiesByPackage := Dictionary new.
	self classNamesDo:
		[ : each | 
		Smalltalk globals
			at: each subStrings first asSymbol
			ifPresent:
				[ : class | | pkgInfo |
				pkgInfo := class packageInfo.
				pkgInfo
					ifNil: [ MauiWarning signal: each subStrings first asSymbol , ' does not appear to be loaded, it will be ignored.' ]
					ifNotNil:
						[ (familiesByPackage
							at: pkgInfo name
							ifAbsentPut: [ MauiFamily newNamed: pkgInfo name ])
							mergeViewsAtKey: each
							from: self ] ]
			ifAbsent: [ MauiWarning signal: each subStrings first asSymbol , ' is not a class in the system, it will be ignored.' ] ].
	^ familiesByPackage! !

!MauiFamily methodsFor: 'save/load' stamp: 'cmm 3/7/2013 13:29'!
fileOut
	"Write this family of screens to multiple files -- one file for each package -- in the current directory."
	self
		 trimEmptySlots ;
		 ensureLastModifiedPopulated ;
		 fixReferencesToDomainObjects.
	self familiesByPackage do:
		[ : each | | existingFile |
		existingFile := FileDirectory default
			entryAt: each name , '.MauiFamily'
			ifAbsent: [  ].
		((existingFile isNil or: [ existingFile modificationDateAndTime < each lastModified ]) or: [ self confirm: existingFile name , ' already exists and has a newer timestamp than my lastModified date.  Is it ok to overwrite it?' ]) ifTrue:
			[ Cursor write showWhile:
				[ MaObjectSerializer new
					 protocol: each protocol ;
					
					beforeSerializingAny: #MauiPreferences
					do:
						[ : aMauiPreferences | aMauiPreferences connector: nil ] ;
					
					fileOut: each
					toFileNamed: each name , '.MauiFamily'
					in: FileDirectory default ] ] ]! !

!MauiFamily methodsFor: 'access' stamp: 'cmm 4/19/2009 14:44'!
filename
	"A filename based on my name."
	^ self name , '.MauiFamily'! !

!MauiFamily methodsFor: 'save/load' stamp: 'cmm 12/10/2012 15:42'!
fixReferencesToDomainObjects
	"This is a hack fix to save the family.   #createSortableColumn:using: leaves references to domain objects.  Remove them before saving the family.  I need a better solution to this."
	MethodContext allInstances do:
		[ : each | (each method notNil and: [ each method selector = #createSortableColumn:using: ]) ifTrue: [ each removeSelf ] ]! !

!MauiFamily methodsFor: 'testing' stamp: 'cmm 4/11/2009 17:40'!
hasViewsAt: className named: aString 
	^ (views 
		at: className
		ifAbsent: [ ^ false ]) includesKey: aString! !

!MauiFamily methodsFor: 'initialize' stamp: 'cmm 8/28/2012 17:43'!
initialize
	super initialize.
	"views:
		keys:  class name
		values:  another dictionary, viewName->OC of the versions of those views"
	views := Dictionary new.
	"contextMenuMessages:
			keys: class name
			values: OC of MauiMessageMorphs to add to context menu."
	contextMenuMessages := Dictionary new.
	name := String empty! !

!MauiFamily methodsFor: 'save/load' stamp: 'cmm 2/9/2013 17:28'!
lastModified
	| lastModified |
	lastModified := nil.
	self allViewsDo:
		[ : each | lastModified := lastModified
			ifNil: [ each lastModified ]
			ifNotNil:
				[ each lastModified ifNotNil: [ each lastModified max: lastModified ] ] ].
	self contextMenuMessagesDo:
		[ : eachMessageMorph | lastModified := lastModified
			ifNil: [ eachMessageMorph lastModified ]
			ifNotNil:
				[ eachMessageMorph lastModified
					ifNil: [ lastModified ]
					ifNotNil: [ eachMessageMorph lastModified max: lastModified ] ] ].
	^ lastModified! !

!MauiFamily methodsFor: 'initialize' stamp: 'cmm 10/13/2012 17:41'!
merge: aMauiFamily 
	"Rudimentary merge of aMauiFamily into the receiver.  aMauiFamily is left unchanged.  This is used for installing new MauiWorlds or MauiFamily's, without losing existing views.
	Collisions between exact view names at the same class will cause aMauiFamily to take the current top version (which can be reverted, if necessary)."
	name := views
		ifEmpty: [ aMauiFamily name ]
		ifNotEmpty:
			[ | appendString |
			appendString := ' and ' , aMauiFamily name.
			(name includesSubString: aMauiFamily name)
				ifTrue: [ name ]
				ifFalse: [ name := name , appendString ] ].
	aMauiFamily classNamesDo:
		[ : each | self
			mergeViewsAtKey: each
			from: aMauiFamily ]! !

!MauiFamily methodsFor: 'initialize' stamp: 'cmm 8/28/2012 17:05'!
mergeViewsAtKey: keyString from: aMauiFamily 
	aMauiFamily
		copyViewsForClassNamed: keyString
		to: self.
	self
		updateContextMenuMessagesFor: keyString
		from: aMauiFamily.
	self ensurePreferences values: aMauiFamily preferences values veryDeepCopy! !

!MauiFamily methodsFor: 'move/copy' stamp: 'cmm 12/5/2013 16:42'!
moveViewsNamed: viewName forClassNamed: oldClassName to: newClassName 
	| oldLocation newLocation |
	oldLocation := self
		viewsAt: oldClassName
		named: viewName.
	oldLocation ifNil: [ MauiUserError signal: 'No views for ' , oldClassName ].
	newLocation := self
		ensureViewsAt: newClassName
		named: viewName.
	newLocation addAll: oldLocation.
	oldLocation do:
		[ : each | each level = oldClassName ifTrue: [ each level: newClassName ] ].
	(self contextMenuMessagesFor: newClassName) addAll: (self contextMenuMessagesFor: oldClassName).
	self removeAllOf: viewName for: oldClassName! !

!MauiFamily methodsFor: 'access' stamp: 'cmm 12/1/2003 00:05'!
name

	^name! !

!MauiFamily methodsFor: 'initialize' stamp: 'cmm 12/1/2003 00:20'!
name: aString

	name := aString! !

!MauiFamily methodsFor: 'create' stamp: 'cmm 4/29/2014 10:18'!
newViewNamed: aString for: anObject 
	^ aString isSymbol
		ifTrue:
			[ | theView |
			theView := anObject asMauiMorphFor: self.
			theView view = aString
				ifTrue: [ theView ]
				ifFalse:
					[ (theView respondsTo: aString)
						ifTrue: [ theView perform: aString ]
						ifFalse:
							[ (self
								viewNamed: anObject mauiDefaultView
								for: anObject) copy
								 object: anObject ;
								 yourself ] ] ]
		ifFalse:
			[ (self
				viewNamed: aString
				for: anObject) copy
				 object: anObject ;
				 yourself ]! !

!MauiFamily methodsFor: 'preferences' stamp: 'cmm 8/11/2004 21:58'!
nextPreferenceSource

	^ MauiPreferences global! !

!MauiFamily methodsFor: 'testing' stamp: 'cmm 1/17/2010 21:17'!
player: playerClass overridesView: viewName from: aClass
	playerClass withAllSuperclassesDo:
		[ : eachClass |
		eachClass = aClass ifTrue: [ ^ false ].
		(self
			hasViewsAt: eachClass
			named: viewName) ifTrue: [ ^ true ] ].
	^ false! !

!MauiFamily methodsFor: 'preferences' stamp: 'cmm 4/14/2008 21:55'!
preferences
	"Answer the nearest (overridden) preferences or the global preferences if there are no overrides."
	^ preferences ifNil: [ self nextPreferenceSource preferences ]! !

!MauiFamily methodsFor: 'preferences' stamp: 'cmm 12/10/2008 13:50'!
preferred: preferenceSelector 
	^ self preferences preferred: preferenceSelector! !

!MauiFamily methodsFor: 'printing' stamp: 'cmm 12/16/2003 00:48'!
printOn: aStream

	super printOn: aStream.
	aStream
		space;
		nextPutAll: name! !

!MauiFamily methodsFor: 'save/load' stamp: 'cmm 8/27/2012 16:29'!
protocol
	"Any subclasses of MauiDomainMorph encountered must also be part of the protocol."
	^ self baseProtocol, self extendedProtocol! !

!MauiFamily methodsFor: 'private' stamp: 'cmm 5/21/2011 16:32'!
prototypeClassKeyFor: anObject 
	^ anObject yourself maOriginalClass! !

!MauiFamily methodsFor: 'remember views' stamp: 'cmm 10/13/2012 12:19'!
remember: aMauiMorph as: viewName atLevel: className 
	| v prototype |
	aMauiMorph isInWorld ifTrue:
		[ aMauiMorph
			 captureSketch ;
			 underlampOff ].
	prototype := aMauiMorph copyForNewObject: aMauiMorph object asMauiPrototype.
	prototype level: className.
	"Don't update the lastModified: unless we made some changes!!  Since that typically only happens via visual manipulation, update it if it's currently in the World.  Otherwise, just by extracting #familiesByPackage we would have all-updated lastModifieds."
	aMauiMorph isInWorld ifTrue: [ prototype lastModified: DateAndTime now ].
	prototype allMauiMorphsDo:
		[ : each | each family: self ].
	(v := self
		ensureViewsAt: className
		named: viewName) addFirst: prototype.
	"Keep bloat managed by keeping only the last 10 versions of each particular view."
	[ v size > 10 ] whileTrue: [ v removeLast ]! !

!MauiFamily methodsFor: 'remember views' stamp: 'cmm 8/7/2010 16:57'!
remember: aMauiDomainMorph atLevel: className 
	self
		remember: aMauiDomainMorph
		as: aMauiDomainMorph view
		atLevel: className! !

!MauiFamily methodsFor: 'remove' stamp: 'cmm 4/11/2009 17:37'!
removeAllButMostRecent: anInteger 
	"Enumerate my views and trim the old ones until there are no more than anInteger versions of that view."
	| c |
	c := 0.
	self classNamesDo: 
		[ : each | 
		(self viewsAt: each) do: 
			[ : eachCollection | 
			[ eachCollection size > anInteger ] whileTrue: 
				[ c := c + 1.
				eachCollection removeLast ] ] ].
	^ 'Removed ' , c asString , ' old Maui views.'! !

!MauiFamily methodsFor: 'remove' stamp: 'cmm 10/13/2012 16:19'!
removeAllOf: viewName for: className 
	(self viewsAt: className) removeKey: viewName.
	self trimEmptySlots! !

!MauiFamily methodsFor: 'remove' stamp: 'cmm 10/13/2012 16:19'!
removeViewsFor: className 
	^ (views removeKey: className) in:
		[ : removed | views changed.
		contextMenuMessages
			removeKey: className
			ifAbsent: [  ].
		self trimEmptySlots.
		removed ]! !

!MauiFamily methodsFor: 'rename' stamp: 'cmm 11/14/2009 18:41'!
renamedClassFrom: oldName to: newName 
	views 
		at: newName
		put: (views removeKey: oldName)! !

!MauiFamily methodsFor: 'preferences' stamp: 'cmm 8/6/2004 11:10'!
resetPreferences

	preferences := nil! !

!MauiFamily methodsFor: 'enumerate' stamp: 'cmm 3/14/2009 19:36'!
sortedViewsFor: aMauiDomainMorph do: oneArgBlock 
	self 
		sortedViewsForClass: (self prototypeClassKeyFor: aMauiDomainMorph object)
		do: oneArgBlock! !

!MauiFamily methodsFor: 'enumerate' stamp: 'cmm 3/14/2009 19:35'!
sortedViewsForClass: aClass do: oneArgBlock 
	| allViews |
	allViews := OrderedCollection new.
	self 
		viewsFrom: aClass
		do: [ : each | (allViews includes: each) ifFalse: [ allViews add: each ] ].
	allViews asSortedCollection do: oneArgBlock! !

!MauiFamily methodsFor: 'testing' stamp: 'cmm 7/17/2007 12:24'!
supportsViewNamed: aString for: aClass 
	aClass ifNil: [ ^ false ].
	^ (self 
		hasViewsAt: aClass
		named: aString) 
		ifTrue: [ true ]
		ifFalse: 
			[ self 
				supportsViewNamed: aString
				for: aClass superclass ]! !

!MauiFamily methodsFor: 'remove' stamp: 'cmm 8/4/2010 16:26'!
trimEmptySlots
	| emptyViews |
	emptyViews := views select:
		[ : each | each isEmpty ].
	emptyViews keysDo:
		[ : each | views removeKey: each ]! !

!MauiFamily methodsFor: 'private' stamp: 'cmm 8/28/2012 16:13'!
updateContextMenuMessagesFor: className from: aMauiFamily 
	| myMessages |
	myMessages := self contextMenuMessagesFor: className.
	(aMauiFamily contextMenuMessagesFor: className) do:
		[ : eachIncoming | myMessages
			detect:
				[ : each | each selector = eachIncoming selector and: [ each invocationStrategy resultView = eachIncoming invocationStrategy resultView ] ]
			ifFound:
				[ : found | myMessages remove: found.
				myMessages add: eachIncoming ]
			ifNone: [ myMessages add: eachIncoming ] ]! !

!MauiFamily methodsFor: 'access' stamp: 'cmm 4/24/2009 15:04'!
viewNamed: aString for: anObject 
	"Answers the actual view stored in me at aString for anObject."
	| v |
	v := self 
		viewsNamed: aString
		for: (self prototypeClassKeyFor: anObject).
	^ v isEmptyOrNil 
		ifTrue: [ (anObject asMauiMorphFor: self) panel ]
		ifFalse: [ v first ]! !

!MauiFamily methodsFor: 'private' stamp: 'cmm 10/13/2012 12:18'!
viewsAt: className 
	^ views 
		at: className
		ifAbsent: [ Dictionary new ]! !

!MauiFamily methodsFor: 'private' stamp: 'cmm 10/13/2012 12:21'!
viewsAt: className named: aString 
	^ (self viewsAt: className) 
		at: aString
		ifAbsent: [ nil ]! !

!MauiFamily methodsFor: 'access' stamp: 'cmm 4/11/2009 17:39'!
viewsForClassNamed: className 
	| sortBlock |
	sortBlock := [ : a : b | a view < b view ].
	^ (self viewsAt: className) 
		inject: (SortedCollection sortBlock: sortBlock)
		into: 
			[ : coll : eachColl | 
			coll
				add: eachColl first copy ;
				yourself ]! !

!MauiFamily methodsFor: 'enumerate' stamp: 'cmm 4/11/2009 17:52'!
viewsFrom: aClass do: oneArgBlock 
	(MauiWorld current userStrategy likesViewsFor: aClass) ifFalse: [ ^ self ].
	(self viewsAt: aClass name) keysDo: oneArgBlock.
	self 
		viewsFrom: aClass superclass
		do: oneArgBlock! !

!MauiFamily methodsFor: 'access' stamp: 'cmm 4/11/2009 17:56'!
viewsNamed: aString for: aClass 
	aClass = nil ifTrue: [ ^ nil ].
	^ (self 
		hasViewsAt: aClass name
		named: aString) 
		ifTrue: 
			[ self 
				viewsAt: aClass name
				named: aString ]
		ifFalse: 
			[ self 
				viewsNamed: aString
				for: aClass superclass ]! !

MaObject subclass: #MauiInstruction
	instanceVariableNames: 'receiver arguments debugMode profileMode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Messages'!

MauiInstruction subclass: #MauiBlock
	instanceVariableNames: 'block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Messages'!

!MauiBlock class methodsFor: 'create' stamp: 'cmm 4/30/2009 16:45'!
receiver: anObject block: aBlock 
	^ self new
		receiver: anObject ;
		block: aBlock ;
		postInitialize ;
		yourself! !

!MauiBlock methodsFor: 'accessing' stamp: 'cmm 2/4/2014 15:34'!
allMauiMorphsDo: aBlock ifNotIn: anIdentitySet 
	block ifNotNil:
		[ block referencesDo:
			[ : each | each isMauiMorph ifTrue:
				[ (anIdentitySet includes: each) ifFalse:
					[ anIdentitySet add: each.
					aBlock value: each.
					each
						allMauiMorphsDo: aBlock
						ifNotIn: anIdentitySet ] ] ] ]! !

!MauiBlock methodsFor: 'private' stamp: 'cmm 10/18/2011 21:35'!
asMessage
	^ block! !

!MauiBlock methodsFor: 'accessing' stamp: 'cmm 4/30/2009 16:44'!
block
	^ block! !

!MauiBlock methodsFor: 'initialize' stamp: 'cmm 4/30/2009 16:44'!
block: aBlock
	block := aBlock! !

!MauiBlock methodsFor: 'testing' stamp: 'cmm 4/30/2009 16:22'!
hasCorrespondingGetter
	^ false! !

!MauiBlock methodsFor: 'testing' stamp: 'cmm 4/30/2009 16:22'!
hasCorrespondingSetter
	^ false! !

!MauiBlock methodsFor: 'accessing' stamp: 'cmm 4/30/2009 16:26'!
implementorClass
	^ block method methodClass! !

!MauiBlock methodsFor: 'printing' stamp: 'cmm 4/30/2009 16:34'!
maPrintAbbreviatedOn: aStream 
	super maPrintAbbreviatedOn: aStream.
	block printOn: aStream.
	aStream
		nextPutAll: ' and arguments: ' ;
		print: arguments! !

!MauiBlock methodsFor: 'accessing' stamp: 'cmm 4/30/2009 16:28'!
mauiName
	^ block printStringLimitedTo: 100! !

!MauiBlock methodsFor: 'private' stamp: 'cmm 4/30/2009 16:39'!
numberOfArguments
	"The block is always one arg, my receiver."
	^ 1! !

!MauiBlock methodsFor: 'private' stamp: 'cmm 5/1/2009 15:49'!
prototypePreferenceSelector
	^ #blockMorph! !

!MauiBlock methodsFor: 'accessing' stamp: 'cmm 2/4/2014 15:40'!
receiver: anObject 
	| oldReceiver |
	oldReceiver := self receiver.
	super receiver: anObject.
	block ifNotNil:
		[ block referencesDo:
			[ : each | each isMauiDomainMorph
				ifTrue:
					[ each
						updateObjectFrom: oldReceiver
						to: anObject ]
				ifFalse:
					[ each isMauiInstructionMorph ifTrue:
						[ each
							updateReceiverFrom: oldReceiver
							to: anObject ] ] ] ]! !

!MauiBlock methodsFor: 'testing' stamp: 'cmm 4/30/2009 16:47'!
sameEffectAs: aMauiBlock 
	self block == aMauiBlock block ifTrue: [ ^ true ].
	^ aMauiBlock block in: 
		[ : otherBlock | 
		block method = otherBlock method and: 
			[ block numArgs = otherBlock numArgs and: [ block startpc = otherBlock startpc ] ] ]! !

!MauiBlock methodsFor: 'accessing' stamp: 'cmm 4/30/2009 16:17'!
sourceString
	^ block printString! !

!MauiBlock methodsFor: 'copying' stamp: 'cmm 6/6/2013 14:03'!
veryDeepInner: aDeepCopier
	super veryDeepInner: aDeepCopier.
	block := block veryDeepCopyWith: aDeepCopier! !

!MauiInstruction methodsFor: 'accessing' stamp: 'cmm 1/1/2010 11:59'!
argumentNameAt: argIndex 
	^ self sourceString ifNotNilDo: 
		[ : source | 
		| sourceString nthColon whiteAfterNthColon |
		sourceString := source asString readStream nextLine.
		nthColon := sourceString 
			occurrence: argIndex
			where: [ : eachChar | eachChar = $: ].
		nthColon > 0 ifTrue: 
			[ whiteAfterNthColon := sourceString 
				occurrence: 1
				where: [ : eachChar | eachChar isSeparator ]
				startingAt: nthColon + 2.	"2 because the arg will be at least one char, and they may or may not have a space before the first char."
			(sourceString 
				copyFrom: nthColon + 1
				to: (whiteAfterNthColon = 0 
						ifTrue: [ sourceString size ]
						ifFalse: [ whiteAfterNthColon ])) withBlanksTrimmed ] ]! !

!MauiInstruction methodsFor: 'initialize' stamp: 'cmm 4/30/2009 16:21'!
arguments

	^ arguments! !

!MauiInstruction methodsFor: 'initialize' stamp: 'cmm 4/30/2009 16:21'!
arguments: anArray

	arguments := anArray! !

!MauiInstruction methodsFor: 'copying' stamp: 'cmm 4/30/2009 16:49'!
commonCopy

	^ self copy
		arguments: arguments ;
		yourself! !

!MauiInstruction methodsFor: 'accessing' stamp: 'cmm 4/30/2009 16:15'!
debugMode

	^debugMode! !

!MauiInstruction methodsFor: 'accessing' stamp: 'cmm 4/30/2009 16:15'!
debugMode: aBoolean

	debugMode := aBoolean! !

!MauiInstruction methodsFor: 'subclass responsibility' stamp: 'cmm 4/30/2009 16:48'!
hasCorrespondingGetter
	self subclassResponsibility ! !

!MauiInstruction methodsFor: 'subclass responsibility' stamp: 'cmm 4/30/2009 16:48'!
hasCorrespondingSetter
	self subclassResponsibility ! !

!MauiInstruction methodsFor: 'subclass responsibility' stamp: 'cmm 4/30/2009 16:49'!
implementorClass
	self subclassResponsibility ! !

!MauiInstruction methodsFor: 'copying' stamp: 'cmm 4/30/2009 16:27'!
independentCopy

	^self commonCopy! !

!MauiInstruction methodsFor: 'initialize' stamp: 'cmm 4/30/2009 16:27'!
initialize

	super initialize.
	self debugMode: false! !

!MauiInstruction methodsFor: 'accessing' stamp: 'cmm 10/18/2011 21:32'!
invokeUsing: aMauiNotificationHandler 
	| profBlock |
	debugMode ifTrue: [ self halt: 'debugging on' ].
	profBlock := 
	[ aMauiNotificationHandler 
		send: self asMessage
		to: receiver ].
	^ self profileMode 
		ifTrue: [ MessageTally spyAllOn: profBlock ]
		ifFalse: profBlock! !

!MauiInstruction methodsFor: 'testing' stamp: 'cmm 4/30/2009 21:18'!
isUnary
	^ true! !

!MauiInstruction methodsFor: 'testing' stamp: 'cmm 5/1/2009 14:26'!
isValid

	^self implementorClass notNil! !

!MauiInstruction methodsFor: 'initialize' stamp: 'cmm 4/30/2009 16:32'!
postInitialize
	self arguments: (Array new: self numberOfArguments)! !

!MauiInstruction methodsFor: 'accessing' stamp: 'cmm 6/8/2009 12:05'!
profileMode
	^ profileMode ifNil: [ profileMode := false ]! !

!MauiInstruction methodsFor: 'accessing' stamp: 'cmm 6/8/2009 12:06'!
profileMode: aBoolean 
	profileMode := aBoolean! !

!MauiInstruction methodsFor: 'accessing' stamp: 'cmm 4/30/2009 16:51'!
receiver

	^receiver! !

!MauiInstruction methodsFor: 'accessing' stamp: 'cmm 4/30/2009 16:51'!
receiver: anObject

	receiver := anObject! !

!MauiInstruction methodsFor: 'private' stamp: 'cmm 4/30/2009 16:31'!
resetArguments
	self arguments: #()! !

!MauiInstruction methodsFor: 'subclass responsibility' stamp: 'cmm 4/30/2009 16:48'!
sameEffectAs: aMauiMessage 
	self subclassResponsibility! !

!MauiInstruction methodsFor: 'copying' stamp: 'cmm 2/16/2014 19:49'!
veryDeepFixupWith: aDeepCopier 
	"The only way we ever want make a copy of my sources' original receiver is if it was part of the Morph tree being copied originally; meaning it was a UI message.  In that case, we want to make sure we point MY receiver to it."
	super veryDeepFixupWith: aDeepCopier.
	(aDeepCopier references includesKey: receiver) ifTrue: [ self receiver: (aDeepCopier references at: receiver) ].
	"It's also possible the arguments will be MauiMorphs, for example when they are the argument to #dropCopy: (for picker support)."
	arguments withIndexDo: 
		[ : eachArg : x | 
		(aDeepCopier references includesKey: eachArg) ifTrue: 
			[ arguments 
				at: x
				put: (aDeepCopier references at: eachArg) ] ]! !

!MauiInstruction methodsFor: 'copying' stamp: 'cmm 4/30/2009 16:49'!
veryDeepInner: aDeepCopier

	super veryDeepInner: aDeepCopier.
	arguments := arguments maShallowCopy! !

MauiInstruction subclass: #MauiMessage
	instanceVariableNames: 'reference'
	classVariableNames: 'CachedReferences'
	poolDictionaries: ''
	category: 'Maui-Core-Messages'!

!MauiMessage commentStamp: 'cmm 8/19/2003 22:42' prior: 0!
I represent a Message object that has access to a little more information to faciliate ease-of-use functions in Maui.  For example, since I know my MethodReference, I facilitate the balloons that appear for MauiParameterHolderMorph's.!

!MauiMessage class methodsFor: 'initialize-release' stamp: 'cmm 12/4/2008 14:17'!
initialize
	super initialize.
	CachedReferences := Dictionary new! !

!MauiMessage class methodsFor: 'private' stamp: 'cmm 12/8/2010 14:20'!
methodReferenceFor: anObject selector: selectorSymbol 
	"Answer canonicalized MethodReference for message selected by selectorSymbol received by anObject."
	| compiledMethod methodRef |
	compiledMethod := anObject realObject maOriginalClass lookupSelector: selectorSymbol.
	compiledMethod ifNil: 
		[ MauiUserError signal: anObject maOriginalClass printString , ' cannot understand ' , selectorSymbol ].
	methodRef := MethodReference 
		class: compiledMethod methodClass
		selector: selectorSymbol.
	^ CachedReferences 
		at: methodRef
		ifAbsentPut: [ methodRef ]! !

!MauiMessage class methodsFor: 'create' stamp: 'cmm 12/24/2003 12:43'!
receiver: anObject selector: selectorSymbol

	^self
		receiver: anObject
		selector: selectorSymbol
		arguments: #()! !

!MauiMessage class methodsFor: 'create' stamp: 'cmm 12/4/2008 15:39'!
receiver: anObject selector: selectorSymbol arguments: anArray 
	^ self new
		receiver: anObject ;
		reference:
			(self 
				methodReferenceFor: anObject
				selector: selectorSymbol) ;
		postInitialize ;
		arguments: anArray! !

!MauiMessage class methodsFor: 'create' stamp: 'cmm 12/4/2008 15:46'!
reference: aMethodReference 
	"Answer a new instance whose receiver is not yet known.  This is used for listing methods in the BehaviorFinder."
	^ self new
		reference: aMethodReference ;
		postInitialize ;
		yourself! !

!MauiMessage methodsFor: 'accessing' stamp: 'cmm 4/17/2014 14:52'!
argumentNameAt: argIndex 
	^ self isBinary
		ifTrue:
			[ | firstLine indexOfFirstLetter |
			firstLine := self sourceString asString readStream nextLine.
			indexOfFirstLetter := firstLine findFirst:
				[ : each | each isLetter ].
			indexOfFirstLetter isZero
				ifTrue: [ String empty ]
				ifFalse:
					[ (firstLine
						copyFrom: indexOfFirstLetter
						to: firstLine size) withBlanksTrimmed ] ]
		ifFalse: [ super argumentNameAt: argIndex ]! !

!MauiMessage methodsFor: 'actions' stamp: 'cmm 12/4/2008 22:21'!
asMauiMessage
	"For API compatibility with MethodReference."
	^ self! !

!MauiMessage methodsFor: 'accessing' stamp: 'cmm 8/21/2003 23:15'!
asMessage

	^Message
		selector: self selector
		arguments: arguments! !

!MauiMessage methodsFor: 'private' stamp: 'cmm 2/9/2014 17:42'!
fixReferenceIfNecessaryAndPossible
	reference isValid ifFalse:
		[ reference asValid ifNotNil:
			[ : newRef | reference := newRef ] ]! !

!MauiMessage methodsFor: 'testing' stamp: 'cmm 10/9/2003 21:18'!
hasCorrespondingGetter

	| getterName |
	receiver ifNil: [ MauiUserError signal: 'I have no receiver.' ].
	getterName := self selector copyWithout: $:.
	^Symbol
		hasInterned: getterName
		ifTrue: [ : selector | ^receiver respondsTo: selector ]! !

!MauiMessage methodsFor: 'testing' stamp: 'cmm 12/19/2004 12:22'!
hasCorrespondingSetter

	| setterName |
	setterName := self selector copyWith: $:.
	^Symbol
		hasInterned: setterName
		ifTrue: [ : selector | ^receiver respondsTo: selector ]! !

!MauiMessage methodsFor: 'accessing' stamp: 'cmm 5/21/2011 16:40'!
implementorClass
	"Answer the class which implements my selector."
	receiver yourself maOriginalClass withAllSuperclassesDo: 
		[ : each | 
		(each methodDict includesKey: self selector) ifTrue: [ ^ each ] ].
	^ nil! !

!MauiMessage methodsFor: 'testing' stamp: 'cmm 12/28/2009 12:23'!
isBinary
	^ self selector isInfix! !

!MauiMessage methodsFor: 'testing' stamp: 'cmm 4/30/2009 21:19'!
isUnary
	^ self selector isUnary! !

!MauiMessage methodsFor: 'testing' stamp: 'cmm 2/9/2014 16:45'!
isValid
	^ super isValid and: [ reference isValid ]! !

!MauiMessage methodsFor: 'accessing' stamp: 'cmm 11/22/2003 18:11'!
mauiName

	^'>> ', self selector! !

!MauiMessage methodsFor: 'private' stamp: 'cmm 4/30/2009 16:32'!
numberOfArguments
	^ (self selector occurrencesOf: $:)! !

!MauiMessage methodsFor: 'printing' stamp: 'cmm 4/17/2014 16:20'!
printOn: aStream

	super printOn: aStream.
	aStream
		nextPutAll: ' with selector: ';
		maPrint: self selector;
		nextPutAll: ' and arguments: ';
		print: arguments! !

!MauiMessage methodsFor: 'private' stamp: 'cmm 5/1/2009 15:50'!
prototypePreferenceSelector
	^ #messageMorph! !

!MauiMessage methodsFor: 'accessing' stamp: 'cmm 3/12/2010 17:11'!
reference
	^ reference! !

!MauiMessage methodsFor: 'private' stamp: 'cmm 8/19/2003 22:56'!
reference: aMethodReference

	reference := aMethodReference! !

!MauiMessage methodsFor: 'comparing' stamp: 'cmm 6/22/2008 00:17'!
sameEffectAs: aMauiMessage 
	aMauiMessage == self ifTrue: [ ^ true ].
	aMauiMessage selector ~~ self selector ifTrue: [ ^ false ].
	aMauiMessage arguments ~= self arguments ifTrue: [ ^ false ].
	^ true! !

!MauiMessage methodsFor: 'accessing' stamp: 'cmm 2/24/2011 14:35'!
selector
	^ reference methodSymbol! !

!MauiMessage methodsFor: 'accessing' stamp: 'cmm 4/17/2014 14:48'!
sourceString
	^ reference isValid
		ifTrue: [ reference sourceString ]
		ifFalse: [ Array empty ]! !

MaObject subclass: #MauiInvocationStrategy
	instanceVariableNames: 'resultView resultHolderTarget previewView producedView postInvokeAction repeat repeatInterval'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Messages'!

MauiInvocationStrategy subclass: #MauiAutoInvocationStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Messages'!

!MauiAutoInvocationStrategy methodsFor: 'dispatch' stamp: 'cmm 11/19/2003 19:59'!
invokedFromUserMenu: aMauiMessageMorph

	aMauiMessageMorph openInHand! !

!MauiAutoInvocationStrategy methodsFor: 'testing' stamp: 'cmm 2/7/2004 01:05'!
isSuitableForGetter

	^self wantsLocalResultTarget ! !

!MauiAutoInvocationStrategy methodsFor: 'Morphic' stamp: 'cmm 7/19/2004 17:55'!
noteNewOwner: aMauiDomainMorph for: aMauiMessageMorph

	aMauiDomainMorph
		ifNil: [ aMauiMessageMorph stopStepping ]
		ifNotNil: [ aMauiMessageMorph startStepping ]! !

!MauiAutoInvocationStrategy methodsFor: 'dispatch' stamp: 'cmm 2/10/2013 14:56'!
parameterDropped: aMauiMessageMorph 
	aMauiMessageMorph noteRefreshNeeded.
	aMauiMessageMorph startStepping! !

!MauiAutoInvocationStrategy methodsFor: 'initializing' stamp: 'cmm 2/15/2013 12:27'!
postInitialize: aMauiMessageMorph
	aMauiMessageMorph
		 noteRefreshNeeded ;
		 startStepping! !

!MauiAutoInvocationStrategy methodsFor: 'dispatch' stamp: 'cmm 2/10/2013 13:57'!
postInvokeCleanup: aMauiInstructionMorph 
	super postInvokeCleanup: aMauiInstructionMorph.
	repeat ifFalse:
		[ aMauiInstructionMorph resetParameterHolderMorphs.
		aMauiInstructionMorph stopStepping ]! !

!MauiAutoInvocationStrategy methodsFor: 'Morphic' stamp: 'cmm 1/14/2008 17:13'!
refreshData: aMauiMessageMorph 
	aMauiMessageMorph invokeIfPossible.
	repeat ifFalse: [ aMauiMessageMorph stopStepping ]! !

!MauiAutoInvocationStrategy methodsFor: 'accessing' stamp: 'cmm 1/15/2008 12:12'!
repeatInterval
	^repeatInterval! !

MauiInvocationStrategy subclass: #MauiClickedInvocationStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Messages'!

!MauiClickedInvocationStrategy methodsFor: 'as yet unclassified' stamp: 'cmm 7/10/2003 00:34'!
handlesMouseDown
	^true! !

!MauiClickedInvocationStrategy methodsFor: 'as yet unclassified' stamp: 'cmm 8/16/2004 16:21'!
note: aMauiMessageMorph hoveringOver: aMauiMorph event: event
	"Indicate we didn't care about this notification."

	^ false! !

!MauiInvocationStrategy methodsFor: 'result' stamp: 'cmm 1/3/2005 12:17'!
balloonResultTargetIdentifier

	^'balloon'! !

!MauiInvocationStrategy methodsFor: 'initializing' stamp: 'cmm 7/28/2007 17:35'!
ensureResultViewFor: anObject 
	^ resultView ifNil: [ resultView := anObject mauiDefaultView ]! !

!MauiInvocationStrategy methodsFor: 'result' stamp: 'cmm 2/12/2004 23:35'!
handResultTargetIdentifier

	^'hand'! !

!MauiInvocationStrategy methodsFor: 'Morphic' stamp: 'cmm 7/10/2003 00:34'!
handlesMouseDown
	^false! !

!MauiInvocationStrategy methodsFor: 'Morphic' stamp: 'cmm 7/10/2003 00:01'!
handlesMouseOver
	^false! !

!MauiInvocationStrategy methodsFor: 'initializing' stamp: 'cmm 2/10/2013 11:39'!
initialize
	super initialize.
	self
		selectLocalResultTarget ;
		resultView: #word.
	postInvokeAction := #yourself	"do nothing".
	repeat := false.
	repeatInterval := 1000 "milliseconds"! !

!MauiInvocationStrategy methodsFor: 'accessing' stamp: 'cmm 2/10/2013 11:55'!
initializeSubmorphsFor: aMauiInvocationStrategyMorph 
	| resultHolderTargetMessage resultHolderTargetMessageParameter postInvokeMessage |
	aMauiInvocationStrategyMorph
		listDirection: #topToBottom ;
		ensureNoCloseBox.
	#(#resultView: #previewView #producedView ) do: [ : each | (aMauiInvocationStrategyMorph addMessageNamed: each) asGetterSetter ].
	resultHolderTargetMessage := (aMauiInvocationStrategyMorph addMessageNamed: #resultHolderTarget:) asGetterSetter.
	resultHolderTargetMessageParameter := resultHolderTargetMessage firstParameterHolder.
	resultHolderTargetMessageParameter
		optionalParametersMorph: aMauiInvocationStrategyMorph object possibleTargets asMauiMorph ;
		evaluator: MauiStringEvaluator.
	postInvokeMessage := (aMauiInvocationStrategyMorph addMessageNamed: #postInvokeAction) asGetterSetter.
	postInvokeMessage firstParameterHolder optionalParametersMorph: #(
			#yourself
			#deleteParent
			#receiverChanged
			#beNotificationHandler
		) asArray asMauiMorph.
	aMauiInvocationStrategyMorph addMessage: (aMauiInvocationStrategyMorph newMessageNamed: #repeat) asGetterSetter asCheckBox.
	(aMauiInvocationStrategyMorph addMessageNamed: #repeatInterval) asGetterSetter! !

!MauiInvocationStrategy methodsFor: 'result' stamp: 'cmm 6/5/2009 11:42'!
injectedResultTargetIdentifier
	^ 'inject'! !

!MauiInvocationStrategy methodsFor: 'menu' stamp: 'cmm 11/19/2003 21:45'!
invokedFromUserMenu: aMauiMessageMorph

	aMauiMessageMorph canInvoke
		ifTrue: [ aMauiMessageMorph invokeIfPossible ]
		ifFalse: [ aMauiMessageMorph openInHand ]! !

!MauiInvocationStrategy methodsFor: 'testing' stamp: 'cmm 6/29/2012 10:55'!
isMouseOver
	^ false! !

!MauiInvocationStrategy methodsFor: 'converting' stamp: 'cmm 11/6/2003 23:24'!
isSuitableForGetter

	^false! !

!MauiInvocationStrategy methodsFor: 'result' stamp: 'cmm 2/7/2004 11:16'!
localResultTargetIdentifier

	^'self'! !

!MauiInvocationStrategy methodsFor: 'Morphic' stamp: 'cmm 6/3/2009 10:56'!
mouseDown: aMouseEvent for: aMauiInstructionMorph 
	aMauiInstructionMorph invokeIfPossible! !

!MauiInvocationStrategy methodsFor: 'Morphic' stamp: 'cmm 1/3/2005 22:38'!
mouseEntered: aMouseEvent for: aMauiMessageMorph
	"mouse-over strategy invokes now."! !

!MauiInvocationStrategy methodsFor: 'Morphic' stamp: 'cmm 1/4/2005 09:33'!
mouseLeft: aMouseEvent for: aMauiMessageMorph
	"mouse-over strategy gets rid of resultMorph."! !

!MauiInvocationStrategy methodsFor: 'Morphic' stamp: 'cmm 2/20/2013 18:08'!
mouseUp: aMouseEvent for: aMauiInstructionMorph 
	aMauiInstructionMorph stopStepping! !

!MauiInvocationStrategy methodsFor: 'converting' stamp: 'cmm 2/5/2004 23:31'!
newBehavingAs: mauiInvocationStrategyClass

	^mauiInvocationStrategyClass new
		copySameFrom: self;
		yourself! !

!MauiInvocationStrategy methodsFor: 'result' stamp: 'cmm 12/3/2004 12:33'!
noResultTargetIdentifier

	^'none'! !

!MauiInvocationStrategy methodsFor: 'result' stamp: 'cmm 5/1/2009 15:57'!
note: aMauiInstructionMorph hoveringOver: aMauiMorph event: event 
	"All but clicked strategy invoke aMauiInstructionMorph for aMauiMorph."
	^ aMauiInstructionMorph message isUnary 
		ifTrue: 
			[ aMauiInstructionMorph
				receiver: aMauiMorph object ;
				invokeIfPossible.
			true ]
		ifFalse: [ false ]! !

!MauiInvocationStrategy methodsFor: 'messages' stamp: 'cmm 2/20/2013 17:27'!
noteInvocationComplete: aMauiMessageMorph 
	aMauiMessageMorph hasResult ifTrue: 
		[ aMauiMessageMorph resultMorph
			previewView: previewView ;
			producedView: producedView ;
			startStepping ].
"	repeat ifFalse: [ aMauiMessageMorph stopStepping ]."
	(aMauiMessageMorph respondsTo: postInvokeAction) ifTrue: [ aMauiMessageMorph perform: postInvokeAction ]! !

!MauiInvocationStrategy methodsFor: 'Morphic' stamp: 'cmm 1/8/2008 11:03'!
noteNewOwner: aMauiDomainMorph for: aMauiMessageMorph! !

!MauiInvocationStrategy methodsFor: 'messages' stamp: 'cmm 1/15/2008 00:27'!
parameterDropped: aMauiMessageMorph
	"This is when the immediate should startStepping."! !

!MauiInvocationStrategy methodsFor: 'result' stamp: 'cmm 6/5/2009 20:16'!
possibleTargets
	^ { 
		(self localResultTargetIdentifier).
		(self handResultTargetIdentifier).
		(self worldResultTargetIdentifier).
		(self balloonResultTargetIdentifier).
		(self noResultTargetIdentifier).
		(self injectedResultTargetIdentifier)
	 }! !

!MauiInvocationStrategy methodsFor: 'initializing' stamp: 'cmm 7/14/2003 00:57'!
postInitialize: aMauiMorph
	"Used by the repeating to startStepping."! !

!MauiInvocationStrategy methodsFor: 'accessing' stamp: 'cmm 4/7/2008 10:10'!
postInvokeAction
	^ postInvokeAction! !

!MauiInvocationStrategy methodsFor: 'accessing' stamp: 'cmm 8/28/2012 21:36'!
postInvokeAction: selectorSymbol 
	"Specify a selector to be performed by the invoking MauiMessageMorph.  For example:
	- for the panel to be removed from the screen, specify #deleteParent.
	- to signal a domain change, specify #receiverChanged.
	- if an object from a new MagmaSession is accessed, #ensureMagmaNotificationHandler."
	(MauiInstructionMorph canUnderstand: selectorSymbol) ifFalse: [ MauiUserError signal: 'MauiInstructionMorph cannot understand ' , selectorSymbol ].
	postInvokeAction := selectorSymbol! !

!MauiInvocationStrategy methodsFor: 'messages' stamp: 'cmm 8/30/2005 10:51'!
postInvokeCleanup: aMauiMessageMorph
	"This runs right after the invoke.  The immediate will want to cleanup the parameterHolderMorphs."! !

!MauiInvocationStrategy methodsFor: 'accessing' stamp: 'cmm 6/3/2009 15:19'!
previewView
	^previewView! !

!MauiInvocationStrategy methodsFor: 'accessing' stamp: 'cmm 6/18/2009 19:29'!
previewView: aString
	"This setting affects what happens when the Hand (mouse pointer) hovers over the result of this message.  If set to nil, standard balloon text is opened, otherwise, a Morph of the specified view is."
	previewView := aString! !

!MauiInvocationStrategy methodsFor: 'accessing' stamp: 'cmm 7/3/2007 16:47'!
producedView
	^producedView! !

!MauiInvocationStrategy methodsFor: 'accessing' stamp: 'cmm 7/13/2007 15:25'!
producedView: aString
	"This setting affects what happens when the red-button (left button) is pressed on the result.  If set to nil, the result or its container is picked up by the hand.  Otherwise, a new specified view of the result is created and attached to the hand."
	producedView := aString! !

!MauiInvocationStrategy methodsFor: 'Morphic' stamp: 'cmm 6/1/2009 11:04'!
refreshData: aMauiInstructionMorph 
	aMauiInstructionMorph removeResult! !

!MauiInvocationStrategy methodsFor: 'accessing' stamp: 'cmm 8/2/2008 12:38'!
repeat
	^ repeat! !

!MauiInvocationStrategy methodsFor: 'accessing' stamp: 'cmm 8/2/2008 12:37'!
repeat: aBoolean
	repeat := aBoolean! !

!MauiInvocationStrategy methodsFor: 'accessing' stamp: 'cmm 1/15/2008 12:14'!
repeatInterval
	"This isn't used, but the number if representative to mean, 'a very long time'."
	^ 999999999! !

!MauiInvocationStrategy methodsFor: 'accessing' stamp: 'cmm 1/15/2008 12:12'!
repeatInterval: numberOfMilliseconds
	repeatInterval := numberOfMilliseconds! !

!MauiInvocationStrategy methodsFor: 'result' stamp: 'cmm 2/7/2004 01:02'!
resultHolderTarget

	^resultHolderTarget! !

!MauiInvocationStrategy methodsFor: 'accessing' stamp: 'cmm 6/5/2009 11:41'!
resultHolderTarget: aString
	"aString can be:
		'self'  (the messageMorph itself)
		'world'
		'hand'
		'balloon'
		'none'
		'inject'

Note this setting is overridden by #resultHolderMorph:."

	resultHolderTarget := aString! !

!MauiInvocationStrategy methodsFor: 'result' stamp: 'cmm 7/2/2008 15:48'!
resultTargetFor: aMauiMessageMorph 
	self wantsLocalResultTarget ifTrue: [ ^ aMauiMessageMorph ].
	self wantsHandResultTarget ifTrue: [ ^ ActiveHand ].
	self wantsWorldResultTarget ifTrue: [ ^ aMauiMessageMorph world ifNil: [ World ] ].
	self wantsBalloonResultTarget ifTrue: 
		[ ^ MauiBalloonMorph 
			contentsMorph: aMauiMessageMorph resultMorph
			for: aMauiMessageMorph ].
	^ nil! !

!MauiInvocationStrategy methodsFor: 'result' stamp: 'cmm 2/6/2004 00:07'!
resultView

	^resultView! !

!MauiInvocationStrategy methodsFor: 'accessing' stamp: 'cmm 7/15/2004 10:28'!
resultView: aString
	"Set the default view that should be assumed by the object resulting from my invocation."

	resultView := aString! !

!MauiInvocationStrategy methodsFor: 'accessing' stamp: 'cmm 7/31/2007 17:48'!
selectBalloonResultTarget
	self resultHolderTarget: self balloonResultTargetIdentifier ! !

!MauiInvocationStrategy methodsFor: 'accessing' stamp: 'cmm 7/31/2007 17:48'!
selectHandResultTarget
	self resultHolderTarget: self handResultTargetIdentifier ! !

!MauiInvocationStrategy methodsFor: 'accessing' stamp: 'cmm 7/31/2007 17:48'!
selectLocalResultTarget
	self resultHolderTarget: self localResultTargetIdentifier ! !

!MauiInvocationStrategy methodsFor: 'accessing' stamp: 'cmm 7/31/2007 17:48'!
selectNoResultTarget
	self resultHolderTarget: self noResultTargetIdentifier ! !

!MauiInvocationStrategy methodsFor: 'accessing' stamp: 'cmm 7/31/2007 17:48'!
selectWorldResultTarget
	self resultHolderTarget: self worldResultTargetIdentifier ! !

!MauiInvocationStrategy methodsFor: 'result' stamp: 'cmm 1/3/2005 12:17'!
wantsBalloonResultTarget

	^resultHolderTarget = self balloonResultTargetIdentifier! !

!MauiInvocationStrategy methodsFor: 'result' stamp: 'cmm 2/12/2004 23:37'!
wantsHandResultTarget

	^resultHolderTarget = self handResultTargetIdentifier! !

!MauiInvocationStrategy methodsFor: 'result' stamp: 'cmm 6/5/2009 11:42'!
wantsInjectedResultTarget
	^ resultHolderTarget = self injectedResultTargetIdentifier! !

!MauiInvocationStrategy methodsFor: 'result' stamp: 'cmm 2/7/2004 11:14'!
wantsLocalResultTarget

	^resultHolderTarget = self localResultTargetIdentifier! !

!MauiInvocationStrategy methodsFor: 'result' stamp: 'cmm 6/14/2007 16:24'!
wantsNoResultTarget
	^ resultHolderTarget = self noResultTargetIdentifier! !

!MauiInvocationStrategy methodsFor: 'result' stamp: 'cmm 7/9/2004 10:44'!
wantsWorldResultTarget

	^resultHolderTarget = self worldResultTargetIdentifier! !

!MauiInvocationStrategy methodsFor: 'result' stamp: 'cmm 7/9/2004 10:44'!
worldResultTargetIdentifier

	^'world'! !

MauiInvocationStrategy subclass: #MauiMouseOverInvocationStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Messages'!

!MauiMouseOverInvocationStrategy methodsFor: 'as yet unclassified' stamp: 'cmm 7/10/2003 00:34'!
handlesMouseOver

	^true! !

!MauiMouseOverInvocationStrategy methodsFor: 'as yet unclassified' stamp: 'cmm 11/19/2003 19:58'!
invokedFromUserMenu: aMauiMessageMorph

	aMauiMessageMorph openInHand! !

!MauiMouseOverInvocationStrategy methodsFor: 'as yet unclassified' stamp: 'cmm 6/29/2012 10:55'!
isMouseOver
	^ true! !

!MauiMouseOverInvocationStrategy methodsFor: 'as yet unclassified' stamp: 'cmm 6/3/2009 11:08'!
mouseDown: aMouseEvent for: aMauiInstructionMorph 
	aMauiInstructionMorph removeAlarm: #invokeIfPossible.
	super 
		mouseDown: aMouseEvent
		for: aMauiInstructionMorph! !

!MauiMouseOverInvocationStrategy methodsFor: 'as yet unclassified' stamp: 'cmm 2/15/2013 13:54'!
mouseEntered: aMouseEvent for: aMauiMessageMorph 
	(aMauiMessageMorph canInvoke and:
		[ (aMauiMessageMorph hasResult and: [ aMauiMessageMorph resultMorph isInWorld ]) not ]) ifTrue:
		[ "We don't want to invoke when the hand just grazes aMauiMessageMorph because it is on its way across the screen to somewhere else.  Make the user hover to indicate deliberate invocation."
		repeat
			ifTrue:
				[ aMauiMessageMorph isStepping ifFalse:
					[ aMauiMessageMorph
						addAlarm: #startStepping
						after: aMauiMessageMorph balloonHelpDelayTime ] ]
			ifFalse:
				[ aMauiMessageMorph
					addAlarm: #invokeIfPossible
					after: aMauiMessageMorph balloonHelpDelayTime ].
		aMouseEvent wasHandled: true ]! !

!MauiMouseOverInvocationStrategy methodsFor: 'as yet unclassified' stamp: 'cmm 2/20/2013 18:09'!
mouseLeft: aMouseEvent for: aMauiMessageMorph 
	aMauiMessageMorph
		 removeAlarm: #startStepping ;
		 removeAlarm: #invokeIfPossible.
	aMauiMessageMorph hasResult ifTrue: [ aMauiMessageMorph resultMorph deleteOnMouseLeave ].
	aMauiMessageMorph stopStepping! !

!MauiMouseOverInvocationStrategy methodsFor: 'as yet unclassified' stamp: 'cmm 2/15/2013 12:11'!
postInitialize: aMauiMessageMorph 
	"Make sure not stepping until mouseEnter."
	aMauiMessageMorph stopStepping! !

MaObject subclass: #MauiKeyMap
	instanceVariableNames: 'functions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Domain'!

!MauiKeyMap methodsFor: 'private' stamp: 'cmm 2/20/2014 13:27'!
accessingMethods
	"Answer the getter messages for each thing in Maui that can have its own color."
	| category allMethods |
	category := (self maOriginalClass >> #keyForFindObject) methodReference category.
	allMethods := self maOriginalClass methodReferencesInCategory: category.
	^ allMethods select: [ : each | each selector isUnary ]! !

!MauiKeyMap methodsFor: 'initialize' stamp: 'cmm 4/15/2008 22:58'!
initialize
	super initialize.
	functions := Dictionary new! !

!MauiKeyMap methodsFor: 'private' stamp: 'cmm 4/15/2008 22:58'!
keyFor: functionSelector 
	^ functions at: functionSelector! !

!MauiKeyMap methodsFor: 'private' stamp: 'cmm 4/15/2008 22:58'!
keyFor: functionSelector is: aCharacter 
	functions 
		at: functionSelector
		put: aCharacter! !

!MauiKeyMap methodsFor: 'hot keys-string editor' stamp: 'cmm 4/15/2008 22:39'!
keyForAccept
	^ self keyFor: #keyForAccept! !

!MauiKeyMap methodsFor: 'hot keys-string editor' stamp: 'cmm 4/15/2008 22:39'!
keyForAccept: aCharacter
	^ self
		keyFor: #keyForAccept
		is: aCharacter! !

!MauiKeyMap methodsFor: 'hot keys' stamp: 'cmm 4/15/2008 22:35'!
keyForAnotherView
	^ self keyFor: #keyForAnotherView! !

!MauiKeyMap methodsFor: 'hot keys' stamp: 'cmm 4/15/2008 22:35'!
keyForAnotherView: aCharacter
	^ self
		keyFor: #keyForAnotherView
		is: aCharacter! !

!MauiKeyMap methodsFor: 'hot keys' stamp: 'cmm 4/15/2008 22:35'!
keyForBrowseSenders
	^ self keyFor: #keyForBrowseSenders! !

!MauiKeyMap methodsFor: 'hot keys' stamp: 'cmm 4/15/2008 22:35'!
keyForBrowseSenders: aCharacter
	^ self
		keyFor: #keyForBrowseSenders
		is: aCharacter! !

!MauiKeyMap methodsFor: 'hot keys-string editor' stamp: 'cmm 4/15/2008 22:39'!
keyForCancelEdit
	^ Character escape! !

!MauiKeyMap methodsFor: 'hot keys' stamp: 'cmm 4/15/2008 22:35'!
keyForComeToFront
	^ self keyFor: #keyForComeToFront! !

!MauiKeyMap methodsFor: 'hot keys' stamp: 'cmm 4/15/2008 22:35'!
keyForComeToFront: aCharacter
	^ self
		keyFor: #keyForComeToFront
		is: aCharacter! !

!MauiKeyMap methodsFor: 'hot keys' stamp: 'cmm 4/15/2008 22:35'!
keyForContextCommands
	^ self keyFor: #keyForContextCommands! !

!MauiKeyMap methodsFor: 'hot keys' stamp: 'cmm 4/15/2008 22:35'!
keyForContextCommands: aCharacter
	^ self
		keyFor: #keyForContextCommands
		is: aCharacter! !

!MauiKeyMap methodsFor: 'hot keys' stamp: 'cmm 4/15/2008 22:35'!
keyForDesignNewView
	^ self keyFor: #keyForDesignNewView! !

!MauiKeyMap methodsFor: 'hot keys' stamp: 'cmm 4/15/2008 22:35'!
keyForDesignNewView: aCharacter
	^ self
		keyFor: #keyForDesignNewView
		is: aCharacter! !

!MauiKeyMap methodsFor: 'hot keys' stamp: 'cmm 4/15/2008 22:35'!
keyForEdit
	^ self keyFor: #keyForEdit! !

!MauiKeyMap methodsFor: 'hot keys' stamp: 'cmm 4/15/2008 22:35'!
keyForEdit: aCharacter
	^ self
		keyFor: #keyForEdit
		is: aCharacter! !

!MauiKeyMap methodsFor: 'hot keys' stamp: 'cmm 4/15/2008 22:35'!
keyForExploreMorph
	^ self keyFor: #keyForExploreMorph! !

!MauiKeyMap methodsFor: 'hot keys' stamp: 'cmm 4/15/2008 22:35'!
keyForExploreMorph: aCharacter
	^ self
		keyFor: #keyForExploreMorph
		is: aCharacter! !

!MauiKeyMap methodsFor: 'hot keys' stamp: 'cmm 4/15/2008 22:35'!
keyForExploreObject
	^ self keyFor: #keyForExploreObject! !

!MauiKeyMap methodsFor: 'hot keys' stamp: 'cmm 4/15/2008 22:35'!
keyForExploreObject: aCharacter
	^ self
		keyFor: #keyForExploreObject
		is: aCharacter! !

!MauiKeyMap methodsFor: 'hot keys' stamp: 'cmm 4/15/2008 22:35'!
keyForFindMessage
	^ self keyFor: #keyForFindMessage! !

!MauiKeyMap methodsFor: 'hot keys' stamp: 'cmm 4/15/2008 22:35'!
keyForFindMessage: aCharacter
	^ self
		keyFor: #keyForFindMessage
		is: aCharacter! !

!MauiKeyMap methodsFor: 'hot keys' stamp: 'cmm 4/15/2008 22:35'!
keyForFindObject
	^ self keyFor: #keyForFindObject! !

!MauiKeyMap methodsFor: 'hot keys' stamp: 'cmm 4/15/2008 22:35'!
keyForFindObject: aCharacter
	^ self
		keyFor: #keyForFindObject
		is: aCharacter! !

!MauiKeyMap methodsFor: 'hot keys' stamp: 'cmm 4/15/2008 22:35'!
keyForFocusShift
	^ self keyFor: #keyForFocusShift! !

!MauiKeyMap methodsFor: 'hot keys' stamp: 'cmm 4/15/2008 22:35'!
keyForFocusShift: aCharacter
	^ self
		keyFor: #keyForFocusShift
		is: aCharacter! !

!MauiKeyMap methodsFor: 'hot keys' stamp: 'cmm 4/15/2008 22:35'!
keyForGrab
	^ self keyFor: #keyForGrab! !

!MauiKeyMap methodsFor: 'hot keys' stamp: 'cmm 4/15/2008 22:35'!
keyForGrab: aCharacter
	^ self
		keyFor: #keyForGrab
		is: aCharacter! !

!MauiKeyMap methodsFor: 'hot keys' stamp: 'cmm 1/14/2010 21:43'!
keyForGrabFocusedObject
	^ self keyFor: #keyForGrabFocusedObject! !

!MauiKeyMap methodsFor: 'hot keys' stamp: 'cmm 1/14/2010 21:44'!
keyForGrabFocusedObject: aCharacter
	^ self
		keyFor: #keyForGrabFocusedObject
		is: aCharacter! !

!MauiKeyMap methodsFor: 'hot keys' stamp: 'cmm 4/15/2008 22:35'!
keyForHalos
	^ self keyFor: #keyForHalos! !

!MauiKeyMap methodsFor: 'hot keys' stamp: 'cmm 4/15/2008 22:35'!
keyForHalos: aCharacter
	^ self
		keyFor: #keyForHalos
		is: aCharacter! !

!MauiKeyMap methodsFor: 'hot keys' stamp: 'cmm 4/15/2008 22:35'!
keyForLabel
	^ self keyFor: #keyForLabel! !

!MauiKeyMap methodsFor: 'hot keys' stamp: 'cmm 4/15/2008 22:35'!
keyForLabel: aCharacter
	^ self
		keyFor: #keyForLabel
		is: aCharacter! !

!MauiKeyMap methodsFor: 'hot keys' stamp: 'cmm 4/15/2008 22:35'!
keyForMakeWord
	^ self keyFor: #keyForMakeWord! !

!MauiKeyMap methodsFor: 'hot keys' stamp: 'cmm 4/15/2008 22:35'!
keyForMakeWord: aCharacter
	^ self
		keyFor: #keyForMakeWord
		is: aCharacter! !

!MauiKeyMap methodsFor: 'hot keys' stamp: 'cmm 4/15/2008 22:35'!
keyForOpenHierarchy
	^ self keyFor: #keyForOpenHierarchy! !

!MauiKeyMap methodsFor: 'hot keys' stamp: 'cmm 4/15/2008 22:35'!
keyForOpenHierarchy: aCharacter
	^ self
		keyFor: #keyForOpenHierarchy
		is: aCharacter! !

!MauiKeyMap methodsFor: 'hot keys' stamp: 'cmm 4/15/2008 22:35'!
keyForOpenPackage
	^ self keyFor: #keyForOpenPackage! !

!MauiKeyMap methodsFor: 'hot keys' stamp: 'cmm 4/15/2008 22:35'!
keyForOpenPackage: aCharacter
	^ self
		keyFor: #keyForOpenPackage
		is: aCharacter! !

!MauiKeyMap methodsFor: 'hot keys' stamp: 'cmm 12/15/2008 22:18'!
keyForOpenPreferences
	^ self keyFor: #keyForOpenPreferences! !

!MauiKeyMap methodsFor: 'hot keys' stamp: 'cmm 12/15/2008 22:17'!
keyForOpenPreferences: aCharacter
	^ self
		keyFor: #keyForOpenPreferences
		is: aCharacter! !

!MauiKeyMap methodsFor: 'hot keys-string editor' stamp: 'cmm 8/19/2008 21:10'!
keyForRefresh
	^ self keyFor: #keyForRefresh! !

!MauiKeyMap methodsFor: 'hot keys-string editor' stamp: 'cmm 8/19/2008 21:11'!
keyForRefresh: aCharacter
	^ self
		keyFor: #keyForRefresh
		is: aCharacter! !

!MauiKeyMap methodsFor: 'hot keys' stamp: 'cmm 4/15/2008 22:35'!
keyForRemove
	^ self keyFor: #keyForRemove! !

!MauiKeyMap methodsFor: 'hot keys' stamp: 'cmm 4/15/2008 22:35'!
keyForRemove: aCharacter
	^ self
		keyFor: #keyForRemove
		is: aCharacter! !

!MauiKeyMap methodsFor: 'hot keys' stamp: 'cmm 3/30/2009 14:43'!
keyForRemoveWidget
	^ self keyFor: #keyForRemoveWidget! !

!MauiKeyMap methodsFor: 'hot keys' stamp: 'cmm 3/30/2009 14:43'!
keyForRemoveWidget: aCharacter
	^ self
		keyFor: #keyForRemoveWidget
		is: aCharacter! !

!MauiKeyMap methodsFor: 'hot keys' stamp: 'cmm 4/15/2008 22:35'!
keyForSave
	^ self keyFor: #keyForSave! !

!MauiKeyMap methodsFor: 'hot keys' stamp: 'cmm 4/15/2008 22:35'!
keyForSave: aCharacter
	^ self
		keyFor: #keyForSave
		is: aCharacter! !

!MauiKeyMap methodsFor: 'hot keys' stamp: 'cmm 6/21/2008 23:44'!
keyForSendAllToBack
	^ self keyFor: #keyForSendAllToBack! !

!MauiKeyMap methodsFor: 'hot keys' stamp: 'cmm 6/21/2008 23:51'!
keyForSendAllToBack: aCharacter
	^ self
		keyFor: #keyForSendAllToBack
		is: aCharacter! !

!MauiKeyMap methodsFor: 'hot keys' stamp: 'cmm 4/15/2008 22:35'!
keyForSendToBack
	^ self keyFor: #keyForSendToBack! !

!MauiKeyMap methodsFor: 'hot keys' stamp: 'cmm 4/15/2008 22:35'!
keyForSendToBack: aCharacter
	^ self
		keyFor: #keyForSendToBack
		is: aCharacter! !

!MauiKeyMap methodsFor: 'hot keys' stamp: 'cmm 4/15/2008 22:35'!
keyForToggleLabelled
	^ self keyFor: #keyForToggleLabelled! !

!MauiKeyMap methodsFor: 'hot keys' stamp: 'cmm 4/15/2008 22:35'!
keyForToggleLabelled: aCharacter
	^ self
		keyFor: #keyForToggleLabelled
		is: aCharacter! !

!MauiKeyMap methodsFor: 'hot keys' stamp: 'cmm 4/15/2008 22:35'!
keyForToolsAccess
	^ self keyFor: #keyForToolsAccess! !

!MauiKeyMap methodsFor: 'hot keys' stamp: 'cmm 4/15/2008 22:35'!
keyForToolsAccess: aCharacter
	^ self
		keyFor: #keyForToolsAccess
		is: aCharacter! !

!MauiKeyMap methodsFor: 'hot keys' stamp: 'cmm 4/15/2008 22:35'!
keyForViewMethod
	^ self keyFor: #keyForViewMethod! !

!MauiKeyMap methodsFor: 'hot keys' stamp: 'cmm 4/15/2008 22:35'!
keyForViewMethod: aCharacter
	^ self
		keyFor: #keyForViewMethod
		is: aCharacter! !

!MauiKeyMap methodsFor: 'hot keys-string editor' stamp: 'cmm 4/15/2008 22:40'!
modifierForAccept
	^ self keyFor: #modifierForAccept! !

!MauiKeyMap methodsFor: 'hot keys-string editor' stamp: 'cmm 4/15/2008 22:40'!
modifierForAccept: aCharacter
	^ self
		keyFor: #modifierForAccept
		is: aCharacter! !

!MauiKeyMap methodsFor: 'copying' stamp: 'cmm 11/9/2009 21:32'!
veryDeepInner: aDeepCopier 
	super veryDeepInner: aDeepCopier.
	functions := functions veryDeepCopyWith: aDeepCopier! !

MaObject subclass: #MauiListSpec
	instanceVariableNames: 'widths alignment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Widgets'!

!MauiListSpec methodsFor: 'column access' stamp: 'cmm 4/29/2009 10:34'!
addColumn
	^ self addColumn: 1! !

!MauiListSpec methodsFor: 'column access' stamp: 'cmm 4/29/2009 10:35'!
addColumn: width 
	^ widths add: width! !

!MauiListSpec methodsFor: 'private' stamp: 'cmm 6/20/2012 11:23'!
adjustColumnsWidthsIn: aMauiDomainMorph 
	self columnFractions in: 
		[ : columnFractions | 
		self widths withIndexDo: 
			[ : eachColumn : x | 
			x <= aMauiDomainMorph submorphs size ifTrue: 
				[ (aMauiDomainMorph submorphs at: x) layoutFrame: (LayoutFrame new
						leftFraction: (columnFractions at: x) ;
						rightFraction: (columnFractions at: x + 1) ;
						rightOffset: (x<self widths size ifTrue: [-2] ifFalse:[0]) ;
						leftOffset: (x>1 ifTrue: [2] ifFalse: [0]) ;
						yourself) ] ] ]! !

!MauiListSpec methodsFor: 'accessing' stamp: 'cmm 8/14/2007 15:43'!
alignment
	^ alignment! !

!MauiListSpec methodsFor: 'accessing' stamp: 'cmm 8/15/2007 16:41'!
alignment: aSymbol
	"The alignment within the table cells.  Specify any of #(center topLeft topRight bottomLeft bottomRight topCenter leftCenter rightCenter bottomCenter)."
	alignment := aSymbol! !

!MauiListSpec methodsFor: 'private' stamp: 'cmm 12/8/2009 10:38'!
columnFractions
	"Answer the left column positions based on their weights.  The first column always starts at 0."
	"The 1.05 multiplier allows enough of a right-margin to keep the right-edge of the right-most from being truncated."
	^ self totalOfWeights in: [ : total | self columnPositions collect: [ : each | each / total asFloat ] ]! !

!MauiListSpec methodsFor: 'private' stamp: 'cmm 4/29/2009 10:36'!
columnPositions
	"Answer the weighted positions for each column based on my widths weights.  The first column is always at position 0."
	| answer |
	answer := OrderedCollection with: 0.
	widths
		inject: 0
		into: [ : sum : each | answer add: sum + each ].
	^ answer! !

!MauiListSpec methodsFor: 'copying' stamp: 'cmm 6/8/2009 18:47'!
copyMerged: columnRange 
	"Answer a copy of the receiver with columns in columnRange merged."
	| answer |
	answer := self veryDeepCopy.
	^ answer
		mergeColumns: columnRange ;
		yourself! !

!MauiListSpec methodsFor: 'initialize-release' stamp: 'cmm 4/29/2009 10:39'!
initialize
	super initialize.
	alignment := #leftCenter.
	widths := OrderedCollection new! !

!MauiListSpec methodsFor: 'copying' stamp: 'cmm 6/8/2009 19:05'!
mergeColumns: columnInterval 
	| mergedWidth newWidths |
	newWidths := OrderedCollection new.
	"Columns to the left of the merged columns."
	1 
		to: columnInterval first - 1
		do: [ : columnIndex | newWidths add: (widths at: columnIndex) ].
	"Merge columns into one wide one."
	mergedWidth := columnInterval 
		inject: 0
		into: [ : sum : columnIndex | sum + (widths at: columnIndex) ].
	newWidths add: mergedWidth.
	"Columns to the right of the merged columns."
	columnInterval last + 1 
		to: self numberOfColumns
		do: [ : columnIndex | newWidths add: (widths at: columnIndex) ].
	widths := newWidths! !

!MauiListSpec methodsFor: 'column access' stamp: 'cmm 4/29/2009 10:30'!
numberOfColumns
	^ widths size! !

!MauiListSpec methodsFor: 'private' stamp: 'cmm 4/29/2009 10:30'!
totalOfWeights
	^ widths sum! !

!MauiListSpec methodsFor: 'copying' stamp: 'cmm 4/29/2009 10:38'!
veryDeepInner: aDeepCopier 
	super veryDeepInner: aDeepCopier.
	widths := widths veryDeepCopyWith: aDeepCopier! !

!MauiListSpec methodsFor: 'accessing' stamp: 'cmm 4/29/2009 10:37'!
widthAt: columnIndex put: width 
	widths 
		at: columnIndex
		put: width! !

!MauiListSpec methodsFor: 'accessing' stamp: 'cmm 4/29/2009 10:31'!
widths
	^ widths! !

MaObject subclass: #MauiOptionalParametersStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Messages'!

!MauiOptionalParametersStrategy commentStamp: 'cmm 7/21/2003 21:43' prior: 0!
I implement hook methods called by Maui at various points so that your overriding classes can give you the visual behavior you desire.!

MauiOptionalParametersStrategy subclass: #MauiClickAndPickParameterStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Messages'!

!MauiClickAndPickParameterStrategy commentStamp: 'cmm 12/22/2003 23:41' prior: 0!
Behaves like your old MEGA-Check "selector" dialogs.  :-)!

!MauiClickAndPickParameterStrategy methodsFor: 'as yet unclassified' stamp: 'cmm 8/8/2004 21:26'!
parameterDropped: aMorphOrMauiMorph into: aMauiParameterHolderMorph

	aMauiParameterHolderMorph ensureNoOptionalParametersMorph! !

!MauiClickAndPickParameterStrategy methodsFor: 'as yet unclassified' stamp: 'cmm 12/29/2009 11:36'!
selectUsing: aMauiParameterHolderMorph 
	| comboBox |
	comboBox := aMauiParameterHolderMorph optionalParametersMorph.
	comboBox
		position: (aMauiParameterHolderMorph localPointToGlobal: aMauiParameterHolderMorph position) + (0 @ aMauiParameterHolderMorph height) ;
		mauiEnsureOnScreen.
	comboBox openInWorld deleteOnMouseLeave! !

MauiOptionalParametersStrategy subclass: #MauiCycleParametersStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Messages'!

!MauiCycleParametersStrategy commentStamp: 'cmm 6/28/2007 09:16' prior: 0!
This strategy is primarily used for checkboxes, but is general enough to cycle any number of objects.!

!MauiCycleParametersStrategy methodsFor: 'overriding' stamp: 'cmm 6/28/2007 10:35'!
customize: aMauiMessageMorph 
	"resultDomainMorph is the result of a message invocation and is owned by a ParameterHolderMorph (as in a getter/setter), subclasses may override."
	aMauiMessageMorph resultMorph redButtonMessage: 
		(MauiMessage 
			receiver: self
			selector: #selectUsing:
			arguments: {  aMauiMessageMorph resultHolderMorph  })! !

!MauiCycleParametersStrategy methodsFor: 'private' stamp: 'cmm 12/25/2003 21:54'!
optionalParameterAfter: anotherOptionalValue using: aMauiParameterHolder

	aMauiParameterHolder optionalParameters isEmpty ifTrue: [ ^nil ].
	(aMauiParameterHolder optionalParameters notEmpty
		and: [ aMauiParameterHolder optionalParameters last = anotherOptionalValue ])
		ifTrue:
			[ ^aMauiParameterHolder optionalParameters first ].
	^aMauiParameterHolder optionalParameters
		after: anotherOptionalValue
		ifAbsent:
			[ aMauiParameterHolder optionalParameters isEmptyOrNil
				ifTrue: [ nil ]
				ifFalse: [ aMauiParameterHolder optionalParameters first ] ]! !

!MauiCycleParametersStrategy methodsFor: 'overriding' stamp: 'cmm 7/12/2007 14:16'!
selectUsing: aMauiParameterHolderMorph 
	aMauiParameterHolderMorph dropParameter: 
		(self 
			optionalParameterAfter: aMauiParameterHolderMorph submorphs first object
			using: aMauiParameterHolderMorph) asMauiMorph! !

MauiOptionalParametersStrategy subclass: #MauiListSelectionStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Messages'!

!MauiListSelectionStrategy commentStamp: 'cmm 12/22/2003 23:43' prior: 0!
This one behaves like a listbox with a single, selectable item in it.!

!MauiListSelectionStrategy methodsFor: 'overrides' stamp: 'cmm 1/7/2005 00:01'!
addOptions: aMauiParameterHolderMorph

	aMauiParameterHolderMorph addMorphBack: aMauiParameterHolderMorph optionalParametersMorph! !

!MauiListSelectionStrategy methodsFor: 'overrides' stamp: 'cmm 1/7/2005 00:04'!
initializeUsing: aMauiParameterHolderMorph

	aMauiParameterHolderMorph layoutInset: 0@0.
	self addOptions: aMauiParameterHolderMorph! !

!MauiListSelectionStrategy methodsFor: 'overrides' stamp: 'cmm 12/25/2003 12:16'!
noteNewOwner: aMauiMessageMorph for: aMauiParameterHolderMorph

	self addOptions: aMauiParameterHolderMorph! !

!MauiListSelectionStrategy methodsFor: 'overrides' stamp: 'cmm 12/22/2003 23:51'!
selectUsing: aMauiParameterHolder

	"nothing to do for this guy, since he always has his selections presented."! !

!MauiOptionalParametersStrategy methodsFor: 'override' stamp: 'cmm 6/28/2007 10:44'!
customize: aMauiMessageMorph
	"Allow me to customize aMauiMessageMorph after its invocation."! !

!MauiOptionalParametersStrategy methodsFor: 'override' stamp: 'cmm 12/25/2003 12:17'!
initializeUsing: aMauiParameterHolderMorph
	"called when aMauiParameterHolderMorph's optional-parameters strategy has been set or changed."! !

!MauiOptionalParametersStrategy methodsFor: 'override' stamp: 'cmm 12/24/2003 14:51'!
noteNewOwner: aMauiMessageMorph for: aMauiParameterHolderMorph
	"optional subclass responsibility"! !

!MauiOptionalParametersStrategy methodsFor: 'override' stamp: 'cmm 12/25/2003 19:59'!
parameterDropped: aMorphOrMauiMorph into: aMauiParameterHolderMorph
	"optional subclass responsibility"! !

!MauiOptionalParametersStrategy methodsFor: 'override' stamp: 'cmm 7/31/2003 23:47'!
selectUsing: aMauiParameterHolder

	self subclassResponsibility! !

MaObject subclass: #MauiPreferences
	instanceVariableNames: 'values target'
	classVariableNames: 'GlobalPreferences'
	poolDictionaries: ''
	category: 'Maui-Core-Domain'!

!MauiPreferences class methodsFor: 'accessing' stamp: 'cmm 7/1/2003 00:34'!
global

	^GlobalPreferences! !

!MauiPreferences class methodsFor: 'initialize' stamp: 'cmm 12/21/2008 20:17'!
initialize
	GlobalPreferences := self new.	 "it's gotta be set before we can initializeGlobalValues."
	GlobalPreferences initializeGlobalValues! !

!MauiPreferences class methodsFor: 'create' stamp: 'cmm 8/11/2004 21:56'!
target: anObject
	"anObject should be aMauiMorph, aMauiFamily (or nil if initializing the global)."

	^ self new
		target: anObject ;
		yourself! !

!MauiPreferences methodsFor: 'dependents' stamp: 'cmm 12/10/2008 21:51'!
addDependent: aMauiPreferencesMorph 
	super addDependent: aMauiPreferencesMorph.
	(self specifies: #colorScheme) ifTrue: [ self colorScheme addDependent: aMauiPreferencesMorph ]! !

!MauiPreferences methodsFor: 'usability' stamp: 'cmm 2/6/2008 16:26'!
autoResizeEditor
	"Whether MauiPage editors should automatically resize according to the quantity of contents."
	^ values 
		at: #autoResizeEditor
		ifAbsent: [ self nextPreferences autoResizeEditor ]! !

!MauiPreferences methodsFor: 'usability' stamp: 'cmm 2/6/2008 16:26'!
autoResizeEditor: aBoolean 
	"Whether MauiPage editors should automatically resize according to the quantity of contents."
	self 
		preferred: #autoResizeEditor
		is: aBoolean! !

!MauiPreferences methodsFor: 'basic prototypes' stamp: 'cmm 5/1/2009 15:37'!
blockMorph
	"The MauiBlockMorph prototype used when new messages are created."
	^ values 
		at: #blockMorph
		ifAbsent: [ self nextPreferences blockMorph ]! !

!MauiPreferences methodsFor: 'basic prototypes' stamp: 'cmm 5/1/2009 15:37'!
blockMorph: aMauiBlockMorph 
	"The MauiBlockMorph prototype used when new MauiBlocks are created."
	aMauiBlockMorph
		family: nil ;
		resetReceiver.
	self 
		preferred: #blockMorph
		is: aMauiBlockMorph! !

!MauiPreferences methodsFor: 'colors' stamp: 'cmm 4/17/2008 09:47'!
colorScheme
	"Answer the palette of colors used by Maui panels."
	^ values
		at: #colorScheme 
		ifAbsent: [ self nextPreferences colorScheme ]! !

!MauiPreferences methodsFor: 'colors' stamp: 'cmm 12/3/2004 10:26'!
colorScheme: aMauiColorScheme
	"The MauiColorScheme used to specify the default colors of MauiMorphs."
	self
		preferred: #colorScheme
		is: aMauiColorScheme! !

!MauiPreferences methodsFor: 'usability' stamp: 'cmm 8/11/2004 21:29'!
connectObjects

	MauiWorld hasConnectors ifFalse: [ ^ false].
	^ values 
		at: #connectObjects
		ifAbsent: [ self nextPreferences connectObjects ]! !

!MauiPreferences methodsFor: 'usability' stamp: 'cmm 8/12/2004 00:40'!
connectObjects: aBoolean
	"If true and Connectors is present, multiple views of the same object will be connected with a line."

	self
		preferred: #connectObjects
		is: aBoolean! !

!MauiPreferences methodsFor: 'basic prototypes' stamp: 'cmm 11/23/2010 21:39'!
connector
	"An actual NCConnector prototype cloned to generate the connecting lines between morphs."
	^ values 
		at: #connector
		ifAbsent: 
			[ self hasNextPreferences 
				ifTrue: [ self nextPreferences connector ]
				ifFalse: 
					[ "Lazily instantiate default connector."
					MauiWorld hasConnectors ifTrue: 
						[ | connector |
						self connector: (connector := (Smalltalk classNamed: #NCAAConnectorMorph) new
								toggleSmoothing ;
								lineWidth: 3 ;
"								borderColor: (self colorScheme highlightColor alpha: 0.5) ;"
lineColor: (self colorScheme highlightColor alpha: 0.3) ;
								lock ;
"								color: (self colorScheme highlightColor alpha: 0.5) ;"
								yourself).
						connector ] ] ]! !

!MauiPreferences methodsFor: 'basic prototypes' stamp: 'cmm 12/3/2004 10:25'!
connector: aNCConnectorMorph
	"An actual NCConnector prototype cloned to generate the connecting lines."
	self 
		preferred: #connector 
		is: aNCConnectorMorph! !

!MauiPreferences methodsFor: 'basic prototypes' stamp: 'cmm 12/11/2008 14:44'!
contentDomainMorph
	"Alternate prototype MauiDomainMorph used for renderings of pure content, like the #word view or #panel view of a MauiCollectionMorph."
	^ values 
		at: #contentDomainMorph
		ifAbsent: [ self nextPreferences contentDomainMorph ]! !

!MauiPreferences methodsFor: 'basic prototypes' stamp: 'cmm 3/18/2009 10:36'!
contentDomainMorph: aMauiDomainMorph 
	"Alternate prototype MauiDomainMorph used for renderings of pure content, like the #word view or #panel view of a MauiCollectionMorph."
	aMauiDomainMorph
		resetObject ;
		family: nil.
	self 
		preferred: #contentDomainMorph
		is: aMauiDomainMorph! !

!MauiPreferences methodsFor: 'basic prototypes' stamp: 'cmm 12/10/2008 22:49'!
domainMorph
	"The MauiDomainMorph prototype used for new objects."
	^ values 
		at: #domainMorph
		ifAbsent: [ self nextPreferences domainMorph ]! !

!MauiPreferences methodsFor: 'basic prototypes' stamp: 'cmm 3/18/2009 10:35'!
domainMorph: aMauiDomainMorph 
	"The MauiMessageMorph prototype used when new domain panels are created."
	aMauiDomainMorph
		resetObject ;
		family: nil.
	self 
		preferred: #domainMorph
		is: aMauiDomainMorph! !

!MauiPreferences methodsFor: 'basic prototypes' stamp: 'cmm 12/11/2008 14:48'!
embeddedDomainMorph
	"Alternate prototype MauiDomainMorph used for places where compactness is desired, such as embedded panels and #word view morphs."
	^ values 
		at: #embeddedDomainMorph
		ifAbsent: [ self nextPreferences embeddedDomainMorph ]! !

!MauiPreferences methodsFor: 'basic prototypes' stamp: 'cmm 3/18/2009 10:36'!
embeddedDomainMorph: aMauiDomainMorph 
	"Alternate prototype MauiDomainMorph used for the look when embedded in another MauiDomainMorph.  Typically, we want to reduce the layoutInset and make borders 'inset' instead of 'raised'."
	aMauiDomainMorph
		resetObject ;
		family: nil.
	self 
		preferred: #embeddedDomainMorph
		is: aMauiDomainMorph! !

!MauiPreferences methodsFor: 'private' stamp: 'cmm 4/14/2008 21:53'!
ensurePreferences
	"The global preferences acts as both the 'chain-link' to the next preferences *as well as* the preferences themselves, this method is part of the role of the chain-link that contains the preference.  The other two links are MauiFamily and MauiMorph."
	^ self! !

!MauiPreferences methodsFor: 'private' stamp: 'cmm 8/11/2004 10:43'!
hasNextPreferences

	^ target notNil! !

!MauiPreferences methodsFor: 'testing' stamp: 'cmm 4/14/2008 21:19'!
hasValues
	^ values notEmpty! !

!MauiPreferences methodsFor: 'icons' stamp: 'cmm 10/7/2007 22:28'!
iconSet
	"Answer the MauiIconSet that contains the built-in icon data."
	^ values 
		at: #iconSet
		ifAbsent: [ self nextPreferences iconSet ]! !

!MauiPreferences methodsFor: 'icons' stamp: 'cmm 10/8/2007 12:05'!
iconSet: aMauiIconSet
	"The MauiIconSet used to specify the default icons of MauiMorphs."
	self
		preferred: #iconSet
		is: aMauiIconSet! !

!MauiPreferences methodsFor: 'accessing' stamp: 'cmm 4/15/2008 09:52'!
inherit: preferenceSymbol 
	"Ensure I am not overriding preferenceSymbol with my own value and inherit it from my super preferences."
	target ifNil: 
		[ MauiUserError signal: 'This is the global preference, there are no other preferences to inherit from.' ].
	self removePreferred: preferenceSymbol! !

!MauiPreferences methodsFor: 'initializing' stamp: 'cmm 8/8/2004 20:36'!
initialize

	super initialize.
	values := Dictionary new! !

!MauiPreferences methodsFor: 'initializing' stamp: 'cmm 11/22/2010 09:58'!
initializeColors
	self colorScheme: MauiColorScheme light! !

!MauiPreferences methodsFor: 'initializing' stamp: 'cmm 1/14/2009 08:56'!
initializeGlobalValues
	self
		initializeColors ;
		initializeIcons ;
		initializeUsability ;
		initializeHotKeys ;
		initializeResources ;
		initializePrototypes ;
		initializeLabelling! !

!MauiPreferences methodsFor: 'initializing' stamp: 'cmm 1/14/2010 21:44'!
initializeHotKeys
	self keyMap: MauiKeyMap new.
	"MauiMorphs"
	self keyMap
		keyForRemove: $x ;
		keyForRemoveWidget: $X ;
		keyForContextCommands: Character escape ;
		keyForAnotherView: $v ;
		keyForOpenPreferences: $r ;
		keyForMakeWord: $w ;
		keyForToolsAccess: $t ;
		keyForFocusShift: Character tab ;
		keyForOpenHierarchy: $c ;
		keyForOpenPackage: $p ;
		keyForExploreObject: $i ;
		keyForExploreMorph: $m ;
		keyForHalos: $h ;
		keyForFindObject: $f ;
		keyForFindMessage: $b ;
		keyForLabel: $l ;
		keyForToggleLabelled: $L ;
		keyForGrab: $g ;
		keyForGrabFocusedObject: $G ;
		keyForSendToBack: $- ;
		keyForSendAllToBack: $_ ;
		keyForComeToFront: $  ;
		keyForDesignNewView: $n.
	"MauiMessageMorphs"
	self keyMap
		keyForBrowseSenders: $n ;
		keyForViewMethod: $m ;
		keyForEdit: $e ;
		keyForSave: $s ;
		keyForRefresh: $r.
	"String-editor"
	self keyMap
		keyForAccept: Character cr ;
		modifierForAccept: false "no shift"! !

!MauiPreferences methodsFor: 'initializing' stamp: 'cmm 10/7/2007 22:29'!
initializeIcons
	self iconSet: MauiIconSet new! !

!MauiPreferences methodsFor: 'initializing' stamp: 'cmm 6/21/2012 11:16'!
initializeLabelling
	self
		 label:
			(StringMorph
				contents: String empty
				font: nil
				emphasis: TextEmphasis bold emphasisCode) ;
		 useCloseBoxes: true! !

!MauiPreferences methodsFor: 'initializing' stamp: 'cmm 11/22/2010 10:31'!
initializePrototypes
	self
		parameterHolderMorph: (MauiParameterHolderMorph new
				borderWidth: 3 ;
				borderColor: #complexInset ;
				layoutInset: 5 @ 1 ;
				yourself) ;
		domainMorph: ((MauiMorph newFor: MauiPrototype current)
				layoutInset: 2 ;
				borderWidth: 3 ;
				cornerStyle: #rounded ;
				yourself) ;
		embeddedDomainMorph: ((MauiMorph newFor: MauiPrototype current)
				layoutInset: 1 ;
				borderWidth: 3 ;
				borderColor: (Color white alpha: 0.7) ;
				yourself) ;
		contentDomainMorph: ((MauiMorph newFor: MauiPrototype current)
				layoutInset: 0 ;
				borderWidth: 1 ;
				borderColor: Color transparent ;
				yourself) ;
		messageMorph: ((MauiMessageMorph 
				receiver: MauiPrototype current
				selector: #yourself)
				borderWidth: 1 ;
				layoutInset: 4 @ 0 ;
				borderColor: Color transparent ;
				yourself) ;
		blockMorph: ((MauiBlockMorph 
				receiver: MauiPrototype current
				block: [ : rcvr | nil ])
				borderWidth: 1 ;
				borderColor: Color transparent ;
				yourself)! !

!MauiPreferences methodsFor: 'initializing' stamp: 'cmm 8/8/2004 20:27'!
initializeResources

	self resourcePath: ''! !

!MauiPreferences methodsFor: 'initializing' stamp: 'cmm 6/21/2012 16:32'!
initializeUsability
	self
		useMenuBalloonHelp: true ;
		connectObjects: true ;
		scalePoint: 0.25 @ 0.25 ;
		transitionDuration: 0 ;
		autoResizeEditor: false! !

!MauiPreferences methodsFor: 'testing' stamp: 'cmm 8/11/2004 22:54'!
isGlobal

	^ self == MauiPreferences global! !

!MauiPreferences methodsFor: 'hot keys' stamp: 'cmm 4/17/2008 09:48'!
keyMap
	"Answer the keyboard keys used to invoke commands on objects or messages."
	^ values 
		at: #keyMap
		ifAbsent: [ self nextPreferences keyMap ]! !

!MauiPreferences methodsFor: 'hot keys' stamp: 'cmm 4/15/2008 22:41'!
keyMap: aMauiKeyMap 
	self 
		preferred: #keyMap
		is: aMauiKeyMap! !

!MauiPreferences methodsFor: 'basic prototypes' stamp: 'cmm 8/8/2004 20:33'!
label
	"I am the default Morph used for message and object labels."

	^ values
		at: #label
		ifAbsent: [ self nextPreferences label ]! !

!MauiPreferences methodsFor: 'basic prototypes' stamp: 'cmm 8/12/2004 00:36'!
label: aMauiStringMorph
	"I am the default Morph used for message and object labels."

	self
		preferred: #label
		is: aMauiStringMorph! !

!MauiPreferences methodsFor: 'private' stamp: 'cmm 7/31/2003 17:28'!
loadSketch: filenameString

	| sketch inputStream |
	inputStream := FileStream readOnlyFileNamed: self resourcePath, filenameString.
	sketch := inputStream fileInObjectAndCode.
	inputStream close.
	^sketch! !

!MauiPreferences methodsFor: 'private' stamp: 'cmm 10/13/2012 17:19'!
maWantsPreSerialization 
	^ true! !

!MauiPreferences methodsFor: 'basic prototypes' stamp: 'cmm 12/9/2008 17:30'!
messageMorph
	"The MauiMessageMorph prototype used when new messages are created."
	^ values 
		at: #messageMorph
		ifAbsent: [ self nextPreferences messageMorph ]! !

!MauiPreferences methodsFor: 'basic prototypes' stamp: 'cmm 3/18/2009 10:37'!
messageMorph: aMauiMessageMorph 
	"The MauiMessageMorph prototype used when new messages are created."
	aMauiMessageMorph
		family: nil ;
		resetReceiver.
	self 
		preferred: #messageMorph
		is: aMauiMessageMorph! !

!MauiPreferences methodsFor: 'private' stamp: 'cmm 8/11/2004 10:28'!
newOverrideFor: targetObject
	"Create a new set of preferences for targetObject that can override specific values of its nextPreferenceSource."

	^ MauiPreferences target: targetObject! !

!MauiPreferences methodsFor: 'accessing' stamp: 'cmm 4/14/2008 23:16'!
nextPreferenceSource
	"Answer the object from which I inherit preferences if I don't specify them myself."
	^ self target nextPreferenceSource! !

!MauiPreferences methodsFor: 'private' stamp: 'cmm 4/14/2008 22:22'!
nextPreferences

	^ target
		ifNil: [ MauiSoftwareError signal: 'no preference found' ]
		ifNotNil: [ target nextPreferenceSource ensurePreferences ]! !

!MauiPreferences methodsFor: 'accessing' stamp: 'cmm 4/15/2008 09:56'!
overridablePreferences
	^ self class global specifiedPreferences difference: self specifiedPreferences! !

!MauiPreferences methodsFor: 'accessing' stamp: 'cmm 6/8/2009 21:16'!
overridden: preferenceSelector 
	"If preferenceSelector has been previously overridden, answer that overridden preference, otherwise, override it and answer it."
	^ (self overrides: preferenceSelector) 
		ifTrue: [ self preferred: preferenceSelector ]
		ifFalse: [ self override: preferenceSelector ]! !

!MauiPreferences methodsFor: 'accessing' stamp: 'cmm 12/27/2008 14:44'!
override: preferenceSelector 
	"Override the preference specifed by preferenceSelector from my nextPreferenceSource."
	| answer |
	self isGlobal ifTrue: 
		[ MauiUserError signal: 'This is the global preference, there are no parent preferences to override.' ].
	"The value is initialized with the inherited value, which the user will then change."
	self 
		preferred: preferenceSelector
		is: (answer := (self preferred: preferenceSelector) veryDeepCopy).
	^ answer! !

!MauiPreferences methodsFor: 'testing' stamp: 'cmm 6/8/2009 21:14'!
overrides: preferenceSelector
	^ values includesKey: preferenceSelector! !

!MauiPreferences methodsFor: 'basic prototypes' stamp: 'cmm 12/10/2008 21:11'!
parameterHolderMorph
	"The MauiParameterHolderMorph prototype used when new messages are added to a MauiMorph."
	^ values 
		at: #parameterHolderMorph
		ifAbsent: [ self nextPreferences parameterHolderMorph ]! !

!MauiPreferences methodsFor: 'basic prototypes' stamp: 'cmm 3/18/2009 10:37'!
parameterHolderMorph: aMauiParameterHolderMorph 
	"The MauiParameterHolderMorph prototype used when new messages are added to a MauiMorph."
	aMauiParameterHolderMorph family: nil.
	self 
		preferred: #parameterHolderMorph
		is: aMauiParameterHolderMorph! !

!MauiPreferences methodsFor: 'usability' stamp: 'cmm 6/29/2007 13:05'!
preferenceOrMenuBalloonMessage: aString 
	^ self useMenuBalloonHelp ifTrue: [ aString ]! !

!MauiPreferences methodsFor: 'private' stamp: 'cmm 8/11/2004 22:03'!
preferences
	"This is a confusing method to have.  Since the global preferences acts as both the 'chain-link' to the next preferences *as well as* the preferences themselves, this method is part of the role of the chain-link that contains the preference.  The other two links are MauiFamily and MauiMorph."
	^ self! !

!MauiPreferences methodsFor: 'accessing' stamp: 'cmm 8/5/2004 15:55'!
preferred: preferenceSelector

	^ self perform: preferenceSelector! !

!MauiPreferences methodsFor: 'accessing' stamp: 'cmm 4/25/2008 17:00'!
preferred: preferenceSymbol is: anObject 
	anObject 
		ifNil: [ self removePreferred: preferenceSymbol ]
		ifNotNil: 
			[ values 
				at: preferenceSymbol
				put: anObject.
			self changed ]! !

!MauiPreferences methodsFor: 'private' stamp: 'cmm 2/20/2014 13:27'!
prototypePreferenceSelectors
	| usabilityCategory unaryMethods unarySelectors |
	"Use whatever category label is in, in case we ever rename the category."
	usabilityCategory := (self maOriginalClass >> #label) methodReference category.
	"Select the unary messages.."
	unaryMethods := (self maOriginalClass methodReferencesInCategory: usabilityCategory) select: [ : each | each selector isUnary ].
	"But this method, itself, is a unary in the usability category, so exclude it too."
	unarySelectors := (unaryMethods collect: [ : each | each selector ]) copyWithout: #specifiedPrototypePreferences.
	^ unarySelectors! !

!MauiPreferences methodsFor: 'private' stamp: 'cmm 4/25/2008 16:59'!
removePreferred: preferenceSymbol 
	values 
		removeKey: preferenceSymbol
		ifAbsent: 
			[ "ok"
			 ].
	self changed! !

!MauiPreferences methodsFor: 'resources' stamp: 'cmm 8/8/2004 20:27'!
resourcePath

	^ values 
		at: #resourcePath
		ifAbsent: [ self nextPreferences resourcePath ]! !

!MauiPreferences methodsFor: 'resources' stamp: 'cmm 8/12/2004 00:40'!
resourcePath: aString

	self
		preferred: #resourcePath
		is: aString! !

!MauiPreferences methodsFor: 'usability' stamp: 'cmm 4/13/2008 17:27'!
scalePoint
	"A point between 0.1 and 1.0 used to scale-down the size of the sketch."
	^ values 
		at: #scalePoint
		ifAbsent: [ self nextPreferences scalePoint ]! !

!MauiPreferences methodsFor: 'usability' stamp: 'cmm 4/13/2008 17:26'!
scalePoint: aPoint 
	"A point between 0.1 and 1.0 used to scale-down the size of the sketch."
	self 
		preferred: #scalePoint
		is: aPoint! !

!MauiPreferences methodsFor: 'accessing' stamp: 'cmm 8/11/2004 22:19'!
sourceOfPreference: preferenceSymbol
	"Answers the MauiPreferences that specifies: preferenceSymbol."
	^ (self specifies: preferenceSymbol)
		ifTrue: [ self ]
		ifFalse: [ self nextPreferences sourceOfPreference: preferenceSymbol ]! !

!MauiPreferences methodsFor: 'accessing' stamp: 'cmm 4/15/2008 09:56'!
specifiedPreferences
	^ values keys asSortedCollection! !

!MauiPreferences methodsFor: 'accessing' stamp: 'cmm 4/16/2008 16:52'!
specifiedPrototypePreferences
	"Answer the preferences in the 'basic prototypes' category that have been overridden for my #target."
	^ self specifiedPreferences intersection: self prototypePreferenceSelectors! !

!MauiPreferences methodsFor: 'accessing' stamp: 'cmm 4/17/2008 10:26'!
specifiedUsabilityPreferences
	"Answer the usability preferences that have been overridden for my #target."
	^ self specifiedPreferences intersection: self usabilityPreferenceSelectors! !

!MauiPreferences methodsFor: 'accessing' stamp: 'cmm 8/8/2004 20:34'!
specifies: preferenceSymbol
	"Answers whether I have value for preferenceSymbol."

	^ values includesKey: preferenceSymbol! !

!MauiPreferences methodsFor: 'accessing' stamp: 'cmm 8/11/2004 18:10'!
target

	^ target ifNil: [ self "I should be the global prefs if I had no target" ]! !

!MauiPreferences methodsFor: 'initializing' stamp: 'cmm 8/11/2004 21:56'!
target: anObject
	"anObject will be either MauiMorph or a MauiFamily."

	target := anObject! !

!MauiPreferences methodsFor: 'usability' stamp: 'cmm 12/30/2004 00:04'!
transitionDuration
	^ values 
		at: #transitionDuration
		ifAbsent: [ self nextPreferences transitionDuration ]! !

!MauiPreferences methodsFor: 'usability' stamp: 'cmm 1/1/2005 14:46'!
transitionDuration: numberOfMilliseconds
	"Set the length of the cutsey transition effects, in milliseconds.  Try 100.  The effects run in the background so they don't affect responsiveness, but it is more work for the computer so a value of 0 is recommended for slow computers."

	self
		preferred: #transitionDuration
		is: numberOfMilliseconds! !

!MauiPreferences methodsFor: 'private' stamp: 'cmm 2/20/2014 13:27'!
usabilityPreferenceSelectors
	| usabilityCategory unaryMethods unarySelectors |
	"Use whatever category connectObjects is in, in case we ever rename the category."
	usabilityCategory := (self maOriginalClass >> #connectObjects) methodReference category.
	"Select the unary messages.."
	unaryMethods := (self maOriginalClass methodReferencesInCategory: usabilityCategory) select: [ : each | each selector isUnary ].
	"But this method, itself, is a unary in the usability category, so exclude it too."
	unarySelectors := (unaryMethods collect: [ : each | each selector ]) copyWithout: #specifiedUsabilityPreferences.
	^ unarySelectors! !

!MauiPreferences methodsFor: 'usability' stamp: 'cmm 6/15/2007 10:29'!
useCloseBoxes
	"Whether the upper-left 'X' should appear by default in all MauiDomainMorphs."
	^ values
		at: #useCloseBoxes
		ifAbsent: [ self nextPreferences useCloseBoxes ]! !

!MauiPreferences methodsFor: 'usability' stamp: 'cmm 7/10/2007 16:08'!
useCloseBoxes: aBoolean
	"Set whether the upper-left 'X' should initially appear in all MauiDomainMorphs."
	self
		preferred: #useCloseBoxes
		is: aBoolean! !

!MauiPreferences methodsFor: 'usability' stamp: 'cmm 8/8/2004 20:28'!
useMenuBalloonHelp

	^ values 
		at: #useMenuBalloonHelp
		ifAbsent: [ self nextPreferences useMenuBalloonHelp ]! !

!MauiPreferences methodsFor: 'usability' stamp: 'cmm 8/12/2004 00:40'!
useMenuBalloonHelp: aBoolean
	"If true, balloon-help will appear when the pointer hovers over a pop-up menu item."

	self
		preferred: #useMenuBalloonHelp
		is: aBoolean! !

!MauiPreferences methodsFor: 'private' stamp: 'cmm 8/28/2012 17:04'!
values
	^ values! !

!MauiPreferences methodsFor: 'private' stamp: 'cmm 8/28/2012 17:04'!
values: aDictionary
	values := aDictionary! !

!MauiPreferences methodsFor: 'copying' stamp: 'cmm 4/14/2008 21:29'!
veryDeepInner: aDeepCopier 
	super veryDeepInner: aDeepCopier.
	values := values veryDeepCopyWith: aDeepCopier.
	target isMauiMorph ifTrue: [ target := target veryDeepCopyWith: aDeepCopier ]! !

MaObject subclass: #MauiRegistry
	instanceVariableNames: 'mauiClasses'
	classVariableNames: 'Global'
	poolDictionaries: ''
	category: 'Maui-Core-Kernel'!

!MauiRegistry commentStamp: 'cmm 1/5/2004 21:58' prior: 0!
I am a registry for overriding some of Maui's default behaviors, such as the default MauiMorph class used to represent a particular class of domain.  You may have a better MauiCollectionMorph or to have a calendar-representation of a MauiDateMorph.!

!MauiRegistry class methodsFor: 'as yet unclassified' stamp: 'cmm 1/9/2005 20:29'!
global

	^ Global ifNil: [ Global := self new ]! !

!MauiRegistry class methodsFor: 'as yet unclassified' stamp: 'cmm 7/18/2007 17:37'!
initialize
	super initialize.
	Global := nil.
	self initializeTheWorldMenu! !

!MauiRegistry class methodsFor: 'as yet unclassified' stamp: 'cmm 7/25/2007 12:46'!
initializeTheWorldMenu
	TheWorldMenu
		unregisterOpenCommandWithReceiver: self ;
		registerOpenCommand: { 
				'Maui Dashboard'.
				{  MauiDashboard new. #maui  }.
				'Work with objects visually.'
			 }! !

!MauiRegistry class methodsFor: 'as yet unclassified' stamp: 'cmm 7/18/2007 17:49'!
unload
	TheWorldMenu unregisterOpenCommandWithReceiver: self! !

!MauiRegistry methodsFor: 'initialize' stamp: 'cmm 6/28/2012 12:07'!
initialize
	super initialize.
	self initializeMauiClasses! !

!MauiRegistry methodsFor: 'initialize' stamp: 'cmm 7/18/2013 14:24'!
initializeMauiClasses
	mauiClasses := Dictionary new.
	self 
		register: MauiMessageMorph
		forAny: MauiMessage.
	self 
		register: MauiBlockMorph
		forAny: MauiBlock.
	self 
		register: MauiMessageMorph
		forAny: MethodReference.
	self 
		register: MauiUserErrorMorph
		forAny: MaUserError.
	self 
		register: MauiColorMorph
		forAny: Color.
	self 
		register: MauiSketchMorph 
		forAny: SketchMorph.
	self 
		register: MauiBehaviorFinderMorph
		forAny: MaBehaviorFinder.
	self 
		register: MauiFillStyleMorph
		forAny: FillStyle.
	self 
		register: MauiColorPickerMorph
		forAny: Color class.
	self 
		register: MauiInvocationStrategyMorph
		forAny: MauiInvocationStrategy.
	self 
		register: MauiClientProcessMorph
		forAny: MaClientProcess.
	self 
		register: MauiCollectionMorph
		forAny: SequenceableCollection.
	(Smalltalk hasClassNamed: #MagmaCollectionReader) ifTrue: 
		[ self 
			register: MauiCollectionMorph
			forAny: (Smalltalk at: #MagmaCollectionReader) ].
	self 
		register: MauiPreferencesMorph
		forAny: MauiPreferences.
	self 
		register: MauiTimespanMorph
		forAny: Timespan.
	self 
		register: MauiMonthMorph
		forAny: Month.
	self 
		register: MauiWeekMorph
		forAny: Week.
	self 
		register: MauiDateMorph
		forAny: Date.
	self 
		register: MauiProgressorMorph
		forAny: MaProgressor.
	self 
		register: MauiStringMorph
		forAny: String.
	self 
		register: MauiPageMorph
		forAny: MauiPage.
	self 
		register: MauiMorphMorph
		forAny: Morph.
	self 
		register: MauiColorSchemeMorph
		forAny: MauiColorScheme.
	self 
		register: MauiKeyMapMorph
		forAny: MauiKeyMap.
	self 
		register: MauiDashboardMorph
		forAny: MauiDashboard.
	self 
		register: MauiFileDirectoryMorph
		forAny: FileDirectory.
	self 
		register: MauiDirectoryEntryDirectoryMorph
		forAny: DirectoryEntryDirectory.
	self 
		register: MauiDirectoryEntryFileMorph
		forAny: DirectoryEntryFile.
	self 
		register: MauiBooleanMorph
		forAny: Boolean.
	self 
		register: MauiContextMorph
		forAny: MaSearchContext.
	self 
		register: MauiCompositeContextMorph
		forAny: MaCompositeContext.
	self 
		register: MauiFamilyMorph
		forAny: MauiFamily! !

!MauiRegistry methodsFor: 'access' stamp: 'cmm 1/5/2004 22:33'!
mauiMorphClassFor: aClass

	^aClass
		ifNil: [ MauiDomainMorph ]
		ifNotNil: 
			[ mauiClasses 
				at: aClass
				ifAbsent: [ self mauiMorphClassFor: aClass superclass ] ]! !

!MauiRegistry methodsFor: 'register' stamp: 'cmm 12/8/2004 15:35'!
register: morphClass forAny: domainClass

	mauiClasses
		at: domainClass
		put: morphClass! !

!MauiRegistry methodsFor: 'register' stamp: 'cmm 10/12/2009 15:33'!
unregisterFor: domainClass 
	mauiClasses 
		removeKey: domainClass
		ifAbsent: 
			[ "don't blow up when only trying to unregister.."
			 ]! !

MaObject subclass: #MauiStringEvaluator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Kernel'!

MauiStringEvaluator subclass: #MauiDateEvaluator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Kernel'!

!MauiDateEvaluator class methodsFor: 'as yet unclassified' stamp: 'cmm 7/2/2008 16:10'!
evaluate: aString for: anObject
	^ Date fromString: aString! !

!MauiDateEvaluator class methodsFor: 'as yet unclassified' stamp: 'cmm 2/2/2008 16:22'!
interpretation
	"Answer how strings entered in MauiParameterHolderMorphs will be interpreted."
	^ 'date'! !

!MauiDateEvaluator class methodsFor: 'as yet unclassified' stamp: 'cmm 12/19/2010 17:07'!
logicalPicker
	^ MauiWorld current family
		newViewNamed: #threeMonth
		for: Date today! !

MauiStringEvaluator subclass: #MauiDirectoryEntryEvaluator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Kernel'!

!MauiDirectoryEntryEvaluator class methodsFor: 'as yet unclassified' stamp: 'cmm 7/18/2010 17:48'!
evaluate: aString for: anObject 
	^ FileDirectory
		splitName: aString
		to:
			[ : path : localName | (path
				ifEmpty: [ FileDirectory default ]
				ifNotEmpty: [ FileDirectory on: path ]) entryAt: localName ]! !

!MauiDirectoryEntryEvaluator class methodsFor: 'as yet unclassified' stamp: 'cmm 4/6/2010 22:02'!
interpretation
	"Answer how strings entered in MauiParameterHolderMorphs will be interpreted."
	^ 'fully-qualified filename'! !

!MauiDirectoryEntryEvaluator class methodsFor: 'as yet unclassified' stamp: 'cmm 12/19/2010 17:07'!
logicalPicker
	^ MauiWorld current family
		newViewNamed: #panel
		for: FileDirectory default! !

MauiStringEvaluator subclass: #MauiFileDirectoryEvaluator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Kernel'!

!MauiFileDirectoryEvaluator commentStamp: 'cmm 4/6/2010 21:56' prior: 0!
A MauiFileDirectoryEvaluator evaluates strings into a FileDirectory object.!

!MauiFileDirectoryEvaluator class methodsFor: 'as yet unclassified' stamp: 'cmm 4/6/2010 21:57'!
evaluate: aString for: anObject
	^ FileDirectory on: aString! !

!MauiFileDirectoryEvaluator class methodsFor: 'as yet unclassified' stamp: 'cmm 4/6/2010 22:02'!
interpretation
	"Answer how strings entered in MauiParameterHolderMorphs will be interpreted."
	^ 'full directory path'! !

!MauiFileDirectoryEvaluator class methodsFor: 'as yet unclassified' stamp: 'cmm 12/19/2010 17:07'!
logicalPicker 
	^ MauiWorld current family
		newViewNamed: #panel
		for: FileDirectory default! !

MauiStringEvaluator subclass: #MauiSmalltalkEvaluator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Kernel'!

!MauiSmalltalkEvaluator class methodsFor: 'as yet unclassified' stamp: 'cmm 7/2/2008 16:12'!
evaluate: aString for: anObject 
	| answer |
	Transcript
		cr ;
		show: 'evaluating ' , aString.
	answer := 
	[ Compiler 
		evaluate: aString
		for: anObject
		logged: false ] 
		on: Error
		do: 
			[ : exc | 
			Transcript
				cr ;
				show: exc messageText ;
				show: ' - using as entered string.'.
			exc return: (super 
					evaluate: aString
					for: anObject) ].
	^ answer! !

!MauiSmalltalkEvaluator class methodsFor: 'as yet unclassified' stamp: 'cmm 2/2/2008 16:22'!
interpretation
	"Answer how strings entered in MauiParameterHolderMorphs will be interpreted."
	^ 'Smalltalk expression'! !

!MauiSmalltalkEvaluator class methodsFor: 'as yet unclassified' stamp: 'cmm 2/18/2009 14:16'!
isSmalltalkInterpreter
	^ true! !

!MauiStringEvaluator class methodsFor: 'as yet unclassified' stamp: 'cmm 7/2/2008 16:10'!
evaluate: aString for: anObject
	^ aString! !

!MauiStringEvaluator class methodsFor: 'as yet unclassified' stamp: 'cmm 2/2/2008 16:22'!
interpretation
	"Answer how strings entered in MauiParameterHolderMorphs will be interpreted."
	^ 'string'! !

!MauiStringEvaluator class methodsFor: 'as yet unclassified' stamp: 'cmm 2/18/2009 14:16'!
isSmalltalkInterpreter
	^ false! !

!MauiStringEvaluator class methodsFor: 'as yet unclassified' stamp: 'cmm 12/19/2010 17:06'!
logicalPicker
	^ nil! !

MaObject subclass: #MauiUserStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Kernel'!

MauiUserStrategy subclass: #MauiDeveloperStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Kernel'!

!MauiDeveloperStrategy methodsFor: 'testing' stamp: 'cmm 8/10/2004 00:02'!
allowsMorphComposition
	"Answers whether a MauiDomainMorph may be dragged directly into another.  This is used during development to compose into row/column layouts."
	
	^ true! !

!MauiDeveloperStrategy methodsFor: 'menus' stamp: 'cmm 10/9/2012 22:01'!
appendCollectionMenuItemsTo: aMenu for: aMauiCollectionMorph 
	| elementsViewMenu |
	super 
		appendCollectionMenuItemsTo: aMenu
		for: aMauiCollectionMorph.
	aMauiCollectionMorph view = #panel ifTrue: 
		[ "Add heading option."
		aMenu 
			add: 'generate heading' translated
			target: aMauiCollectionMorph
			selector: #regenerateHeading ].
	"Add elements view cascading menu."
	elementsViewMenu := self buildElementsViewMenuFor: aMauiCollectionMorph.
	elementsViewMenu items notEmpty ifTrue: 
		[ aMenu addLine.
		aMenu 
			add: 'elements view'
			subMenu: elementsViewMenu ]! !

!MauiDeveloperStrategy methodsFor: 'menus' stamp: 'cmm 7/16/2004 13:52'!
appendDomainMenuItemsTo: aMenu for: aMauiDomainMorph

	super
		appendDomainMenuItemsTo: aMenu
		for: aMauiDomainMorph! !

!MauiDeveloperStrategy methodsFor: 'hooks' stamp: 'cmm 8/19/2008 21:09'!
appendMessageMorphItemsTo: aMenu for: aMauiMessageMorph 
	super 
		appendMessageMorphItemsTo: aMenu
		for: aMauiMessageMorph.
	aMenu 
		add: 
			(aMauiMessageMorph 
				string: 'refresh'
				withKeyBindingFor: #keyForRefresh)
		target: aMauiMessageMorph
		selector: #refreshResult! !

!MauiDeveloperStrategy methodsFor: 'menus' stamp: 'cmm 3/19/2011 15:39'!
appendParameterHolderMenuItemsTo: aMenu for: aMauiParameterHolderMorph 
	super 
		appendParameterHolderMenuItemsTo: aMenu
		for: aMauiParameterHolderMorph.
	aMauiParameterHolderMorph argumentName suggestedTypeNames isEmpty ifFalse: 
		[ aMenu 
			add: 'try to browse parameter hierarchy'
			target: aMauiParameterHolderMorph
			selector: #browseParameterHierarchy ].
	aMenu 
		add: aMauiParameterHolderMorph preferencesMenuText
		target: aMauiParameterHolderMorph
		selector: #openPreferencesPanel! !

!MauiDeveloperStrategy methodsFor: 'menus' stamp: 'cmm 11/29/2007 22:47'!
appendStandardMenuItemsTo: aMenu for: aMauiMorph 
	super 
		appendStandardMenuItemsTo: aMenu
		for: aMauiMorph.
	"Not in user strategy because all windows are labelled there."
	aMauiMorph view = #word ifFalse: 
		[ aMenu 
			addUpdating: #labelledMenuString
			target: aMauiMorph
			action: #toggleLabelled ].
	aMenu 
		add: (aMauiMorph 
				string: 'halos'
				withKeyBindingFor: #keyForHalos)
		target: aMauiMorph
		selector: #addHalo.
	aMenu 
		add: (aMauiMorph 
				string: 'tools'
				withKeyBindingFor: #keyForToolsAccess)
		target: aMauiMorph
		selector: #openToolMenu! !

!MauiDeveloperStrategy methodsFor: 'menus' stamp: 'cmm 7/16/2004 10:25'!
buildElementsViewMenuFor: aMauiCollectionMorph

	| answer |
	answer := MenuMorph new.
	aMauiCollectionMorph intersectingViews do:
		[ : each | 
		answer
			add: each
			target: aMauiCollectionMorph
			selector: #elementsView:
			argument: each ].
	^ answer! !

!MauiDeveloperStrategy methodsFor: 'keyboard' stamp: 'cmm 4/23/2014 10:36'!
handleMessageKeyboardEvent: aKeyboardEvent for: aMauiMessageMorph 
	^ (super
		handleMessageKeyboardEvent: aKeyboardEvent
		for: aMauiMessageMorph) or: [ aMauiMessageMorph handleMessageKeyboardEvent: aKeyboardEvent ]! !

!MauiDeveloperStrategy methodsFor: 'keyboard' stamp: 'cmm 4/16/2008 10:03'!
handleParameterHolderKeyboardEvent: aKeyboardEvent for: aMauiParameterHolderMorph
	| keyPressed |
	super
		handleParameterHolderKeyboardEvent: aKeyboardEvent
		for: aMauiParameterHolderMorph.
	keyPressed := aKeyboardEvent keyCharacter.
	(keyPressed = (aMauiParameterHolderMorph preferred: #keyMap) keyForOpenHierarchy
	and: [ aKeyboardEvent commandKeyPressed ])
		ifTrue:
			[ aMauiParameterHolderMorph browseParameterHierarchy. 
			aKeyboardEvent wasHandled: true ]! !

!MauiDeveloperStrategy methodsFor: 'keyboard' stamp: 'cmm 12/8/2010 16:54'!
handleStandardKeyboardEvent: aKeyboardEvent for: aMauiMorph 
	| keyPressed h keyMap |
	keyMap := aMauiMorph preferred: #keyMap.
	h := super 
		handleStandardKeyboardEvent: aKeyboardEvent
		for: aMauiMorph.
	h ifTrue: [ ^ true ].
	keyPressed := aKeyboardEvent keyCharacter.
	keyPressed = keyMap keyForAnotherView ifTrue: 
		[ aMauiMorph cloneUi.
		h := true ].
	keyPressed = keyMap keyForToolsAccess ifTrue: 
		[ aMauiMorph openToolMenu.
		h := true ].
	keyPressed = keyMap keyForOpenHierarchy ifTrue: 
		[ aMauiMorph browseDomainHierarchy.
		h := true ].
	keyPressed = keyMap keyForOpenPackage ifTrue: 
		[ aMauiMorph browseDomainFull.
		h := true ].
	keyPressed = keyMap keyForHalos ifTrue: 
		[ aMauiMorph addHalo.
		h := true ].
	keyPressed = keyMap keyForFindMessage ifTrue: 
		[ aMauiMorph openDomainBehaviorFinder.
		h := true ].
	keyPressed = keyMap keyForFindObject ifTrue: 
		[ aMauiMorph isMauiDomainMorph ifTrue: 
			[ aMauiMorph findObject.
			h := true ] ].
	keyPressed = keyMap keyForExploreObject ifTrue: 
		[ aMauiMorph object inspect.
		h := true ].
	keyPressed = keyMap keyForExploreObject asUppercase ifTrue: 
		[ aMauiMorph object explore.
		h := true ].
	keyPressed = keyMap keyForExploreMorph ifTrue: 
		[ aMauiMorph inspect.
		h := true ].
	keyPressed = keyMap keyForExploreMorph asUppercase ifTrue: 
		[ aMauiMorph explore.
		h := true ].
	keyPressed = keyMap keyForEdit ifTrue: 
		[ aMauiMorph openSettingsPanel.
		h := true ].
	keyPressed = keyMap keyForSave ifTrue: 
		[ aMauiMorph isMauiDomainMorph ifTrue: 
			[ aMauiMorph save.
			h := true ] ].
	keyPressed = keyMap keyForDesignNewView ifTrue: 
		[ aMauiMorph isMauiDomainMorph ifTrue: [ aMauiMorph designNewView ].
		h := true ].
	^ h! !

!MauiDeveloperStrategy methodsFor: 'testing' stamp: 'cmm 7/15/2004 23:02'!
isDevelopmentMode

	^ true! !

!MauiDeveloperStrategy methodsFor: 'preferences' stamp: 'cmm 8/13/2004 14:31'!
mauiFamilyPreferenceSelectors

	^ self mauiGlobalPreferenceSelectors! !

!MauiDeveloperStrategy methodsFor: 'preferences' stamp: 'cmm 12/11/2008 16:32'!
mauiGlobalPreferenceSelectors
	^ #(
		#connector
		#label
		#domainMorph
		#contentDomainMorph
		#embeddedDomainMorph
		#messageMorph
		#parameterHolderMorph
		#colorScheme
		#modifierForAccept
		#connectObjects
		#useMenuBalloonHelp
	)! !

!MauiDeveloperStrategy methodsFor: 'hooks' stamp: 'cmm 7/16/2004 15:25'!
noteNewUserStrategyFor: aMauiMorph

	aMauiMorph revertToPrototype! !

!MauiDeveloperStrategy methodsFor: 'Morphic' stamp: 'cmm 8/16/2007 16:31'!
yellowDown: shiftPressed on: aMauiMorph 
	shiftPressed 
		ifTrue: [ aMauiMorph openToolMenu ]
		ifFalse: 
			[ super 
				yellowDown: shiftPressed
				on: aMauiMorph ]! !

MauiUserStrategy subclass: #MauiEndUserStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Kernel'!

!MauiEndUserStrategy methodsFor: 'name conversion' stamp: 'cmm 11/5/2007 01:00'!
nameFor: aString 
	^ aString smalltalkToWords! !

!MauiEndUserStrategy methodsFor: 'hooks' stamp: 'cmm 7/16/2004 15:24'!
noteNewUserStrategyFor: aMauiMorph

	self adjustMessageLabelsOf: aMauiMorph! !

!MauiUserStrategy methodsFor: 'menus' stamp: 'cmm 12/24/2007 22:22'!
addAsWordTo: aMenu for: aMauiDomainMorph 
	aMenu 
		add: (aMauiDomainMorph 
				string: 'grab word'
				withKeyBindingFor: #keyForMakeWord)
		target: aMauiDomainMorph
		selector: #makeWord! !

!MauiUserStrategy methodsFor: 'menus' stamp: 'cmm 3/6/2008 23:20'!
addFindObjectTo: aMenu for: aMauiDomainMorph 
	aMenu 
		add: 
			(aMauiDomainMorph 
				string: 'find...'
				withKeyBindingFor: #keyForFindObject)
		target: aMauiDomainMorph
		selector: #findObject! !

!MauiUserStrategy methodsFor: 'menus' stamp: 'cmm 5/27/2008 14:03'!
addMakeListTo: aMenu for: aMauiDomainMorph 
	aMenu 
		add: 'start a list' translated
		target: aMauiDomainMorph
		selector: #makeList! !

!MauiUserStrategy methodsFor: 'menus' stamp: 'cmm 7/10/2007 15:43'!
addViewsMenuTo: aMenu for: aMauiDomainMorph 
	aMauiDomainMorph
		addCodedViewsMenuTo: aMenu ;
		addCustomViewsMenuTo: aMenu! !

!MauiUserStrategy methodsFor: 'hooks' stamp: 'cmm 12/8/2008 22:37'!
adjustLabelsOf: aMauiMessageMorph 
	aMauiMessageMorph labelsDo: 
		[ : eachLabelMorph | 
		(eachLabelMorph respondsTo: #string) ifTrue: [ eachLabelMorph contents: (self nameFor: eachLabelMorph contents) ] ]! !

!MauiUserStrategy methodsFor: 'name conversion' stamp: 'cmm 2/13/2014 17:06'!
adjustMessageLabelsOf: aMauiMorph 
	aMauiMorph allInstructionMorphsDo:
		[ : each | each isMauiMessageMorph ifTrue: [ self adjustLabelsOf: each ] ]! !

!MauiUserStrategy methodsFor: 'testing' stamp: 'cmm 8/10/2004 00:02'!
allowsMorphComposition
	"Answers whether a MauiDomainMorph may be dragged directly into another.  This is used during development to compose into row/column layouts."
	
	^ false! !

!MauiUserStrategy methodsFor: 'menus' stamp: 'cmm 7/23/2008 23:00'!
appendCollectionMenuItemsTo: aMenu for: aMauiCollectionMorph
	aMenu
			add: 'refresh'
			target: aMauiCollectionMorph
			selector: #refresh! !

!MauiUserStrategy methodsFor: 'menus' stamp: 'cmm 5/27/2008 10:00'!
appendDomainMorphMenuItemsTo: aMenu for: aMauiDomainMorph 
	aMenu defaultTarget: aMauiDomainMorph.
	self 
		addAsWordTo: aMenu
		for: aMauiDomainMorph.
	self 
		addFindObjectTo: aMenu
		for: aMauiDomainMorph.
	self 
		addMakeListTo: aMenu
		for: aMauiDomainMorph! !

!MauiUserStrategy methodsFor: 'menus' stamp: 'cmm 2/6/2008 16:19'!
appendMauiPageMenuItemsTo: aMenu for: aMauiPageMorph 
	aMenu 
		addUpdating: #toolBarEnabledMenuString
		enablementSelector: #canHaveToolBar
		target: aMauiPageMorph
		selector: #toggleToolBar
		argumentList: #().
	aMenu 
		addUpdating: #autoResizeEnabledMenuString
		target: aMauiPageMorph
		selector: #toggleAutoResize
		argumentList: #()! !

!MauiUserStrategy methodsFor: 'menus' stamp: 'cmm 7/16/2004 12:04'!
appendMessageMorphItemsTo: aMenu for: aMauiMessageMorph

	aMauiMessageMorph canInvoke
		ifTrue:
			[ aMenu
				add: 'invoke'
				target: aMauiMessageMorph
				selector: #invoke ]! !

!MauiUserStrategy methodsFor: 'menus' stamp: 'cmm 7/18/2007 18:16'!
appendParameterHolderMenuItemsTo: aMenu for: aMauiParameterHolderMorph
! !

!MauiUserStrategy methodsFor: 'menus' stamp: 'cmm 4/21/2009 19:08'!
appendStandardMenuItemsTo: aMenu for: aMauiMorph 
	aMenu 
		add: (aMauiMorph 
				string: 'grab' translated
				withKeyBindingFor: #keyForGrab)
		target: aMauiMorph
		selector: #grab.
	aMauiMorph owner = World ifTrue: 
		[ aMenu 
			add: (aMauiMorph 
					string: 'send to back' translated
					withKeyBindingFor: #keyForSendToBack)
			target: aMauiMorph
			selector: #goBehind.
		aMenu 
			add: (aMauiMorph 
					string: 'come to front' translated
					withKeyBindingFor: #keyForComeToFront)
			target: aMauiMorph
			selector: #comeToFront ].
	aMauiMorph preferences useCloseBoxes ifFalse: 
		[ aMenu 
			add: (aMauiMorph 
					string: 'remove' translated
					withKeyBindingFor: #keyForRemove)
			target: aMauiMorph
			selector: #cut ].
	aMenu 
		add: (aMauiMorph 
					string: aMauiMorph preferencesMenuText
					withKeyBindingFor: #keyForOpenPreferences)
		target: aMauiMorph
		selector: #openPreferencesPanel.
	aMenu 
		add: (aMauiMorph 
				string: 'set label' translated
				withKeyBindingFor: #keyForLabel)
		target: aMauiMorph
		selector: #updateLabel.
	aMenu 
		add: (aMauiMorph 
				string: 'duplicate this view' translated
				withKeyBindingFor: #keyForAnotherView)
		target: aMauiMorph
		selector: #cloneUi.
	aMauiMorph hasCustomLabel ifTrue: 
		[ aMenu 
			add: 'reset label' translated
			target: aMauiMorph
			selector: #initializeLabelString ]! !

!MauiUserStrategy methodsFor: 'keyboard' stamp: 'cmm 4/23/2014 10:35'!
handleMessageKeyboardEvent: aKeyboardEvent for: aMauiMessageMorph
	"No default keys for messages."
	^ false! !

!MauiUserStrategy methodsFor: 'keyboard' stamp: 'cmm 7/16/2004 12:27'!
handleParameterHolderKeyboardEvent: aKeyboardEvent for: aMauiParameterHolderMorph
	"No special command-keys by default."! !

!MauiUserStrategy methodsFor: 'keyboard' stamp: 'cmm 1/14/2010 21:46'!
handleStandardKeyboardEvent: aKeyboardEvent for: aMauiMorph 
	| keyPressed h keyMap |
	h := false.
	keyPressed := aKeyboardEvent keyCharacter.
	keyMap := aMauiMorph preferred: #keyMap.
	keyPressed = Character arrowDown ifTrue: [ aMauiMorph position: aMauiMorph position + (0 @ 1) ].
	keyPressed = Character arrowUp ifTrue: [ aMauiMorph position: aMauiMorph position + (0 @ -1) ].
	keyPressed = Character arrowRight ifTrue: [ aMauiMorph position: aMauiMorph position + (1 @ 0) ].
	keyPressed = Character arrowLeft ifTrue: [ aMauiMorph position: aMauiMorph position + (-1 @ 0) ].
	keyPressed = keyMap keyForRemove ifTrue: 
		[ aMauiMorph focusOnNextPlayerUsing: aKeyboardEvent.
		aMauiMorph removeHalo.
		aMauiMorph outerMostMauiMorph cut.
		h := true ].
	keyPressed = keyMap keyForRemoveWidget ifTrue: 
		[ aMauiMorph focusOnNextPlayerUsing: aKeyboardEvent.
		aMauiMorph cut.
		h := true ].
	keyPressed = keyMap keyForMakeWord ifTrue: 
		[ aMauiMorph isMauiDomainMorph ifTrue: [ aMauiMorph makeWord ].
		h := true ].
	keyPressed = keyMap keyForFocusShift ifTrue: 
		[ aMauiMorph shiftFocus: aKeyboardEvent.
		h := true ].
	keyPressed = keyMap keyForContextCommands ifTrue: 
		[ aMauiMorph openContextMenu.
		h := true ].
	keyPressed = keyMap keyForLabel ifTrue: [ aMauiMorph updateLabel ].
	keyPressed = keyMap keyForToggleLabelled ifTrue: [ aMauiMorph toggleLabelled ].
	keyPressed = keyMap keyForGrab ifTrue: [ aMauiMorph grab ].
	keyPressed = keyMap keyForGrabFocusedObject ifTrue: [ aMauiMorph grabFocusedObject ].
	keyPressed = keyMap keyForSendToBack ifTrue: [ aMauiMorph root goBehind ].
	keyPressed = keyMap keyForSendAllToBack ifTrue: [ aMauiMorph goBehindWithFellowPlayers ].
	keyPressed = keyMap keyForOpenPreferences ifTrue: [ aMauiMorph openPreferencesPanel ].
	keyPressed = keyMap keyForComeToFront ifTrue: 
		[ aKeyboardEvent shiftPressed 
			ifTrue: [ aMauiMorph comeToFrontWithFellowPlayers ]
			ifFalse: [ aMauiMorph root comeToFront ] ].
	^ h! !

!MauiUserStrategy methodsFor: 'testing' stamp: 'cmm 7/16/2004 10:23'!
isDevelopmentMode

	^ false! !

!MauiUserStrategy methodsFor: 'testing' stamp: 'cmm 7/16/2004 11:04'!
likesViewsFor: aClass

	^ aClass notNil! !

!MauiUserStrategy methodsFor: 'preferences' stamp: 'cmm 8/13/2004 14:22'!
mauiFamilyPreferenceSelectors

	^ #()! !

!MauiUserStrategy methodsFor: 'name conversion' stamp: 'cmm 7/16/2004 10:22'!
nameFor: aString

	^ aString! !

!MauiUserStrategy methodsFor: 'Morphic' stamp: 'cmm 8/16/2007 16:31'!
yellowDown: shiftPressed on: aMauiMorph 
	aMauiMorph openContextMenu! !

MaObject subclass: #MauiWorld
	instanceVariableNames: 'name family menu flaps players connectors userStrategy clipboard log courtPlayers'
	classVariableNames: 'AllMauiWorlds'
	poolDictionaries: ''
	category: 'Maui-Core-Domain'!

!MauiWorld commentStamp: 'cmm 5/7/2007 12:44' prior: 0!
I keep track of all MauiMorphs in a single World (aPasteUpMorph).

I specify parameters and options for a single "application" for a single user.

I have a "userStrategy", which can be for developers (advanced features and UI composition) or users (application usage only).!

!MauiWorld class methodsFor: 'accessing' stamp: 'cmm 1/9/2005 12:00'!
allMauiWorlds

	^ AllMauiWorlds ifNil: [ self initializeWorldsContainer ]! !

!MauiWorld class methodsFor: 'initialize' stamp: 'cmm 1/10/2005 22:34'!
cleanUp
	self initializeWorldsContainer! !

!MauiWorld class methodsFor: 'accessing' stamp: 'cmm 12/25/2003 11:59'!
current

	^self for: World! !

!MauiWorld class methodsFor: 'file-in' stamp: 'cmm 4/21/2009 18:15'!
fileExtension
	^ 'MauiWorld'! !

!MauiWorld class methodsFor: 'file-in' stamp: 'cmm 4/21/2009 21:47'!
fileInMauiWorldService
	^ SimpleServiceEntry 
		provider: self
		label: 'Load MauiWorld'
		selector: #installMauiWorld:
		description: 'Installs the MauiWorld into this image.'
		buttonLabel: 'install'! !

!MauiWorld class methodsFor: 'file-in' stamp: 'cmm 4/21/2009 18:42'!
fileReaderServicesForFile: fullName suffix: suffix 
	^ suffix = self fileExtension asLowercase
		ifTrue: 
			[ {  (self fileInMauiWorldService)  } ]
		ifFalse: 
			[ {   } ]! !

!MauiWorld class methodsFor: 'accessing' stamp: 'cmm 8/6/2008 16:07'!
for: aWorld 
	"Answer the MauiWorld to represent this World."
	^ self allMauiWorlds 
		at: aWorld
		ifAbsent: 
			[ self 
				mauiWorldFor: aWorld
				is: self new ]! !

!MauiWorld class methodsFor: 'environment' stamp: 'cmm 6/18/2011 15:27'!
hasConnectors
	^ MCWorkingCopy registry includesKey: (MCPackage named: 'Connectors')! !

!MauiWorld class methodsFor: 'initialize' stamp: 'cmm 4/21/2009 18:14'!
initialize
	super initialize.
	self
		initializeMaui ;
		registerSelfAsFileReader! !

!MauiWorld class methodsFor: 'initialize' stamp: 'cmm 9/15/2009 10:06'!
initializeMaui
	self cleanUp.
	AllMauiWorlds := nil.
	MauiFamily initialize.
	MauiPreferences initialize.
	MauiRegistry initialize.
	self replaceDependentsFields.
	Preferences
		setPreference: #generalizedYellowButtonMenu
			toValue: false ;
		setPreference: #mouseOverForKeyboardFocus
			toValue: true ;
		setPreference: #browseWithDragNDrop
			toValue: true! !

!MauiWorld class methodsFor: 'initialize' stamp: 'cmm 1/24/2014 15:31'!
initializeWorldsContainer
	super initialize.
	AllMauiWorlds ifNotNil:
		[ AllMauiWorlds do:
			[ : each | each cleanUp ] ].
	AllMauiWorlds := MaObjectSerializerPreferences newWeakIdentityKeyDictionary.
	self setUpTransferMorphListeners.
	^ AllMauiWorlds! !

!MauiWorld class methodsFor: 'file-in' stamp: 'cmm 11/21/2010 21:17'!
install: aDirectoryEntryFile 
	FileStream
		detectFile: [ aDirectoryEntryFile readStream ]
		do:
			[ : stream | SARInstaller installMauiWorldFromStream: stream ]! !

!MauiWorld class methodsFor: 'file-in' stamp: 'cmm 6/8/2009 13:13'!
installMauiWorld: filename 
	self install: (FileDirectory maDirectoryEntryFor: filename)! !

!MauiWorld class methodsFor: 'initialize' stamp: 'cmm 11/25/2004 20:23'!
listenForLeavingWorlds
	Project allProjects do:
		[ : each |
		each world
			when: #aboutToLeaveWorld
			send: #setUpTransferMorphListeners
			to: self ]! !

!MauiWorld class methodsFor: 'accessing' stamp: 'cmm 10/28/2011 15:41'!
mauiWorldFor: aWorld is: aMauiWorld 
	aWorld ifNil: [ MauiSoftwareError signal: 'must have a world.' ].
	"Merge the existing world into the new world."
	self allMauiWorlds 
		at: aWorld
		ifPresent: [ : foundMauiWorld | aMauiWorld merge: foundMauiWorld ]
		ifAbsent: [  ].
	^ self allMauiWorlds 
		at: aWorld
		put: aMauiWorld! !

!MauiWorld class methodsFor: 'initialize' stamp: 'cmm 11/25/2004 20:27'!
releaseLeavingWorldListeners
	Project allProjects do:
		[ : each |
		each world removeActionsForEvent: #aboutToLeaveWorld ]! !

!MauiWorld class methodsFor: 'initialize' stamp: 'cmm 3/11/2010 22:52'!
releaseTransferMorphListeners
	PasteUpMorph allInstancesDo: [ : each | each resetTransferMorphConverter ]! !

!MauiWorld class methodsFor: 'initialize' stamp: 'cmm 11/14/2010 22:09'!
replaceDependentsFields
	| nd |
	nd := MaWeakIdentityKeyDictionary new.
	WeakArray addWeakDependent: nd.
	DependentsFields keysAndValuesDo: [ : k : v | k ifNotNil: 
			[ nd 
				at: k
				put: v ] ].
	DependentsFields := nd! !

!MauiWorld class methodsFor: 'initialize' stamp: 'cmm 3/11/2010 22:41'!
setUpTransferMorphListeners
	self listenForLeavingWorlds.
	Project allProjects do:
		[ : each |
		each world ifNotNil: [ each world transferMorphConverter: #asMauiMorph: ] ]! !

!MauiWorld class methodsFor: 'debugging' stamp: 'cmm 7/25/2004 22:42'!
signalWhereInvalid

	self current playersDo:
		[ : each |
		each world == World ifTrue: [ each signalWhereInvalid ] ]! !

!MauiWorld class methodsFor: 'initialize' stamp: 'cmm 3/18/2008 12:42'!
startUp
	super startUp.
	self current playersDo: [ : e | e owner = World ifTrue: [ e mauiEnsureOnScreen ] ]! !

!MauiWorld class methodsFor: 'initialize' stamp: 'cmm 11/25/2004 20:27'!
unload

	self
		releaseTransferMorphListeners ;
		releaseLeavingWorldListeners! !

!MauiWorld class methodsFor: 'accessing' stamp: 'cmm 4/19/2009 19:26'!
worldFor: aMauiWorld 
	"Answer the MauiWorld to represent this World."
	^ (self allMauiWorlds maAllKeysAtValue: aMauiWorld) 
		ifEmpty: [ World ]
		ifNotEmptyDo: [ : all | all anyOne ]! !

!MauiWorld methodsFor: 'initialize' stamp: 'cmm 8/6/2008 16:08'!
beForCurrentWorld
	self class 
		mauiWorldFor: World
		is: self! !

!MauiWorld methodsFor: 'players' stamp: 'cmm 7/1/2012 16:42'!
cleanPlayers
	| toBeRemoved |
	toBeRemoved := OrderedCollection new.
	self playersDo:
		[ : e | e isInWorld ifFalse: [ toBeRemoved add: e ] ].
	toBeRemoved do:
		[ : e | self removePlayer: e ]! !

!MauiWorld methodsFor: 'initialize' stamp: 'cmm 8/7/2008 22:28'!
cleanUp
	self
		removeFlaps ;
		playersDo: [ : each | each delete ] ;
		initialize! !

!MauiWorld methodsFor: 'clipboard' stamp: 'cmm 12/15/2008 21:51'!
clipboard
	^clipboard! !

!MauiWorld methodsFor: 'clipboard' stamp: 'cmm 12/15/2008 21:51'!
clipboard: aMauiMorph
	clipboard := aMauiMorph! !

!MauiWorld methodsFor: 'connect' stamp: 'cmm 3/8/2008 16:51'!
connect: sourceMorph to: targetMorph 
	(self 
		newConnectorFrom: sourceMorph
		to: targetMorph) ifNotNilDo: [ : newConnector | (self connectorsFor: sourceMorph) add: newConnector ]! !

!MauiWorld methodsFor: 'connect' stamp: 'cmm 12/31/2004 15:50'!
connectAllFrom: aMauiMorph

	self
		disconnectAllFrom: aMauiMorph;
		initializeConnectorsFor: aMauiMorph;
		showConnectorsFor: aMauiMorph! !

!MauiWorld methodsFor: 'connect' stamp: 'cmm 11/8/2009 18:57'!
connectFrom: aMauiMorph
	(aMauiMorph preferred: #connectObjects) ifTrue: [ self connectAllFrom: aMauiMorph ]! !

!MauiWorld methodsFor: 'connect' stamp: 'cmm 12/10/2003 21:27'!
connectorsFor: aMauiMorph

	^connectors 
		at: aMauiMorph
		ifAbsentPut: [ OrderedCollection new ]! !

!MauiWorld methodsFor: 'connect' stamp: 'cmm 12/31/2004 15:28'!
delineateAllFrom: aMauiMorph

	(self playersFor: aMauiMorph object) do: [ : each | each delineate ]! !

!MauiWorld methodsFor: 'connect' stamp: 'cmm 12/31/2004 15:31'!
delineateFrom: aMauiMorph

	self delineateAllFrom: aMauiMorph.
	(aMauiMorph preferred: #connectObjects) ifTrue: [ self connectAllFrom: aMauiMorph ]! !

!MauiWorld methodsFor: 'connect' stamp: 'cmm 12/31/2004 15:49'!
disconnectAllFrom: aMauiMorph

	| c |
	c := connectors
		removeKey: aMauiMorph
		ifAbsent: [ #() ].
	c do: [ : each | each maFadeAwayOver: (aMauiMorph preferred: #transitionDuration) ]! !

!MauiWorld methodsFor: 'family' stamp: 'cmm 8/15/2004 22:15'!
family

	^ family! !

!MauiWorld methodsFor: 'family' stamp: 'cmm 8/15/2004 22:10'!
family: aMauiFamily
	"Set the default family of MauiMorphs this world should use."

	family := aMauiFamily! !

!MauiWorld methodsFor: 'serialization' stamp: 'cmm 4/19/2009 20:48'!
fileOut
	"Write this family of screens to a file of my name in the current directory."
	^ MaObjectSerializer new
		fileOut: self
		toFileNamed: self name, '.MauiWorld'
		in: FileDirectory default! !

!MauiWorld methodsFor: 'players' stamp: 'cmm 1/1/2004 15:51'!
hasPlayers

	^self playerCount > 0! !

!MauiWorld methodsFor: 'players' stamp: 'cmm 12/8/2010 14:17'!
hasPlayersFor: anObject 
	^ anObject notNil and: 
		[ (players includesKey: anObject realObject) and: [ (self playersAt: anObject) notEmpty ] ]! !

!MauiWorld methodsFor: 'initialize' stamp: 'cmm 6/8/2009 13:33'!
initialize
	family := MauiFamily newNamed: 'a new family of screens'.
	self
		initializePlayers ;
		initializeConnectors ;
		initializeLog ;
		userStrategy: MauiDeveloperStrategy new! !

!MauiWorld methodsFor: 'initialize' stamp: 'cmm 8/6/2008 22:02'!
initializeConnectors
	connectors := MaWeakKeyDictionary new! !

!MauiWorld methodsFor: 'connect' stamp: 'cmm 12/31/2004 16:08'!
initializeConnectorsFor: aMauiMorph

	(self playersFor: aMauiMorph object) do:
		[ : each |
		(each ~~ aMauiMorph and: [ each isInWorld ])
			ifTrue: [ self connect: aMauiMorph to: each ] ]! !

!MauiWorld methodsFor: 'initialize' stamp: 'cmm 6/8/2009 13:33'!
initializeLog
	log := OrderedCollection new! !

!MauiWorld methodsFor: 'initialize' stamp: 'cmm 12/19/2010 17:38'!
initializePlayers
	players := MaWeakKeyDictionary new! !

!MauiWorld methodsFor: 'flaps' stamp: 'cmm 11/17/2010 10:50'!
installFlaps
	"Install my flaps which are not already in the world."
	flaps ifNotNil: 
		[ flaps do: [ : eachFlapTab | eachFlapTab veryDeepCopy installInWorld: self world ] ]! !

!MauiWorld methodsFor: 'initialize' stamp: 'cmm 11/17/2010 10:49'!
installMenu
	menu ifNotNil: [ TheWorldMainDockingBar instance: menu ]! !

!MauiWorld methodsFor: 'serialization' stamp: 'cmm 4/19/2009 22:11'!
installPlayers
	players 
		ifNil: [ self initializePlayers ]
		ifNotNil: [ courtPlayers do: [ : each | each copy openInWorld ] ]! !

!MauiWorld methodsFor: 'players' stamp: 'cmm 8/9/2004 23:08'!
isPlayer: aMauiDomainMorph
	"aMauiDomainMorph may not be a player if it is embedded within another MauiDomainMorph."

	^ (self playersFor: aMauiDomainMorph object) includes: aMauiDomainMorph! !

!MauiWorld methodsFor: 'log' stamp: 'cmm 12/17/2009 17:09'!
logInvocation: aMauiMessage 
"Commenting this out until we have someone to consume it.  Copying all these messages, (especially with auto repeating strategy's!!) is quite a lot of work!!"
"	[ log size >= 10 ] whileTrue: [ log removeFirst ].
	log add: aMauiMessage independentCopy"! !

!MauiWorld methodsFor: 'serialization' stamp: 'cmm 6/8/2009 13:33'!
maPostMaterialize
	"This method is used by the Ma object serialization package (utilized by Magma).  It will be used if that package is loaded."
	self
		initializePlayers ;
		initializeConnectors ;
		initializeLog! !

!MauiWorld methodsFor: 'serialization' stamp: 'cmm 11/17/2010 10:54'!
maPreSerialize
	"This method is used by the Ma object serialization package to perform pre-serialization capture."
	self
		noteMenu ;
		noteFlaps ;
		noteCourtPlayers! !

!MauiWorld methodsFor: 'serialization' stamp: 'cmm 6/8/2009 13:30'!
maTransientVariables
	^ super maTransientVariables , #('players' 'connectors' 'clipboard' 'log' )! !

!MauiWorld methodsFor: 'serialization' stamp: 'cmm 8/7/2008 00:28'!
maWantsPostMaterialization
	^ true! !

!MauiWorld methodsFor: 'serialization' stamp: 'cmm 4/19/2009 14:42'!
maWantsPreSerialization
	^ true! !

!MauiWorld methodsFor: 'flaps' stamp: 'cmm 8/6/2008 20:13'!
mauiFlaps
	"Answer the flaps in the world I represent which have MauiMorphs embedded in them."
	^ self worldFlaps select: 
		[ : eachFlap | 
		eachFlap referent submorphs anySatisfy: [ : eachMorph | eachMorph isMauiMorph and: [ eachMorph family = self family ] ] ]! !

!MauiWorld methodsFor: 'serialization' stamp: 'cmm 6/8/2009 13:35'!
merge: aMauiWorld 
	"When loading a MauiWorld, it replaces the current but also merges its family and flaps.  aMauiWorld is left unchanged."
	family merge: aMauiWorld family! !

!MauiWorld methodsFor: 'accessing' stamp: 'cmm 4/19/2009 16:44'!
name
	^name! !

!MauiWorld methodsFor: 'accessing' stamp: 'cmm 4/19/2009 16:44'!
name: aString
	name := aString! !

!MauiWorld methodsFor: 'user strategy' stamp: 'cmm 9/25/2007 17:11'!
nameFor: aString 
	^ userStrategy 
		ifNil: [ aString ]
		ifNotNil: [ userStrategy nameFor: aString ]! !

!MauiWorld methodsFor: 'connect' stamp: 'cmm 6/3/2009 21:27'!
newConnectorFrom: sourceMorph to: targetMorph 
	^ (sourceMorph preferred: #connector) ifNotNilDo: 
		[ : connector | 
		connector copy
			connectStartTo: sourceMorph ;
			connectFinishTo: targetMorph ;
			yourself ]! !

!MauiWorld methodsFor: 'serialization' stamp: 'cmm 11/21/2010 11:14'!
noteCourtPlayers
	"Court players are typcically stationary objects on the desktop; such as application tool-bars or something."
	courtPlayers := OrderedCollection new.
	self world in: 
		[ : w | 
		self playersDo: [ : each | each owner = w ifTrue: [ courtPlayers add: each ] ] ]! !

!MauiWorld methodsFor: 'flaps' stamp: 'cmm 11/21/2010 11:21'!
noteFlaps
	"When I am filed-out, I will look at all flaps in the current World and, add each one that contains at least one MauiMorph, in its entirety."
	flaps := self mauiFlaps veryDeepCopy! !

!MauiWorld methodsFor: 'serialization' stamp: 'cmm 11/21/2010 11:29'!
noteMenu
	menu := TheWorldMainDockingBar instance class ~= TheWorldMainDockingBar ifTrue: [ TheWorldMainDockingBar instance ]! !

!MauiWorld methodsFor: 'players' stamp: 'cmm 1/22/2008 23:46'!
onePlayerFor: anObject is: aMauiMorph 
	"extra guard for safety, may not be necessary."
	({  true. false. nil  } includes: anObject) ifTrue: [ ^ self ].
	(aMauiMorph world isNil or: [ aMauiMorph isSelfContained ]) ifTrue: [ ^ self ].
	self maMarked: 'dev'.
	"Try to get rid of this."
	"self cleanGonePlayers."
	^ (self playersAt: anObject) add: aMauiMorph! !

!MauiWorld methodsFor: 'clipboard' stamp: 'cmm 12/15/2008 22:37'!
paste
	"Put the last cut morph onto the hand."
	clipboard ifNotNil: [ clipboard openInHand ]! !

!MauiWorld methodsFor: 'players' stamp: 'cmm 6/7/2007 16:33'!
playerCount
	^players size! !

!MauiWorld methodsFor: 'private' stamp: 'cmm 12/8/2010 14:17'!
playersAt: anObject 
	^ anObject 
		ifNil: 
			[ #() ]
		ifNotNil: 
			[ players 
				at: anObject realObject
				ifAbsentPut: [ WeakSet new ] ]! !

!MauiWorld methodsFor: 'players' stamp: 'cmm 6/12/2007 16:15'!
playersDo: aBlock 
	players copy do: [ : eachSet | eachSet ifNotNil: [ eachSet copy do: aBlock ] ]! !

!MauiWorld methodsFor: 'players' stamp: 'cmm 3/18/2008 12:35'!
playersFor: anObject 
	^ anObject 
		ifNil: [ #() ]
		ifNotNil: 
			[ (self hasPlayersFor: anObject) 
				ifTrue: [ self playersAt: anObject ]
				ifFalse: [ #() ] ]! !

!MauiWorld methodsFor: 'players' stamp: 'cmm 1/16/2008 14:22'!
rehashPlayers
	"The hash of some of my players will sometimes change.  This is an argument to use an WeakKeyIdentityDictionary instead of a WeakKeyDictionary, but for now let's try rehashing on changed."
	players rehash! !

!MauiWorld methodsFor: 'flaps' stamp: 'cmm 11/30/2008 15:14'!
removeFlaps
	flaps ifNotNil: [ flaps do: [ : each | each delete ] ]! !

!MauiWorld methodsFor: 'players' stamp: 'cmm 7/1/2012 16:53'!
removePlayer: aMauiMorph 
	self undelineateFrom: aMauiMorph.
	aMauiMorph object ifNotNil: 
		[ | playersForObject |
		playersForObject := (players 
			at: aMauiMorph object
			ifAbsent: [ ^ self ])
			remove: aMauiMorph
				ifAbsent:  [ "don't complain" ] ;
			yourself.
		playersForObject isEmpty ifTrue: 
			[ players 
				removeKey: aMauiMorph object
					ifAbsent: [  ] ;
				finalizeValues ] ]! !

!MauiWorld methodsFor: 'players' stamp: 'cmm 1/2/2005 16:14'!
removePlayersWithNonDefaultNotificationHandler: aMauiNotificationHandler

	self playersDo:
		[ : each |
		(each notificationHandler = aMauiNotificationHandler
		and: [ (each notificationHandler ~= MauiNotificationHandler default) ])	
			ifTrue: [ each delete ] ]! !

!MauiWorld methodsFor: 'connect' stamp: 'cmm 12/10/2003 21:31'!
showConnectorsFor: aMauiMorph

	(self connectorsFor: aMauiMorph) do: [ : each | each openInWorld ]! !

!MauiWorld methodsFor: 'connect' stamp: 'cmm 12/31/2004 15:48'!
undelineateAllFrom: aMauiMorph

	(self playersFor: aMauiMorph object) do: [ : each | each undelineate ]! !

!MauiWorld methodsFor: 'connect' stamp: 'cmm 12/31/2004 15:56'!
undelineateFrom: aMauiMorph

	self
		undelineateAllFrom: aMauiMorph ;
		disconnectAllFrom: aMauiMorph! !

!MauiWorld methodsFor: 'user strategy' stamp: 'cmm 7/16/2004 10:27'!
userStrategy

	^ userStrategy! !

!MauiWorld methodsFor: 'user strategy' stamp: 'cmm 3/28/2005 22:41'!
userStrategy: aMauiUserStrategy

	| didChange |
	didChange := userStrategy species ~= aMauiUserStrategy species.
	userStrategy := aMauiUserStrategy.
	didChange
		ifTrue:
			[ self playersDo:
				[ : each | 
				aMauiUserStrategy noteNewUserStrategyFor: each ] ]! !

!MauiWorld methodsFor: 'private' stamp: 'cmm 8/7/2008 00:34'!
world
	"Answer the PasteUpMorph world I represent."
	^ self class worldFor: self! !

!MauiWorld methodsFor: 'private' stamp: 'cmm 8/6/2008 15:56'!
worldFlaps
	^ World submorphs select: [ : each | each isFlapTab ]! !

!PasteUpMorph class methodsFor: '*maui-core-office flap prototypes' stamp: 'cmm 6/18/2011 14:10'!
connectorPrototype
	^ MauiWorld hasConnectors ifTrue: [ (Smalltalk classNamed: #NCAAConnectorMorph) new makeForwardArrow ]! !

!PasteUpMorph class methodsFor: '*maui-core-office flap prototypes' stamp: 'cmm 11/20/2010 20:54'!
documentPrototype
	^ MauiPage new asMauiMorph light! !

!PasteUpMorph class methodsFor: '*maui-core-office flap prototypes' stamp: 'cmm 11/18/2010 16:00'!
ellipsePrototype
	^ EllipseMorph new
		 borderWidth: 1 ;
		 borderColor: Color black ;
		 color: Color white darker ;
		 yourself! !

!PasteUpMorph class methodsFor: '*maui-core-office flap' stamp: 'cmm 6/17/2011 13:45'!
flapQuads
	| quads |
	quads := OrderedCollection new.
	quads 
		add: { self name.  #rectanglePrototype.  'Rectangle'.  'Rectangular shape, multiple uses.' }.
	(Smalltalk hasClassNamed: #NCAAConnectorMorph) ifTrue: 
		[ quads add: { self name.  #connectorPrototype.  'Connector'.  'A line or arrow that connects two objects.' } ].
	quads
		add: { self name.  #listPrototype.  'List'.  'Make a list of objects.' } ;
		add: { #PaintInvokingMorph.  #new.  'Sketch'.  'Sketch a painting by hand.' } ;
		add: { self name.  #documentPrototype.  'Document'.  'A small text editor that allows embedded objects.' } ;
		add: { self name.  #textPrototype.  'Text'.  'Simply a floating piece of text (i.e., for labelling).' } ;
		add: { self name.  #presentationPrototype.  'Presentation'.  'A small presentation editor that allows embedded objects.' } ;
		add: { self name.  #regionPrototype.  'sub-region'.  'A rectangular color-shaded sub-region.' } ;
"		add: { self name.  #starPrototype.  'Star'.  'A star shape.' } ;"
		add: { self name.  #ellipsePrototype.  'Ellipse'.  'An adjustable elliptical shape (use for circles).' } ;
		add: { self name.  #polygonPrototype.  'Polygon'.  'A customizable shape with a series of connected line segments which may be a closed solid, or a zig-zag line.  Shift-click to get handles and move the points.' }. ";
		add: { self name.  #personPrototype.  'Person'.  'A shape to represent a human user.' }".
	(Smalltalk hasClassNamed: #BroomMorph) ifTrue: 
		[ quads	add: { #BroomMorph.  #new.  'Broom'.  'An alignment tool.  Drop it near the morphs you want to align, then drag it to slightly push the nearby items into alignment.' } ].
	^ quads! !

!PasteUpMorph class methodsFor: '*maui-core-office flap prototypes' stamp: 'cmm 11/18/2010 20:18'!
listPrototype
	^ RectangleMorph new
		 layoutPolicy: TableLayout new ;
		 listDirection: #topToBottom ;
		 hResizing: #shrinkWrap ;
		 vResizing: #shrinkWrap ;
		 setNameTo: 'List' ;
		 color: (Color blue darker alpha: 0.15) ;
		 borderWidth: 0 ;
		 cellInset: 4 ;
		 layoutInset: 6 ;
		 enableDragNDrop ;
		 setBalloonText: 'Objects dropped here will form this list.' translated ;
		 yourself! !

!PasteUpMorph class methodsFor: '*maui-core-office flap' stamp: 'cmm 12/15/2010 22:05'!
newOfficeFlap
	| flapTab strip color |
	color := Color white slightlyDarker.
	strip := PartsBin
		newPartsBinWithOrientation: #topToBottom
		andColor: (color alpha: 0.9)
		from: self flapQuads.
	strip
		borderWidth: 0 ;
		width: 100 ;
		beSticky ;
		cellPositioning: #center.
	flapTab := FlapTab new referent: strip.
	flapTab
		setName: 'Office' translated
		edge: #left
		color: (color).
	flapTab
		 cornerStyle: #square ;
		 setToPopOutOnMouseOver: true ;
		 setToPopOutOnDragOver: true.
	strip beFlap: true.
	^ flapTab! !

!PasteUpMorph class methodsFor: '*maui-core-office flap prototypes' stamp: 'cmm 11/18/2010 19:58'!
polygonPrototype
	^ PolygonMorph new
		 borderWidth: 0 ;
		 color: (Color random alpha: 0.3) ;
		 yourself! !

!PasteUpMorph class methodsFor: '*maui-core-office flap prototypes' stamp: 'cmm 11/18/2010 19:11'!
presentationPrototype
	^ BookMorph new
		 color: Color white darker ;
		 yourself! !

!PasteUpMorph class methodsFor: '*maui-core-office flap prototypes' stamp: 'cmm 12/15/2010 21:12'!
rectanglePrototype
	^ RectangleMorph new
		 borderWidth: 1 ;
		 borderColor: Color black ;
		 color: Color white darker ;
		 yourself! !

!PasteUpMorph class methodsFor: '*maui-core-office flap prototypes' stamp: 'cmm 11/18/2010 19:30'!
regionPrototype
	"A color-shaded sub-region where individual users may collaborate without conflicting."
	^ RectangleMorph new
		 borderWidth: 0 ;
		 extent: 450 @ 275 * 0.7 ;
		 color: (Color random alpha: 0.3) ;
		 dropEnabled: true ;
		 yourself! !

!PasteUpMorph class methodsFor: '*maui-core-office flap prototypes' stamp: 'cmm 11/18/2010 15:44'!
starPrototype
	^ StarMorph new
		 makeVertices: 30 ;
		 borderWidth: 1 ;
		 borderColor: (Color red alpha: 0.5) ;
		 color: (Color yellow alpha: 0.9) ;
		 yourself! !

!PasteUpMorph class methodsFor: '*maui-core-office flap prototypes' stamp: 'cmm 11/18/2010 17:16'!
textPrototype
	^ TextMorph new
		 contentsWrapped: 'text' ;
		 width: 100 ;
"		 selectAll ;"
		 yourself! !

!PasteUpMorph class methodsFor: '*maui-core-office flap prototypes' stamp: 'cmm 5/1/2014 10:36'!
whiteboardPrototype
	^ PasteUpMorph new
		borderWidth: 0 ;
		color: (Color white alpha: 0.9) ;
		extent: 800@600 ;
		gradientFillColor: Color white slightlyDarker ;
		hResizing: #rigid; vResizing: #rigid ;
		clipSubmorphs: false ;
		yourself! !

!PasteUpMorph methodsFor: '*maui-core' stamp: 'cmm 5/27/2012 17:48'!
asMauiMorph: aTransferMorph 
	^ (aTransferMorph passenger mauiMorphForDesktopFrom: aTransferMorph)
		 position: aTransferMorph position ;
		 yourself! !

!PasteUpMorph methodsFor: '*maui-core-office flap' stamp: 'cmm 11/19/2010 14:18'!
hideOfficeFlap
	self officeFlap delete! !

!PasteUpMorph methodsFor: '*maui-core' stamp: 'cmm 12/2/2010 21:21'!
mauiCodedViews
	^ #(edit)! !

!PasteUpMorph methodsFor: '*maui-core' stamp: 'cmm 11/19/2010 13:45'!
mauiDefaultView
	^ #edit! !

!PasteUpMorph methodsFor: '*maui-core' stamp: 'cmm 1/17/2004 16:19'!
maxMauiExtent

	^(self width*4//5) @ (self height*2//3)! !

!PasteUpMorph methodsFor: '*maui-core' stamp: 'cmm 1/19/2004 23:08'!
maxMauiExtentFor: aMorph

	| mostParentMauiMorph requiredParentSpace maxExtent |
	mostParentMauiMorph := aMorph outermostMorphThat: [ : each | each isMauiMorph ].
	requiredParentSpace := (mostParentMauiMorph isNil or: [ mostParentMauiMorph == aMorph ])
		ifTrue: [ 0@0 ]
		ifFalse:
			[ mostParentMauiMorph listDirection = #leftToRight
				ifTrue: [ (mostParentMauiMorph width-aMorph width)@0 ]
				ifFalse: [ 0@(mostParentMauiMorph height-aMorph height) ] ].
	maxExtent := (self width*4//5) @ (self height*2//3).
	^(mostParentMauiMorph isNil or: [ mostParentMauiMorph isCustomLayout ])
		ifTrue: [ maxExtent ]
		ifFalse: [ maxExtent - requiredParentSpace ]! !

!PasteUpMorph methodsFor: '*maui-core-office flap' stamp: 'cmm 2/5/2012 14:54'!
newOfficeFlap
	| flapTab strip color |
	color := Color white slightlyDarker.
	strip := PartsBin
		newPartsBinWithOrientation: #topToBottom
		andColor: (color alpha: 0.9)
		from: self class flapQuads.
	strip
		borderWidth: 0 ;
		width: 100 ;
		beSticky ;
		cellPositioning: #center.
	flapTab := FlapTab new referent: strip.
	flapTab
		setName: 'Office' translated
		edge: #left
		color: (color).
	flapTab
		 cornerStyle: #square ;
"		 position: 50 @ (self currentWorld height - flapTab height) ;"
"		 position: (0) @ (Display height // 3) ;"
		 setToPopOutOnMouseOver: true ;
		 setToPopOutOnDragOver: true.
	strip beFlap: true.
	^ flapTab! !

!PasteUpMorph methodsFor: '*maui-core' stamp: 'cmm 8/18/2011 20:45'!
noteMightChangeKeywords
	"All PasteUps in the same Magma repository as me must noteOldKeys - we don't now what all changes will be made to them by the time the commit occurs."
	self magmaSession ifNotNil:
		[ : mySession | mySession ensureConnected.
		self class allInstances do:
			[ : each | each quickMagmaSession = mySession ifTrue:
				[ each officeItem ifNotNilDo:
					[ : item | item magmaSession ifNotNilDo:
						[ : sess | sess noteOldKeysFor: item ] ] ] ] ]! !

!PasteUpMorph methodsFor: '*maui-core-office flap' stamp: 'cmm 12/15/2010 22:05'!
officeFlap
	^ self
		valueOfProperty: #officeFlap
		ifAbsentPut: [ self class newOfficeFlap ]! !

!PasteUpMorph methodsFor: '*maui-core-office flap' stamp: 'cmm 11/19/2010 14:18'!
showOfficeFlap
	self addMorphFront: self officeFlap! !

ScrollBar subclass: #MauiScrollBar
	instanceVariableNames: 'realTimeScrolling'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Widgets'!

!MauiScrollBar methodsFor: 'initialize' stamp: 'cmm 1/25/2010 16:16'!
initialize
	super initialize.
	realTimeScrolling := false! !

!MauiScrollBar methodsFor: 'overriding' stamp: 'cmm 11/7/2007 16:32'!
mouseUpInSlider: event 
	super mouseUpInSlider: event.
	super scrollAbsolute: event! !

!MauiScrollBar methodsFor: 'overriding' stamp: 'cmm 11/7/2007 16:17'!
proposeValue: newValue 
	"Because scrolling in MauiCollectionMorph is so slow, make it so when they grab the scroll bar we simply drag the scroller to the new position instead of repainting constantly."
	self value: newValue! !

!MauiScrollBar methodsFor: 'access' stamp: 'cmm 2/9/2010 14:21'!
realTimeScrolling
	^ realTimeScrolling ifNil: [ realTimeScrolling := false ]! !

!MauiScrollBar methodsFor: 'access' stamp: 'cmm 1/25/2010 16:16'!
realTimeScrolling: aBoolean 
	realTimeScrolling := aBoolean! !

!MauiScrollBar methodsFor: 'overriding' stamp: 'cmm 2/9/2010 14:20'!
scrollAbsolute: aMouseMoveEvent 
	| r p v |
	r := self roomToMove.
	bounds isWide 
		ifTrue: [ r width = 0 ifTrue: [ ^ self ] ]
		ifFalse: [ r height = 0 ifTrue: [ ^ self ] ].
	p := aMouseMoveEvent targetPoint adhereTo: r.
	v := self descending 
		ifFalse: 
			[ bounds isWide 
				ifTrue: [ (p x - r left) asFloat / r width ]
				ifFalse: [ (p y - r top) asFloat / r height ] ]
		ifTrue: 
			[ bounds isWide 
				ifTrue: [ (r right - p x) asFloat / r width ]
				ifFalse: [ (r bottom - p y) asFloat / r height ] ].
	self realTimeScrolling 
		ifTrue: [ self setValue: v ]
		ifFalse: [ self proposeValue: v ]! !

!MauiScrollBar methodsFor: 'overriding' stamp: 'cmm 2/5/2009 21:19'!
sliderColor: aColor 
	super sliderColor: aColor.
	pagingArea color: (Preferences textHighlightColor twiceDarker alpha: 0.7)! !

!ScrollBar methodsFor: '*maui-core' stamp: 'cmm 5/24/2007 12:29'!
sliderBottom
	"Answer the percentage (Float 0.0 - 1.0) the top of my slider."
	^ self sliderTop + interval min: 1.0! !

!ScrollBar methodsFor: '*maui-core' stamp: 'cmm 5/24/2007 12:29'!
sliderTop
	"Answer the percentage (Float 0.0 - 1.0) the top of my slider."
	^ self value! !

TextMorphForEditView subclass: #MauiTextMorph
	instanceVariableNames: 'spacer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Widgets'!

!MauiTextMorph methodsFor: 'drag and drop' stamp: 'cmm 12/13/2010 20:13'!
acceptDroppingMorph: droppingMorph event: event 
	"Replace my spacer morph with droppingMorph."
	spacer ifNil: [ ^ self ].
	droppingMorph isMauiDomainMorph ifTrue: [ droppingMorph ensureHasProducedView ].
	self ensureNoSpacer.
	self 
		anchorMorph: droppingMorph
		at: (self localPointToGlobal: droppingMorph topCenter)
		type: #inline.
	self hasUnacceptedEdits: true! !

!MauiTextMorph methodsFor: 'override' stamp: 'cmm 11/1/2007 17:52'!
addMissingMorphsIn: embeddedMorphs 
	"Morphs in embeddedMorphs that are not in my submorphs need to be added at the correct position."
	embeddedMorphs size > submorphs size ifFalse: [ ^ self ].
	embeddedMorphs do: [ : each | (submorphs includes: each) ifFalse: [ self addMorph: each ] ]! !

!MauiTextMorph methodsFor: 'private' stamp: 'cmm 1/26/2008 15:48'!
checkForMauiIt: aKeyboardEvent 
	| result |
	aKeyboardEvent commandKeyPressed ifFalse: [ ^ false ].
	aKeyboardEvent keyValue = 111 ifFalse: 
		[ "o"
		^ false ].
	result := self editor evaluateSelection.
	((result isKindOf: FakeClassPool) or: [ result == #failedDoit ]) 
		ifTrue: [ self flash ]
		ifFalse: [ result maui ].
	^ true! !

!MauiTextMorph methodsFor: 'private' stamp: 'cmm 2/21/2009 13:46'!
cursorEnd
	"This fixes the problem with the cursor appearing in front of the first character instead of behind it."
	self editor selectAt: self text size + 1! !

!MauiTextMorph methodsFor: 'override' stamp: 'cmm 10/31/2007 16:40'!
deleteMorphsNotIn: embeddedMorphs 
	self submorphs copy do: [ : each | (embeddedMorphs includes: each) ifFalse: [ each delete ] ]! !

!MauiTextMorph methodsFor: 'drag and drop' stamp: 'cmm 10/1/2007 17:27'!
ensureNoSpacer
	spacer ifNotNil: [ spacer delete ].
	spacer := nil! !

!MauiTextMorph methodsFor: 'drag and drop' stamp: 'cmm 10/1/2007 17:09'!
extentOfDraggedMorph
	^ self primaryHand firstSubmorph extent! !

!MauiTextMorph methodsFor: 'override' stamp: 'cmm 10/24/2007 12:57'!
handleKeystroke: aKeyboardEvent 
	aKeyboardEvent wasHandled ifTrue: [ ^ self ].
	(self handlesKeyboard: aKeyboardEvent) ifFalse: [ ^ self ].
	"Give my listeners first chance to handle keys, so that keys can have special functions."
	self eventHandler ifNotNil: 
		[ self eventHandler 
			keyStroke: aKeyboardEvent
			fromMorph: self ].
	aKeyboardEvent wasHandled ifFalse: [ self keyStroke: aKeyboardEvent ]! !

!MauiTextMorph methodsFor: 'drag and drop' stamp: 'cmm 10/13/2009 15:15'!
handleMouseMove: aMouseEvent 
	aMouseEvent hand submorphs notEmpty ifTrue: 
		[ aMouseEvent shiftPressed 
			ifTrue: [ spacer ifNil: [ self startTrackingDropZones ] ]
			ifFalse: [ self stopTrackingDropZones ] ].
self maMarked: 'dev'.  "Everyone else only overrides this method and doesn't call super.  And, looking at the super-impl, perhaps we could have done this simply by going through the handleMouseStillDown:..?"
	super handleMouseMove: aMouseEvent! !

!MauiTextMorph methodsFor: 'drag and drop' stamp: 'cmm 10/2/2007 10:55'!
handlesMouseOverDragging: event
	"Answer whether #mouseEnterDragging: and #mouseLeaveDragging: should be called on me."
	"Make sure the hand has one object attached to it."
	| submorph |
	event hand submorphs size = 1 ifFalse: [ ^ false ].
	submorph := event hand firstSubmorph renderedMorph.
	"Disallow windows and TransferMorphs."
	(submorph isSystemWindow or: [ submorph isTransferMorph ]) ifTrue: [ ^ false ].
	^ true! !

!MauiTextMorph methodsFor: 'drag and drop' stamp: 'cmm 10/8/2007 17:10'!
initialize
	super initialize.
	self
		hResizing: #spaceFill ;
		vResizing: #spaceFill ;
		margins: 3@3! !

!MauiTextMorph methodsFor: 'drag and drop' stamp: 'cmm 4/12/2008 20:37'!
initializeSpacer
	self ensureNoSpacer.
	spacer := RectangleMorph new
		color: Color transparent ;
		borderColor: MauiPreferences global colorScheme highlightColor ;
		borderWidth: 1 ;
		extent: self extentOfDraggedMorph! !

!MauiTextMorph methodsFor: 'override' stamp: 'cmm 2/21/2009 13:46'!
keyStroke: aKeyboardEvent 
	"Remove all morphs that are no longer embedded in my Text."
	| embeddedMorphs |
	(self checkForMauiIt: aKeyboardEvent) ifTrue: [ ^ self ].
	super keyStroke: aKeyboardEvent.
	embeddedMorphs := self text embeddedMorphs.
	"In case they just pasted some text with embeddedMorphs.."
	self
		deleteMorphsNotIn: embeddedMorphs ;
		addMissingMorphsIn: embeddedMorphs! !

!MauiTextMorph methodsFor: 'drag and drop' stamp: 'cmm 3/31/2008 13:22'!
mouseEnterDragging: aMouseEvent 
	aMouseEvent shiftPressed ifTrue: [ self startTrackingDropZones ]! !

!MauiTextMorph methodsFor: 'drag and drop' stamp: 'cmm 10/1/2007 00:17'!
mouseLeaveDragging: aMouseEvent
	self stopTrackingDropZones ! !

!MauiTextMorph methodsFor: 'override' stamp: 'cmm 10/25/2007 17:39'!
newContents: stringOrText 
	"Accept new text contents."
	"cmm - Overridden to fix a bug when using embedded Morphs.  The paragraphs text needs to be updated before re-embedding the morphs.."
	| newText embeddedMorphs |
	"If my text is all the same font, use the font for my new contents"
	newText := stringOrText isString ifTrue: [ | textSize |
		(text notNil
		  and: [ (textSize := text size) > 0
		    and: [ (text runLengthFor: 1) = textSize ]]) ifTrue: [ | attribs |
			attribs := text attributesAt: 1 forStyle: textStyle.
			Text string: stringOrText copy attributes: attribs.
		]
		ifFalse: [ Text fromString: stringOrText copy ]
	]
	ifFalse: [ stringOrText copy asText.	"should be veryDeepCopy?" ].

	(text = newText and: [text runs = newText runs]) ifTrue: [^ self].	"No substantive change"
	text ifNotNil: [(embeddedMorphs := text embeddedMorphs)
			ifNotNil: 
				[self removeAllMorphsIn: embeddedMorphs.
				embeddedMorphs do: [:m | m delete]]].

	text := newText.

	"add all morphs off the visible region; they'll be moved into the right 
	place when they become visible. (this can make the scrollable area too 
	large, though)"
	newText embeddedMorphs do: 
		[:m | 
		self addMorph: m.
		m position: -1000 @ 0].

	self releaseParagraphReally.
	"update the paragraph cache"
	self paragraph.

	"re-instantiate to set bounds"
	self world ifNotNil: [self world startSteppingSubmorphsOf: self]! !

!MauiTextMorph methodsFor: 'override' stamp: 'cmm 3/1/2012 21:31'!
setDefaultContentsIfNil
	"Override this to prevent 'abc' and an apparent inconsistency in the model (that my 'text' is not the same instance as my paragraphs 'text')."
	text ifNil: [ text := String empty asText ]! !

!MauiTextMorph methodsFor: 'drag and drop' stamp: 'cmm 10/1/2007 17:11'!
startTrackingDropZones
	self initializeSpacer.
	self 
		startStepping: #trackDropZones
		at: Time millisecondClockValue
		arguments: nil
		stepTime: 100! !

!MauiTextMorph methodsFor: 'drag and drop' stamp: 'cmm 10/1/2007 17:05'!
stopTrackingDropZones
	self
		stopSteppingSelector: #trackDropZones ;
		ensureNoSpacer! !

!MauiTextMorph methodsFor: 'drag and drop' stamp: 'cmm 12/13/2010 20:12'!
trackDropZones
	"I am called many times per second when a droppable Morph is hovering, ready to be dropped onto me.  Put a 'spacer' morph whereever the current morph *could* be dropped."
	| hand |
	hand := self primaryHand.
	hand submorphs
		ifEmpty: [ self stopTrackingDropZones ]
		ifNotEmptyDo:
			[ : draggingMorphs | self
				anchorMorph: spacer
				at: draggingMorphs anyOne topCenter
				type: #inline ]! !

!MauiTextMorph methodsFor: 'copying' stamp: 'cmm 10/2/2007 15:47'!
veryDeepInner: deepCopier 
	super veryDeepInner: deepCopier.
	"The spacer should never be set during a copy, but this won't hurt nontheless."
	spacer := spacer veryDeepCopyWith: deepCopier! !

!MauiTextMorph methodsFor: 'drag and drop' stamp: 'cmm 3/31/2008 13:23'!
wantsDroppedMorph: aMorph event: anEvent 
	"Don't allow embedded documents."
	spacer ifNil: [ ^ false ].
	aMorph class = self class ifTrue: [ ^ false ].
	^ true! !

!TextMorphForEditView methodsFor: '*maui-core' stamp: 'cmm 10/30/2007 13:34'!
veryDeepInner: deepCopier
	super veryDeepInner: deepCopier.
	editView := editView veryDeepCopyWith: deepCopier! !

Morph subclass: #MaProgressBarMorph
	instanceVariableNames: 'bar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maui-Core-Widgets'!

!MaProgressBarMorph methodsFor: 'as yet unclassified' stamp: 'cmm 2/4/2008 09:36'!
initialize
	super initialize.
	self
		extent: 100 @ 12 ;
		color: Color gray ;
		layoutPolicy: TableLayout new ;
		hResizing: #spaceFill ;
		position: 100 @ 100.
	bar := RectangleMorph new
		color: Preferences textHighlightColor ;
		extent: 0 @ self height ;
		borderWidth: 0 ;
		layoutInset: 0 ;
		position: 0 @ 0 ;
"		setBorderStyle: #complexRaised ;"
		vResizing: #spaceFill ;
		yourself.
	self percent: 0.0.
	self addMorph: bar! !

!MaProgressBarMorph methodsFor: 'as yet unclassified' stamp: 'cmm 8/6/2003 00:23'!
percent: aFloat "between 0.0 and 1.0"

	| secureFloat |
	secureFloat := aFloat > 1.0 ifTrue: [ 1.0 ] ifFalse: [ aFloat < 0.0 ifTrue: [ 0.0 ] ifFalse: [ aFloat ] ].
	bar width: self width*secureFloat! !

!MaProgressBarMorph methodsFor: 'as yet unclassified' stamp: 'cmm 7/19/2004 23:52'!
veryDeepInner: aDeepCopier

	super veryDeepInner: aDeepCopier.
	bar := bar veryDeepCopyWith: aDeepCopier! !

!Morph methodsFor: '*maui-core' stamp: 'cmm 8/25/2003 18:05'!
asMauiMessageUsing: aMauiMorph

	^nil! !

!Morph methodsFor: '*maui-core' stamp: 'cmm 1/19/2004 23:16'!
canDropIntoMauiMorph

	^true! !

!Morph methodsFor: '*maui-core' stamp: 'cmm 5/27/2008 18:34'!
deleteParent
	owner == World 
		ifTrue: [ self delete ]
		ifFalse: [ owner ifNotNil: [ owner deleteParent ] ]! !

!Morph methodsFor: '*maui-core' stamp: 'cmm 10/5/2007 11:49'!
isMauiSpacer
	^ false! !

!Morph methodsFor: '*maui-core' stamp: 'cmm 2/12/2004 00:26'!
isTransferMorph

	^false! !

!Morph methodsFor: '*maui-core' stamp: 'cmm 12/30/2004 16:49'!
maBorderColorAlpha: aFloat

	| existingBorderColor |
	existingBorderColor := self borderColor.
	existingBorderColor isColor ifFalse: [ ^ self ].
	self borderColor: (existingBorderColor alpha: aFloat)! !

!Morph methodsFor: '*maui-core' stamp: 'cmm 12/30/2004 16:47'!
maColorAlpha: aFloat
	self color: (self color alpha: aFloat)! !

!Morph methodsFor: '*maui-core' stamp: 'cmm 12/20/2010 14:06'!
maContextKeywordsDo: aBlock
	self submorphsDo: [ : each | each maContextKeywordsDo: aBlock ]! !

!Morph methodsFor: '*maui-core' stamp: 'cmm 12/30/2004 16:04'!
maFadeAwayOver: millisecondsDuration

	millisecondsDuration = 0 ifTrue: [ ^ self delete ].
	self
		maSlide: #maTransparency:
		from: self maTransparency
		to: 0.0
		over: millisecondsDuration
		finally: [ self delete ]! !

!Morph methodsFor: '*maui-core' stamp: 'cmm 9/5/2003 00:14'!
maHasOwner

	^owner notNil! !

!Morph methodsFor: '*maui-core' stamp: 'cmm 11/19/2003 00:19'!
maIsMenuItemMorph

	^false! !

!Morph methodsFor: '*maui-core' stamp: 'cmm 1/10/2010 19:45'!
maIsStringMorph
	^ false! !

!Morph methodsFor: '*maui-core' stamp: 'cmm 12/30/2004 14:51'!
maSlide: selectorSymbol from: startValue to: endValue over: millisecondsDuration finally: aBlock

	| stopwatch |
	millisecondsDuration = 0 maSeconds ifTrue: [ ^ self perform: selectorSymbol with: endValue ].
	stopwatch := MaStopwatch new start.
	[ [ stopwatch time totalMilliseconds < millisecondsDuration and: [ self isInWorld ] ] whileTrue:
		[ | currentValue |
		currentValue := ((millisecondsDuration - stopwatch time totalMilliseconds) / millisecondsDuration) asFloat.
		WorldState addDeferredUIMessage:
			[ self
				perform: selectorSymbol
				with: currentValue ].
		(Delay forMilliseconds: 50) wait ].
	WorldState addDeferredUIMessage: [ self perform: selectorSymbol with: endValue ].
	WorldState addDeferredUIMessage: [ aBlock value ] ] fork! !

!Morph methodsFor: '*maui-core' stamp: 'cmm 12/30/2004 16:04'!
maTransparency
	^ self color alpha! !

!Morph methodsFor: '*maui-core' stamp: 'cmm 12/30/2004 16:48'!
maTransparency: aFloat
	self
		maColorAlpha: aFloat ";
		
For some reason, Connectors seem to go black with this..
		maBorderColorAlpha: aFloat   "! !

!Morph methodsFor: '*maui-core' stamp: 'cmm 12/11/2008 11:05'!
maVerticalLayoutInset
	^ self layoutInset in: 
		[ : li | 
		li isPoint 
			ifTrue: [ li y ]
			ifFalse: [ li ] ]! !

!Morph methodsFor: '*maui-core' stamp: 'cmm 12/15/2009 13:53'!
mauiClippingExtent
	| min |
	min := self clippingBounds extent.
	self allOwnersDo: 
		[ : each | 
		min := min min: (each clipSubmorphs 
				ifTrue: [ each clippingBounds extent ]
				ifFalse: [ min ]) ].
	^ min! !

!Morph methodsFor: '*maui-core' stamp: 'cmm 8/16/2004 16:26'!
mauiDropInto: aMauiMorph event: event at: spacerPosition

	aMauiMorph
		addMorph: self 
		asElementNumber: (spacerPosition max: 1).
	"In case we're custom-layout."
	self position: event hand position! !

!Morph methodsFor: '*maui-core' stamp: 'cmm 10/13/2007 18:20'!
mauiEnsureOnScreen
	| worldBounds |
	((worldBounds := self mauiWorldBounds) containsRect: self bounds) ifFalse: [ self bounds: (self bounds translatedToBeWithin: worldBounds) ]! !

!Morph methodsFor: '*maui-core' stamp: 'cmm 4/29/2009 17:46'!
mauiLabelString
	^ self name! !

!Morph methodsFor: '*maui-core' stamp: 'cmm 6/21/2012 21:14'!
mauiNoteOutOfWorld
	"I could not use outOfWorld: because it is called more often than I expected, such as when adding a Morph for example (couldn't figure out why).  Therefore, I implement this so I can better control when it happens."
	"I think the only reason we'd ever have dependents is for updating display.  If a Morph is not in the world, it should not leave its dependents hanging around."
	self
		 removeHalo ;
		 breakDependents.
	"Have seen sometimes that Morphs don't get out of the WorldState's 'stepList'  Try to alleviate that."
	World stopStepping: self! !

!Morph methodsFor: '*maui-core' stamp: 'cmm 10/13/2007 18:20'!
mauiWorldBounds
	"Answer the bounds of the World."
	^ (self world ifNil: [ World ]) bounds! !

!Morph methodsFor: '*maui-core' stamp: 'cmm 1/16/2004 00:15'!
nextMauiOwner

	owner ifNil: [ ^ nil ].
	^owner isMauiMorph
		ifTrue: [ owner ]
		ifFalse: [ owner nextMauiOwner ]! !

!Morph methodsFor: '*maui-core-debugging' stamp: 'cmm 7/21/2004 14:32'!
signalWhereInvalid

	self submorphs do:
		[ : each | 
		each == self ifTrue: [ MauiSoftwareError signal ].
		each owner == self ifFalse: [ MauiSoftwareError signal ].
		each signalWhereInvalid ]! !
MauiNotificationHandler initialize!
MauiPackageInfo initialize!
MauiClipboard initialize!
MauiFamily initialize!
MauiMessage initialize!
MauiPreferences initialize!
MauiRegistry initialize!
MauiWorld initialize!
